/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control React Select
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup } from 'reactstrap';
// import CircularProgress from '@material-ui/core/CircularProgress';
// import AppConfig from 'DefaultConstants/AppConfig';
import Select from "react-select";
// const { swaggerPostAPI, swaggerGetAPI } = require('DefaultHelpers')

/**
 * Start BankSelectWidget class component
 * @state {*Object} reqData
 */
class BankSelectWidget extends Component {
    constructor(props) {
        super(props);
        this.state = {
            selectOptions: [],
            externalURL: '',
            loading: true
        }
        //this.callAPI = this.callAPI.bind(this)
    }

    /* Convert option to react select options*/
    _convertOptions(reactOptions) {
        let selectOptions = [];
        reactOptions.map((item) => {
            let optionLabel = item.label;
            if (item.label.locale !== undefined && Object.keys(item.label.locale).length > 0) {
                optionLabel = item.label.locale[this.props.defaultLng];
            } else if (Object.keys(item.label).length > 0) {
                optionLabel = item.label[this.props.defaultLng]
            }
            let object = {
                label: optionLabel,
                value: item.value
            };
            if (item.image !== undefined && item.image !== '') {
                object.image = item.image;
            }
            selectOptions.push(object);
        });
        return selectOptions;
    }

    componentDidMount() {
        if (this.props && this.props.optionsObj && this.props.optionsObj.options && this.props.optionsObj.options.length) {
            const selectedOptions = this._convertOptions(this.props.optionsObj.options);
            this.setState({ selectOptions: selectedOptions, externalURL: '', loading: false })
        } else if (this.props.optionsObj && this.props.optionsObj.externalURL && this.props.optionsObj.externalURL.URL && this.state.externalURL !== this.props.optionsObj.externalURL.URL) {
            this.setState({ selectOptions: [], externalURL: this.props.optionsObj.externalURL.URL, loading: false }, () => {
                this.callAPI()
            })
        } else if (!this.props.optionsObj.options.length && (this.props.optionsObj && (!this.props.optionsObj.externalURL || !this.props.optionsObj.externalURL.URL))) {
            this.setState({ selectOptions: [], externalURL: '', loading: false });
        }
    }

    componentWillReceiveProps(nextProps) {
        if (nextProps && nextProps.optionsObj && nextProps.optionsObj.options && nextProps.optionsObj.options.length) {
            const selectedOptions = this._convertOptions(this.props.optionsObj.options);
            this.setState({ selectOptions: selectedOptions, externalURL: '', loading: false })
        } else if (nextProps.optionsObj && nextProps.optionsObj.externalURL && nextProps.optionsObj.externalURL.URL && this.state.externalURL !== nextProps.optionsObj.externalURL.URL) {
            this.setState({ selectOptions: [], externalURL: this.props.optionsObj.externalURL.URL, loading: false }, () => {
                this.callAPI()
            })
        } else if (!nextProps.optionsObj.options.length && (nextProps.optionsObj && (!nextProps.optionsObj.externalURL || !nextProps.optionsObj.externalURL.URL))) {
            this.setState({ selectOptions: [], externalURL: '', loading: false });
        }
    }

    async callAPI() {
        const {
            optionsObj: { name: inputName = '' } = {},
            optionsObj: {
                options: inputOptions = [],
                externalURL: externalObj = {},
                externalURL: { URL: externalAPIUrl = '', label: extLables = [], value: extValue = '' } = {}
            } = {},
            swaggerGetAPI
        } = this.props;

        if (inputOptions.length) {
            this.setState({ selectOptions: inputOptions, loading: false })
        } else if (Object.keys(externalObj).length > 0&&typeof swaggerGetAPI==="function") {
            var response = await swaggerGetAPI(externalAPIUrl, {}, true);
            const { responseCode = '', data: responseData = [] } = response;
            if (responseCode === 0) {
                let selectOptions = [];
                responseData.map((dataItem) => {
                    dataItem.BankHolderName = 'JOHN DEO';
                    dataItem.customerAccountNumber = '777545';
                    dataItem.bankName = 'SBI';

                    let optionDataArr = [];
                    let selObj = {};
                    if (extLables.length > 0) {
                        extLables.map((extObj) => {
                            let labelObj = Object.assign({}, extObj);
                            const { value: exValue = '' } = extObj;
                            labelObj.optionLabel = dataItem[exValue];
                            selObj[exValue] = dataItem[exValue]
                            optionDataArr.push(labelObj);
                        })
                    }
                    let object = {
                        optionDataArr: optionDataArr,
                        'selectObj': selObj,
                        value: dataItem[extValue]
                    };
                    selectOptions.push(object);
                });
                this.setState({ selectOptions: selectOptions, externalURL: externalAPIUrl, loading: false })
            } else {
                this.setState({ selectOptions: [], externalURL: externalAPIUrl, loading: false })
            }
        }
    }

    /* on blur event */
    handleOnBlurEvent = (e, reactSelect) => {
        this.onBlurCallAPI(e, reactSelect);
    }
    /* on focus event */
    handleOnFocusEvent = (e) => {
        this.onFocusCallAPI(e);
    }
    /* on change event */
    handleOnChangeEvent = (e, isMultiple, reactSelect) => {
        const { assignResponseValue,onChange } = this.props
        if (isMultiple !== undefined && isMultiple&&typeof onChange==="function") {
            onChange('mvsl_multi_select', this.props.optionsObj.name, e);
        } else {
            onChange('mvsl_select', this.props.optionsObj.name, e.value)
        }
        if (Array.isArray(e.label.props.children) && e.label.props.children.length > 0) {
            e.label.props.children.map((item) => {
                if (Array.isArray(item.props.children) && item.props.children.length > 0) {
                    item.props.children.map((childItem) => {
                        if (childItem.type === 'input') {
                            assignResponseValue(childItem.props.name, childItem.props.value)
                        }
                    })
                }
            })
        }
        assignResponseValue(this.props.optionsObj.name, e.value)

        this.onChangeCallAPI(e, isMultiple, reactSelect);
    }

    onBlurCallAPI = async (e) => {

        const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {}, assignResponseValue,swaggerPostAPI,swaggerGetAPI,onError } = this.props;
        if (onBlurURL !== '') {

            let response = '';
            let inputName = e.target.name;
            let inputValue = e.target.value;

            if (blurMethod !== '' && blurMethod === 'POST'&&typeof swaggerPostAPI==="function") {
                let data = {
                    [inputName]: inputValue
                }
                response = await swaggerPostAPI(onBlurURL, data, true);
                if (response.responseCode === 0&&typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1&&typeof onError==="function") {
                    onError(inputName, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if(typeof swaggerGetAPI==="function"){
                response = await swaggerGetAPI(onBlurURL, {}, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0&&typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                }
            }

        }
    }

    onFocusCallAPI = async (e) => {

        const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue,swaggerPostAPI,swaggerGetAPI,onError } = this.props;
        if (onFocusURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (focusMethod !== '' && focusMethod === 'POST'&&typeof swaggerPostAPI==="function") {
                response = await swaggerPostAPI(onFocusURL, data, true);
                if (response.responseCode === 0&&typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1&&typeof onError==="function") {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if(typeof swaggerGetAPI==="function"){
                response = await swaggerGetAPI(onFocusURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0&&typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1&&typeof onError==="function") {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }

    async onChangeCallAPI(e, isMultiple, reactSelect) {

        const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '' } = {}, assignResponseValue,swaggerPostAPI,swaggerGetAPI,onError } = this.props;
        if (onChangeURL !== '') {

            let response = '';

            if (changeMethod !== '' && changeMethod === 'POST'&&typeof swaggerPostAPI==="function") {
                if (isMultiple !== undefined && isMultiple) {
                    response = await swaggerPostAPI(onChangeURL, e.target.selectedOptions, true);
                } else {
                    response = await swaggerPostAPI(onChangeURL, (reactSelect) ? e.value : e.target.value, true);
                }
                // response = await swaggerPostAPI(onChangeURL, data, true);
                if (response.responseCode === 0&&typeof assignResponseValue === 'function') {
                        assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1&&typeof onError==="function") {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if(typeof swaggerGetAPI==="function"){
                if (isMultiple !== undefined && isMultiple) {
                    response = await swaggerGetAPI(onChangeURL, e.target.selectedOptions, true);
                } else {
                    response = await swaggerGetAPI(onChangeURL, (reactSelect) ? e.value : e.target.value, true);
                }
                // response = await swaggerGetAPI(onChangeURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0&&typeof assignResponseValue === 'function') {
                        assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1&&typeof onError==="function") {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }

    /* shouldComponentUpdate = (nextProps, nextState) => {
        if (this.props === nextProps || nextState === this.state) {
            return false;
        }
        return true;
    }; */

    render() {
        const { errorMsg, defaultLng, defaultValue, intl } = this.props;
        const { autoComplete, id, key, className, label, name, status, required, isDisabled, options, isMultiple, displaysize, labelAlignment, icon, iconPosition, helpText, autoFocus, type, onBlurURL, onFocusURL, onChangeURL, externalURL } = this.props.optionsObj;
        const { selectOptions } = this.state;
        let dynamicKey = 'frm_select_' + (name !== undefined ? name : 'textSelectInput');
        let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
        let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
        let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
        let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
        let reactDefaultValue = [];

        if (Array.isArray(defaultValue) && defaultValue.length > 0) {
            selectOptions.map((item) => {
                if (defaultValue.indexOf(item.value) !== -1) {
                    let rObj = {};
                    item.optionDataArr.map((optnItem) => {
                        if (optnItem.displayInSelect === true) {
                            rObj = {
                                label: item.value, //item[optnItem.value], 
                                value: item.value
                            };
                        }
                    })

                    reactDefaultValue.push(rObj);
                }
            })
        } else if (defaultValue !== undefined && defaultValue !== '') {
            selectOptions.map((item) => {
                if (item.value === defaultValue.value) {
                    let rObj = {};
                    item.optionDataArr.map((optnItem) => {
                        if (optnItem.displayInSelect === true) {
                            rObj = {
                                label: item.value, //item[optnItem.value], 
                                value: item.value
                            };
                        }
                    })

                    reactDefaultValue.push(rObj);
                }
            })
        }

        if (icon !== '') {
            classInput += (iconPosition !== undefined && iconPosition.toLowerCase() === 'right') ? ' icon_right' : ' icon_left';
        }
        return (
            <Fragment>
                {/* {status && */}
                <FormGroup className="row" key={dynamicKey}>
                    {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={`${classInput} ${(className !== undefined && className) ? className : ''}${errorMsg ? ' is_err' : ''}`}>
                                    {/* {this.state.loading && <CircularProgress className="cstm_progress" thickness={3} />} */}
                                    {selectOptions.length > 0 &&
                                        <Select
                                            type="select"
                                            isMulti={(isMultiple !== undefined && isMultiple) ? isMultiple : false}
                                            isSearchable
                                            closeMenuOnSelect={false}
                                            autoComplete={autoComplete}
                                            autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                            className={`${(className !== undefined && className) ? className : ''} ${(isMultiple !== undefined && isMultiple) ? ' is_multi_sel' : ''}`}
                                            key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                            id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                            name={(name !== undefined && name) ? name : 'textSelectInput'}
                                            disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                            required={(required !== undefined && required) ? required : false}
                                            size={(displaysize !== undefined && displaysize) ? displaysize : ''}
                                            onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e, true) : () => ({})}
                                            onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                            onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, isMultiple, true))}
                                            value={reactDefaultValue}
                                            defaultValue={reactDefaultValue}
                                            options={
                                                selectOptions.map((item, i) => ({
                                                    label: (
                                                        <div className="row" key={i}>
                                                            {
                                                                item.optionDataArr.map((optionItem, index) => {
                                                                    const { title: { locale: { [defaultLng]: optionWithTitle = '' } = {} } = {}, optionLabel = '', isHighLight = false } = optionItem;
                                                                    let alignClassName = 'pull-left'
                                                                    if ((index % 2) !== 0) {
                                                                        alignClassName = "pull-right text-right"
                                                                    }
                                                                    return (
                                                                        <div className={`col-md-6 ${alignClassName}`} key={i + '_' + index}>
                                                                            {isHighLight ? <strong>{(optionWithTitle + ' ' + optionLabel)}</strong> : (optionWithTitle + ' ' + optionLabel)}
                                                                        </div>
                                                                    )
                                                                })
                                                            }
                                                        </div>
                                                    ),
                                                    value: item,
                                                    // name: (name !== undefined && name) ? name : 'textSelectInput',
                                                }))
                                            }
                                        />}
                                    {icon !== '' && <span className="is_icon"><i className={icon} /></span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                                <div className={`${classInput} ${(className !== undefined && className) ? className : ''}${errorMsg ? ' is_err' : ''}`}>
                                    {/* {this.state.loading && <CircularProgress className="cstm_progress" thickness={3} />} */}
                                    {selectOptions.length != 0 && <Select
                                        isMulti={(isMultiple !== undefined && isMultiple) ? isMultiple : false}
                                        type="select"
                                        isSearchable={autoComplete}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        className={`${(className !== undefined && className) ? className : ''} ${(isMultiple !== undefined && isMultiple) ? ' is_multi_sel' : ''}`}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        name={(name !== undefined && name) ? name : 'textSelectInput'}
                                        isDisabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        size={(displaysize !== undefined && displaysize) ? displaysize : ''}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e, true) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, isMultiple, true))}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange((isMultiple !== undefined && isMultiple) ? 'multi_select' : 'select', (name !== undefined && name) ? name : 'textSelectInput', (isMultiple !== undefined && isMultiple) ? e.target.selectedOptions : e.value)}
                                        value={reactDefaultValue}
                                        defaultValue={reactDefaultValue}
                                        options={
                                            selectOptions.map((item, i) => ({
                                                label: (
                                                    <div className="row" key={i}>
                                                        {
                                                            item.optionDataArr.map((optionItem, index) => {
                                                                const { title: { locale: { [defaultLng]: optionWithTitle = '' } = {} } = {}, optionLabel = '', isHighLight = false } = optionItem;
                                                                let alignClassName = 'pull-left'
                                                                if ((index % 2) !== 0) {
                                                                    alignClassName = "pull-right text-right"
                                                                }
                                                                return (
                                                                    <div className={`col-md-6 ${alignClassName}`} key={i + '_' + index}>
                                                                        {isHighLight ? <strong>{(optionWithTitle + ' ' + optionLabel)}</strong> : (optionWithTitle + ' ' + optionLabel)}
                                                                    </div>
                                                                )
                                                            })
                                                        }
                                                    </div>
                                                ),
                                                value: item,
                                                // name: (name !== undefined && name) ? name : 'textSelectInput',
                                            }))
                                        }
                                    />}
                                    {icon !== '' && <span className="is_icon"><i className={icon} /></span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                            </Fragment>
                    }
                </FormGroup>
                {/* } */}
            </Fragment >
        )
    }
}

//Default Props for Select
BankSelectWidget.defaultProps = {
    optionsObj: {
        autoComplete: false,
        id: 'Demo',
        className: 'cstm_input_sel',
        label: 'Select',
        name: 'Demo',
        status: false,
        required: true,
        validationMsg: '',
        regex: '',
        isDisabled: false,
        options: [],
        isMultiple: false,
        displaysize: 1,
        labelAlignment: 'left',
        icon: '',
        iconPosition: '',
        helpText: {},
        autoFocus: false,
        type: 'default',
        onBlurURL: "",
        onFocusURL: "",
        onChangeURL: "",
    },
    defaultValue: '',
    defaultLng: 'en',
    onChange: '',
    errorMsg: ''
}

export default BankSelectWidget;