/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control checkbox
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input } from 'reactstrap';
// import AppConfig from 'DefaultConstants/AppConfig';
// const { swaggerPostAPI, swaggerGetAPI } = require('DefaultHelpers')
// import IntlMessages from "Util/IntlMessages";

/**
 * Start CheckboxForPGBalance class component
 * @state {*Object} reqData
 */
class CheckboxForPGBalance extends Component {
    state = { cashBackWalletValue: 0 }

    // shouldComponentUpdate = (nextProps, nextState) => {
    //     if (this.props === nextProps) {
    //         return false;
    //     }
    //     return true;
    // };

    /* on blur event */
    handleOnBlurEvent = (e) => {
        this.onBlurCallAPI(e);
    }
    /* on focus event */
    handleOnFocusEvent = (e) => {
        this.onFocusCallAPI(e);
    }
    /* on change event */
    handleOnChangeEvent = (e) => {
        let checkVal = e.target.value;
        this.props.onChange(e.target.type, e.target.name, e.target.value, e.target.checked)
        setTimeout(() => {
            this.onChangeCallAPI(checkVal);

        }, 200)

    }

    onBlurCallAPI = async (e) => {

        const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {}, assignResponseValue, swaggerPostAPI, swaggerGetAPI, onError } = this.props;
        if (onBlurURL !== '') {

            let response = '';
            let inputName = e.target.name;
            let inputValue = e.target.value;

            if (blurMethod !== '' && blurMethod === 'POST' && typeof swaggerPostAPI === "function") {
                let data = {
                    [inputName]: inputValue
                }
                response = await swaggerPostAPI(onBlurURL, data, true);
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1 && typeof onError === "function") {
                    onError(inputName, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof swaggerGetAPI === "function") {
                response = await swaggerGetAPI(onBlurURL, {}, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                }
            }

        }
    }

    onFocusCallAPI = async (e) => {

        const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue, onError, swaggerPostAPI, swaggerGetAPI } = this.props;
        if (onFocusURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (focusMethod !== '' && focusMethod === 'POST' && typeof swaggerPostAPI === "function") {
                response = await swaggerPostAPI(onFocusURL, data, true);
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1 && typeof onError === "function") {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof swaggerGetAPI === "function") {
                response = await swaggerGetAPI(onFocusURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1 && typeof onError === "function") {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }

    async onChangeCallAPI(checkVal) {
        const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '' } = {}, assignResponseValue, swaggerPostAPI, swaggerGetAPI, onError } = this.props;
        if (onChangeURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (changeMethod !== '' && changeMethod === 'POST' && typeof swaggerPostAPI === "function") {
                response = await swaggerPostAPI(onChangeURL, data, true);
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1 && typeof onError === "function") {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof swaggerGetAPI === "function") {
                response = await swaggerGetAPI(onChangeURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1 && typeof onError === "function") {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        } else if (changeBindIn !== '' && typeof assignResponseValue === 'function') {
            assignResponseValue(changeBindIn, checkVal)
            assignResponseValue('cashBackAmount', this.state.cashBackWalletValue)
        }

    }

    componentDidMount() {
        this.setWalletBalance()
    }

    componentWillReceiveProps() {
        this.setWalletBalance()
    }

    setWalletBalance = () => {
        const { balanceObj = [], AppConfig: { mainBalanceKey = '' } } = this.props
        let cashBackWalletValue = 0
        balanceObj.map((item) => {
            const { [mainBalanceKey]: availableBalance = 0, pouchExternalId = '' } = item;
            if (pouchExternalId.toLowerCase().indexOf('cashback') > -1) {
                cashBackWalletValue = availableBalance;
            }
        })
        this.setState({ cashBackWalletValue });
    }

    render() {
        const { errorMsg, defaultValue, defaultLng, IntlMessages } = this.props;
        const { id, className, label, name, status, required, isDisabled, options, labelAlignment, displayAsButton, onBlurURL, onFocusURL, onChangeURL } = this.props.optionsObj;
        let dynamicKey = 'frm_checkbox_' + (name !== undefined ? name : 'textCheckBoxInput');
        let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
        let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
        let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
        let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
        let showAsButton = displayAsButton !== undefined && displayAsButton ? displayAsButton : false;
        const { cashBackWalletValue } = this.state

        return (
            <Fragment>
                {/* {status && */}
                <FormGroup className="row" key={dynamicKey}>
                    {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={classInput + ' ' + className}>
                                    <div className={`cstm_icn_area ${showAsButton && 'show_btn row'}`}>
                                        {(options !== undefined && options.length > 0) && options.map((item, index) => {
                                            let checkDefaulValue = '';
                                            if (defaultValue !== undefined && ((Array.isArray(defaultValue) && defaultValue.includes(item.value)) || defaultValue === item.value)) {
                                                checkDefaulValue = 'checked';
                                            }
                                            return (
                                                <Fragment>
                                                    {
                                                        showAsButton
                                                            ?
                                                            <div className="col-md-4 chk_btn_area" key={`mlti_chkbx_${index}`}>
                                                                <Label className={`chk_btn ${checkDefaulValue ? 'active' : ''}`} htmlFor={'int_chk_' + index}>
                                                                    <IntlMessages id={item.label.locale[defaultLng]} values={{ balance: cashBackWalletValue }} />
                                                                </Label>
                                                                <Input
                                                                    type="checkbox"
                                                                    className={`custom-control-input`}
                                                                    name={((name !== undefined && name) ? name : dynamicKey + index)}
                                                                    key={'int_chk_' + index}
                                                                    id={'int_chk_' + index}
                                                                    value={(item.value !== undefined && item.value) ? item.value : ''}
                                                                    disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                                                    required={(required !== undefined && required) ? required : false}
                                                                    checked={checkDefaulValue}
                                                                    onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                                    onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                                    onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                                />
                                                            </div>
                                                            :
                                                            <div className="custom-control custom-checkbox custom-control-inline" key={`mlti_chkbx_${index}`}>
                                                                <Input
                                                                    type="checkbox"
                                                                    className={`custom-control-input`}
                                                                    name={((name !== undefined && name) ? name : dynamicKey + index)}
                                                                    key={'int_chk_' + index}
                                                                    id={'int_chk_' + index}
                                                                    value={(item.value !== undefined && item.value) ? item.value : ''}
                                                                    disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                                                    required={(required !== undefined && required) ? required : false}
                                                                    checked={checkDefaulValue}
                                                                    onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                                    onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                                    onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                                />
                                                                {(item.label !== undefined && item.label.locale !== undefined && item.label.locale[defaultLng] !== undefined) &&
                                                                    <IntlMessages id={item.label.locale[defaultLng]} values={{ balance: cashBackWalletValue }} />}
                                                            </div>
                                                    }
                                                </Fragment>
                                            )
                                        })}
                                    </div>
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined && label.locale[defaultLng] !== '') &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined && label.locale[defaultLng] !== '') &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                                <div className={classInput + ' ' + className}>
                                    <div className={`cstm_icn_area ${showAsButton && 'show_btn row'}`}>
                                        {(options !== undefined && options.length > 0) && options.map((item, index) => {
                                            let checkDefaulValue = '';
                                            if (defaultValue !== undefined && ((Array.isArray(defaultValue) && defaultValue.includes(item.value)) || defaultValue === item.value)) {
                                                checkDefaulValue = 'checked';
                                            }
                                            return (
                                                <Fragment>
                                                    {
                                                        showAsButton
                                                            ?
                                                            <div className="col-md-4 chk_btn_area" key={`mlti_chkbx_${index}`}>
                                                                <Label className={`chk_btn ${checkDefaulValue ? 'active' : ''}`} htmlFor={'int_chk_' + index}>
                                                                    <IntlMessages id={item.label.locale[defaultLng]} values={{ balance: cashBackWalletValue }} />
                                                                </Label>
                                                                <Input
                                                                    type="checkbox"
                                                                    className={`custom-control-input`}
                                                                    name={((name !== undefined && name) ? name : dynamicKey + index)}
                                                                    key={'int_chk_' + index}
                                                                    id={'int_chk_' + index}
                                                                    value={(item.value !== undefined && item.value) ? item.value : ''}
                                                                    disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                                                    required={(required !== undefined && required) ? required : false}
                                                                    checked={checkDefaulValue}
                                                                    onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                                    onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                                    onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                                />
                                                            </div>
                                                            :
                                                            <div className="custom-control custom-checkbox custom-control-inline" key={`mlti_chkbx_${index}`}>
                                                                <Input
                                                                    type="checkbox"
                                                                    className={`custom-control-input`}
                                                                    name={((name !== undefined && name) ? name : dynamicKey + index)}
                                                                    key={'int_chk_' + index}
                                                                    id={'int_chk_' + index}
                                                                    value={(item.value !== undefined && item.value) ? item.value : ''}
                                                                    disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                                                    required={(required !== undefined && required) ? required : false}
                                                                    checked={checkDefaulValue}
                                                                    onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                                    onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                                    onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                                />
                                                                {(item.label !== undefined && item.label.locale !== undefined && item.label.locale[defaultLng] !== undefined) &&
                                                                    <label className="custom-control-label" htmlFor={'int_chk_' + index}>
                                                                        <IntlMessages id={item.label.locale[defaultLng]} values={{ balance: cashBackWalletValue }} /></label>
                                                                }
                                                            </div>
                                                    }
                                                </Fragment>
                                            )
                                        })}
                                    </div>
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                            </Fragment>
                    }

                </FormGroup>
                {/* } */}
            </Fragment>
        )
    }
}

//Default Props for CheckboxForPGBalance
CheckboxForPGBalance.defaultProps = {
    optionsObj: {
        "id": 'cashBack',
        "className": 'cstm_input_sel',
        "label": 'Checkbox',
        "name": "cashBack",
        "defaultValue": "",
        "isExternal": false,
        "status": false,
        "required": false,
        "validationMsg": '',
        "regex": '',
        "isDisabled": false,
        "options": [
            {
                "value": "true",
                "label": {
                    "locale": {
                        "en": "cashback.message",
                        "prs": "cashback.message"
                    }
                }
            }
        ],
        "responseBindFrom": "",
        "labelAlignment": 'left',
        "icon": '',
        "iconPosition": '',
        "displayAsButton": false,
        "onBlurURL": "",
        "onFocusURL": "",
        "onChangeURL": "",
        "changeBindIn": "includeCashbackAmount",
    },
    defaultValue: [],
    defaultLng: 'en',
    onChange: '',
    errorMsg: ''
}

export default CheckboxForPGBalance;