/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control otp
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
 import React, { Component, Fragment } from 'react';
 import { Label, FormGroup, Col } from 'reactstrap';
//  import AppConfig from 'DefaultConstants/AppConfig';
//  const {swaggerPostAPI} = require('DefaultHelpers');
//  import IntlMessages from "Util/IntlMessages";
 import { NotificationManager } from 'react-notifications';
 /**
  * Start CopyWidget class component
  * @state {*Object} reqData
  */
 class CopyWidget extends Component {
     state = {
         isShowCopyMsg: ""
     }
 
     /* copy on clipboard */
     copyText = (value) => {
         const el = document.createElement('textarea');
         el.value = value;
         document.body.appendChild(el);
         el.select();
         document.execCommand('copy');
         document.body.removeChild(el);
         this.setState({ isShowCopyMsg: value });
         setTimeout(() => {
             this.setState({ isShowCopyMsg: "" });
         }, 3000);
 
     }
 
     render() {
         const { defaultLng , IntlMessages} = this.props;
         const { isShowCopyMsg } = this.state;
         const {
             select,
             copyOption,
             showBorder,
             value,
             label,
             /* additional */
             className,
             fontStyle,
             fontSize,
             color,
         } = this.props.optionsObj;
         let dynamicKey = 'frm_copy_' + (name !== undefined ? name : 'dynamicKeyCopy');
         let style = {
             color: color,
             fontSize: fontSize
         }
         if ((fontStyle !== undefined && Array.isArray(fontStyle) && fontStyle.length > 0)) {
             fontStyle.map((sty, index) => {
                 if (sty === 'bold') {
                     style.fontWeight = 'bold';
                 } else if (sty === 'italic') {
                     style.fontStyle = 'italic';
                 } else if (sty === 'underline') {
                     style.textDecoration = 'underline';
                 }
             })
         }
         return (
             <Fragment>
                 <FormGroup className="row" key={dynamicKey}>
                     <Col sm={12} className={"text-center"}>
                         <Label>
                             {label.locale[defaultLng]}
                         </Label>
                     </Col>
                     <Col sm={12} className={"text-center " + (showBorder === true ? " border p-10" : "")}>
                         <Label
                             className={className + (select === false ? " noselect " : "")}
                             style={style}
                         >
                             {value}
                         </Label>
                     </Col>
                     {copyOption === true && <Col sm={12} className={`text-center ${isShowCopyMsg !== '' ? 'success-color' : ''}`}>
                         <a
                             className={''}
                             onClick={() => this.copyText(value)}
                         >
                             {isShowCopyMsg == value ? <IntlMessages id={`general.copied`} /> : <IntlMessages id={`general.copy`} />}
                         </a>
                     </Col>}
                 </FormGroup>
             </Fragment>
         );
     }
 }
 CopyWidget.defaultProps = {
     optionsObj: {
         select: true,
         copyOption: true,
         showBorder: true,
         value: "",
         label: {
             locale: { en: "" }
         },
         className: "",
         fontStyle: "",
         fontSize: "",
         color: "",
     },
     defaultValue: '',
     defaultLng: '',
     onChange: '',
     errorMsg: '',
 };
 
 export default CopyWidget;