/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control text
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input, Button, Row } from 'reactstrap';
// import AppConfig from 'DefaultConstants/AppConfig';
// import { injectIntl } from 'react-intl';
/**
 * Start Datepicker class component
 * @state {*Object} reqData
 */
class CustomTimePicker extends Component {
    constructor(props) {
        super(props);
        this.state = {
            selectedTime: "",
            selectedZone: "",
            times: [
                { value: 1, label: 1 },
                { value: 2, label: 2 },
                { value: 3, label: 3 },
                { value: 4, label: 4 },
                { value: 5, label: 5 },
                { value: 6, label: 6 },
                { value: 7, label: 7 },
                { value: 8, label: 8 },
                { value: 9, label: 9 },
                { value: 10, label: 10 },
                { value: 11, label: 11 },
                { value: 12, label: 12 }
            ]
        }
    }

    /* handle time select */
    onSelectTime = (value) => {
        this.setState({ selectedTime: value });
    }
    /* handle time select */
    onSelectZone = (zone) => {
        this.setState({ selectedZone: zone });
    }


    render() {
        const { intl } = this.props;
        const { times, selectedZone, selectedTime } = this.state;
        return (
            <div className="calender_area">
                {/* time */}
                <div className="time_area">
                    <div className="time_left cal_box">
                        {times.map((time, index) => {
                            return <Button key={index} color="secondary" onClick={() => this.onSelectTime(time.value)} className={`btn_cal ${time.value === selectedTime && 'active'}`}>{time.value}</Button>
                        })}
                    </div>
                    <div className="time_right cal_box">
                        <Button color="secondary" onClick={() => this.onSelectZone('AM')} className={`btn_cal btn_last_month ${'AM' === selectedZone && 'active'}`}>{intl.formatMessage({ id: "occurrence.am" })}</Button>
                        <Button color="secondary" onClick={() => this.onSelectZone('PM')} className={`btn_cal btn_last_month ${'PM' === selectedZone && 'active'}`}>{intl.formatMessage({ id: "occurrence.pm" })}</Button>
                    </div>
                </div>
            </div>
        )
    }
}
export default CustomTimePicker;