/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control text
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input, Button, Row } from 'reactstrap';
// import AppConfig from 'DefaultConstants/AppConfig';
/**
 * Start Datepicker class component
 * @state {*Object} reqData
 */
class CustomWeekPicker extends Component {
    constructor(props) {
        super(props);
        this.state = {
            selectedDays: [],
            weeks: [
                { value: 'Monday', label: 'Monday' },
                { value: 'Tuesday', label: 'Tuesday' },
                { value: 'Wednesday', label: 'Wednesday' },
                { value: 'Thursday', label: 'Thursday' },
                { value: 'Friday', label: 'Friday' },
                { value: 'Saturday', label: 'Saturday' },
                { value: 'Sunday', label: 'Sunday' },
            ]
        }
    }
    /* handle selection */
    onSelectWeek = (index) => {
        let Days = Object.assign([], this.state.selectedDays);
        if (Days.indexOf(this.state.weeks[index].value) === -1) {
            Days.push(this.state.weeks[index].value);
            this.setState({ selectedDays: Days });
        } else {
            delete Days[Days.indexOf(this.state.weeks[index].value)];
            this.setState({ selectedDays: Days });
        }
    }
    onSelectAllDays = () => {
        this.setState({ selectedDays: ['Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday'] })
    }
    render() {
        const { intl } = this.props;
        const { weeks, selectedDays } = this.state;
        return (
            <div className="calender_area">
                {/* weeks*/}
                <div className="week_area1 cal_box">
                    {weeks.map((week, index) => (
                        <Button key={index} onClick={() => this.onSelectWeek(index)} color="secondary" className={`btn_cal ${selectedDays.indexOf(week.value) !== -1 && 'active'}`}>{week.value}</Button>
                    ))}
                    <Button onClick={() => this.onSelectAllDays()} color="secondary" className={`btn_cal`}>{intl.formatMessage({ id: "list.all" })}</Button>
                </div>
            </div>
        )
    }
}
export default CustomWeekPicker