/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control text
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input } from 'reactstrap';
// import AppConfig from 'CitybankConstants/AppConfig';
// const { swaggerPostAPI, swaggerGetAPI, changeDateFormat } = require('DefaultHelpers');
import moment from 'moment';
import DatePicker from "react-datepicker";
import "react-datepicker/dist/react-datepicker.css";

/**
 * Start Datepicker class component
 * @state {*Object} reqData
 */
class Datepicker extends Component {
    shouldComponentUpdate = (nextProps, nextState) => {
        if (this.props === nextProps) {
            return false;
        }
        return true;
    };

    /* on blur event */
    handleOnBlurEvent = (e) => {
        this.onBlurCallAPI(e);
    }
    /* on focus event */
    handleOnFocusEvent = (e) => {
        this.onFocusCallAPI(e);
    }
    /* on change event */
    handleOnChangeEvent = (name, value) => {
        let { format = 'YYYY-MM-DD' } = this.props.optionsObj;
        if (format === '')
            format = 'YYYY-MM-DD';
        if (typeof this.props.changeDateFormat === 'function') {
            this.props.onChange('', name, (value !== '' && value !== null) ? this.props.changeDateFormat(value, format, false) : '')
            this.onChangeCallAPI({ target: { name, value: (value !== '' && value !== null) ? this.props.changeDateFormat(value, format, false) : '' } });
        }
    }

    onBlurCallAPI = async (e) => {

        const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {}, assignResponseValue } = this.props;
        if (onBlurURL !== '') {

            let response = '';
            let inputName = e.target.name;
            let inputValue = e.target.value;

            if (blurMethod !== '' && blurMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                let data = {
                    [inputName]: inputValue
                }
                response = await this.props.swaggerPostAPI(onBlurURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(inputName, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof this.props.swaggerGetAPI === 'function') {
                response = await this.props.swaggerGetAPI(onBlurURL, {}, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                    }
                }
            }

        }
    }

    onFocusCallAPI = async (e) => {

        const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue } = this.props;
        if (onFocusURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (focusMethod !== '' && focusMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                response = await this.props.swaggerPostAPI(onFocusURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof this.props.swaggerGetAPI === 'function') {
                response = await this.props.swaggerGetAPI(onFocusURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }

    async onChangeCallAPI(e) {

        const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '' } = {}, assignResponseValue } = this.props;
        if (onChangeURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (changeMethod !== '' && changeMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                response = await this.props.swaggerPostAPI(onChangeURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof this.props.swaggerGetAPI === 'function') {
                response = await this.props.swaggerGetAPI(onChangeURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }

    render() {
        const { errorMsg, defaultValue, defaultLng } = this.props;
        let defaultSetValue = (defaultValue !== '' && defaultValue !== "Invalid date" && defaultValue !== null) ? new Date(defaultValue.toString().split(' ')[0]) : '';//Object.assign(changeDateFormat(defaultValue, 'YYYY-MM-DD', false))
        let { autoComplete, key, id, className, label, name, status, placeHolder, required, isDisabled, labelAlignment, icon, iconPosition, autoFocus, onChangeURL, onBlurURL, onFocusURL, max, min, validateAge = {}, allowFutureDate = false, allowPastDate = false, displayFormat = 'dd-MM-yyyy' } = this.props.optionsObj;
        // console.log("defaultSetValue", defaultSetValue)
        let dynamicKey = 'frm_datepicker_' + (name !== undefined ? name : 'textDatePickerInput');
        let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
        let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
        let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
        let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';

        if (allowFutureDate === true) {
            min = moment().format("YYYY-MM-DD")
        }
        if (allowPastDate === true) {
            max = moment().format("YYYY-MM-DD")
        }

        if (icon !== '') {
            classInput += (iconPosition !== undefined && iconPosition.toLowerCase() === 'right') ? ' icon_right' : ' icon_left';
        }
        const { enabled = false, ageLimit = '' } = validateAge;
        if (enabled && ageLimit !== '') {
            max = moment().subtract(parseInt(ageLimit), 'years').format("YYYY-MM-DD"); // 06/03/2020
            min = moment().subtract(100, "years").format("YYYY-MM-DD");
        }
        return (
            <Fragment>
                {/* {status && */}
                <FormGroup className="row" key={dynamicKey}>
                    {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={`${classInput} ${className} ${errorMsg ? ' is_err' : ''}`}>
                                    <DatePicker
                                        dateFormat={displayFormat}
                                        autoComplete={(autoComplete !== undefined && autoComplete) ? autoComplete : 'off'}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        className={(className !== undefined && className) ? className + ' form-control' : 'form-control'}
                                        name={(name !== undefined && name) ? name : 'textDatePickerInput'}
                                        value={(defaultSetValue !== undefined && defaultSetValue) ? defaultSetValue : ''}
                                        placeholderText={(placeHolder !== undefined && placeHolder.locale !== undefined && placeHolder.locale[defaultLng] !== undefined) ? placeHolder.locale[defaultLng] : ''}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange('', e.target.name, e.target.value)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                        max={(max !== undefined) ? max : ""}
                                        min={(min !== undefined) ? min : ""}
                                        showYearDropdown
                                        showMonthDropdown
                                        scrollableYearDropdown

                                    />
                                    {(icon !== undefined && icon !== '') && <span className="is_icon"><i className={icon} /></span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                                <div className={`${classInput} ${className} ${errorMsg ? ' is_err' : ''}`}>
                                    <DatePicker
                                        dateFormat={displayFormat}
                                        selected={defaultSetValue}
                                        autoComplete={(autoComplete !== undefined && autoComplete) ? autoComplete : 'off'}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        className={(className !== undefined && className) ? className + ' form-control' : 'form-control'}
                                        name={(name !== undefined && name) ? name : 'textDatePickerInput'}
                                        value={(defaultSetValue !== undefined && defaultSetValue) ? defaultSetValue : ''}
                                        placeholderText={(placeHolder !== undefined && placeHolder.locale !== undefined && placeHolder.locale[defaultLng] !== undefined) ? placeHolder.locale[defaultLng] : ''}
                                        // placeholderText="dd-mm-yyyy"
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange('', e.target.name, e.target.value)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(name, e))}
                                        maxDate={(max !== undefined) ? new Date(max) : ""}
                                        minDate={(min !== undefined) ? new Date(min) : ""}
                                        shouldCloseOnSelect={true}
                                        showYearDropdown
                                        showMonthDropdown
                                        scrollableYearDropdown
                                    />
                                    {(icon !== undefined && icon !== '') && <span className="is_icon"><i className={icon} /></span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                            </Fragment>
                    }
                </FormGroup>
                {/* } */}
            </Fragment>
        )
    }
}

//Default Props for Datepicker
Datepicker.defaultProps = {
    optionsObj: {
        autoComplete: false,
        key: 'input_date_',
        id: 'Demo_date',
        className: 'cstm_input_date',
        label: 'Date',
        name: 'Demo',
        status: false,
        placeHolder: 'Demo input',
        required: true,
        validationMsg: '',
        regex: '',
        isDisabled: false,
        labelAlignment: 'left',
        icon: '',
        iconPosition: '',
        format: 'YYYY-MM-DD',
        /* additional */
        autoFocus: false,
        onChangeURL: "",
        onBlurURL: "",
        onFocusURL: "",
        max: "",
        min: "",
        onBlurURL: "",
        onFocusURL: "",
        onChangeURL: "",
    },
    defaultValue: '',
    defaultLng: '',
    onChange: '',
    errorMsg: ''
}

export default Datepicker;