/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control file
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input } from 'reactstrap';
// import AppConfig from 'DefaultConstants/AppConfig';
// import IntlMessages from "Util/IntlMessages";
import { NotificationManager } from "react-notifications";
// const {swaggerPostAPI, swaggerGetAPI, redirectToLogin, getNotificationFunction }= require('DefaultHelpers')
import { post } from 'axios';
import $ from 'jquery';
import * as PapaParse from 'papaparse';
import validator from 'validator';
import dot from 'dot-object';

/**
 * Start File class component
 * @state {*Object} reqData
 */
class File extends Component {

    shouldComponentUpdate = (nextProps, nextState) => {
        if (this.props === nextProps) {
            return false;
        }
        return true;
    };

    /* on blur event */
    handleOnBlurEvent = (e) => {
        this.onBlurCallAPI(e);
    }
    /* on focus event */
    handleOnFocusEvent = (e) => {
        this.onFocusCallAPI(e);
    }
    /* on change event */
    handleOnChangeEvent = (e) => {
        if (typeof this.props.onChange === "function") {
            this.props.onChange(e.target.type, e.target.name, e.target.value, '', e.target.files)
        }
        this.onChangeCallAPI(e);
    }

    downloadFile = async (urlDetail, fileName) => {
        const { showLink, link: { url = '' } = {} } = this.props.optionsObj;
        const { swaggerGetAPI } = this.props;
        if (showLink && url !== '' && typeof swaggerGetAPI === "function") {
            let fileNameUnique = url.split('csvsamples/');
            if (fileNameUnique[1] !== undefined && fileNameUnique[1] !== '') {
                fileNameUnique = fileNameUnique[1].split('.');
                if (fileNameUnique[0] !== undefined && fileNameUnique[0] !== '') {
                    fileName = fileNameUnique[0]
                }
            }
            const response = await swaggerGetAPI(url, {}, true);
            if (response.responseCode === 0 && response.data !== undefined && response.data.file !== undefined) {
                if (response.data.fileType !== undefined && response.data.fileType !== '') {
                    // window.open(`data:${response.data.fileType};base64,${response.data.file}`, 'target_blank');
                    var a = document.createElement("a"); //Create <a>
                    a.href = `data:${response.data.fileType};base64,${response.data.file}`; //Image Base64 Goes here
                    a.download = fileName + response.data.fileExtention;
                    a.click();
                } else {
                    var a = document.createElement("a"); //Create <a>
                    a.href = `data:image/png;base64,${response.data.file}`; //Image Base64 Goes here
                    a.download = fileName + response.data.fileExtention;
                    a.click();
                    // window.open(`data:image/png;base64,${response.data.file}`, 'target_blank');
                }
            }
        }
    }

    onBlurCallAPI = async (e) => {

        const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {}, assignResponseValue, name, swaggerPostAPI, swaggerGetAPI } = this.props;
        if (onBlurURL !== '') {

            let response = '';
            let inputName = e.target.name;
            let inputValue = e.target.value;

            if (blurMethod !== '' && blurMethod === 'POST' && typeof swaggerPostAPI === "function") {
                let data = {
                    [inputName]: inputValue
                }
                response = await swaggerPostAPI(onBlurURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1 && typeof onError === 'function') {
                    onError(inputName, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof swaggerGetAPI === "function") {
                response = await swaggerGetAPI(onBlurURL, {}, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                }
            }

        }
    }

    onFocusCallAPI = async (e) => {

        const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue } = this.props;
        if (onFocusURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (focusMethod !== '' && focusMethod === 'POST' && typeof swaggerPostAPI === 'function') {
                response = await swaggerPostAPI(onFocusURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1 && typeof onError === "function") {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof swaggerGetAPI === "function") {
                response = await swaggerGetAPI(onFocusURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1 && typeof onError === 'function') {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }

    async onChangeCallAPI(e) {
        const { optionsObj: { onChangeURL = '', type, name, id, kycPath = '', kycResponseBindFrom = '', savedObject = {} } = {}, assignResponseValue, getNotificationFunction, onChange, IntlMessages } = this.props;
        if (onChangeURL !== '') {
            const { defaultLng, optionsObj: { size, type, name, checkHeader: { enable: enabled = false, columns = [], rowCount = 0, rowCountErrorMessage: { locale: { [this.props.defaultLng]: errorRows = '' } = {} } = {}, columnRegex = [] } = {} } = {} } = this.props;
            let startProcess = false;
            let targetFile = e.target;
            let validType = type !== undefined ? type : [];
            let fileType = targetFile.files[0].type;
            let fileSize = targetFile.files[0].size;
            let fileTypeExtension = '.' + targetFile.files[0].name.toString().split('.').pop();// targetFiles[0].type;
            let dynamicKeyValue = 'frm_file_' + (name !== undefined ? name : 'textFileInput');
            let fieldId = (id !== undefined && id) ? id : dynamicKeyValue + "id";
            if (fileType !== '' && Array.isArray(validType) && validType.length > 0 && !validType.includes(fileType) && typeof onChange === "function") {
                $("#" + fieldId).val('');
                onChange(e.target.type, name, '', '', [])
                return false;
            } else if (fileType === '' && Array.isArray(validType) && validType.length > 0 && !validType.includes(fileTypeExtension) && typeof onChange === "function") {
                onChange(e.target.type, name, '', '', [])
                $("#" + fieldId).val('');
                return false;
            } else if (size !== undefined && size !== '' && fileSize > size && typeof onChange === "function") {
                onChange(e.target.type, name, '', '', [])
                $("#" + fieldId).val('');
                return false;
            } else {
                startProcess = true
            }

            const formData = new FormData();
            if (kycPath !== '') {
                let kycPathNew = kycPath;
                // console.log("kycResponseBindFrom", kycResponseBindFrom, savedObject)
                if (kycResponseBindFrom !== '') {
                    kycPathNew = kycPathNew + dot.pick(kycResponseBindFrom, savedObject);//getValueUsingKey(kycResponseBindFrom, savedObject)
                }
                formData.append('keyType', kycPathNew);
            } else {
                formData.append('kycField', name);
            }
            formData.append('file', targetFile.files[0]);

            if (startProcess) {
                if (enabled) {

                    try {

                        let reader = new FileReader();
                        console.log("reader", reader)
                        reader.onloadend = () => {
                            console.log(reader, "reader.result", reader.result)
                            const parseData = PapaParse.parse(reader.result, PapaParse.ParseConfig);
                            let { data: { [0]: fileHeaders = [] } = {}, data } = parseData;
                            if (Array.isArray(fileHeaders) && fileHeaders.length === columns.length) {
                                let fieldCount = 0;
                                columns.map((value, index) => {
                                    if (fileHeaders[index] !== undefined && value.toLowerCase() === fileHeaders[index].toLowerCase()) {
                                        fieldCount++;
                                    }
                                });

                                if (fieldCount === columns.length) {
                                    if (data.length > 1 && data.length <= parseFloat(rowCount)) {

                                        let emptyFields = false, skipValidation = false;
                                        data.map((value, mainIndex) => {
                                            if (mainIndex === 0 || (mainIndex + 1 === data.length && data[mainIndex].length === 1)) {
                                                return false;
                                            }
                                            columns.map((column, index) => {
                                                const { [index]: { regex = '', message: { locale: { [defaultLng]: errorMessage = '' } = {} } = {} } = {} } = columnRegex;
                                                if (value.length === columns.length && value[index] !== undefined && value[index].trim() !== '' && value[index].trim() !== null) {
                                                    if (regex !== '' && !validator.matches(value[index], regex) && !skipValidation && errorMessage !== '') {
                                                        getNotificationFunction('error', errorMessage);
                                                        emptyFields = true;
                                                        skipValidation = true;
                                                    } else if (regex !== '' && !validator.matches(value[index], regex) && !skipValidation && errorMessage === '') {
                                                        skipValidation = true;
                                                    }
                                                } else {
                                                    emptyFields = true;
                                                }
                                            })
                                        });

                                        if (emptyFields && typeof onChange === 'function') {
                                            $("#" + fieldId).val('');
                                            onChange(e.target.type, name, '', '', [])
                                            if (!skipValidation && typeof getNotificationFunction === "function") {
                                                getNotificationFunction('error', <IntlMessages id="validationError.csvFieldEmpty" />);
                                            }
                                        } else {
                                            // let fileType = targetFiles[0].type;
                                            this.uploadFile(formData, targetFile);
                                        }

                                    } else if (typeof onChange === "function" && typeof getNotificationFunction === "function") {
                                        $("#" + fieldId).val('');
                                        onChange(e.target.type, name, '', '', [])
                                        getNotificationFunction('error', errorRows);
                                    }
                                } else if (typeof onChange === "function" && typeof getNotificationFunction === "function") {
                                    $("#" + fieldId).val('');
                                    onChange(e.target.type, name, '', '', [])
                                    getNotificationFunction('error', <IntlMessages id="validationError.csvFileUploadError" />);
                                }
                            } else if (typeof onChange === "function" && typeof getNotificationFunction === "function") {
                                $("#" + fieldId).val('');
                                onChange(e.target.type, name, '', '', [])
                                getNotificationFunction('error', <IntlMessages id="validationError.csvFileUploadError" />);
                            }

                        }
                        reader.readAsText(targetFile.files[0]);

                    } catch (e) {
                        if (typeof onChange === "function" && typeof getNotificationFunction === "function") {
                            onChange(e.target.type, name, '', '', [])
                            getNotificationFunction('error', <IntlMessages id="message.pleaseTryAfterSometime" />);
                        }
                    }

                } else {
                    this.uploadFile(formData, targetFile);
                }

            } else {
                if (typeof onChange === "function" && typeof getNotificationFunction === "function") {
                    $("#" + fieldId).val('');
                    onChange(e.target.type, name, '', '', [])
                    getNotificationFunction('error', <IntlMessages id="validationError.invalidFileType" />);
                }
            }

        }
    }


    // function for file upload into server and get id from response and set into request Object
    uploadFile = async (formData, targetFile) => {

        const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '', name } = {}, assignResponseValue, AppConfig: { nodeAPIUrl = "", authorizationToken = "" } } = this.props;

        let response = '';
        const url = nodeAPIUrl + onChangeURL;
        const config = {
            headers: {
                'content-type': 'multipart/form-data', // 'application/x-www-form-urlencoded'
                'authorization': authorizationToken + localStorage.getItem('front_authorize_token')
                // get token from local storage
            }
        }

        if (changeMethod !== '' && changeMethod === 'POST') {
            var self = this;
            // response = await swaggerPostAPI(onChangeURL, formData, 99); // pass 99 for add content type extra for file
            post(url, formData, config).then((apiResponse) => {
                const { data: response = {} } = apiResponse;
                const { onChange, redirectToLogin, onError } = self.props;
                // response = { responseCode: 0, data: { fileUniqueId: "abc" + (Math.random()) } }
                if (apiResponse !== undefined && apiResponse.status === 401 && typeof redirectToLogin === "function") {
                    redirectToLogin();
                } else if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    if (changeResponseField !== '' && response.data[changeResponseField] === undefined && typeof onChange === "function") {
                        onChange(targetFile.type, targetFile.name, '', '', [])
                        return false;
                    }
                    if (changeBindIn !== '')
                        assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                    else
                        assignResponseValue((name !== undefined && name) ? name : 'textDatePickerInput', response.data['fileUniqueId'], 'fileUniqueId');
                    // self.props.onChange(targetFile.type, (name !== undefined && name) ? name : 'textDatePickerInput', targetFile.value, '', targetFile.files, '', '', response.data.fileUniqueId)
                } else if (response.responseCode === 1) {
                    if (changeBindIn === '' && typeof onChange === "function" && typeof onError === "function")
                        onChange(targetFile.type, (name !== undefined && name) ? name : 'textDatePickerInput', targetFile.value, '', '')
                    onError((name !== undefined && name) ? name : 'textDatePickerInput', `error.message.${response.errCode}`)
                    setTimeout(() => {
                        if (typeof onChange === "function") {
                            onChange(e.target.type, name, '', '', [])
                        }
                    }, 1000)
                }
            })
            // to do handle response of post method
        } else if (typeof swaggerGetAPI === "function") {
            response = await swaggerGetAPI(onChangeURL, data, true);
            // response = { responseCode: 0, data: { billAmount: 1000 } }
            if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
            } else if (response.responseCode === 1 && typeof onError === "function") {
                onError(e.target.name, `error.message.${response.errCode}`)
            }
        }

    }

    render() {
        const { errorMsg, defaultLng, savedObject } = this.props;
        const { id, key, className, label, name, type, status, required, isDisabled, labelAlignment, multiple, onBlurURL, onFocusURL, onChangeURL, showLink, link, helpText } = this.props.optionsObj;
        let dynamicKey = 'frm_file_' + (name !== undefined ? name : 'textFileInput');
        let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
        let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
        let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
        let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';

        var helpTextDetail = helpText !== undefined ? helpText : {};
        if (helpTextDetail.locale !== undefined && savedObject !== undefined && Object.keys(savedObject).length > 0) {
            Object.keys(helpTextDetail.locale).map((key) => {
                Object.keys(savedObject).map((savedKey) => {
                    var regex = new RegExp("{" + savedKey + "}", 'g');
                    helpTextDetail.locale[key] = helpTextDetail.locale[key].replace(regex, savedObject[savedKey])
                });
            });
        }

        return (
            <Fragment>
                {/* {status && */}
                <FormGroup className="row" key={dynamicKey}>
                    {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    <Input
                                        {...(multiple !== undefined && multiple === true && { multiple })}
                                        type="file"
                                        className={`cstm_icn_area`}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        name={(name !== undefined && name) ? name : 'textDatePickerInput'}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        accept={(type !== undefined && Array.isArray(type) && type.length > 0) ? type : '*.*'}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange(e.target.type, e.target.name, e.target.value, '', e.target.files)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                    />
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                                {(showLink !== undefined && showLink == true && link !== undefined && link.url !== undefined) &&
                                    <Label className={`control-label col temp`} align={link.position}>
                                        {/* <Link to={"#"} onClick={() => this.downloadFile(link.url, link.label.locale[defaultLng])}>{link.label.locale[defaultLng]}</Link> */}
                                        <a sethref="javascript:void(0)" onClick={() => this.downloadFile(link.url, link.label.locale[defaultLng])}>{link.label.locale[defaultLng]}</a>
                                        {/* <a href={link.url}>{link.label.locale[defaultLng]}</a> */}
                                    </Label>}
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    <Input
                                        {...(multiple !== undefined && multiple === true && { multiple })}
                                        type="file"
                                        className={`cstm_icn_area upload-file-class`}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        name={(name !== undefined && name) ? name : 'textDatePickerInput'}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        accept={(type !== undefined && Array.isArray(type) && type.length > 0) ? type : '*.*'}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange(e.target.type, e.target.name, e.target.value, '', e.target.files)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                    />
                                    {helpTextDetail !== undefined && Object.keys(helpTextDetail).length > 0 && <Label className={`control-label`}>{helpTextDetail.locale[defaultLng]}</Label>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                            </Fragment>
                    }
                </FormGroup>
                {/* } */}
            </Fragment>
        )
    }
}

//Default Props for File
File.defaultProps = {
    optionsObj: {
        id: 'Demo_file',
        className: 'cstm_input_file',
        label: 'File',
        name: 'Demo',
        type: '',
        size: '',
        status: false,
        required: true,
        isDisabled: false,
        labelAlignment: 'left',
        icon: '',
        iconPosition: '',
        multiple: false,
        onBlurURL: "",
        onFocusURL: "",
        onChangeURL: "",
    },
    defaultLng: "en",
    onChange: '',
    fileType: {},
    errorMsg: ''
}

export default File;