/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control file details
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Link } from 'react-router-dom';
import { Label, FormGroup, Input } from 'reactstrap';
import IntlMessages from "Util/IntlMessages";
import { NotificationManager } from "react-notifications";
import { post } from 'axios';
import * as PapaParse from 'papaparse';
import $ from 'jquery';
import validator from 'validator';
const { swaggerPostAPI, swaggerGetAPI, redirectToLogin } = require('DefaultHelpers');
import AppConfig from 'DefaultConstants/AppConfig';

/**
 * Start FileDetails class component
 * @state {*Object} reqData
 */
class FileDetails extends Component {
    render() {
        const { errorMsg, defaultLng } = this.props;
        const {
            id = '',
            key = '',
            className = '',
            label: { locale: { [defaultLng]: labelName = 'Applicant Photo' } = {} } = {},
            name = '',
            type = '',
            required = false,
            isDisabled = false,
            multiple = false,
            onBlurURL = '',
            onFocusURL = '',
            onChangeURL = '',
            showLink = false,
            labelAlignment = 'top-left',
            link: {
                url: lnkUrl = '',
                position: lnkPosition = 'right',
                label: { locale: { [defaultLng]: lnkLabel = '' } = {} } = {}
            } = {}
        } = this.props.optionsObj;
        let dynamicKey = 'frm_file_' + (name !== undefined ? name : 'textFileInput');
        let labelString = labelAlignment !== '' ? labelAlignment.toString().toLowerCase() : '';
        let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
        let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
        let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';

        return (
            <Fragment>
                <FormGroup className="row" key={dynamicKey}>
                    {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={classInput + ' ' + className}>
                                    <div className="file_details">
                                        <img src={require('DefaultAssets/image/user-4.jpg')} alt="photo" className="photo" />
                                        <div className="ext_dtl">
                                            <div className="fl_info">
                                                <div className="title">demo.png</div>
                                                <div className="sub_tlt">178KB</div>
                                            </div>
                                            <div className="fl_utility">
                                                <span className="i_icon"><i className="moon-Cloud-Download" /></span>
                                                <span className="i_icon"><i className="moon-Delete" /></span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                {labelName && <Label className={`control-label ${classLabel}`} align={lableAlign}>{labelName}{required && <span className="text-danger">*</span>}</Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {labelName && <Label className={`control-label ${classLabel}`} align={lableAlign}>{labelName}{required && <span className="text-danger">*</span>}</Label>}
                                {(showLink == true && lnkUrl !== '') &&
                                    <Label className={`control-label col temp`} align={lnkPosition}>
                                        <a sethref="javascript:void(0)" onClick={() => this.downloadFile(lnkUrl, lnkLabel)}>{lnkLabel}</a>
                                    </Label>
                                }
                                <div className={classInput + ' ' + className}>
                                    <div className="file_details">
                                        <img src={require('DefaultAssets/image/user-4.jpg')} alt="photo" className="photo" />
                                        <div className="ext_dtl">
                                            <div className="fl_info">
                                                <div className="title">demo.png</div>
                                                <div className="sub_tlt">178KB</div>
                                            </div>
                                            <div className="fl_utility">
                                                <span className="i_icon"><i className="moon-Cloud-Download" /></span>
                                                <span className="i_icon"><i className="moon-Delete" /></span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </Fragment>

                    }

                    {/* <div className="col-md-4">
                        <div className="file_details">
                            <img src={require('DefaultAssets/image/user-4.jpg')} alt="photo" className="photo" />
                            <div className="ext_dtl">
                                <div className="fl_info">
                                    <div className="title">self-photo.jpg</div>
                                    <div className="sub_tlt">178KB</div>
                                </div>
                                <div className="fl_utility">
                                    <span className="i_icon"><i className="moon-Cloud-Download" /></span>
                                    <span className="i_icon"><i className="moon-Delete" /></span>
                                </div>
                            </div>
                        </div>
                    </div> */}
                    {/* {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={classInput + ' ' + className}>
                                    <Input
                                        {...(multiple === true && { multiple })}
                                        type="file"
                                        className={`cstm_icn_area`}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        name={(name !== undefined && name) ? name : 'textDatePickerInput'}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        accept={(type !== undefined && Array.isArray(type) && type.length > 0) ? type : '*.*'}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                    />
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                                {(showLink !== undefined && showLink == true && link !== undefined && link.url !== undefined) &&
                                    <Label className={`control-label col temp`} align={link.position}>
                                        <a sethref="javascript:void(0)" onClick={() => this.downloadFile(link.url, link.label.locale[defaultLng])}>{link.label.locale[defaultLng]}</a>
                                    </Label>}
                                <div className={classInput + ' ' + className}>
                                    <Input
                                        {...(multiple !== undefined && multiple === true && { multiple })}
                                        type="file"
                                        className={`cstm_icn_area upload-file-class`}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        name={(name !== undefined && name) ? name : 'textDatePickerInput'}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        accept={(type !== undefined && Array.isArray(type) && type.length > 0) ? type : '*.*'}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                    />
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                            </Fragment>
                    } */}
                </FormGroup>
            </Fragment>
        )
    }
}

export default FileDetails;