/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control file type1
 *
 * Initial all package and component required for this component
 * injectIntl : used for display label langauge wise.
 */
 import React, { Component, Fragment } from 'react';
 import { post } from 'axios';
 import { Label, FormGroup, Input, Button } from 'reactstrap';
//  import { injectIntl } from 'react-intl';
 // import IntlMessages from "Util/IntlMessages";
//  const { FileDetails, ModelDialog } = require('DefaultComponents/Widgets')
 import WebCamera, { FACING_MODES, IMAGE_TYPES } from 'react-html5-camera-photo';
 import 'react-html5-camera-photo/build/css/index.css';
//  const { swaggerPostAPI, swaggerGetAPI, redirectToLogin, getFileSizeToBase64String, getValueUsingKey, callNativeFunction, checkReactNativeWebView, convertBase64ToFile, getNotificationFunction, encodeQueryData } = require('DefaultHelpers');
//  import AppConfig from 'DefaultConstants/AppConfig';
 import Tooltip from '@material-ui/core/Tooltip';
 import ReactHtmlParser from "react-html-parser";
 import $ from 'jquery';
 import dot from 'dot-object';
 const Compress = require('compress.js')
 dot.override = true;
 
 /**
  * Start File Type1 class component
  * @state {*Object} reqData
  */
 
 class FileType1 extends Component {
     constructor(props) {
         super(props);
         this.state = {
             fileData: {},
             _openWebCamera: false,
             loader: false,
             isDelete: false
         }
         this.setValue = this.setValue.bind(this);
     }
 
     componentWillReceiveProps(nextProps) {
         const { optionsObj: { name = '', responseBindFrom = '', isShowFileDetails = false, isEnabledWebCam = false } = {}, reqData = {} } = nextProps;
         // console.log('componentWillReceiveProps :', reqData, name, responseBindFrom)
         if (!this.state.isDelete && name !== '' && responseBindFrom !== '' && Object.keys(reqData).length > 0 && reqData.hasOwnProperty(name) /* && typeof reqData[name] === 'object' */) {
             let fileData = dot.pick(responseBindFrom, reqData) !== undefined ? dot.pick(responseBindFrom, reqData) : dot.pick(name, reqData)
             if (fileData === undefined) {
                 fileData = {};
             }
             const { sizeLabel = '', size = '' } = fileData;
             // console.log('componentWillReceiveProps :', isShowFileDetails, isEnabledWebCam)
             if (isShowFileDetails && !isEnabledWebCam && sizeLabel === '' && size !== '' && typeof this.props.getFileSizeToBase64String === 'function') {
                 const sizeIn = 'kb';
                 fileData.sizeLabel = this.props.getFileSizeToBase64String(size, sizeIn, true) + sizeIn;
             }
             this.setState({ fileData: { [name]: fileData } })
         }
     }
 
     componentDidMount() {
         const { optionsObj: { name = '', responseBindFrom = '', isShowFileDetails = false, isEnabledWebCam = false } = {}, reqData = {} } = this.props;
         // console.log('componentDidMount :', reqData, name, responseBindFrom)
         if (name !== '' && responseBindFrom !== '' && Object.keys(reqData).length > 0 && reqData.hasOwnProperty(name) /* && typeof reqData[name] === 'object' */) {
             let fileData = dot.pick(responseBindFrom, reqData) !== undefined ? dot.pick(responseBindFrom, reqData) : dot.pick(name, reqData)
             if (fileData === undefined) {
                 fileData = {};
             }
             const { sizeLabel = '', size = '' } = fileData;
             // console.log('componentDidMount :', isShowFileDetails, isEnabledWebCam)
             if (isShowFileDetails && !isEnabledWebCam && sizeLabel === '' && size !== '' && typeof this.props.getFileSizeToBase64String === 'function') {
                 const sizeIn = 'kb';
                 fileData.sizeLabel = this.props.getFileSizeToBase64String(size, sizeIn, true) + sizeIn;
             }
             this.setState({ fileData: { [name]: fileData } })
         }
     }
 
     shouldComponentUpdate = (nextProps, nextState) => {
         if (this.props === nextProps && this.state === nextState) {
             return false;
         }
         return true;
     };
 
     /* compress event */
     convertToCompressFile = (e, compressObj = {}) => {
         const { size = 2, quality = 0.75, maxWidth = 1920, maxHeight = 1920, resize = true } = compressObj;
         const compress = new Compress();
         const files = [...e.target.files];
         const compressResponse = compress.compress(files, {
             size: size, // the max size in MB, defaults to 2MB
             quality: quality, // the quality of the image, max is 1,
             maxWidth: maxWidth, // the max width of the output image, defaults to 1920px
             maxHeight: maxHeight, // the max height of the output image, defaults to 1920px
             resize: resize, // defaults to true, set false if you do not want to resize the image width and height
         })
 
         return compressResponse;
     }
 
     /* on blur event */
     handleOnBlurEvent = (e) => {
         this.onBlurCallAPI(e);
     }
 
     /* on focus event */
     handleOnFocusEvent = (e) => {
         this.onFocusCallAPI(e);
     }
 
     /* on change event */
     handleOnChangeEvent = (e) => {
         let targetFile = e.target.files;
         const { optionsObj: { onChangeURL = '', isShowFileDetails = false, name: inputName = '', size, type: validFileType = [], isCompress: { enabled = false } = {}, isCompress = {} } = {} } = this.props;
         if (enabled) {
             const { [0]: { type: originalFileType = '' } = [] } = e.target.files;
             if (originalFileType !== '' && Array.isArray(validFileType) && validFileType.length > 0 && !validFileType.includes(originalFileType)) {
                 this.props.onChange(e.target.type, e.target.name, e.target.value, '', targetFile)
             } /* else if(Array.isArray(validFileType) && validFileType.length > 0 && validFileType.includes('application/pdf')) {
                 console.log('pdf enabled')
             }  */else {
                 this.setState({ loader: true })
                 let self = this;
                 const { optionsObj: { name: inputName = '' } = {} } = this.props;
                 this.convertToCompressFile(e, isCompress).then(function (compressResponse) {
                     const { [0]: { data: fileImage = '', alt: fileName = '', ext: fileType = '', prefix = '' } = [] } = compressResponse;
                     const sizeIn = 'kb';
                     const fileSize = (typeof this.props.getFileSizeToBase64String === 'function' ? this.props.getFileSizeToBase64String(fileImage, sizeIn) : '') + sizeIn;
                     const fileExtension = '.' + fileName.toString().split('.').pop();
                     let fileData = {
                         [inputName]: {
                             imageUrl: prefix + fileImage,
                             name: fileName,
                             size: typeof this.props.getFileSizeToBase64String === 'function' ? this.props.getFileSizeToBase64String(fileImage, sizeIn) : '',
                             sizeLabel: fileSize,
                             type: fileType,
                             fileExtension: fileExtension
                         }
                     }
                     self.setState({ fileData: fileData, _openWebCamera: false }, () => self.setValue('onFileUpload', JSON.stringify(fileData[inputName]), inputName));
                 });
             }
         } else {
             if (inputName !== '' && ['LEFTTHUMB', 'RIGHTTHUMB', 'LEFTINDEX', 'RIGHTINDEX'].indexOf(inputName) > -1) {
                 return false;
             }
             let startProcess = this.checkFileValidation(e, {});
             if (isShowFileDetails) {
                 const { [0]: { name: fileName = '', size: fileSize = '', type: fileType = '' } = {} } = targetFile;
                 const fileExtension = '.' + fileName.toString().split('.').pop();
                 let fileData = {};
                 const sizeIn = 'kb';
                 let reader = new FileReader();
                 if (startProcess) {
                     reader.onloadend = () => {
                         fileData = {
                             [inputName]: {
                                 imageUrl: reader.result,
                                 name: fileName,
                                 size: fileSize,
                                 sizeLabel: (typeof this.props.getFileSizeToBase64String === 'function' ? this.props.getFileSizeToBase64String(fileSize, sizeIn, true) : '') + sizeIn,
                                 type: fileType,
                                 fileExtension: fileExtension
                             }
                         }
                         this.setState({ fileData: fileData });
                     }
                     reader.readAsDataURL(targetFile[0]);
                 }
             } else {
                 this.setState({ fileData: {} });
             }
             if (startProcess) {
                 this.props.onChange(e.target.type, e.target.name, e.target.value, '', targetFile)
                 this.onChangeCallAPI(e);
             }
         }
     }
 
     /*Take Webcam Photo */
     handleTakePhoto = (fileImage) => {
         const { optionsObj: { onChangeURL = '', name: inputName = '', webConfig: { imageType = 'JPG' } = {} } = {} } = this.props;
         let _imageType = imageType.toLowerCase();
         const sizeIn = 'kb';
         const fileSize = (typeof this.props.getFileSizeToBase64String === 'function' ? this.props.getFileSizeToBase64String(fileImage, sizeIn) : '') + sizeIn;
         const fileName = inputName + '.' + _imageType;
         const fileType = 'image/' + _imageType;
         const filePath = `C:\fakepath\${fileName}`;
         let fileData = {
             [inputName]: {
                 imageUrl: fileImage,
                 name: fileName,
                 size: typeof this.props.getFileSizeToBase64String === 'function' ? this.props.getFileSizeToBase64String(fileImage, sizeIn) : '',
                 sizeLabel: fileSize,
                 type: fileType,
                 fileExtension: _imageType
             }
         }
         this.setState({ fileData: fileData, _openWebCamera: false }, () => this.setValue('onFileUpload', JSON.stringify(fileData[inputName]), inputName));
         /* const webCameraObj = {
             size: fileSize,
             name: fileName,
             type: fileType,
             value: fileImage,
             filePath: filePath,
             inputName: inputName
         }
         this.props.onChange('file_type1', inputName, webCameraObj)
         this.onChangeCallAPI('', webCameraObj); */
     }
 
     setValue(child_id, data, fileFieldName) {
         // console.log('setValue :', child_id, data, fileFieldName, JSON.parse(data))
         if (child_id === "onFileUpload" || child_id === "onVideoUpload") {
             try {
                 const { optionsObj: { isShowFileDetails = false } = {} } = this.props;
                 let resData = data.replace(/__@@__/g, '"');//(data);
                 resData = JSON.parse(/* JSON.stringify */(resData))
                 let { ext = "", filePath = "", inputName = "", name: fileName = "", size = 0, sizeLabel = 0, type = "", value = "", imageUrl = '', fileExtension = '' } = resData;
                 // alert("run onFileUpload" + '|' + inputName + '|' + ext + '|' + fileName + '|' + type)
                 value = value !== '' ? value : imageUrl;
                 inputName = inputName !== '' ? inputName : fileFieldName;
                 let fileData = [{
                     imageUrl: value,
                     name: fileName,
                     size: size,
                     sizeLabel: sizeLabel,
                     type: type,
                     fileExtension: ext !== '' ? ext : fileExtension
                 }]
 
                 if (isShowFileDetails) {
                     this.setState({ fileData: { [inputName]: fileData[0] } }/* , () => {
                         alert(JSON.stringify(this.state.fileData))
                     } */);
                 }
                 // console.log('fileData :', fileData, resData)
                 // this.props.onChange(this.props.optionsObj.type !== undefined ? this.props.optionsObj.type : 'text', inputName, data)
                 this.props.onChange('file', inputName, fileData, '', fileData, '', '', 1)
 
                 const { optionsObj: { onChangeURL = '', kycPath = '', kycResponseBindFrom = '' } = {}, assignResponseValue, reqData, savedObject } = this.props;
                 let returnObject = typeof this.props.convertBase64ToFile === 'function' ? this.props.convertBase64ToFile(value, inputName) : '';
                 // let formData = returnObject.formData;
                 let formData = new FormData();
                 // alert("run here 13"+kycPath)
                 if (kycPath !== '') {
                     let kycPathNew = kycPath;
                     // alert(kycResponseBindFrom)
                     // alert(JSON.stringify(savedObject))
                     if (kycResponseBindFrom !== '') {
                         kycPathNew = kycPathNew + dot.pick(kycResponseBindFrom, savedObject);//getValueUsingKey(responseBindFrom, savedObject)
                     }
                     // alert(kycPathNew)
                     formData.append('keyType', kycPathNew);
                 } else {
                     formData.append('kycField', inputName);
                 }
                 // console.log('returnObject :', fileData)
                 formData.append(kycPath !== '' ? 'files' : 'file', returnObject.blob, fileData[0].name);
                 // formData.append('files', webCameraObj, webCameraObj.name);
                 let targetFile = {
                     files: [{
                         name: fileName,
                         size: size,
                         sizeLabel: sizeLabel,
                         type: type,
                         fileExtension: ext
                     }]
                 }
                 this.uploadFile(formData, targetFile);
 
             } catch (e) {
                 alert("run onFileUpload E " + e.message)
                 if (typeof this.props.getNotificationFunction === 'function') {
                 this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
             }
            }
 
         } else if (child_id === "onGetFingerPrint1") {
 
             try {
                 // alert("data|" + data)
                 // alert("onGetFingerPrint||" + data)
                 let resData = data.replace(/__@@__/g, '"');//(data);
                 // alert("resData|" + resData)
                 resData = JSON.parse(resData);
                 const { value = '', inputName = '' } = resData;
                 // alert("inputName|" + inputName)
                 let fileData = [{
                     // imageUrl: value,
                     name: inputName,
                     size: size,
                     sizeLabel: sizeLabel,
                     type: type,
                     // fileExtension: ''
                 }]
 
                 this.props.onChange('file', inputName, fileData, '', fileData, '', '', 1)
                 // this.uploadFileFromNative(sentObject);
                 const { optionsObj: { onChangeURL = '', kycPath = '', responseBindFrom = '' } = {}, savedObject } = this.props;
                 let formData = typeof this.props.convertBase64ToFile === 'function' ? this.props.convertBase64ToFile(value, inputName) : ''
                 // alert("run here 13")
                 if (kycPath !== '') {
                     let kycPathNew = kycPath;
                     if (responseBindFrom !== '') {
                         kycPathNew = kycPathNew + dot.pick(responseBindFrom, savedObject);//getValueUsingKey(responseBindFrom, savedObject)
                     }
                     formData.append('keyType', kycPathNew);
                 } else {
                     formData.append('kycField', inputName);
                 }
                 formData.append(kycPath !== '' ? 'files' : 'file', blob);
                 let targetFile = {
                     files: [{
                         name: inputName,
                         type: ''
                     }]
                 }
                 this.uploadFile(formData, targetFile, inputName);
 
             } catch (e) {
                 alert("run onGetFingerPrint E " + e.message)
                 NotificationManager.error(this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
             }
 
         }
     }
 
     toggleWebCamera = () => {
         this.setState({ _openWebCamera: !this.state._openWebCamera });
     }
 
     openWebCamera = () => {
         this.setState({ _openWebCamera: true });
     }
 
     closeWebCamera = () => {
         this.setState({ _openWebCamera: false });
     }
 
     handleCameraError = (error) => {
         NotificationManager.error(error)
     }
 
     handleTakePhotoAnimationDone = (dataUri) => {
         console.log('takePhoto');
         setDataUri(dataUri);
     }
 
     handleCameraStart = (stream) => {
         console.log('handleCameraStart :', stream);
     }
 
     handleCameraStop = () => {
         console.log('handleCameraStop');
     }
 
     onBlurCallAPI = async (e) => {
 
         const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {}, assignResponseValue, name } = this.props;
         if (onBlurURL !== '') {
 
             let response = '';
             let inputName = e.target.name;
             let inputValue = e.target.value;
 
             if (blurMethod !== '' && blurMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                 let data = {
                     [inputName]: inputValue
                 }
                 response = await this.props.swaggerPostAPI(onBlurURL, data, true);
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(inputName, `error.message.${response.errCode}`)
                 }
                 // to do handle response of post method
             } else if(typeof this.props.swaggerGetAPI === 'function'){
                 response = await this.props.swaggerGetAPI(onBlurURL, {}, true);
                 // response = { responseCode: 0, data: { billAmount: 1000 } }
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                     }
                 }
             }
 
         }
     }
 
     onFocusCallAPI = async (e) => {
 
         const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue } = this.props;
         if (onFocusURL !== '') {
 
             let data = {
                 [e.target.name]: e.target.value
             }
             let response = '';
 
             if (focusMethod !== '' && focusMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                 response = await this.props.swaggerPostAPI(onFocusURL, data, true);
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(e.target.name, `error.message.${response.errCode}`)
                 }
                 // to do handle response of post method
             } else if(typeof this.props.swaggerGetAPI === 'function') {
                 response = await this.props.swaggerGetAPI(onFocusURL, data, true);
                 // response = { responseCode: 0, data: { billAmount: 1000 } }
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(e.target.name, `error.message.${response.errCode}`)
                 }
             }
 
         }
 
     }
 
     async onChangeCallAPI(e, webCameraObj = {}) {
         const { optionsObj: { onChangeURL = '', type = '', name: inputName = '', id = '', kycPath = '', kycResponseBindFrom = '' } = {}, assignResponseValue, reqData, savedObject } = this.props;
         const { size: webCamSize = '', name: webCamName = '', type: webCamType = '', /* inputName = '', */ filePath = '' } = webCameraObj;
         // console.log('onChangeURL :', onChangeURL)
         if (onChangeURL !== '') {
             const { defaultLng, optionsObj: { size, type, name = '', checkHeader: { enable: enabled = false, columns = [], rowCount = 0, rowCountErrorMessage: { locale: { [this.props.defaultLng]: errorRows = '' } = {} } = {}, columnRegex = [] } = {} } = {} } = this.props;
             let targetFile = Object.keys(webCameraObj).length > 0 ? {} : e.target;
             let dynamicKeyValue = 'frm_file_' + (name !== '' ? name : 'textFileInput');
             let fieldId = name !== '' ? name : dynamicKeyValue + "id";
             let startProcess = this.checkFileValidation(e, webCameraObj);
 
             const formData = new FormData();
             if (kycPath !== '') {
                 let kycPathNew = kycPath;
                 // console.log("kycResponseBindFrom", kycResponseBindFrom, savedObject)
                 if (kycResponseBindFrom !== '') {
                     kycPathNew = kycPathNew + dot.pick(kycResponseBindFrom, savedObject);//getValueUsingKey(kycResponseBindFrom, savedObject)
                 }
                 // console.log('kycPathNew :', kycPathNew, savedObject)
                 formData.append('keyType', kycPathNew);
             } else {
                 formData.append('kycField', inputName);
             }
             // console.log('file data :', targetFile.files[0], webCameraObj)
             formData.append(kycPath !== '' ? 'files' : 'file', Object.keys(webCameraObj).length > 0 ? webCameraObj : targetFile.files[0]);
 
             if (startProcess) {
                 if (enabled) {
                     try {
                         let reader = new FileReader();
                         reader.onloadend = () => {
                             const parseData = PapaParse.parse(reader.result, PapaParse.ParseConfig);
                             let { data: { [0]: fileHeaders = [] } = {}, data } = parseData;
                             if (Array.isArray(fileHeaders) && fileHeaders.length === columns.length) {
                                 let fieldCount = 0;
                                 columns.map((value, index) => {
                                     if (fileHeaders[index] !== undefined && value.toLowerCase() === fileHeaders[index].toLowerCase()) {
                                         fieldCount++;
                                     }
                                 });
 
                                 if (fieldCount === columns.length) {
                                     if (data.length > 1 && data.length <= parseFloat(rowCount)) {
 
                                         let emptyFields = false, skipValidation = false;
                                         data.map((value, mainIndex) => {
                                             if (mainIndex === 0 || (mainIndex + 1 === data.length && data[mainIndex].length === 1)) {
                                                 return false;
                                             }
                                             columns.map((column, index) => {
                                                 const { [index]: { regex = '', message: { locale: { [defaultLng]: errorMessage = '' } = {} } = {} } = {} } = columnRegex;
                                                 if (value.length === columns.length && value[index] !== undefined && value[index].trim() !== '' && value[index].trim() !== null) {
                                                     if (regex !== '' && !validator.matches(value[index], regex) && !skipValidation && errorMessage !== '') {
                                                         NotificationManager.error(errorMessage);
                                                         emptyFields = true;
                                                         skipValidation = true;
                                                     } else if (regex !== '' && !validator.matches(value[index], regex) && !skipValidation && errorMessage === '') {
                                                         skipValidation = true;
                                                     }
                                                 } else {
                                                     emptyFields = true;
                                                 }
                                             })
                                         });
 
                                         if (emptyFields) {
                                             $("#" + fieldId).val('');
                                             this.props.onChange('file_type1', inputName, {})
                                             if (!skipValidation)
                                                 NotificationManager.error(this.props.intl.formatMessage({ id: 'validationError.csvFieldEmpty' }));
                                         } else {
                                             // let fileType = targetFiles[0].type;
                                             this.uploadFile(formData, targetFile);
                                         }
 
                                     } else {
                                         $("#" + fieldId).val('');
                                         this.props.onChange('file_type1', inputName, {})
                                         NotificationManager.error(errorRows);
                                     }
                                 } else {
                                     $("#" + fieldId).val('');
                                     this.props.onChange('file_type1', inputName, {})
                                     NotificationManager.error(this.props.intl.formatMessage({ id: "validationError.csvFileUploadError" }));
                                 }
                             } else {
                                 $("#" + fieldId).val('');
                                 this.props.onChange('file_type1', inputName, {})
                                 NotificationManager.error(this.props.intl.formatMessage({ id: "validationError.csvFileUploadError" }));
                             }
 
                         }
                         reader.readAsText(targetFile.files[0]);
 
                     } catch (e) {
                         this.props.onChange('file_type1', inputName, {})
                         NotificationManager.error(this.props.intl.formatMessage({ id: "message.pleaseTryAfterSometime" }));
                     }
 
                 } else {
                     this.uploadFile(formData, Object.keys(webCameraObj).length > 0 ? webCameraObj : targetFile);
                 }
             } else {
                 $("#" + fieldId).val('');
                 this.props.onChange('file_type1', inputName, {})
                 this.setState({ fileData: {} });
                 NotificationManager.error(this.props.intl.formatMessage({ id: "validationError.invalidFileType" }));
             }
         }
     }
 
     deleteFile = () => {
         const { optionsObj: { name = '' } = {}, assignResponseValue } = this.props;
         this.setState({ fileData: { [name]: {} }, isDelete: true }, () => assignResponseValue(name, '', '', true));
         /* if (typeof assignResponseValue === 'function') {
             assignResponseValue(name, '', '', true)
         } */
     }
 
     downloadFile = () => {
         const { optionsObj: { name: inputName = '' } = {} } = this.props;
         const { [inputName]: { imageUrl = '', name = '' } = {} } = this.state.fileData;
         if (imageUrl !== '') {
             const { reqData: { [inputName]: { imageUrl = '', name = '' } = {} } = {} } = this.props;
             if (typeof this.props.checkReactNativeWebView === 'function' && this.props.checkReactNativeWebView() && typeof this.props.callNativeFunction === 'function') {
                 // alert("name|" + name +"|"+inputName)
                 this.props.callNativeFunction("onDownloadFile", { based64String: imageUrl, name });
             } else {
                 const downloadLink = document.createElement("a");
                 downloadLink.href = imageUrl.trim();
                 downloadLink.download = name;
                 downloadLink.click();
             }
         }
     }
 
     checkFileValidation = (e, webCameraObj = {}) => {
         const { optionsObj: { size, type, name = '', checkHeader: { enable: enabled = false, columns = [], rowCount = 0, rowCountErrorMessage: { locale: { [this.props.defaultLng]: errorRows = '' } = {} } = {}, columnRegex = [] } = {} } = {} } = this.props;
         const { size: webCamSize = '', name: webCamName = '', type: webCamType = '', inputName = '', filePath = '' } = webCameraObj;
         let targetFile = Object.keys(webCameraObj).length > 0 ? {} : e.target;
         let fileType = webCamType !== '' ? webCamType : targetFile.files[0].type;
         // console.log("targetFile.files[0]", targetFile.files[0])
         let fileSize = webCamSize !== '' ? webCamSize : targetFile.files[0].size;
         let targetFiles = targetFile.files !== undefined ? targetFile.files : [];
         let fileTypeExtension = '.' + (webCamName !== '' ? webCamName.toString().split('.').pop() : targetFile.files[0].name.toString().split('.').pop());// targetFiles[0].type;
         let validType = type !== '' ? type : [];
         let dynamicKeyValue = 'frm_file_' + (name !== '' ? name : 'textFileInput');
         let fieldId = name !== '' ? name : dynamicKeyValue + "id";
         // console.log("webCamSize", size, targetFile.files[0])
         if (Object.keys(webCameraObj).length > 0) {
             return true;
         } else {
             if (fileType !== '' && Array.isArray(validType) && validType.length > 0 && !validType.includes(fileType)) {
                 $("#" + fieldId).val('');
                 // this.props.onChange('file_type1', inputName, {})
                 this.props.onChange(e.target.type, e.target.name, e.target.value, '', targetFiles)
                 return false;
             } else if (fileType === '' && !validType.includes(fileTypeExtension)) {
                 $("#" + fieldId).val('');
                 // this.props.onChange('file_type1', inputName, {})
                 this.props.onChange(e.target.type, e.target.name, e.target.value, '', targetFiles)
                 return false;
             } else if (size !== undefined && size !== '' && parseFloat(fileSize) > parseFloat(size)) {
                 $("#" + fieldId).val('');
                 this.props.onChange(e.target.type, e.target.name, e.target.value, '', targetFiles)
                 // this.props.onChange('file_type1', inputName, {})
                 return false;
             } else {
                 return true;
             }
         }
     }
 
     // function for file upload into server and get id from response and set into request Object
     uploadFile = async (formData, targetFile, inputFieldName = '') => {
         this.setState({ loader: true });
         const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '', name: inputName = '', validateImage = {} } = {}, assignResponseValue ,
         AppConfig: { nodeAPIUrl = {}, authorizationToken : AuthorizationToken = {} } = {} 
        } = this.props;
 
         let response = '';
         const loaderTime = 200;
         const url = nodeAPIUrl + onChangeURL;
         let authorizationToken = localStorage.getItem('front_authorize_token');
         const selfProcessStart = sessionStorage.getItem('selfProcessStart') !== undefined ? sessionStorage.getItem('selfProcessStart') : '';
         if (selfProcessStart !== '' && selfProcessStart == 1) {
             authorizationToken = sessionStorage.getItem('front_temp_authorize_token');
         }
         const config = {
             headers: {
                 'content-type': 'multipart/form-data', // 'application/x-www-form-urlencoded'
                 'authorization': AuthorizationToken + authorizationToken
                 // get token from local storage
             }
         }
 
         if (changeMethod !== '' && changeMethod === 'POST') {
             var self = this;
             // alert("call api")
             // response = await swaggerPostAPI(onChangeURL, formData, 99); // pass 99 for add content type extra for file
             try {
                 post(url, formData, config).then((apiResponse) => {
                     const { data: response = {} } = apiResponse;
                     // alert("call api||" + JSON.stringify(apiResponse))
 
                     // response = { responseCode: 0, data: { fileUniqueId: "abc" + (Math.random()) } }
                     if (apiResponse !== undefined && apiResponse.status === 401 && typeof this.props.redirectToLogin === 'function') {
                         this.props.redirectToLogin();
                     } else if (response.responseCode === 0) {
                         let bindData = '';
                         if (changeResponseField !== '') {
                             bindData = dot.pick(changeResponseField, response);
                         } else {
                             bindData = dot.pick('data.fileUniqueId', response);
                         }
 
                         const { files: { [0]: { name = '' } = {} } = {} } = targetFile;
                         if (name !== '') {
                             let extension = name.toString().split('.').pop();
                             bindData = bindData + '.' + extension;
                         }
 
                         self.checkImageValidation(validateImage, response, assignResponseValue, bindData, function (isSuccess) {
                             if (typeof assignResponseValue === 'function' && isSuccess) {
                                 if (changeBindIn !== '')
                                     assignResponseValue(changeBindIn, bindData, 'fileUniqueId'); // first argument field and second response value
                                 else
                                     assignResponseValue(inputFieldName !== '' ? inputFieldName : inputName !== '' ? inputName : 'textDatePickerInput', bindData, 'fileUniqueId');
                                 // self.props.onChange(targetFile.type, name !== '' ? name : 'textDatePickerInput', targetFile.value, '', targetFile.files, '', '', response.data.fileUniqueId)
                             } else if (!isSuccess) {
                                 assignResponseValue(inputFieldName !== '' ? inputFieldName : inputName, '', '', true);
                                 self.setState({ fileData: {} });
                                 // self.props.onChange('file_type1', inputName, {});
                             }
 
                             setTimeout(() => {
                                 self.setState({ loader: false });
                             }, loaderTime);
 
                         });
 
                     } else if (response.responseCode === 1) {
                         self.setState({ fileData: {} });
                         self.props.onChange('file_type1', inputFieldName !== '' ? inputFieldName : inputName, {})
                         if (changeBindIn === '')
                             self.props.onChange(targetFile.type, inputFieldName !== '' ? inputFieldName : inputName !== '' ? inputName : 'textDatePickerInput', targetFile.value, '', '')
                         self.props.onError(inputFieldName !== '' ? inputFieldName : inputName !== '' ? inputName : 'textDatePickerInput', `error.message.${response.errCode}`)
 
                         setTimeout(() => {
                             self.setState({ loader: false });
                         }, loaderTime);
                     }
                 })
             } catch (e) {
 
                 setTimeout(() => {
                     self.setState({ loader: false });
                 }, loaderTime);
 
                 self.setState({ fileData: {} });
                 alert("run onFileUpload Eupload " + e.message)
                 // NotificationManager.error(this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
             }
             // to do handle response of post method
         } else if(typeof this.props.swaggerGetAPI === 'function'){
             response = await this.props.swaggerGetAPI(onChangeURL, data, true);
             // response = { responseCode: 0, data: { billAmount: 1000 } }
             if (response.responseCode === 0) {
                 if (typeof assignResponseValue === 'function') {
                     assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                 }
             } else if (response.responseCode === 1) {
                 this.setState({ fileData: {} });
                 this.props.onError(e.target.name, `error.message.${response.errCode}`)
             }
             setTimeout(() => {
                 this.setState({ loader: false });
             }, loaderTime);
         }
     }
 
     componentWillUnmount() {
         this.setState({ fileData: {} })
     }
 
     onClickEvent = (e) => {
         // e.preventDefault();
         return false;
 
         /* const { optionsObj: { isShowFileDetails = false, name: inputName = '', size, type } = {} } = this.props;
         if (inputName !== '' && ['LEFTTHUMB', 'RIGHTTHUMB', 'LEFTINDEX', 'RIGHTINDEX'].indexOf(inputName) > -1 && callNativeFunction("onGetFingerPrint", { "formatType": "BMPBase64", inputName })) {
             return false;
         } else if (inputName !== '' && ['APPLICANT_PHOTO'].indexOf(inputName) > -1 && callNativeFunction("onVideoUpload", { size, type, inputName })) { // onTakeVideo
             return false;
         } else if (inputName !== '' && callNativeFunction("onFileUpload", { size, type, inputName })) {
             return false;
         } */
     }
 
     checkImageValidation = async (validateImage, response, assignResponseValue, fileId, callback) => {
 
         let { enabled = false, request = [], apiMethod = '', apiUrl = '', changeBindIn = '', changeResponseField = '' } = validateImage;
         if (enabled && apiUrl !== '') {
 
             let { reqData = {}, savedObject = {} } = this.props;
             let apiRequest = { data: {} };
             Array.isArray(request) && request.map((item) => {
                 const { key = '', value = '', isFromResponse = false } = item;
                 if (key !== '' && key === 'fileUniqueId') {
                     apiRequest.data[key] = fileId;
                 } else if (key !== '' && key === 'userIdentifier') {
                     if (localStorage.getItem('user') !== null && localStorage.getItem('user') !== undefined)
                         apiRequest.data[key] = localStorage.getItem('user');
                     else if (sessionStorage.getItem('user') !== null && sessionStorage.getItem('user') !== undefined)
                         apiRequest.data[key] = sessionStorage.getItem('user');
                 } else if (key !== '' && typeof this.props.getValueUsingKey === 'function') {
                     if (isFromResponse) {
                         apiRequest.data[key] = this.props.getValueUsingKey(value, response);
                     } else {
                         apiRequest.data[key] = this.props.getValueUsingKey(value, { ...savedObject, ...reqData });
                     }
                 } else {
                     apiRequest.data[key] = '';
                 }
             });
 
             let resData = {};
             if (apiMethod !== '' && apiMethod.toString().toLowerCase() === 'post' && typeof this.props.swaggerPostAPI === 'function') {
                 resData = await this.props.swaggerPostAPI(apiUrl, apiRequest, true);
             } else if(typeof this.props.swaggerGetAPI === 'function'){
                 if (apiUrl.toString().indexOf("?") && typeof this.props.encodeQueryData === 'function') {
                     apiUrl = apiUrl + '&' + this.props.encodeQueryData(apiRequest.data);
                 } else if(typeof this.props.encodeQueryData === 'function'){
                     apiUrl = apiUrl + '?' + this.props.encodeQueryData(apiRequest.data);
                 }
                 resData = await this.props.swaggerGetAPI(apiUrl, apiRequest, true);
             }
 
             const { responseCode = 1, errCode = '' } = resData;
             if (responseCode === 0) {
                 if (changeBindIn !== '' && changeResponseField !== '' && typeof this.props.getValueUsingKey === 'function') {
                     setTimeout(() => {
                         assignResponseValue(changeBindIn, this.props.getValueUsingKey(changeResponseField, resData));
                     }, 1000);
                 }
                 callback(true);
             } else if (typeof this.props.getNotificationFunction === 'function')  {
                 this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: `error.message.${errCode}` }));
                 callback(false);
             }
 
         } else {
             callback(!enabled);
         }
     }
 
     render() {
         const { errorMsg, defaultLng, optionsObj = {}, reqData = {}, intl ,ModelDialog} = this.props;
         let {
             id = 'file_upload_',
             key = '',
             className = '',
             label: { locale: { [defaultLng]: labelTitle = '' } = {} } = {},
             name = '',
             type = '',
             defaultValue = '',
             required = false,
             isDisabled = false,
             multiple = false,
             onBlurURL = '',
             onFocusURL = '',
             onChangeURL = '',
             showLink = false,
             labelAlignment = 'top-left',
             icon = '',
             iconPosition = 'right',
             link: {
                 url: lnkUrl = '',
                 position: lnkPosition = 'right',
                 label: { locale: { [defaultLng]: lnkLabel = '' } = {} } = {}
             } = {},
             isMerge: {
                 enabled: isShowMerge = false,
                 icon: icon1 = '',
                 orTitle: { locale: { [defaultLng]: orLabel = '' } = {} } = {},
                 placeholder: { locale: { [defaultLng]: placeHolderLabel1 = '' } = {} } = {},
                 isEnabledWebCam: mergeWebCam = false
             } = {},
             helpText: { locale: { [defaultLng]: fNote = '' } = {} } = {},
             placeholder: { locale: { [defaultLng]: placeHolderLabel = '' } = {} } = {},
             isShowFileDetails = false,
             isEnabledWebCam = false,
             extraClass = '',
             fileImage: {
                 enabled: fileImageEnabled = false,
                 base64Image: defaultFileImage = '',
                 // route = ''
             } = {},
             webConfig: {
                 className: webCampClassName = 'mdl_card_photo',
                 idealResolution = { width: 700, height: 500 },
                 imageType = 'JPG',
                 isImageMirror = false,
                 isMaxResolution = false,
                 isSilentMode = false,
                 imageCompression = 1,
                 isDisplayStartCameraError = true,
                 isFullscreen = false,
                 sizeFactor = 1,
                 idealFacingMode = "FACING_MODES.ENVIRONMENT"
             } = {},
             tooltip: {
                 enabled: showTooltip = false,
                 locale: { [defaultLng]: tooltipContent = '' } = {}
             } = {}
         } = optionsObj;
         // console.log('webConfig :', idealResolution)
         let { fileData = {}, _openWebCamera, loader } = this.state;
         // console.log('file render :', this.props, this.state)
         // console.log('file render fileData:', fileData, name, defaultValue)
         let { [name]: { imageUrl: fileImage = '', name: fileName = '', sizeLabel: fileSize = '', type: fileType = '', fileExtension = '' } = {}, [name]: fileDataObj = {} } = fileData;
         // if(fileImageEnabled || true) {
         if (fileImageEnabled) {
             let newFileImage = defaultFileImage !== '' ? defaultFileImage : require('./image/Card_back.png');
             fileImage = fileImage !== '' ? fileImage : newFileImage;
         }
 
         // placeHolderLabel = Object.keys(placeHolder).length > 0 ? placeHolderLabel : placeHolder;
         // placeHolderLabel1 = Object.keys(isMerge.placeHolder).length > 0 ? placeHolderLabel1 : isMerge.placeHolder;
         let dynamicKey = 'frm_file_' + (name !== undefined ? name : 'textFileInput');
         let labelString = labelAlignment !== '' ? labelAlignment.toString().toLowerCase() : '';
         let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
         let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
         let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
         let utilityObj = {};
         if (!isDisabled) {
             utilityObj = {
                 download: { enabled: true, icon: 'moon-Cloud-Download', downloadFile: () => this.downloadFile() },
                 delete: { enabled: true, icon: 'moon-Delete', deleteFile: () => this.deleteFile() },
                 // icon : 'moon-info'
             }
         }
 
         let fingerObjects = ['LEFTTHUMB', 'RIGHTTHUMB', 'LEFTINDEX', 'RIGHTINDEX'];
 
         return (
             <Fragment>
                 <FormGroup className="row" key={dynamicKey}>
                     {fingerObjects.indexOf(name) > -1 ?
                         <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                             <div className="file_type1" onClick={isDisabled ? () => ({}) : ((e) => this.onClickEvent(e))}>
                                 {labelTitle !== '' && <Label className={`control-label ${classLabel}`} align={lableAlign}>{labelTitle}{required && <span className="text-danger">*</span>}{showTooltip && <Tooltip id="tooltip-icon" title={ReactHtmlParser(tooltipContent)} disableFocusListener={true}><i className="zmdi zmdi-info zmdi-hc-lg fs-lg float-right" /></Tooltip>}</Label>}
                                 <Label className="inner_area" key={`tp_key_${name !== '' ? name : dynamicKey}`} htmlFor={`tp_${name !== '' ? name : dynamicKey}`} onClick={isEnabledWebCam ? () => this.openWebCamera() : () => ({})}>
                                     {placeHolderLabel}
                                     {icon !== '' && <span className="icon"><i className={icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                 </Label>
                             </div>
                         </div>
                         :
                         labelString === 'right'
                             ?
                             <Fragment>
                                 <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                     <div hidden id="handleFile"></div>
                                     <div className="col-12 mb_file_img">
                                         <img src={fileImage} alt={name} />
                                     </div>
                                     <div className="file_type1">
                                         {loader && <div className="fl_loader"><i className="fa fa-spinner fa-spin" />{intl.formatMessage({ id: 'constant.loading' })}</div>}
                                         {
                                             isShowMerge
                                                 ?
                                                 <div className="merge_area">
                                                     <div className="merge_brd">
                                                         <div className="or">{orLabel}</div>
                                                         <Label className="item" key={`mfu_key_${name !== '' ? name : dynamicKey}`} htmlFor={`mfu_${name !== '' ? name : dynamicKey}`} onClick={isEnabledWebCam ? () => this.openWebCamera() : () => ({})}>
                                                             {placeHolderLabel}
                                                             {icon !== '' && <span className="icon"><i className={icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                                             {!isEnabledWebCam && <Input
                                                                 {...(multiple === true && { multiple })}
                                                                 type="file"
                                                                 className={className}
                                                                 key={`mfu_key_${name !== '' ? name : dynamicKey}`}
                                                                 id={`mfu_${name !== '' ? name : dynamicKey}`}
                                                                 name={name !== '' ? name : 'mk_fle_uld'}
                                                                 disabled={isDisabled ? isDisabled : false}
                                                                 required={required ? required : false}
                                                                 accept={(type !== "" && Array.isArray(type) && type.length > 0) ? type : '*.*'}
                                                                 onBlur={onBlurURL ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                                 onFocus={onFocusURL ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                                 onChange={isDisabled ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                             />}
                                                         </Label>
                                                         <Label className="item" key={`tp_key_${name !== '' ? name : dynamicKey}`} htmlFor={`tp_${name !== '' ? name : dynamicKey}`} onClick={mergeWebCam ? () => this.openWebCamera() : () => ({})}>
                                                             {placeHolderLabel1}
                                                             {icon1 !== '' && <span className="icon"><i className={icon1}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                                             {!mergeWebCam && <Input
                                                                 {...(multiple === true && { multiple })}
                                                                 type="file"
                                                                 className={className}
                                                                 key={`tp_key_${name !== '' ? name : dynamicKey}`}
                                                                 id={`tp_${name !== '' ? name : dynamicKey}`}
                                                                 name={name !== '' ? name : 'tk_pht'}
                                                                 disabled={isDisabled ? isDisabled : false}
                                                                 required={required ? required : false}
                                                                 accept={(type !== "" && Array.isArray(type) && type.length > 0) ? type : '*.*'}
                                                                 onBlur={onBlurURL ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                                 onFocus={onFocusURL ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                                 onChange={isDisabled ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                             />}
                                                         </Label>
                                                     </div>
                                                 </div>
                                                 :
                                                 <Label className="inner_area" key={`tp_key_${name !== '' ? name : dynamicKey}`} htmlFor={`tp_${name !== '' ? name : dynamicKey}`} onClick={isEnabledWebCam ? () => this.openWebCamera() : () => ({})}>
                                                     {placeHolderLabel}
                                                     {icon !== '' && <span className="icon"><i className={icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                                     {!isEnabledWebCam && <Input
                                                         {...(multiple === true && { multiple })}
                                                         type="file"
                                                         className={className}
                                                         key={`tp_key_${name !== '' ? name : dynamicKey}`}
                                                         id={`tp_${name !== '' ? name : dynamicKey}`}
                                                         name={name !== '' ? name : 'tk_pht'}
                                                         disabled={isDisabled ? isDisabled : false}
                                                         required={required ? required : false}
                                                         accept={(type !== "" && Array.isArray(type) && type.length > 0) ? type : '*.*'}
                                                         onBlur={onBlurURL ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                         onFocus={onFocusURL ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                         onChange={isDisabled ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                     />}
                                                 </Label>
                                         }
                                     </div>
                                     {fNote && <div className="note_txt">{fNote}</div>}
                                     {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                 </div>
                                 {labelTitle !== '' && <Label className={`control-label ${classLabel}`} align={lableAlign}>{labelTitle}{required && <span className="text-danger">*</span>}{showTooltip && <Tooltip id="tooltip-icon" title={ReactHtmlParser(tooltipContent)} disableFocusListener={true}><i className="zmdi zmdi-info zmdi-hc-lg fs-lg float-right" /></Tooltip>}</Label>}
                             </Fragment>
                             :
                             <Fragment>
                                 {labelTitle !== '' && <Label className={`control-label ${classLabel}`} align={lableAlign}>{labelTitle}{required && <span className="text-danger">*</span>}{showTooltip && <Tooltip id="tooltip-icon" title={ReactHtmlParser(tooltipContent)} disableFocusListener={true}><i className="zmdi zmdi-info zmdi-hc-lg fs-lg float-right" /></Tooltip>}</Label>}
                                 {(showLink == true && lnkUrl !== '') &&
                                     <Label className={`control-label col temp`} align={lnkPosition}>
                                         <a sethref="javascript:void(0)" onClick={() => this.downloadFile(lnkUrl, lnkLabel)}>{lnkLabel}</a>
                                     </Label>
                                 }
                                 <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                     <div className="mb_file_img">
                                         <img src={fileImage} alt={name} />
                                     </div>
                                     <div className="file_type1">
                                         {loader && <div className="fl_loader"><i className="fa fa-spinner fa-spin" />{intl.formatMessage({ id: 'constant.loading' })}</div>}
                                         {
                                             isShowMerge
                                                 ?
                                                 <div className="merge_area">
                                                     <div className="merge_brd">
                                                         <div className="or">{orLabel}</div>
                                                         <Label className="item" key={`mfu_key_${name !== '' ? name : dynamicKey}`} htmlFor={`mfu_${name !== '' ? name : dynamicKey}`} onClick={isEnabledWebCam ? () => this.openWebCamera() : () => ({})}>
                                                             {placeHolderLabel}
                                                             {icon !== '' && <span className="icon"><i className={icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                                             {!isEnabledWebCam && <Input
                                                                 {...(multiple === true && { multiple })}
                                                                 type="file"
                                                                 className={className}
                                                                 key={`mfu_key_${name !== '' ? name : dynamicKey}`}
                                                                 id={`mfu_${name !== '' ? name : dynamicKey}`}
                                                                 name={name !== '' ? name : 'mk_fle_uld'}
                                                                 disabled={isDisabled ? isDisabled : false}
                                                                 required={required ? required : false}
                                                                 accept={(type !== "" && Array.isArray(type) && type.length > 0) ? type : '*.*'}
                                                                 onBlur={onBlurURL ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                                 onFocus={onFocusURL ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                                 onChange={isDisabled ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                             /* onClick={isDisabled ? () => ({}) : ((e) => this.onClickEvent(e))} */
                                                             />}
                                                         </Label>
                                                         <Label className="item" key={`tp_key_${name !== '' ? name : dynamicKey}`} htmlFor={`tp_${name !== '' ? name : dynamicKey}`} onClick={mergeWebCam ? () => this.openWebCamera() : () => ({})}>
                                                             {placeHolderLabel1}
                                                             {icon1 !== '' && <span className="icon"><i className={icon1}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                                             {!mergeWebCam && <Input
                                                                 {...(multiple === true && { multiple })}
                                                                 type="file"
                                                                 className={className}
                                                                 key={`tp_key_${name !== '' ? name : dynamicKey}`}
                                                                 id={`tp_${name !== '' ? name : dynamicKey}`}
                                                                 name={name !== '' ? name : 'tk_pht'}
                                                                 disabled={isDisabled ? isDisabled : false}
                                                                 required={required ? required : false}
                                                                 accept={(type !== "" && Array.isArray(type) && type.length > 0) ? type : '*.*'}
                                                                 onBlur={onBlurURL ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                                 onFocus={onFocusURL ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                                 onChange={isDisabled ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                             /* onClick={isDisabled ? () => ({}) : ((e) => this.onClickEvent(e))} */
                                                             />}
                                                         </Label>
                                                     </div>
                                                 </div>
                                                 :
                                                 <div>
                                                     {<Label className="inner_area" key={`tp_key_${name !== '' ? name : dynamicKey}`} htmlFor={`tp_${name !== '' ? name : dynamicKey}`} onClick={isEnabledWebCam ? () => this.openWebCamera() : () => ({})}>
                                                         {placeHolderLabel}
                                                         {icon !== '' && <span className="icon"><i className={icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                                         {!isEnabledWebCam && <Input
                                                             {...(multiple === true && { multiple })}
                                                             type="file"
                                                             className={className}
                                                             key={`tp_key_${name !== '' ? name : dynamicKey}`}
                                                             id={`tp_${name !== '' ? name : dynamicKey}`}
                                                             name={name !== '' ? name : 'tk_pht'}
                                                             disabled={isDisabled ? isDisabled : false}
                                                             required={required ? required : false}
                                                             accept={(type !== "" && Array.isArray(type) && type.length > 0) ? type : '*.*'}
                                                             onBlur={onBlurURL ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                             onFocus={onFocusURL ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                             onChange={isDisabled ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                         /* onClick={isDisabled ? () => ({}) : ((e) => this.onClickEvent(e))} */
                                                         />}
                                                     </Label>}
                                                     {/* checkReactNativeWebView() && <Input
                                                         {...(multiple === true && { multiple })}
                                                         type="file"
                                                         className={className}
                                                         key={`tp_key_${name !== '' ? name : dynamicKey}`}
                                                         id={`tp_${name !== '' ? name : dynamicKey}`}
                                                         name={name !== '' ? name : 'tk_pht'}
                                                         disabled={isDisabled ? isDisabled : false}
                                                         required={required ? required : false}
                                                         accept={(type !== "" && Array.isArray(type) && type.length > 0) ? type : '*.*'}
                                                         onBlur={onBlurURL ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                         onFocus={onFocusURL ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                         onChange={isDisabled ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                         onClick={isDisabled ? () => ({}) : ((e) => this.onClickEvent(e))}
                                                     /> */}
                                                 </div>
                                         }
                                     </div>
                                     {fNote && <div className="note_txt">{fNote}</div>}
                                     {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                 </div>
                             </Fragment>
                     }
                     {_openWebCamera &&
                         <Fragment>
                             <ModelDialog mdlOpen={_openWebCamera} anyClickClose={false} toggleMethod={() => this.toggleWebCamera()} customClasses={webCampClassName}>
                                 <div className="photo-capture">
                                     <WebCamera
                                         onTakePhoto={(dataUri) => { this.handleTakePhoto(dataUri); }}
                                         idealResolution={idealResolution}
                                         imageType={imageType !== '' ? `IMAGE_TYPES.${imageType.toUpperCase()}` : IMAGE_TYPES.PNG}
                                         // idealFacingMode={FACING_MODES.USER/* FACING_MODES.ENVIRONMENT */}
                                         isImageMirror={isImageMirror}
                                         isMaxResolution={isMaxResolution}
                                         imageCompression={imageCompression}
                                         isFullscreen={isFullscreen}
                                         sizeFactor={sizeFactor}
                                         isSilentMode={isSilentMode}
                                         isDisplayStartCameraError={isDisplayStartCameraError}
                                         onCameraError={(error) => { () => this.handleCameraError(error); }}
                                         // onTakePhotoAnimationDone={(dataUri) => { () => this.handleTakePhotoAnimationDone(dataUri); }}
                                         idealFacingMode={idealFacingMode}
                                         onCameraStart={(stream) => { () => this.handleCameraStart(stream); }}
                                         onCameraStop={() => { () => this.handleCameraStop(); }}
                                     />
                                     <div className="ocrloader">
                                         <em></em>
                                     </div>
                                 </div>
                                 <div className="btn_area">
                                     <Button className="cstm_btn smpl_brd" onClick={() => this.closeWebCamera()}>{intl.formatMessage({ id: 'common.cancel' })}</Button>
                                     <Button className="cstm_btn btn_black" onClick={() => this.closeWebCamera()}>{intl.formatMessage({ id: 'common.ok' })}</Button>
                                 </div>
                             </ModelDialog>
                         </Fragment>
                     }
                 </FormGroup>
             </Fragment >
         )
     }
 }
 
 
 export default FileType1;