/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control file type1
 *
 * Initial all package and component required for this component
 * injectIntl : used for display label langauge wise.
 */
 import React, { Component, Fragment } from 'react';
 import axios, { post } from 'axios';
 import { Label, FormGroup, Modal, ModalBody, Input, Button } from 'reactstrap';
//  const { swaggerPostAPI, swaggerGetAPI, redirectToLogin, getValueUsingKey, callNativeFunction, convertBase64ToFile, getNotificationFunction, checkReactNativeWebView, base64StringCompress } = require('DefaultHelpers');
 // var LZString = require('lz-string');
//  import AppConfig from 'DefaultConstants/AppConfig';
 import $ from 'jquery';
 import dot from 'dot-object';
 dot.override = true;
 
 /**
  * Start File Type1 class component
  * @state {*Object} reqData
  */
 class FingerPrint extends Component {
     constructor(props) {
         super(props);
         this.state = {
             fileData: {},
             ISOFileData: '',
             fingerData: '',
             // loader: props.optionsObj.type === '1' ? true : false,
             loader: true,
             mdlOpen: false,
             finger_scan: false,
             isRescan: false,
             deviceName: '',
             name: props.optionsObj.name
         }
     }
 
     componentDidMount() {
         this.setState({ loader: false });
     }
 
     /* componentWillReceiveProps(nextProps) {
         const { optionsObj: { name: inputName = '' } = {}, reqData: { [inputName]: { deviceName = '', finger_scan = false, fingerData = '', reqString: ISOFileData = '', isRescan = false } = {}, [inputName]: fingerReqObj = {} } = {} } = nextProps;
         if (Object.keys(fingerReqObj).length > 0) {
             this.setState({ deviceName, finger_scan, fingerData, ISOFileData, isRescan })
         }
     } */
 
     setValueForFinger = () => {
         // console.log('setValue :', data, fileFieldName, JSON.parse(data), isCompress)
         const { optionsObj: { name: inputName = '', isCompress: { enabled: isCompressEnabled = false, removeContentBit = false, isString = false } = {} } = {} } = this.props;
         const { fingerData = '', ISOFileData = '', isRescan = false, deviceName = '', finger_scan = false } = this.state;
         try {
             let value = '';
             const { optionsObj: { onChangeURL = '', kycPath = '', responseBindFrom = '' } = {}, savedObject, assignResponseValue } = this.props;
             if (isCompressEnabled && typeof this.props.base64StringCompress === 'function') {
                 value = ISOFileData;
                 if (removeContentBit && value.indexOf(',') > -1) {
                     let newValue = skipDataReplace ? value.split(',') : value.split(';');
                     value = newValue[1];
                 }
                 value = this.props.base64StringCompress(value);
                 assignResponseValue(inputName, value);
                 // let fingerPrintObj = {
                 //     reqString: value,
                 //     fingerData: fingerData,
                 //     isRescan: isRescan,
                 //     deviceName: deviceName,
                 //     finger_scan: finger_scan
                 // }
                 // console.log('fingerPrintObj :', fingerPrintObj)
                 // assignResponseValue(inputName, fingerPrintObj);
                 this.setState({ loader: false, mdlOpen: false });
             } else if(typeof this.props.convertBase64ToFile === 'function'){
                 value = fingerData;
                 let fileData = [{
                     // imageUrl: value,
                     name: inputName,
                     // size: size,
                     // sizeLabel: sizeLabel,
                     // type: type,
                     // fileExtension: ''
                 }]
 
                 assignResponseValue(inputName, 'loading');
                 let formDataObject = this.props.convertBase64ToFile(value, inputName)
                 let { formData, blob } = formDataObject;
                 if (kycPath !== '') {
                     let kycPathNew = kycPath;
                     if (responseBindFrom !== '') {
                         kycPathNew = kycPathNew + dot.pick(responseBindFrom, savedObject);//getValueUsingKey(responseBindFrom, savedObject)
                     }
                     formData.append('keyType', kycPathNew);
                 } else {
                     formData.append('kycField', inputName);
                 }
                 formData.append(kycPath !== '' ? 'files' : 'file', blob);
                 let targetFile = {
                     files: [{
                         name: inputName,
                         type: ''
                     }]
                 }
                 this.uploadFile(formData, targetFile, inputName);
             }
         } catch (e) {
            if (typeof this.props.getNotificationFunction === 'function') {
             this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
         }
        }
     }
 
     // function for file upload into server and get id from response and set into request Object
     uploadFile = async (formData, targetFile, inputFieldName = '') => {
         // this.setState({ loader: true });
         const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '', name: inputName = '' } = {}, assignResponseValue ,
         AppConfig: { nodeAPIUrl = {}, authorizationToken : AuthorizationToken = {} } = {} 
        } = this.props;
 
         let response = '';
         const loaderTime = 200;
         const url = nodeAPIUrl + onChangeURL;
         let authorizationToken = localStorage.getItem('front_authorize_token');
         const selfProcessStart = sessionStorage.getItem('selfProcessStart') !== undefined ? sessionStorage.getItem('selfProcessStart') : '';
         if (selfProcessStart !== '' && selfProcessStart == 1) {
             authorizationToken = sessionStorage.getItem('front_temp_authorize_token');
         }
         const config = {
             headers: {
                 'content-type': 'multipart/form-data', // 'application/x-www-form-urlencoded'
                 'authorization': AuthorizationToken + authorizationToken
                 // get token from local storage
             }
         }
 
         if (changeMethod !== '' && changeMethod === 'POST') {
             // alert("call api")
             // response = await swaggerPostAPI(onChangeURL, formData, 99); // pass 99 for add content type extra for file
             try {
                 post(url, formData, config).then((apiResponse) => {
                     const { data: response = {} } = apiResponse;
                     // alert("call api||" + JSON.stringify(apiResponse))
 
                     // response = { responseCode: 0, data: { fileUniqueId: "abc" + (Math.random()) } }
                     if (apiResponse !== undefined && apiResponse.status === 401 && typeof this.props.redirectToLogin === 'function') {
                         this.props.redirectToLogin();
                     } else if (response.responseCode === 0) {
                         let bindData = '';
                         if (changeResponseField !== '') {
                             bindData = dot.pick(changeResponseField, response);
                         } else {
                             bindData = dot.pick('data.fileUniqueId', response);
                         }
 
                         const { files: { [0]: { name = '' } = {} } = {} } = targetFile;
                         /* if (name !== '') {
                             let extension = name.toString().split('.').pop();
                             bindData = bindData + '.' + extension;
                         } */
                         // alert("bindData|" + bindData + "|" + inputFieldName)
                         // this.setState({ fileData: bindData });
                         let { fileData } = this.state;
                         fileData[inputFieldName] = bindData;
                         this.setState({ fileData });
                         if (typeof assignResponseValue === 'function') {
                             if (changeBindIn !== '')
                                 assignResponseValue(changeBindIn, bindData, ''); // first argument field and second response value
                             else
                                 assignResponseValue(inputFieldName !== '' ? inputFieldName : 'textDatePickerInput', bindData, '');
                             // this.props.onChange(targetFile.type, name !== '' ? name : 'textDatePickerInput', targetFile.value, '', targetFile.files, '', '', response.data.fileUniqueId)
                         }
                     } else if (response.responseCode > 0) {
                         // this.setState({ fileData: {} });
                         let { fileData } = this.state;
                         fileData[inputFieldName] = bindData;
                         this.setState({ fileData });
                         this.props.onChange('file_type1', inputName, {})
                         if (changeBindIn === '')
                             this.props.onChange(targetFile.type, inputFieldName !== '' ? inputFieldName : 'textDatePickerInput', '', '', '')
                         this.props.onError(inputName !== '' ? inputName : 'textDatePickerInput', `error.message.${response.errCode !== undefined ? response.errCode : 9999}`)
                         // getNotificationFunction('error', this.props.intl.formatMessage({ id: `error.message.{}` }));
                     }
                     setTimeout(() => {
                         this.setState({ loader: false, mdlOpen: false });
                     }, loaderTime);
                 })
             } catch (e) {
                 this.setState({ fileData: {} });
                 alert("run onFileUpload Eupload " + e.message)
                 // getNotificationFunction('error', this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
             }
             // to do handle response of post method
         } else if(typeof this.props.swaggerGetAPI === 'function'){
             response = await this.props.swaggerGetAPI(onChangeURL, data, true);
             // response = { responseCode: 0, data: { billAmount: 1000 } }
             if (response.responseCode === 0) {
                 if (typeof assignResponseValue === 'function') {
                     assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                 }
             } else if (response.responseCode === 1) {
                 this.setState({ fileData: {} });
                 this.props.onError(e.target.name, `error.message.${response.errCode}`)
             }
             setTimeout(() => {
                 this.setState({ loader: false, mdlOpen: false });
             }, loaderTime);
         }
     }
 
     componentWillUnmount() {
         this.setState({ fileData: {} })
     }
 
     /* on change event */
     handleOnChangeEvent = (event) => {
         const { target: { name: deviceName = '', value: deviceValue = '' } = {} } = event;
         const { optionsObj: { name: inputName = '' } = {} } = this.props;
         this.setState({ deviceName: deviceValue, isRescan: false, fingerData: '', finger_scan: false });
     }
 
     setFingerPrintData = () => {
         let { deviceName = '', fingerData = '', fileData = '' } = this.state;
         const { optionsObj: { name: inputName = '', isCompress = {} } = {}, intl } = this.props;
 
         if (deviceName !== '' && fingerData !== '') {
             // fingerData = fingerData.replace('data:image/bmp;base64,','')
             // this.setValueForFinger('onGetFingerPrint', fingerData, inputName, isCompress, true);
             this.setValueForFinger('onGetFingerPrint', fileData, inputName, isCompress, true);
         } else if (deviceName !== '' && fingerData === '' && Object.keys(fileData).length === 0 && typeof this.props.getNotificationFunction === 'function') {
             this.props.getNotificationFunction('error', intl.formatMessage({ id: 'common.scanDevice' }));
         } else if(typeof this.props.getNotificationFunction === 'function'){
             this.props.getNotificationFunction('error', intl.formatMessage({ id: 'common.selectDevice' }));
         }
     }
 
     getReScanDevice = () => {
         this.getFingerPrintConfiguration();
     }
 
     getFingerPrintConfiguration = () => {
         const { deviceName = '' } = this.state;
         const { optionsObj: { name: inputName = '', defaultValue = '', reqData = {}, fingerConfig = {} } = {}, intl } = this.props;
         const { secugenConfing = {}, morphoConfing = {}, futronicConfing = {}, abetreeConfing = {} } = fingerConfig;
         let fingerData = require('./image/finger_print.gif');
 
         if (deviceName !== '') {
             this.setState({ finger_scan: true })
             if (deviceName === 'secugen' || deviceName === 'abetree') {
                 this.getSecugenDeviceConfiguration(secugenConfing);
             } else if (deviceName === 'morpho') {
                 this.getMorphoDeviceConfiguration(morphoConfing);
             } /* else if (deviceName === 'abetree') {
                 this.getAbetreeDeviceConfiguration(abetreeConfing);
             } */ else if (deviceName === 'futronic') {
                 this.getFutronicDeviceConfiguration(futronicConfing);
             }
 
             this.setState({ fingerData: fingerData });
         } else if(typeof this.props.getNotificationFunction === 'function'){
             this.props.getNotificationFunction('error', intl.formatMessage({ id: 'common.selectDevice' }));
         }
     }
 
     async getSecugenDeviceConfiguration(secugenConfing = {}) {
         const {
             enabled = true,
             url = 'https://localhost:8443/SGIFPCapture',
             isAxios = false,
             requestType = '1',
             request = { 'Timeout': '10000', 'Quality': '50', 'licstr': '', 'templateFormat': "ISO", 'imageWSQRate': '0.75' },
             methodType = 'POST',
             responseParams = 'ISOTemplateBase64',
             headers = {}
         } = secugenConfing;
 
 
         let self = this;
         let fingerData = '';
         if (enabled) {
             let secugenData = {};
             // requestType = 1 (string), 2 = object
             let apiRequest = request;
             if (requestType === '1') {
                 apiRequest = $.param(apiRequest);
             }
 
             if (isAxios) {
                 var config = {
                     method: methodType,
                     url: url,
                     headers: headers,
                     // headers: {
                     //     'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/87.0.4280.88 Safari/537.36',
                     //     'Origin': 'http://localhost:5056',
                     //     'Content-Type': 'application/x-www-form-urlencoded or multipart/form-data' /* 'text/plain' */,
                     //     'Access-Control-Max-Age': '100',
                     //     'Accept': 'application/json'
                     // },
                     data: apiRequest
                 };
 
                 axios(config)
                     .then(function (response) {
                         // let {[responseParams] : fileData = '', [displayParams] : fingerData = '' } = response;
                         // self.setState({ fileData, fingerData})
                         console.log('response :', response.data.id)
                     })
                     .catch(function (error) {
                         console.log(error);
                         self.setState({ fileData: {}, fingerData: '', isRescan: false })
                         let errorMessage = this.getErrorCodeForSecugenDevice(error.ErrorCode);
                         errorMessage = errorMessage !== '' ? errorMessage : error.ErrorCode;
                         if(typeof this.props.getNotificationFunction === 'function'){
                         this,props.getNotificationFunction('error', errorMessage)
                        }
                     });
             } else {
                 var xmlhttp = new XMLHttpRequest();
                 xmlhttp.onreadystatechange = await function () {
                     if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
                         let fpobject = JSON.parse(xmlhttp.responseText);
                         const { ErrorCode = '', BMPBase64 = '', ISOTemplateBase64 = '' } = fpobject;
                         if (ErrorCode !== 0 && typeof this.props.getNotificationFunction === 'function') {
                             self.setState({ ISOFileData: '', fileData: {}, fingerData: '', isRescan: false, finger_scan: false })
                             let errMsg = self.getErrorCodeForSecugenDevice(ErrorCode);
                             this.props.getNotificationFunction('error', errMsg)
                         } else {
                             let { [responseParams]: ISOFileData = '', 'BMPBase64': fingerData = '' } = fpobject;
                             fingerData = fingerData !== '' ? 'data:image/bmp;base64,' + fingerData : '';
                             self.setState({ ISOFileData, fingerData, isRescan: true })
                             // getNotificationFunction('success', JSON.stringify(fpobject))
                         }
                     }
                     else if (xmlhttp.status == 404 && typeof this.props.getNotificationFunction === 'function') {
                         self.setState({ ISOFileData: '', fileData: {}, fingerData: '', isRescan: false, finger_scan: false })
                         this.props.getNotificationFunction('error', xmlhttp.status)
                     }
                 }
 
                 xmlhttp.open(methodType, url, true);
                 xmlhttp.send(apiRequest);
 
                 xmlhttp.onerror = function () {
                     self.setState({ ISOFileData: '', fileData: {}, fingerData: '', isRescan: false, finger_scan: false })
                     if(typeof this.props.getNotificationFunction === 'function'){

                         this.props.getNotificationFunction('error', xmlhttp.statusText);
                     }
                 }
             }
         } else if(typeof this.props.getNotificationFunction === 'function') {
             self.setState({ ISOFileData: '', fileData: {}, fingerData: '', isRescan: false, finger_scan: false })
             this.props.getNotificationFunction('error', intl.formatMessage({ id: 'common.secugenDisabled' }));
         }
     }
 
     getErrorCodeForSecugenDevice = (ErrorCode) => {
         let errorMessage = '';
         switch (ErrorCode) {
             case 1:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError1" });
                 break;
             case 2:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError2" });
                 break;
             case 3:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError3" });
                 break;
             case 4:
                 errorMessage = "";
                 break;
             case 5:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError5" });
                 break;
             case 6:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError6" });
                 break;
             case 7:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError7" });
                 break;
             case 51:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError51" });
                 break;
             case 52:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError52" });
                 break;
             case 53:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError53" });
                 break;
             case 54:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError54" });
                 break;
             case 55:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError55" });
                 break;
             case 56:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError56" });
                 break;
             case 57:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError57" });
                 break;
             case 58:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError58" });
                 break;
             case 59:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError59" });
                 break;
             case 60:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError60" });
                 break;
             case 61:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError61" });
                 break;
             case 63:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError63" });
                 break;
             case 101:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError101" });
                 break;
             case 102:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError102" });
                 break;
             case 103:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError103" });
                 break;
             case 104:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError104" });
                 break;
             case 105:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError105" });
                 break;
             case 106:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError106" });
                 break;
             case 1000:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError1000" });
                 break;
             case 4000:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError4000" });
                 break;
             case 2000:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError2000" });
                 break;
             case 3000:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError3000" });
                 break;
             case 6000:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError6000" });
                 break;
             case 10001:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError10001" });
                 break;
             case 10002:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError10002" });
                 break;
             case 10003:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError10003" });
                 break;
             case 10004:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenError10004" });
                 break;
 
             default:
                 errorMessage = this.props.intl.formatMessage({ id: "common.secugenUnknowError" });
                 break;
         }
         return errorMessage;
     }
 
     async getMorphoDeviceConfiguration() {
         // console.log('morpho')
     }
 
     async getAbetreeDeviceConfiguration() {
 
     }
 
     async getFutronicDeviceConfiguration() {
         // console.log('futronic')
     }
 
 
     onClickEvent = (e) => {
         // e.preventDefault();
         const { optionsObj: { isShowFileDetails = false, size, type } = {} } = this.props;
         const { name: inputName = '' } = this.state;
         if(typeof this.props.callNativeFunction === 'function'){
             this.props.callNativeFunction("onGetFingerPrint", { "formatType": "BMPBase64", inputName });

         }
     }
 
     onClickOpen = () => {
         // this.setState({ mdlOpen: !this.state.mdlOpen });
         this.setState({ mdlOpen: !this.state.mdlOpen, ISOFileData: '', fingerData: '', finger_scan: false, isRescan: false, deviceName: '' });
     };
 
     onClickClose = () => {
         this.setState({ mdlOpen: false, ISOFileData: '', fingerData: '', finger_scan: false, isRescan: false, deviceName: '' });
 
         /* const { optionsObj : { name = '' } = {}, reqData : { [name]: fingerData = '' } = {} } = this.props;
         if(fingerData !== '') {
             this.setState({ mdlOpen: false });
         } else {
             this.setState({ mdlOpen: false, ISOFileData : '', fingerData : '', finger_scan : false, isRescan : false });
         } */
     };
 
     render() {
         const { mdlOpen, loader, finger_scan, isRescan, deviceName, fingerData } = this.state;
         const { errorMsg, defaultLng, optionsObj = {}, reqData = {}, intl, defaultValue } = this.props;
         let {
             id = 'finger_print_',
             className = '',
             label: { locale: { [defaultLng]: labelTitle = '' } = {} } = {},
             name = '',
             required = false,
             isDisabled = false,
             labelAlignment = 'top-left',
             icon = '',
             iconPosition = 'right',
             placeholder: { locale: { [defaultLng]: placeHolderLabel = '' } = {} } = {},
             helpText: { locale: { [defaultLng]: fNote = '' } = {} } = {},
             extraClass = '',
             componentType = (typeof this.props.checkReactNativeWebView === 'function' ? this.props.checkReactNativeWebView() : '') ? '' : '1', //1 for web & blank for application.
             modalConfig: {
                 enabled: mdlEnabled = true,
                 label: { locale: { [defaultLng]: mdlLabelTitle = 'common.fingerPrint' } = {} } = {},
                 className: mdlClassName = 'mdl_450',
                 anyClickClose = false
             } = {}
         } = optionsObj;
 
         let { [name]: _fingerData = '' } = reqData;
         let dynamicKey = 'frm_file_' + (name !== undefined ? name : 'textFileInput');
         let labelString = labelAlignment !== '' ? labelAlignment.toString().toLowerCase() : '';
         let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
         let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
         let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
 
         let onClick = () => ({})
         if (isDisabled) {
             onClick = () => ({});
         } else {
             onClick = () => this.onClickOpen();
         }
 
         // console.log('render :', fingerData, reqData)
 
         return (
             <Fragment>
                 <FormGroup className="row" key={dynamicKey}>
                     {
                         labelString === 'right'
                             ?
                             <Fragment>
                                 <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                     <div className="file_type1" onClick={onClick}>
                                         {_fingerData === 'loading' && <div className="fl_loader"><i className="fa fa-spinner fa-spin" />{intl.formatMessage({ id: 'constant.loading' })}</div>}
                                         <Label className="inner_area finger_print" key={`tp_key_${name !== '' ? name : dynamicKey}`} htmlFor={`tp_${name !== '' ? name : dynamicKey}`}>
                                             {placeHolderLabel}
                                             {(_fingerData === '' && icon !== '') && <span className="icon"><i className={icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                             {_fingerData !== '' && <span className="i_icon material-icons highlight_green">check_circle</span>}
                                         </Label>
                                     </div>
                                 </div>
                                 {labelTitle !== '' && <Label className={`control-label ${classLabel}`} align={lableAlign}>{labelTitle}{required && <span className="text-danger">*</span>}</Label>}
                             </Fragment>
                             :
                             <Fragment>
                                 {labelTitle !== '' && <Label className={`control-label ${classLabel}`} align={lableAlign}>{labelTitle}{required && <span className="text-danger">*</span>}</Label>}
                                 <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                     <div className="file_type1" onClick={onClick}>
                                         {fingerData === 'loading' && <div className="fl_loader"><i className="fa fa-spinner fa-spin" />{intl.formatMessage({ id: 'constant.loading' })}</div>}
                                         <Label className="inner_area finger_print" key={`tp_key_${name !== '' ? name : dynamicKey}`} htmlFor={`tp_${name !== '' ? name : dynamicKey}`}>
                                             {placeHolderLabel}
                                             {(_fingerData === '' && icon !== '') && <span className="icon"><i className={icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                             {_fingerData !== '' && <span className="i_icon material-icons highlight_green">check_circle</span>}
                                         </Label>
                                     </div>
                                 </div>
                             </Fragment>
                     }
                     {(mdlOpen && mdlEnabled) && <Modal isOpen={mdlOpen} backdrop={anyClickClose} toggle={() => this.onClickOpen()} keyboard={anyClickClose} className={`mdl_dialog mdl_finger ${mdlClassName}`}>
                         <ModalBody className="mdl_body">
                             <div className="mdl_cnt mandatory">
                                 {mdlLabelTitle !== '' && <h2 className="mdl_title">{intl.formatMessage({ id: mdlLabelTitle })}</h2>}
                                 <div className="finger_print_area">
                                     <div className="fp_item">
                                         <div className="row">
                                             <div className="col-md-6">
                                                 <Input type="select" key={dynamicKey} id={dynamicKey} name={name} value={deviceName} onChange={(e) => this.handleOnChangeEvent(e)}>
                                                     <option value="">{intl.formatMessage({ id: 'common.selectDevice' })}</option>
                                                     <option value="secugen">{intl.formatMessage({ id: 'common.secugen' })}</option>
                                                     <option value="morpho">{intl.formatMessage({ id: 'common.morpho' })}</option>
                                                     <option value="abetree">{intl.formatMessage({ id: 'common.abetree' })}</option>
                                                     <option value="futronic">{intl.formatMessage({ id: 'common.futronic' })}</option>
                                                 </Input>
                                             </div>
                                             <div className="col-md-6">
                                                 <div className="btn_area">
                                                     {
                                                         isRescan
                                                             ? <Button className="cstm_btn smpl_brd btn-sm" onClick={() => this.getReScanDevice()}>{intl.formatMessage({ id: 'common.rescan' })}</Button>
                                                             : <Button className="cstm_btn smpl_brd btn-sm" onClick={() => this.getFingerPrintConfiguration()}>{intl.formatMessage({ id: 'common.scan' })}</Button>
                                                     }
                                                     <Button className="cstm_btn btn_black btn-sm" onClick={() => this.setFingerPrintData()}>{intl.formatMessage({ id: 'common.ok' })}</Button>
                                                 </div>
                                             </div>
                                         </div>
                                     </div>
                                     {finger_scan && <div className="fp_item finger_print_inner">
                                         <img src={fingerData} alt="finger_print" className="finger_print_img scan_img" />
                                     </div>}
                                     <div className="fp_item btn_area">
                                         <Button className="cstm_btn btn_black" onClick={() => this.onClickClose()}>{intl.formatMessage({ id: 'common.cancel' })}</Button>
                                     </div>
                                 </div>
                             </div>
                         </ModalBody>
                     </Modal>}
                 </FormGroup>
             </Fragment >
         )
     }
 }
 
 
 export default FingerPrint;