/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control button
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Button } from 'reactstrap';
// import AppConfig from 'DefaultConstants/AppConfig';
// import IntlMessages from "Util/IntlMessages";
// const {swaggerPostAPI, swaggerGetAPI }= require('DefaultHelpers')
/**
 * Start InputButton class component
 * @state {*Object} reqData
 * @state {*Object} cloneReqData
 * @state {*Object} errors
 */
class InputButton extends Component {

    /* on click event */
    handleOnClickEvent = (e) => {
        if (typeof this.props.onSubmit === "function") {
            this.props.onSubmit(e, this.props.optionsObj)
        }
        this.onClickCallAPI(e);
    }

    async onClickCallAPI(e) {
        if (this.props.optionsObj && this.props.optionsObj.onClickURL && typeof this.props.swaggerPostAPI === 'function') {
            var response = await this.props.swaggerPostAPI(this.props.optionsObj.onClickURL, e.target.value, true);
            // if (response.responseCode === 0) {
            // } else {
            // }
        }
    }
    render() {
        let dynamicKey = 'frm_btn_' + Date.now();
        const { defaultLng, color } = this.props;
        const { id, className, label, name, status, isDisabled, labelAlignment, icon, iconPosition, type, autoFocus, onClickURL } = this.props.optionsObj;
        let buttonAlign = labelAlignment !== undefined && (labelAlignment.toLowerCase() === 'right' || labelAlignment.toLowerCase() === 'top-right') ? 'right' : 'left';

        return (
            <Fragment>
                {/* {status && */}
                <div className="btn_area" align={buttonAlign} key={dynamicKey}>
                    {
                        iconPosition !== undefined && iconPosition.toLowerCase() === 'right'
                            ?
                            <Button
                                index={(id !== undefined && id) ? id : id}
                                type={type}
                                autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                color={(color !== undefined && color) ? color : ""}
                                name={(name !== undefined && name) ? name : dynamicKey}
                                className={(className !== undefined && className) ? className : 'btn_general ' + (type === 'float' ? " button_float " : "")}
                                disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                // onClick={(typeof this.props.onSubmit !== "function") ? () => ({}) : this.props.onSubmit}
                                onClick={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnClickEvent(e))}
                            >
                                {label.locale[defaultLng]} {(icon !== undefined && icon !== '') && <span><i className={icon} /></span>} {/* general.btnSubmit */}
                            </Button>
                            :
                            <Button
                                index={(id !== undefined && id) ? id : id}
                                type={type}
                                autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                color={(color !== undefined && color) ? color : ""}
                                name={(name !== undefined && name) ? name : dynamicKey}
                                className={(className !== undefined && className) ? className : 'btn_general ' + (type === 'float' ? " button_float " : "")}
                                disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                // onClick={(typeof this.props.onSubmit !== "function") ? () => ({}) : this.props.onSubmit}
                                onClick={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnClickEvent(e))}
                            >
                                {(icon !== undefined && icon !== '') && <span><i className={icon} /></span>} {label.locale[defaultLng]}
                            </Button>
                    }
                </div>
                {/* } */}
            </Fragment>
        )
    }
}

//Default Props for InputButton
InputButton.defaultProps = {
    optionsObj: {
        buttonAlign: 'left',
        key: 'input_txt_',
        id: 'Demo_text',
        className: 'cstm_input_txt',
        label: 'Button',
        name: 'Demo',
        status: false,
        isDisabled: false,
        labelAlignment: 'left',
        icon: '',
        iconPosition: '',
        autoFocus: false,
        onClickURL: "",
        type: "button",
    },
    reqData: {},
    defaultLng: '',
}

export default InputButton;