/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control otp
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup } from 'reactstrap';
//  import AppConfig from 'DefaultConstants/AppConfig';
import moment from 'moment';
//  const { getValueUsingKey, convertProperString } = require('DefaultHelpers');
import dot from 'dot-object';
dot.override = true;

/**
 * Start Otp class component
 * @state {*Object} reqData
 */
class LabelComponent extends Component {
    render() {
        const { defaultLng, optionsObj = {}, reqData = {}, savedObject = {}, isMultiple = false, AppConfig: { mainCurrency = '' } = {} } = this.props;
        let {
            showCurrency = false,
            name = '',
            icon = '',
            iconPosition = 'right',
            fontStyle = [],
            fontSize = '',
            color = '',
            label: { locale: { [defaultLng]: labelTitle = '' } = {} } = {},
            labelAlignment = 'left',
            /* additional */
            className = 'lbl_tlt',//lbl_item
            isHighLight = false,
            for: referance = '',
            responseBindFrom = '', //Response base get value
            stepIndex = '',
            ruleIndex = '',
            fulllength = '',
            allowClose = false,
            displayValue: {
                enabled: enabledData = false,
                bindFrom: disBindFrom = '',  //field of the form
                bindParam: disBindParam = '', //Request base get value
                isHighLight: disHighLight = true,
                mapping: displayMapping = []
            } = {},
            displayAsDate: {
                enabled: dateEnabled = false,
                format: dateFormat = ''
            } = {}
        } = optionsObj;
        let { [name]: defaultValue = '' } = reqData;

        if (responseBindFrom !== '' && !isMultiple && typeof this.props.getValueUsingKey === 'function' && enabledData) {
            // defaultValue = dot.pick(responseBindFrom, savedObject);
            defaultValue = this.props.getValueUsingKey(responseBindFrom, { ...savedObject, ...reqData });
        } else if (disBindParam !== '' && !isMultiple && enabledData) {
            defaultValue = dot.pick(disBindParam, { ...savedObject, ...reqData });
            // defaultValue = getValueUsingKey(responseBindFrom, savedObject);
        } else if (disBindFrom !== '' && !isMultiple && typeof this.props.getValueUsingKey === 'function' && enabledData) {
            defaultValue = this.props.getValueUsingKey(disBindFrom, disBindFrom)
        }

        //Display value mapping
        if (Array.isArray(displayMapping) && displayMapping.length > 0) {
            displayMapping.map(dItem => {
                const { key = '', label: { locale: { [defaultLng]: displayTitle = '' } = {} } = {}, icon: displayIcon = '', customClass = '' } = dItem;
                if (key.toString() === defaultValue.toString()) {
                    defaultValue = displayTitle;
                    className = customClass;
                    icon = displayIcon;
                    return false;
                }
            })
        }

        let dynamicKey = 'frm_label_' + (name !== '' ? name : 'dynamicKeyLabel');
        let style = { color: color, fontSize: fontSize }
        if ((fontStyle !== undefined && Array.isArray(fontStyle) && fontStyle.length > 0)) {
            fontStyle.map((sty, index) => {
                if (sty === 'bold') {
                    style.fontWeight = 'bold';
                } else if (sty === 'italic') {
                    style.fontStyle = 'italic';
                } else if (sty === 'underline') {
                    style.textDecoration = 'underline';
                }
            })
        }
        let _labelTitle = typeof this.props.convertProperString === 'function' && this.props.convertProperString(labelTitle, '', savedObject)
        labelTitle = _labelTitle;
        if (dateEnabled && dateFormat !== '' && defaultValue) {
            defaultValue = moment(defaultValue).format(dateFormat);
        }

        let labelClass = defaultValue !== '' ? " col-md-5 " : " col-md-12 ";
        let valueClass = labelTitle !== '' ? " col-md-7 " : " col-md-12 ";
        let labelCenter = '';
        let valueCenter = 'text-right text-primary';
        if (labelAlignment.toLowerCase() === 'center') {
            labelClass = valueClass = 'col-12';
            labelCenter = valueCenter = ' text-center';
        }
        return (
            <Fragment>
                <FormGroup className="row" key={dynamicKey}>
                    {(defaultValue && dateEnabled) &&
                        <div className={valueClass}>
                            <Label className={`${labelClass + className + valueCenter} ${dateEnabled ? ('lbl_vle' + (disHighLight ? ' highlight' : '')) : 'highlight'}`} for={referance} style={style}>
                                <span>{icon && <i className={icon} />}{showCurrency ? mainCurrency : ''} {defaultValue} </span>
                            </Label>
                        </div>}
                    {labelTitle &&
                        <div className={`${labelClass} ${isHighLight ? ' highlight' : ''}${fulllength ? ' is_address' : ''} ${className}`} style={fulllength ? style : {}}>
                            <Label className={`${className + labelCenter} ${isHighLight ? ' highlight' : ''}`} for={referance} style={!fulllength ? style : {}}>
                                {
                                    (icon !== '' && iconPosition === 'left') ?
                                        <span><i className={icon} /> {labelTitle} </span> :
                                        <span> {labelTitle} <i className={icon} /></span>
                                }
                            </Label>
                        </div>}
                    {defaultValue &&
                        <div className={valueClass}>
                            <Label className={`${className + valueCenter} ${dateEnabled ? ('lbl_vle' + (disHighLight ? ' highlight' : '')) : 'highlight'}`} for={referance} style={style}>
                                <span>{icon && <i className={icon} />}{showCurrency ? mainCurrency : ''} {defaultValue} </span>
                            </Label>
                        </div>}
                </FormGroup>
            </Fragment>
        );
    }
}
LabelComponent.defaultProps = {
    optionsObj: {
        name: "",
        icon: "",
        iconPosition: "right",
        label: {
            locale: { en: "" }
        },
        /* additional */
        className: "",
        for: "",
        fontStyle: "",
        fontSize: "",
        color: "",
    },
    defaultValue: '',
    defaultLng: '',
    onChange: '',
    errorMsg: '',
};

export default LabelComponent;