
/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control button
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
 import React, { Component, Fragment } from 'react';
//  import IntlMessages from "Util/IntlMessages";
 import { NotificationManager } from "react-notifications";
//  import AppConfig from 'DefaultConstants/AppConfig';
 import { FormGroup } from 'reactstrap';
//  const { swaggerPostAPI, swaggerGetAPI, getValueUsingKey, isUserLogin, getLinkObjBaseOnUrl, getNotificationFunction } = require('DefaultHelpers')
 
 const qs = require('querystring');
 /**
  * Start Link class component
  * @state {*Object} reqData
  */
 class Link extends Component {
     state = {
         response: {},
         loading: false
     }
     /* on click event */
     handleOnClickEvent = (e) => {
         const { optionsObj: { url = '' } = {}, reqData = {} } = this.props;
         if (url !== '' && url.indexOf('?') !== -1) {
             var linkObj = {};
             if (url.indexOf("page_id=") > -1 && typeof this.props.getLinkObjBaseOnUrl === 'function') {
                 linkObj = this.props.getLinkObjBaseOnUrl(url)
             } else {
                 linkObj.pathname = url;
                 linkObj.state = reqData;
             }
 
             if (url.indexOf("services") > -1) {
                 linkObj.state = { qrData: reqData, ...linkObj.state }
             }
             this.props.history.push(linkObj)
         } else {
             this.onClickCallAPI(e);
         }
     }
 
     async onClickCallAPI(e) {
         const {
             reqData = {},
             IntlMessages,
             optionsObj: {
                 isDisabled = false,
                 onClickURL = '',
                 linkType = '',
                 target_blank = '',
                 url = '',
                 isDependent = false,
                 dependency: dependencyList = [],
                 method: apiMethodType = 'POST',
                 isExternalLink: { enabled = false, fetch = false, method = "GET", requestParams = [], responseBindIn = [], displayLabels = [] } = {}
             } = {}
         } = this.props;
         if (!isDisabled) {
             if (onClickURL) {
                 let response = {};
                 if (apiMethodType === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                     response = await this.props.swaggerPostAPI(onClickURL, {}, true);
                 } else if (apiMethodType === 'GET' && typeof this.props.swaggerGetAPI === 'function') {
                     response = await this.props.swaggerGetAPI(onClickURL, {}, true);
                 }
 
                 const { responseCode = '', errCode = '' } = response;
                 if (responseCode === 0 && typeof this.props.getNotificationFunction === 'function') {
                     this.props.getNotificationFunction('success', <IntlMessages id={`error.message.${errCode}`} />);
                 } else if (responseCode > 0 && typeof this.props.getNotificationFunction === 'function') {
                     this.props.getNotificationFunction('error', <IntlMessages id={`error.message.${errCode}`} />);
                 }
             } else {
                 let response = {};
                 if (linkType === 'api' && enabled === true && fetch === true && url !== '' && typeof this.props.isUserLogin === 'function') {
                     let apiRequest = {};
                     if (Array.isArray(requestParams) && requestParams.length > 0) {
                         apiRequest = this.props.getValueFromField(requestParams)
                        }
                     let isLogin = this.props.isUserLogin();
                     if (!apiRequest) {
                         if (sessionStorage.getItem("userIdentifier") !== null) {
                             apiRequest = { userIdentifier: sessionStorage.getItem("userIdentifier") }
                         } else if (localStorage.getItem("user") !== null) {
                             apiRequest = { userIdentifier: localStorage.getItem("user") }
                         }
                     } else {
                         if (sessionStorage.getItem("userIdentifier") !== null) {
                             apiRequest['userIdentifier'] = sessionStorage.getItem("userIdentifier");
                         } else if (localStorage.getItem("user") !== null) {
                             apiRequest['userIdentifier'] = localStorage.getItem("user");
                         }
                     }
                     if (apiRequest !== -1 && apiRequest) {
                         this.setState({ loading: true })
                         if (method === "POST" && typeof this.props.swaggerPostAPI === 'function') {
                             response = await this.props.swaggerPostAPI(url, { data: apiRequest }, isLogin, !isLogin);
                             // response = { responseCode: 0, data: { WalletName: "Devang Parekh", MobileNo: '9033380042', WalletID: '9827348723' } }
                         } else if(typeof this.props.swaggerGetAPI === 'function'){
                             response = await this.props.swaggerGetAPI(url + '?' + qs.stringify(apiRequest), {}, isLogin, !isLogin);
                             // response = { responseCode: 0, data: { WalletName: "Devang Parekh", MobileNo: '9033380042', WalletID: '9827348723' } }
                         }
                         const { responseCode = '', errCode = '', data = {} } = response;
                         if (responseCode === 0 && data !== undefined) {
                             if (Array.isArray(responseBindIn) && responseBindIn.length > 0 && typeof this.props.getValueUsingKey === 'function') {
                                 responseBindIn.map((value) => {
                                     const { field = '', responseField = '' } = value;
                                     if (field !== '' && responseField !== '') {
                                         const multiArray = responseField.split("|");
                                         let passValue = '', index = 0;
                                         multiArray.map((responseFieldKey) => {
                                             passValue += this.props.getValueUsingKey(responseFieldKey, response);
                                             if (index !== multiArray.length - 1) {
                                                 passValue = passValue + " "
                                             }
                                             index++;
                                         })
                                         this.props.assignResponseValue(field, passValue);
                                     }
                                 });
                             }
                         } else {
                             NotificationManager.error(<IntlMessages id={`error.message.${errCode}`} />)
                         }
                         this.setState({ loading: false, response: response })
                     }
 
                 } else if (url !== '') {
                     if (enabled === true) {
                         if (target_blank === true) {
                             window.open(url, "_blank");
                         } else {
                             window.location.href = url;
                         }
                     } else {
                         var linkObj = {};
                         if (url.indexOf("page_id=") > -1 && typeof this.props.getLinkObjBaseOnUrl === 'function') {
                             linkObj = this.props.getLinkObjBaseOnUrl(url)
                         } else {
                             linkObj.pathname = url;
                             linkObj.state = reqData;
                         }
 
                         if (url.indexOf("services") > -1) {
                             linkObj.state = { qrData: reqData, ...linkObj.state }
                         }
 
                         this.props.history.push(linkObj);
                     }
                 }
 
             }
         }
     }
 
     async _resendSMS() {
         let response = {};
         const { userIdentifier = '', optionsObj: { url: apiUrl = '', method: apiMethodType = 'POST' } = {} ,IntlMessages} = this.props;
         let request = {
             data: {
                 userIdentifier: userIdentifier
             }
         }
         if (apiUrl !== '' && apiMethodType === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
             response = await this.props.swaggerPostAPI(apiUrl, request, true, true);
         } else if (apiUrl !== '' && apiMethodType === 'GET' && typeof this.props.swaggerGetAPI === 'function') {
             response = await this.props.swaggerGetAPI(apiUrl, request, true, true);
         }
 
         const { responseCode = '', errCode = '' } = response;
         if (responseCode === 0 && typeof this.props.getNotificationFunction === 'function') {
             this.props.getNotificationFunction('success', <IntlMessages id={`error.message.${errCode}`} />);
         } else if (responseCode > 0 && typeof this.props.getNotificationFunction === 'function') {
             this.props.getNotificationFunction('error', <IntlMessages id={`error.message.${errCode}`} />);
         }
     }
 
     render() {
         let dynamicKey = 'frm_link_';
         const { response, loading } = this.state;
         const { defaultLng, optionsObj = {} } = this.props;
         const { id = 'link_area_id', className = '', label: { locale: { [defaultLng]: linkLabel = '' } = {} } = {}, url, target_blank = false, status, isDisabled, icon = '', iconPosition = 'left', labelAlignment = 'left', onClickURL, rel, displayAsButton, isExternalLink: { displayPreReponse = false, displayLabels = [] } = {} } = optionsObj;
         let align = labelAlignment !== undefined ? labelAlignment : 'left';
         let showAsButton = displayAsButton !== undefined && displayAsButton ? displayAsButton : false;
         // let align = labelAlignment !== undefined ? labelAlignment : 'left';
 
         return (
             <Fragment>
                 {/* {status && */}
                 <div className={`link_area ${showAsButton && 'btn_general  btn btn- mb-10'}`} key={dynamicKey} align={align}>
                     {
                         (iconPosition !== undefined && iconPosition.toLowerCase() === 'right')
                             ?
                             <a
                                 onClick={url === 'adapter/v1/resendSMS' ? () => this._resendSMS() : () => this.handleOnClickEvent()}
                                 rel={rel}
                                 index={id}
                                 sethref="javascript:void(0)"
                                 // color="primary"
                                 target={target_blank ? "_blank" : '_self'}
                                 className={`${((className) ? className : 'anch-link')}  ${showAsButton && 'text-white'}`}>
                                 {linkLabel} {icon !== '' && <i className={icon} />}
                                 &nbsp;&nbsp;&nbsp;{loading && <i className="fa fa-refresh fa-spin"></i>}
                             </a>
                             :
                             <a
                                 onClick={url === 'adapter/v1/resendSMS' ? () => this._resendSMS() : () => this.handleOnClickEvent()}
                                 rel={rel}
                                 index={id}
                                 sethref="javascript:void(0)"
                                 // color="primary"
                                 target={target_blank ? "_blank" : '_self'}
                                 className={`${((className) ? className : 'anch-link')}  ${showAsButton && 'text-white'}`}>
                                 {icon !== '' && <i className={icon} />} {linkLabel}
                                 &nbsp;&nbsp;&nbsp;{loading && <i className="fa fa-refresh fa-spin"></i>}
                             </a>
                     }
                 </div>
                 {((displayPreReponse === true || (!displayPreReponse && Object.keys(response).length > 0)) && response.responseCode === 0 && Array.isArray(displayLabels) && displayLabels.length > 0) &&
                     <div className="row">
                         <FormGroup className="col-md-8 col-sm-8 no-padding">
                             {displayLabels.map((item, key) => {
                                 const { label: { locale: { [defaultLng]: mainTitle = '' } = {} } = {}, value = '', isHighLight = false } = item;
                                 let displayValue = '', keyIndex = 0;
                                 const multiArray = value.split("|");
                                 multiArray.map((fieldKey) => {
                                     if (typeof this.props.getValueUsingKey === 'function') {
                                         displayValue += this.props.getValueUsingKey(fieldKey, response);
                                     }
                                     if (keyIndex !== multiArray.length - 1) {
                                         displayValue += " "
                                     }
                                     keyIndex++;
                                 })
 
                                 return <div className='d-flex link-module' key={"newscreen" + key}>
                                     <span className="col-sm-5 col-5 trans_detail_left">{mainTitle + (mainTitle !== '' && " : ")}</span>
                                     <span className={"col-sm-7 col-7 trans_detail_right " + (isHighLight === true ? 'highlight' : '')}>{displayValue}</span>
                                 </div>
                             })}
                         </FormGroup>
                     </div>}
             </Fragment>
         )
     }
 }
 
 //Default Props for Link
 Link.defaultProps = {
     optionsObj: {
         labelAlignment: 'left',
         key: 'input_txt_',
         id: 'Demo_text',
         className: 'cstm_input_txt',
         label: 'Link',
         status: false,
         isDisabled: false,
         url: 'https://www.google.com/',
         target_blank: 'blank',
         icon: '',
         iconPosition: '',
         onClickURL: "",
         rel: ""
     },
     defaultLng: "",
 }
 
 export default Link;