/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control notetext
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import ReactHtmlParser from "react-html-parser";
// import AppConfig from 'DefaultConstants/AppConfig';

/**
 * Start Notetext class component
 * @state {*Object} reqData
 */
class Notetext extends Component {
    render() {
        let dynamicKey = 'frm_notetext_' + Date.now();
        const { defaultLng } = this.props;
        const { key, className, text, status, labelAlignment, fontStyle, fontSize, color } = this.props.optionsObj;
        let style = {
            color: color,
            fontSize: fontSize
        }
        if ((fontStyle !== undefined && Array.isArray(fontStyle) && fontStyle.length > 0)) {
            fontStyle.map((sty, index) => {
                if (sty === 'bold') {
                    style.fontWeight = 'bold';
                } else if (sty === 'italic') {
                    style.fontStyle = 'italic';
                } else if (sty === 'underline') {
                    style.textDecoration = 'underline';
                }
            })
        }
        return (
            <Fragment>
                {/* {status && <div key={key} className={`note_txt ${className}`}><strong>Note : </strong>{text.locale[defaultLng]}</div>} */}
                {/* <div key={dynamicKey} className={`note_txt ${className}`}><strong>Note : </strong>{text.locale[defaultLng]}</div> */}
                {(text !== undefined && text.locale !== undefined && text.locale[defaultLng] !== undefined) &&
                    <div key={dynamicKey} className={`note_txt ${className} text-${labelAlignment}`} style={style}>{ReactHtmlParser(text.locale[defaultLng])}</div>}
            </Fragment>
        )
    }
}

//Default Props for Notetext
Notetext.defaultProps = {
    optionsObj: {
        key: 'note_txt',
        className: 'cstm_input_txt',
        text: "Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry's standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged.",
        status: false,
        labelAlignment: 'left',
        fontStyle: "",
        fontSize: "",
        color: "",
    },
    defaultLng: '',
}

export default Notetext;