/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control text
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input, Button, Row, Col } from 'reactstrap';
// import AppConfig from 'DefaultConstants/AppConfig';
/**
 * Start Datepicker class component
 * @state {*Object} reqData
 */
class Occurrence extends Component {
    constructor(props) {
        super(props);
        this.state = {
            // /* selected */
            // selectedType: 1,
            // selectedWeek: [],
            // selectedDay: "",
            // selectedTime: "",
            // selectedZone: "",
            // startDate: "",
            // endDate: "",
            /* type */
            occurrenceTypeList: [
                { value: 1, label: props.intl.formatMessage({ id: "occurrence.daily" }) },
                { value: 2, label: props.intl.formatMessage({ id: "occurrence.weekly" }) },
                { value: 3, label: props.intl.formatMessage({ id: "occurrence.monthly" }) },
            ],
            /* week */
            weekList: [
                { value: 1, label: props.intl.formatMessage({ id: "occurrence.week.1" }) },
                { value: 2, label: props.intl.formatMessage({ id: "occurrence.week.2" }) },
                { value: 3, label: props.intl.formatMessage({ id: "occurrence.week.3" }) },
                { value: 4, label: props.intl.formatMessage({ id: "occurrence.week.4" }) },
                { value: 5, label: props.intl.formatMessage({ id: "occurrence.week.5" }) },
                { value: 6, label: props.intl.formatMessage({ id: "occurrence.week.6" }) },
                { value: 7, label: props.intl.formatMessage({ id: "occurrence.week.7" }) },
            ],
            /* month */
            days: [
                { value: 1, label: 1 },
                { value: 2, label: 2 },
                { value: 3, label: 3 },
                { value: 4, label: 4 },
                { value: 5, label: 5 },
                { value: 6, label: 6 },
                { value: 7, label: 7 },
                { value: 8, label: 8 },
                { value: 9, label: 9 },
                { value: 10, label: 10 },
                { value: 11, label: 11 },
                { value: 12, label: 12 },
                { value: 13, label: 13 },
                { value: 14, label: 14 },
                { value: 15, label: 15 },
                { value: 16, label: 16 },
                { value: 17, label: 17 },
                { value: 18, label: 18 },
                { value: 19, label: 19 },
                { value: 20, label: 20 },
                { value: 21, label: 21 },
                { value: 22, label: 22 },
                { value: 23, label: 23 },
                { value: 24, label: 24 },
                { value: 25, label: 25 },
                { value: 26, label: 26 },
                { value: 27, label: 27 },
                { value: 28, label: 28 },
                { value: 29, label: 29 },
                { value: 30, label: 30 },
                { value: 31, label: 31 },
            ],
            /* time */
            timeList: [
                { value: 1, label: 1 },
                { value: 2, label: 2 },
                { value: 3, label: 3 },
                { value: 4, label: 4 },
                { value: 5, label: 5 },
                { value: 6, label: 6 },
                { value: 7, label: 7 },
                { value: 8, label: 8 },
                { value: 9, label: 9 },
                { value: 10, label: 10 },
                { value: 11, label: 11 },
                { value: 12, label: 12 }
            ],
        }
    }
    /* handle occurrence type */
    onChangeType = (value) => {
        // this.setState({ selectedType: value });
        this.props.onChange('occurrence', this.props.optionsObj.name, value, "", "", 'occurrenceType');
    }
    /* handle selection */
    onSelectWeek = (value) => {
        this.props.onChange('occurrence', this.props.optionsObj.name, value, "", "", 'weeks');
        /* let Days = Object.assign([], this.state.selectedWeek);
        if (Days.indexOf(value) === -1) {
            Days.push(value);
        } else {
            Days.splice(Days.indexOf(value), 1);
            this.props.onChange('occurrence', this.props.optionsObj.name, Days, "", "", 'weeks');
        } */
    }
    onSelectAllDays = () => {
        this.props.onChange('occurrence', this.props.optionsObj.name, [1, 2, 3, 4, 5, 6, 7], "", "", 'weeks');
    }
    /* handle time select */
    onSelectDay = (value) => {
        let selectDay = value;
        if(value === -1) {
            var today = new Date();
            selectDay = new Date(today.getFullYear(), today.getMonth()+1, 0).getDate();
        }
        this.props.onChange('occurrence', this.props.optionsObj.name, selectDay, "", "", 'month');
    }
    /* handle time select */
    onSelectTime = (value) => {
        this.props.onChange('occurrence', this.props.optionsObj.name, value, "", "", 'times');
    }
    /* handle time select */
    onSelectZone = (zone) => {
        this.props.onChange('occurrence', this.props.optionsObj.name, zone, "", "", 'periods');
    }
    /* date change handler */
    onChangeHandler = (e, name) => {
        this.props.onChange('occurrence', this.props.optionsObj.name, e.target.value, "", "", name);
    }
    render() {
        const { intl, errorMsg, defaultValue = {} } = this.props;
        const { days, occurrenceTypeList, weekList, timeList } = this.state;
        let {
            occurrenceType = 1,
            startDate,
            endDate,
            month,
            weeks,
            times,
            periods
        } = defaultValue;
        month = (month !== undefined) ? parseInt(month) : "";
        weeks = (weeks !== undefined) ? weeks : "";
        times = parseInt(times);
        return (
            <Fragment>
                {errorMsg && <div className="validation_error">{errorMsg}</div>}
                <div className="calender_area">
                    <Label className={`control-label`}>
                        {intl.formatMessage({ id: "header.occurrence" })}
                    </Label>
                    {/* occurrenceTypeList*/}
                    <div className="week_area1 cal_box">
                        {occurrenceTypeList.map((occurrence, index) => (
                            <Button key={index} onClick={() => this.onChangeType(occurrence.value)} color="secondary" className={`btn_cal ${occurrence.value === occurrenceType && 'active'}`}>{occurrence.label}</Button>
                        ))}
                    </div>
                </div>
                {occurrenceType === 2 && <div className="calender_area">
                    <Label className={`control-label`}>
                        {intl.formatMessage({ id: "occurrence.selectWeek" })}
                    </Label>
                    {/* weeks*/}
                    <div className="week_area1 cal_box">
                        {weekList.map((week, index) => {
                            return <Button key={index} onClick={() => this.onSelectWeek(week.value)} color="secondary" className={`btn_cal ${(week.value == weeks) ? "active" : ""}`}>{week.label}</Button>
                        })}
                        {/* <Button onClick={() => this.onSelectAllDays()} color="secondary" className={`btn_cal`}>{intl.formatMessage({ id: "list.all" })}</Button> */}
                    </div>
                </div>}
                {occurrenceType === 3 && <div className="calender_area">
                    <Label className={`control-label`}>
                        {intl.formatMessage({ id: "occurrence.selectMonth" })}
                    </Label>
                    {/* days */}
                    <div className="day_area cal_box">
                        {days.map((day, index) => {
                            return <Button key={index} onClick={() => this.onSelectDay(day.value)} color="secondary" className={`btn_cal ${(day.value == month) ? "active" : ""}`}>{day.value}</Button>
                        })}
                        <Button color="secondary" onClick={() => this.onSelectDay(-1)} className={`btn_cal btn_last_month ${-1 === month && 'active'}`}>{intl.formatMessage({ id: "occurrence.lastDayOfTheMonth" })}</Button>
                    </div>
                </div>}
                <Row>
                    <Col xs={6}>
                        <Label className={`control-label `}>
                            {intl.formatMessage({ id: "occurrence.startDate" })}
                        </Label>
                        <div className={' icon_right '}>
                            <Input
                                type="date"
                                value={startDate}
                                onChange={(e) => this.onChangeHandler(e, 'startDate')}
                            />
                            <span className="is_icon"><i className={'zmdi zmdi-calendar'} /></span>
                        </div>
                    </Col>
                    <Col xs={6}>
                        <Label className={`control-label `}>
                            {intl.formatMessage({ id: "occurrence.endDate" })}
                        </Label>
                        <div className={' icon_right '}>
                            <Input
                                type="date"
                                value={endDate}
                                onChange={(e) => this.onChangeHandler(e, 'endDate')}
                            />
                            <span className="is_icon"><i className={'zmdi zmdi-calendar'} /></span>
                        </div>
                    </Col>
                </Row>
                <div className="calender_area">
                    {/* time */}
                    <div className="time_area">
                        <div className="time_left cal_box">
                            {timeList.map((time, index) => {
                                return <Button key={index} color="secondary" onClick={() => this.onSelectTime(time.value)} className={`btn_cal ${time.value === times && 'active'}`}>{time.value}</Button>
                            })}
                        </div>
                        <div className="time_right cal_box">
                            <Button color="secondary" onClick={() => this.onSelectZone('AM')} className={`btn_cal btn_last_month ${'AM' === periods && 'active'}`}>{intl.formatMessage({ id: "occurrence.am" })}</Button>
                            <Button color="secondary" onClick={() => this.onSelectZone('PM')} className={`btn_cal btn_last_month ${'PM' === periods && 'active'}`}>{intl.formatMessage({ id: "occurrence.pm" })}</Button>
                        </div>
                    </div>
                </div>
            </Fragment>
        )
    }
}
export default Occurrence