/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control otp
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
 import React, { Component, Fragment } from 'react';
 import { Label, FormGroup } from 'reactstrap';
 import OTPInput, { ResendOTP } from 'otp-input-react';
 // import AppConfig from 'DefaultConstants/AppConfig';
 // const { swaggerPostAPI, swaggerGetAPI, isUserLogin, callNativeFunction, checkReactNativeWebView, getValueUsingKey, getNotificationFunction } = require('DefaultHelpers');
 // import { NotificationManager } from "react-notifications";
 import dot from 'dot-object';
 dot.override = true;
 import $ from "jquery";
 
 /**
  * Start Otp class component
  * @state {*Object} reqData
  */
 class OTP extends Component {
     constructor(props) {
         super(props);
         let hideResendOnFailed = false;
         let { optionsObj: { failedAttempt: { enabled: attemptEnabled = false, retryTime = 5 } = {}, name: inputName = '' } = {}, reqData } = props;
         if (reqData !== undefined && attemptEnabled) {
             const { assignDirectReqData, currentStep } = props;
             if (sessionStorage.getItem("resendOtpProcessIndex") !== null && currentStep != sessionStorage.getItem("resendOtpProcessIndex")) {
                 sessionStorage.removeItem("resendClickCount");
             }
             sessionStorage.setItem("resendOtpProcessIndex", currentStep);
             let totalCount = 0, matchValuesCount = 0;
             Object.keys(reqData).map((keyDetail) => {
                 if (keyDetail.toString().indexOf('failedAttempt_') > -1) {
                     totalCount++;
                     if (reqData[keyDetail] !== undefined && reqData[keyDetail] != "") {
                         matchValuesCount++;
                     }
                 }
             });
             // console.log("matchValuesCount === totalCount", matchValuesCount, totalCount)
             if (matchValuesCount === totalCount) {
                 hideResendOnFailed = true;
                 assignDirectReqData(reqData); // req object and removeResponseObject
                 self = this;
                 setTimeout(() => {
                     // console.log("run here enabledOTPScreen");
                     self.enabledOTPScreen(props);
                 }, parseFloat(retryTime) * 60000)
             }
         }
         // console.log("hideResendOnFailed", hideResendOnFailed)
         this.state = {
             resendClickCount: 0,
             disableLink: false,
             hideResendOnFailed: hideResendOnFailed
         }
 
         this._isMounted = false;
         if (typeof this.props.checkReactNativeWebView === 'function') {
             if (this.props.checkReactNativeWebView() && typeof this.props.callNativeFunction === 'function') {
                 // alert("run call")
                 window.onOTPRetrieve = this;
                 let self = this;
                 const { props: { optionsObj: { name: inputName = '' } = {} } = {} } = self;
                 setTimeout(function () {
                     $("#divForAddScript").append(`<script type="text/javascript">function onDataReceiveFromRN${inputName}(child_id, data){ window.onOTPRetrieve.setValue(child_id, data,"${self.props.optionsObj.name}");}</script>`)
                 }, 1000);
                 this.props.callNativeFunction("onRetrieveSMS", { inputName })
             }
         }
         window.addEventListener('beforeunload', () => {
             sessionStorage.removeItem("resendClickCount");
             sessionStorage.removeItem("resendOtpProcessIndex");
             window.removeEventListener('beforeunload');
         });
     }
 
     enabledOTPScreen = (props) => {
         let { optionsObj: { failedAttempt: { enabled: attemptEnabled = false, retryTime = 5 } = {} } = {}, reqData, assignDirectReqData } = props;
         Object.keys(reqData).map((keyDetail) => {
             if (keyDetail.toString().indexOf('failedAttempt_') > -1) {
                 reqData[keyDetail] = undefined;
             }
         });
         sessionStorage.removeItem("resendClickCount");
         // console.log("run here enabledOTPScreen fun");
         this.setState({ hideResendOnFailed: false }, () => assignDirectReqData(reqData, true))
     }
 
     /* rendered */
     componentDidMount() {
         this._isMounted = true;
     }
 
     /* unmount handler */
     componentWillUnmount() {
         this._isMounted = false;
     }
 
     setValue(child_id, data, fileFieldName) {
 
         if (child_id === 'onRetrieveSMS') {
             try {
                 const { optionsObj: { isShowFileDetails = false } = {} } = this.props;
                 let resData = data.replace(/__@@__/g, '"');//(data);
                 resData = JSON.parse(/* JSON.stringify */(resData))
                 const { inputName = '', value = '' } = resData;
                 const { assignResponseValue } = this.props;
                 if (inputName !== '')
                     assignResponseValue(inputName, value)
             } catch (e) {
                 alert("run retrive E " + e.message)
                 if (typeof this.props.getNotificationFunction === 'function')
                     this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
             }
 
         }
 
     }
 
     componentWillReceiveProps(nextProps) {
 
         let { optionsObj: { failedAttempt: { enabled: attemptEnabled = false, retryTime = 5 } = {} } = {}, reqData } = nextProps;
         if (nextProps.reqData !== undefined && !this.state.hideResendOnFailed && attemptEnabled) {
             const { assignDirectReqData } = nextProps;
             let totalCount = 0, matchValuesCount = 0;
             // console.log("reqData", reqData)
             Object.keys(reqData).map((keyDetail) => {
                 if (keyDetail.toString().indexOf('failedAttempt_') > -1) {
                     totalCount++;
                     if (reqData[keyDetail] !== undefined && reqData[keyDetail] != '') {
                         matchValuesCount++;
                     }
                 }
             });
 
             if (matchValuesCount === totalCount) {
                 this.setState({ hideResendOnFailed: true }, () => assignDirectReqData(reqData));
                 setTimeout(() => {
                     let { reqData: latestReqData = {} } = nextProps;
                     Object.keys(latestReqData).map((keyDetail) => {
                         if (keyDetail.toString().indexOf('failedAttempt_') > -1) {
                             latestReqData[keyDetail] = undefined;
                         }
                     });
                     sessionStorage.removeItem("resendClickCount");
                     // console.log("run here will rec");
                     this.setState({ hideResendOnFailed: false }, () => assignDirectReqData(latestReqData, true));
                 }, parseFloat(retryTime) * 60000)
             }
         }
     }
 
     /* Generate OTP method call...*/
     onResendOTP = async () => {
         let { reqData: { transactionId = '', userIdentifier = '' } = {}, optionsObj: { onResendURL: apiUrl = '', resendMethod = 'POST', onResendRequest, maxResend = '',
             failedAttempt: { enabled: attemptEnabled = false } = {} } = {}, savedObject, assignResponseValue } = this.props;
         let { resendClickCount } = this.state;
         if (apiUrl !== '' && this._isMounted) {
             let data = {
                 ...this.props.reqData,
                 userIdentifier: userIdentifier !== '' ? userIdentifier : localStorage.getItem('user'),
                 transactionId: transactionId
 
             }
             Array.isArray(onResendRequest) && onResendRequest.length > 0 && onResendRequest.map((item) => {
                 const { key = '', value = '' } = item;
                 if (key !== '' && value !== '') {
                     // data[key] = dot.pick(value, savedObject);
                     if (typeof this.props.getValueUsingKey === 'function') {
                         data[key] = this.props.getValueUsingKey(value, savedObject)
                     }
                 }
             });
 
             let response = '';
             if (resendMethod === 'GET' && typeof this.props.swaggerGetAPI === 'function' && typeof this.props.isUserLogin === 'function') {
                 response = await this.props.swaggerGetAPI(apiUrl, { data }, true, !this.props.isUserLogin());
             } else if (typeof this.props.swaggerPostAPI === 'function' && typeof this.props.isUserLogin === 'function') {
                 response = await this.props.swaggerPostAPI(apiUrl, { data }, true, !this.props.isUserLogin());
             }
 
             try {
                 if (response.responseCode === 0 && typeof this.props.getNotificationFunction === 'function') {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue('transactionId', response.data.transactionId); // first argument field and second response value
                     }
                     this.props.getNotificationFunction('success', this.props.intl.formatMessage({ id: `message.resendSMSSuccess` }));
                     // NotificationManager.success(this.props.intl.formatMessage({ id: `error.message.${response.errCode}` }))
                 } else if (response.responseCode > 0 && typeof this.props.getNotificationFunction === 'function') {
                     this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: `error.message.${response.errCode}` }));
                 }
                 let resendClickCount = 0;
                 if (sessionStorage.getItem("resendClickCount") === null) {
                     sessionStorage.setItem("resendClickCount", resendClickCount + 1);
                 } else {
                     resendClickCount = sessionStorage.getItem("resendClickCount");
                 }
                 resendClickCount = parseInt(resendClickCount) + 1;
                 sessionStorage.setItem("resendClickCount", resendClickCount);
                 // console.log("resendClickCount", resendClickCount, maxResend)
                 let disableLink = false;
                 if (maxResend !== '' && parseInt(maxResend) === resendClickCount && attemptEnabled) {
                     disableLink = true;
                 }
                 // console.log("disableLink", disableLink)
                 this.setState({ resendClickCount: resendClickCount, disableLink });
 
             } catch (error) {
                 if (typeof this.props.getNotificationFunction === 'function') {
                     this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: `message.pleaseTryAfterSometime` }));
                 }
             }
         } else if (this.props.resendAPIObject !== '' && typeof this.props.resendAPIObject === 'function') {
             this.props.resendAPIObject();
         }
     }
 
     /**
      * Resend button display or not
      * @params {*Object} buttonProps
      */
     renderButton = buttonProps => {
         const { defaultLng, optionsObj, intl } = this.props;
         const { resendLabel: { locale: { [defaultLng]: resend = intl.formatMessage({ id: "general.resend" }) } = {} } = {} } = optionsObj;
         return (
             buttonProps.remainingTime === 0 ? <button onClick={this.onResendOTP} {...buttonProps}>{resend}</button> : ''
         );
     };
 
     /**
      * Render time method
      * @params {*String} remainingTime
      */
     renderTime = remainingTime => {
         const { maxTime } = this.props.optionsObj;
         let displayTimer = maxTime !== undefined && maxTime !== 0 && maxTime !== '' ? true : false;
         return remainingTime === 0 ? null : !displayTimer ? React.Fragment : <span>{remainingTime} {this.props.intl.formatMessage({ id: "occurrence.secondsRemaining" })}</span>;
     };
 
     render() {
         console.log("otp    this.props",this.props)
         const { errorMsg, defaultValue, defaultLng, intl } = this.props;
         const { label, name, type, required, isDisabled, maxLength, labelAlignment, resendButton, secure, maxTime, maxResend } = this.props.optionsObj;
         let { disableLink, hideResendOnFailed } = this.state;
         let dynamicKey = 'frm_otp_' + (name !== undefined ? name : 'dynamicKeyOTP');
         let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
         let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
         let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
         let remainingMaxTime = maxTime !== undefined && maxTime ? parseInt(maxTime) : 60;
         let mxLength = maxLength !== undefined && maxLength ? parseInt(maxLength) : 4;
 
         if (sessionStorage.getItem("resendClickCount") !== null && maxResend == sessionStorage.getItem("resendClickCount")) {
             disableLink = true;
         }
 
         return (
             <Fragment>
                 <FormGroup className="row" key={dynamicKey}>
                     {
                         labelString === 'right'
                             ?
                             <Fragment>
                                 <div className={`col-md-12${errorMsg ? ' is_err' : ''}`}>
                                     <OTPInput
                                         className={`otp_area otp_length_${mxLength}`}
                                         value={defaultValue}
                                         // onChange={this.handleChange}
                                         onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((otp) => this.props.onChange('text', name, otp))}
                                         autoFocus
                                         OTPLength={mxLength}
                                         otpType={type !== undefined && type ? type : 'number'}
                                         disabled={isDisabled !== undefined && isDisabled ? isDisabled : false}
                                         required={required !== undefined && required ? required : false}
                                         secure={secure !== undefined && secure ? secure : false}
                                     />
                                     {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                     {resendButton !== undefined && resendButton && !disableLink && !hideResendOnFailed && (
                                         <div className="otpButton">
                                             <ResendOTP onResendClick={this.onResendOTP} renderButton={this.renderButton} renderTime={this.renderTime} maxTime={remainingMaxTime} />
                                         </div>
                                     )}
                                 </div>
                                 {label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined && (
                                     <Label className={`control-label ${classLabel}`} align={lableAlign}>
                                         {label.locale[defaultLng]}
                                         {required && <span className="text-danger">*</span>}
                                     </Label>
                                 )}
                             </Fragment>
                             :
                             <Fragment>
                                 {label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined && (
                                     <Label className={`control-label ${classLabel}`} align={lableAlign}>
                                         {label.locale[defaultLng]}
                                         {required && <span className="text-danger">*</span>}
                                     </Label>
                                 )}
                                 <div className={`col-md-12${errorMsg ? ' is_err' : ''}`}>
                                     <OTPInput
                                         className={`otp_area otp_length_${mxLength}`}
                                         value={defaultValue}
                                         // onChange={this.handleChange}
                                         onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((otp) => this.props.onChange('text', name, otp))}
                                         autoFocus
                                         OTPLength={mxLength}
                                         otpType={type !== undefined && type ? type : 'number'}
                                         disabled={isDisabled !== undefined && isDisabled ? isDisabled : false}
                                         required={required !== undefined && required ? required : false}
                                         secure={secure !== undefined && secure ? secure : false}
                                     />
                                     {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                     {resendButton !== undefined && resendButton && !disableLink && !hideResendOnFailed && (
                                         <div className="otpButton">
                                             <ResendOTP onResendClick={this.onResendOTP} renderButton={this.renderButton} renderTime={this.renderTime} maxTime={remainingMaxTime} />
                                         </div>
                                     )}
                                 </div>
                             </Fragment>
                     }
                 </FormGroup>
             </Fragment>
         );
     }
 }
 OTP.defaultProps = {
     optionsObj: {
         className: 'cstm_otp',
         label: 'OTP',
         name: 'OTP',
         type: 'number',
         required: true,
         isDisabled: false,
         maxLength: '6',
         labelAlignment: 'left',
         resendButton: true,
         maxTime: 60,
         resendApiUrl: ''
     },
     defaultValue: '',
     defaultLng: '',
     onChange: '',
     errorMsg: '',
 };
 
 export default OTP;