/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control Quantity
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input } from 'reactstrap';
import AppConfig from 'DefaultConstants/AppConfig';
const { swaggerPostAPI, swaggerGetAPI } = require('DefaultHelpers');
/**
 * Start Quantity class component
 * @state {*Object} reqData
 */
class Quantity extends Component {
    constructor(props) {
        super(props);
        this.state = {
            quantity: 0
        }
    }

    /* on change event */
    handleOnChangeEvent = (e) => {

        this.props.onChange(e.target.type, e.target.name, e.target.value)
        this.onChangeCallAPI(e);
    }

    async onChangeCallAPI(e) {

        const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '' } = {}, assignResponseValue } = this.props;
        if (onChangeURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (changeMethod !== '' && changeMethod === 'POST') {
                response = await swaggerPostAPI(onChangeURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else {
                response = await swaggerGetAPI(onChangeURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }


    render() {
        const { errorMsg, defaultLng, defaultValue, requestdta } = this.props;
        const { } = this.props.optionsObj;
        let dynamicKey = 'frm_Quantity_' + (name !== undefined ? name : 'QuantityInput');
        let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
        let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
        let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
        let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';

        if (icon !== '') {
            classInput += (iconPosition !== undefined && iconPosition.toLowerCase() === 'right') ? ' icon_right' : ' icon_left';
        }

        return (
            <Fragment>
                {/* {status && */}
                <FormGroup className="row" key={dynamicKey}>
                    {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    <Input
                                        type="Quantity"
                                        autoComplete={(autoComplete !== undefined && autoComplete) ? autoComplete : ''}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        className={((className !== undefined && className) ? className : '') + (selectText === false ? " noselect " : "")}
                                        name={(name !== undefined && name) ? name : 'QuantityInput'}
                                        value={(defaultValue !== undefined && defaultValue) ? defaultValue : ''}
                                        placeholder={(placeHolder !== undefined && placeHolder.locale !== undefined && placeHolder.locale[defaultLng] !== undefined) ? placeHolder.locale[defaultLng] : ''}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        minLength={(minLength !== undefined && minLength) ? minLength : ''}
                                        maxLength={(maxLength !== undefined && maxLength) ? maxLength : ''}
                                        rows={(rows !== undefined && rows) ? rows : ''}
                                        cols={(cols !== undefined && cols) ? cols : ''}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange(e.target.type, e.target.name, e.target.value)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.handleOnChangeEvent(e)}
                                    />
                                    {(icon !== undefined && icon !== '') && <span className="is_icon"><i className={icon} /></span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    <Input
                                        type="Quantity"
                                        autoComplete={(autoComplete !== undefined && autoComplete) ? autoComplete : ''}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        className={((className !== undefined && className) ? className : '') + (selectText === false ? " noselect " : "")}
                                        name={(name !== undefined && name) ? name : 'QuantityInput'}
                                        value={(defaultValue !== undefined && defaultValue) ? defaultValue : ''}
                                        placeholder={(placeHolder !== undefined && placeHolder.locale !== undefined && placeHolder.locale[defaultLng] !== undefined) ? placeHolder.locale[defaultLng] : ''}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        minLength={(minLength !== undefined && minLength) ? minLength : ''}
                                        maxLength={(maxLength !== undefined && maxLength) ? maxLength : ''}
                                        rows={(rows !== undefined && rows) ? rows : ''}
                                        cols={(cols !== undefined && cols) ? cols : ''}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange(e.target.type, e.target.name, e.target.value)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.handleOnChangeEvent(e)}
                                    />
                                    {(icon !== undefined && icon !== '') && <span className="is_icon"><i className={icon} /></span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                            </Fragment>
                    }
                </FormGroup>
                {/* } */}
            </Fragment >
        )
    }
}

//Default Props for Quantity
Quantity.defaultProps = {
    optionsObj: {
        autoComplete: false,
        key: 'input_txtarea_',
        id: 'Demo_Quantity',
        className: 'cstm_input_txtarea',
        label: 'Quantity',
        name: 'Demo',
        status: false,
        placeHolder: 'Demo input',
        required: true,
        validationMsg: '',
        regex: '',
        isDisabled: false,
        minLength: '',
        maxLength: '',
        labelAlignment: 'left',
        icon: '',
        iconPosition: '',
        rows: '1',
        cols: '',
        helpText: {},
        autoFocus: false,
        selectText: true,
        onBlurURL: "",
        onFocusURL: "",
        onChangeURL: "",
    },
    defaultValue: '',
    defaultLng: AppConfig.locale.locale,
    onChange: '',
    errorMsg: ''
}

export default Quantity;