/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control radio
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input } from 'reactstrap';
// import AppConfig from 'DefaultConstants/AppConfig';
// const { ModalMandatory } = require('DefaultComponents/Widgets');
// const { swaggerPostAPI, swaggerGetAPI, getValueUsingKey, getValueUsingMapping, checkReactNativeWebView } = require('DefaultHelpers')
import dot from 'dot-object';
dot.override = true;

/**
 * Start Radio class component
 * @state {*Object} reqData
 */
class Radio extends Component {

    constructor(props) {
        super(props);
        this.state = {
            selectOptions: [],
            externalURL: '',
            loading: true,
            name: props.optionsObj.name,
            mdlOpen: false,
            mdlConfig: {}
        }
        //this.callAPI = this.callAPI.bind(this)
    }

    onClickOpen = () => {
        this.setState({ mdlOpen: !this.state.mdlOpen });
    };

    onClickClose = () => {
        this.setState({ mdlOpen: false });
    };

    shouldComponentUpdate = (nextProps, nextState) => {
        if (this.props === nextProps && this.state === nextState) {
            return false;
        }
        return true;
    };

    // componentDidMount() {
    //     this.callAPI();
    // }

    componentWillMount() {
        this.callAPI();
    }

    /* on blur event */
    handleOnBlurEvent = (e) => {
        this.onBlurCallAPI(e);
    }
    /* on focus event */
    handleOnFocusEvent = (e) => {
        this.onFocusCallAPI(e);
    }
    /* on change event */
    handleOnChangeEvent = (e, isDirectSubmit = false) => {
        let {
            defaultValue = '',
            optionsObj: {
                mdlConfig: { enabled: mdlEnabled = false, valueMatch = '', isNonEmpty = false } = {},
                mdlConfig: _mdlConfig = {},
                allowClear: { enabled: allowEnabled = false } = {},
                allowClear = {}
            } = {},
            stepperThis,
            allowClearAggregator,
            onChange
        } = this.props;
        // console.log('handleOnChangeEvent :', allowClear, e.target.value)
        if (mdlEnabled && ((e.target.value === valueMatch) || (isNonEmpty && e.target.value !== ''))) {
            this.setState({ mdlOpen: true, mdlConfig: _mdlConfig });
            // this.props.onChange(e.target.type, e.target.name, e.target.value, e.target.checked)
        } else {
            if (allowEnabled && defaultValue !== e.target.value && typeof allowClearAggregator === 'function') {
                allowClear['key'] = e.target.name;
                allowClear['value'] = e.target.value;
                allowClearAggregator(allowClear)
            }
            if (typeof onChange === 'function') {
                onChange(e.target.type, e.target.name, e.target.value, e.target.checked);
            }
            if (isDirectSubmit) {
                setTimeout(() => {
                    window.onSubmit(-1, stepperThis, 'btnSubmit')
                }, 500);
            } else {
                this.onChangeCallAPI(e);
            }
        }
    }

    callAPI = async () => {
        const { optionsObj: { options: defaultOptions = [], externalURL: { URL: extUrl = '', label: extLabel = '', value: extValue = '' } = {}, externalURL: externalObj = {} } = {}, swaggerGetAPI, swaggerPostAPI, getValueUsingKey } = this.props;

        if (defaultOptions.length) {

            this.setState({ ...this.state, selectOptions: defaultOptions, loading: false })
        } else if (externalObj) {

            let externalObj = this.props.optionsObj.externalURL;
            const { optionsObj: { externalURL: { URL = '', method = "", request = [], listKey = '' } = {} } = {}, assignOptions = '' } = this.props;

            if (URL === '') {
                this.setState({ loading: false })
                return false;
            }

            var response = {};
            if (method === "POST" && typeof swaggerPostAPI === 'function') {

                let { reqData: formRequest = {} } = this.props;
                let apiRequest = { data: {} };
                if (formRequest['userIdentifier'] === undefined && localStorage.getItem('user') !== null && localStorage.getItem('user') !== undefined)
                    formRequest['userIdentifier'] = apiRequest.data['userIdentifier'] = localStorage.getItem('user');
                else if (!request.length)
                    apiRequest.data['userIdentifier'] = localStorage.getItem('user');

                Array.isArray(request) && request.map((item) => {
                    const { key = '', value = '' } = item;
                    if (key !== '' && value !== '' && formRequest[value] !== '') {
                        apiRequest.data[key] = key === 'userIdentifier' ? localStorage.getItem('user') : formRequest[value];
                    } else {
                        apiRequest.data[key] = key === 'userIdentifier' ? localStorage.getItem('user') : '';
                    }
                });

                response = await swaggerPostAPI(URL, apiRequest, true);

            } else if (typeof swaggerGetAPI === 'function') {
                response = await swaggerGetAPI(URL, {}, true);
            }
            // response = { "responseCode": 0, "errCode": "1", "message": "Success", "data": [{ "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Tom Dick" }, "UserAccountIdentifier": "7500075771", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515929102835048678664" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Bhavesh" }, "UserAccountIdentifier": "7580907426", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936065125725154969" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Dhruvit" }, "UserAccountIdentifier": "7528173747", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515937626770913723529" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test Branch" }, "UserAccountIdentifier": "7500075025", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924786534912002765" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "yuvi" }, "UserAccountIdentifier": "7500075781", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935284845022592197" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Dipesh" }, "UserAccountIdentifier": "7504248870", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515937614012519889521" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test Branch" }, "UserAccountIdentifier": "7500075007", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "243.00", "AvailableBalanceMajor": "243.00", "UsedValueMajor": "68.00" }] }], "UserAccountUniqueId": "192.168.2.22515904163391506809584" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Branch Test" }, "UserAccountIdentifier": "7500075084", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924828010773185662" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Testing Branch" }, "UserAccountIdentifier": "7500075011", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935960960468106119" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "John Branch" }, "UserAccountIdentifier": "7500078651", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935034671775345748" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test branch new" }, "UserAccountIdentifier": "7511595175", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515912550639133064809" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075024", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924719069386924667" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "John Branch" }, "UserAccountIdentifier": "7500007861", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515930669998288863290" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Testing" }, "UserAccountIdentifier": "7500070011", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515940094683952757395" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test Branch" }, "UserAccountIdentifier": "7500075014", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "1.00", "AvailableBalanceMajor": "1.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515907748412975970446" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075081", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924088046235102768" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500078630", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515934190002438777101" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500071111", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936210714052852340" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075093", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924130547578686914" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500078652", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935039344598621956" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075091", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924094511957188727" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7511595563", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515912559655764781789" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075092", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924122738517108441" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500007860", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515931605789452776765" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7560040075", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936059785412936331" }] }
            if (response.responseCode === 0) {
                if (typeof response.data === "object" && response.data["0"] !== undefined) {
                    let tempArray = [];
                    Object.keys(response.data).map((key) => {
                        tempArray.push(response.data[key])
                    });
                    response.data = tempArray;
                }
                let filteredOptions = [];
                const { optionsObj: { filter = [] } } = this.props;
                if (Array.isArray(filter) && filter.length > 0) {
                    response.data.map((value) => {
                        // const filter = [{ key: "STATUS", value: "ACTIVE" }, { key: "STATUS", value: "INACTIVES" }]
                        filter.map(filterItem => {
                            const splitRegex = '|'
                            const nameList = filterItem.value.split(splitRegex)
                            nameList.map(valueItem => {
                                if (typeof getValueUsingKey === 'function') {
                                    let keyValue = getValueUsingKey(filterItem.key, value);
                                    if (keyValue !== '' && valueItem !== undefined)
                                        if (keyValue.toString().toLowerCase() === valueItem.toString().toLowerCase()) {
                                            filteredOptions.push(value);
                                        }
                                }
                            })
                        })
                    });
                } else {
                    filteredOptions = response.data;
                }

                if (typeof assignOptions === 'function') {
                    this.setState({ loading: false })
                    if (listKey !== '' && typeof getValueUsingKey === 'function') {
                        let optionsList = getValueUsingKey(listKey, filteredOptions);
                        if (optionsList !== '')
                            assignOptions(this.props.optionsObj.name, optionsList)
                    } else {
                        assignOptions(this.props.optionsObj.name, filteredOptions)
                    }
                } else {
                    let selectOptions = [];
                    filteredOptions.map((value) => {
                        let optionLabel = value[externalObj.label];
                        if (value[externalObj.label] !== undefined && value[externalObj.label].locale !== undefined && Object.keys(value[externalObj.label].locale).length > 0) {
                            optionLabel = value[externalObj.label]['locale'][this.props.defaultLng];
                        } else if (value[externalObj.label] !== undefined && typeof value[externalObj.label] === 'object' && Object.keys(value[externalObj.label]).length > 0) {
                            optionLabel = value[externalObj.label][this.props.defaultLng]
                        } else if (typeof getValueUsingKey === 'function') {
                            optionLabel = getValueUsingKey(externalObj.label, value)
                        }
                        if (typeof getValueUsingKey === 'function') {
                            let object = {
                                label: optionLabel,
                                value: getValueUsingKey(externalObj.value, value)
                            };
                            if (value[externalObj.image] !== undefined && value[externalObj.image] !== '') {
                                object.image = value[externalObj.image];
                            }
                            selectOptions.push(object);
                        }
                    });
                    // console.log(selectOptions, 'selectOptions')
                    this.setState({ selectOptions: selectOptions, externalURL: externalObj.URL, loading: false })
                }
            } else {
                this.setState({ selectOptions: [], externalURL: externalObj.URL, loading: false })
            }
        }
    }

    onBlurCallAPI = async (e) => {
        const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {}, assignResponseValue, swaggerPostAPI } = this.props;
        if (onBlurURL !== '') {

            let response = '';
            let inputName = e.target.name;
            let inputValue = e.target.value;

            if (blurMethod !== '' && blurMethod === 'POST') {
                let data = {
                    [inputName]: inputValue
                }
                if (typeof swaggerPostAPI === 'function')
                    response = await swaggerPostAPI(onBlurURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(inputName, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof swaggerGetAPI === 'function') {
                response = await swaggerGetAPI(onBlurURL, {}, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                    }
                }
            }

        }
    }

    onFocusCallAPI = async (e) => {
        const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue, swaggerGetAPI, swaggerPostAPI, onError } = this.props;
        if (onFocusURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (focusMethod !== '' && focusMethod === 'POST' && typeof swaggerPostAPI === 'function') {
                response = await swaggerPostAPI(onFocusURL, data, true);
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1 && typeof onError === 'function') {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else {
                response = await swaggerGetAPI(onFocusURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1 && typeof onError === 'function') {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }

    componentWillReceiveProps(nextProps) {
        // this.callAPI()
        if (nextProps.optionsObj.name === this.state.name && nextProps.optionsObj.options !== undefined && nextProps.optionsObj.options.length && this.state.selectOptions !== nextProps.optionsObj.options) {
            // const selectedOptions = this._convertOptions(nextProps.optionsObj.options);
            this.setState({ selectOptions: nextProps.optionsObj.options })
        } else if (nextProps && nextProps.optionsObj && nextProps.optionsObj.options !== undefined && nextProps.optionsObj.options.length && nextProps.optionsObj.name === this.state.name) {
            // const selectedOptions = this._convertOptions(nextProps.optionsObj.options);
            this.setState({ selectOptions: nextProps.optionsObj.options, externalURL: '' })
        } else if (nextProps.optionsObj && nextProps.optionsObj.externalURL && nextProps.optionsObj.externalURL.URL && this.state.externalURL !== nextProps.optionsObj.externalURL.URL && nextProps.optionsObj.name === this.state.name) {
            this.setState({ selectOptions: [], externalURL: this.props.optionsObj.externalURL.URL }, () => {
                this.callAPI()
            })
        } else if (nextProps && nextProps.optionsObj && nextProps.optionsObj.options && nextProps.optionsObj.options.length && nextProps.optionsObj.selectObjFromProfile) {
            this.setState({ selectOptions: nextProps.optionsObj.options, externalURL: '' })
        } else if (nextProps.optionsObj.options !== undefined && !nextProps.optionsObj.options.length && (nextProps.optionsObj && (!nextProps.optionsObj.externalURL || !nextProps.optionsObj.externalURL.URL)) && nextProps.optionsObj.name === this.state.name) {
            this.setState({ selectOptions: [], externalURL: '' });
        }
    }

    async onChangeCallAPI(e) {
        const { optionsObj: { onChangeURL = '', pageId = '', changeBindIn = '', changeResponseField = '', changeMethod = '', changeRequest = [] } = {}, assignOptions, savedObject = {}, defaultValue, assignResponseValue, checkReactNativeWebView } = this.props;
        if (onChangeURL !== '') {
            const { location: { state: { page_id: OldPageID = '' } = {}, pathname = '' } = {}, reqData = {} } = this.props;
            if (OldPageID === pageId || (e.target.value !== '' && defaultValue !== '' && e.target.value == defaultValue)) {
                return false; // do nothing when same page id are same
            } else if (pageId !== '' && typeof checkReactNativeWebView === 'function') {
                let pageConf = { pathname: checkReactNativeWebView() ? pathname : onChangeURL, state: { page_id: pageId } }
                let reqObj = {};
                if (changeBindIn !== '' && changeResponseField !== '') {
                    reqObj = {
                        [changeBindIn]: reqData[changeResponseField]
                    }
                    pageConf.state = {
                        ...pageConf.state, qrData: reqObj
                    }
                }
                this.props.history.replace(pageConf)
            } else {
                let data = {
                    [e.target.name]: e.target.value,
                    userIdentifier: localStorage.getItem('user') !== null ? localStorage.getItem('user') : sessionStorage.getItem('user')
                }

                if (e.target.name === 'ProductCategory') {
                    data.productCategory = e.target.value;
                } else {
                    data[e.target.name] = e.target.value;
                }

                Array.isArray(changeRequest) && changeRequest.map((item) => {
                    const { key = '', value = '' } = item;
                    if (key !== '' && value !== '') {
                        let resValue = dot.pick(value, savedObject);
                        data[key] = resValue !== undefined ? resValue : (value !== '' && value.toString().indexOf('.') === -1 ? value : '');
                    }
                });

                let response = '';

                if (changeMethod !== '' && changeMethod === 'POST' && typeof swaggerPostAPI === 'function' && typeof getValueUsingKey === 'function') {
                    response = await swaggerPostAPI(onChangeURL, { data }, true);
                    let responseValue = getValueUsingKey(changeResponseField, response);
                    if (response.responseCode === 0) {
                        if (Array.isArray(responseValue) && changeBindIn !== '') {
                            assignOptions(changeBindIn, responseValue)
                        } else if (typeof assignResponseValue === 'function' && changeBindIn !== '') {
                            (changeResponseField.indexOf('.') > -1) ? assignResponseValue(changeBindIn, responseValue) : assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                        }
                    } else if (response.responseCode === 1) {
                        if (Array.isArray(response.data) && changeBindIn !== '')
                            assignOptions(changeBindIn, [])
                        else if (typeof assignResponseValue === 'function' && changeBindIn !== '') {
                            // getValueUsingKey(changeResponseField, response)
                            assignResponseValue(changeBindIn, ''); // first argument field and second response value
                        } else {
                            assignOptions(this.props.optionsObj.name, response.data)
                        }
                        this.props.onError(this.props.optionsObj.name, `error.message.${response.errCode}`)
                    }
                    // to do handle response of post method
                } else if (typeof swaggerGetAPI === 'function') {
                    response = await swaggerGetAPI(onChangeURL, data, true);
                    // response = { responseCode: 0, data: { billAmount: 1000 } }
                    if (response.responseCode === 0) {
                        if (typeof assignResponseValue === 'function' && typeof getValueUsingKey === 'function') {
                            let responseValue = getValueUsingKey(changeResponseField, response);
                            if (Array.isArray(responseValue) && changeBindIn !== '') {
                                assignOptions(changeBindIn, [])
                            } else if (typeof assignResponseValue === 'function' && changeBindIn !== '') {
                                // getValueUsingKey(changeResponseField, response)
                                assignResponseValue(changeBindIn, ''); // first argument field and second response value
                            } else if (typeof assignResponseValue === 'function') {
                                assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                            } else {
                                assignOptions(this.props.optionsObj.name, '')
                            }
                        }
                    } else if (response.responseCode === 1 && typeof onError === 'function') {
                        onError(e.target.name, `error.message.${response.errCode}`)
                    }
                }
            }

        }

    }

    render() {
        const { intl, errorMsg, defaultValue, defaultLng } = this.props;
        const { id, className, key, label, label: { locale: { [defaultLng]: labelTitle = '' } = {} } = {}, name, status, required, isDisabled = false, options, labelAlignment, displayAsButton, isMargeKeyValue, onBlurURL, onFocusURL, onChangeURL } = this.props.optionsObj;
        const { selectOptions = [], mdlOpen, mdlConfig = {} } = this.state
        const { customClasses: mdlCustomClasses = '', icon: mdlIcon = '', tp_text1 = '', bp_text1 = '', button1 = '', button2 = "" } = mdlConfig;
        let dynamicKey = 'frm_radio_' + (name !== undefined ? name : 'textRadioInput');
        let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
        let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
        let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
        let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
        let showAsButton = displayAsButton !== undefined && displayAsButton ? displayAsButton : false;
        let showMargeKeyValue = isMargeKeyValue !== undefined && isMargeKeyValue ? isMargeKeyValue : false;
        let lenghtClass = 'col-md-4';
        if (selectOptions.length === 1) {
            lenghtClass = 'col-md-12';
        } else if (selectOptions.length < 3) {
            lenghtClass = 'col-md-6';
        }

        return (
            <Fragment>
                {/* {status && */}
                <FormGroup className="row" key={dynamicKey}>
                    {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    <div className={`cstm_icn_area ${showAsButton && 'show_btn row'}`}>
                                        {(selectOptions !== undefined && selectOptions.length > 0) && selectOptions.map((item, index) => {
                                            let displayLabel = '';
                                            if (typeof item.label === "object" && item.label.locale !== undefined && Object.keys(item.label.locale).length > 0) {
                                                displayLabel = item.label.locale[defaultLng];
                                            } else {
                                                displayLabel = item.label;
                                            }
                                            const { isDisabled: optionDisabled = false, isDirectSubmit = false } = item;

                                            return (
                                                <Fragment key={index}>
                                                    {
                                                        showAsButton
                                                            ?
                                                            <div className={`col-6 rdo_btn_area ${lenghtClass}`} key={`mlti_rdi_${index}`}>
                                                                <Label className={`rdo_btn ${(isDisabled || optionDisabled) ? ' is_disabled' : ''} ${selectOptions.length < 3 ? 'm-0' : ''} ${(defaultValue !== undefined && item.value !== undefined && defaultValue === item.value) ? 'active' : ''}`} htmlFor={(id !== undefined && id) ? id + '_' + index : dynamicKey + index}>
                                                                    {displayLabel}
                                                                </Label>
                                                                <Input
                                                                    type="radio"
                                                                    className={`custom-control-input`}
                                                                    name={(name !== undefined && name) ? name : dynamicKey + index}
                                                                    key={(id !== undefined && id) ? id : dynamicKey + index}
                                                                    id={(id !== undefined && id) ? id + '_' + index : dynamicKey + index}
                                                                    value={item.value !== undefined ? item.value : ''}
                                                                    disabled={((isDisabled !== undefined && isDisabled) || optionDisabled) ? isDisabled : false}
                                                                    required={(required !== undefined && required) ? required : false}
                                                                    checked={(defaultValue !== undefined && item.value !== undefined && defaultValue === item.value) ? 'checked' : ''}
                                                                    // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange('radio', e.target.name, e.target.value, e.target.checked)}
                                                                    onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                                    onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                                    onChange={((isDisabled !== undefined && isDisabled) || optionDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                                />
                                                            </div>
                                                            :
                                                            <div className="custom-control custom-radio custom-control-inline" key={`mlti_rdi_${index}`}>
                                                                <Input
                                                                    type="radio"
                                                                    className={`custom-control-input`}
                                                                    name={(name !== undefined && name) ? name : dynamicKey + index}
                                                                    key={(id !== undefined && id) ? id : dynamicKey + index}
                                                                    id={(id !== undefined && id) ? id + '_' + index : dynamicKey + index}
                                                                    value={item.value !== undefined ? item.value : ''}
                                                                    disabled={((isDisabled !== undefined && isDisabled) || optionDisabled) ? isDisabled : false}
                                                                    required={(required !== undefined && required) ? required : false}
                                                                    checked={(defaultValue !== undefined && item.value !== undefined && defaultValue === item.value) ? 'checked' : ''}
                                                                    // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange('radio', e.target.name, e.target.value, e.target.checked)}
                                                                    onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                                    onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                                    onChange={((isDisabled !== undefined && isDisabled) || optionDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                                />
                                                                {(item.label !== undefined && item.label.locale !== undefined && item.label.locale[defaultLng] !== undefined) &&
                                                                    <label className="custom-control-label" htmlFor={id + '_' + index}>{item.label.locale[defaultLng]}</label>}
                                                            </div>
                                                    }
                                                </Fragment>
                                            )
                                        })}
                                    </div>
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel} ${labelString === 'right' ? ' lbl_rdo' : ''}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel} ${labelString === 'right' ? ' lbl_rdo' : ''}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                                <div className={classInput + ' ' + className}>
                                    <div className={`cstm_icn_area ${showAsButton && 'show_btn row'}`}>
                                        {(selectOptions !== undefined && selectOptions.length > 0) && selectOptions.map((item, index) => {
                                            let displayLabel = '';
                                            if (typeof item.label === "object" && item.label.locale !== undefined && Object.keys(item.label.locale).length > 0) {
                                                displayLabel = item.label.locale[defaultLng];
                                            } else {
                                                displayLabel = item.label;
                                            }
                                            const { isDisabled: optionDisabled = false, isDirectSubmit = false } = item;

                                            return (
                                                <Fragment key={index}>
                                                    {
                                                        showAsButton
                                                            ?
                                                            <div className={`col-6 rdo_btn_area ${lenghtClass}`} key={`mlti_rdi_${index}`}>
                                                                <Label className={`rdo_btn ${selectOptions.length < 3 ? 'm-0' : ''} ${(defaultValue !== undefined && item.value !== undefined && defaultValue === item.value) ? 'active' : ''}`} htmlFor={(id !== undefined && id) ? id + '_' + index : dynamicKey + index}>
                                                                    {displayLabel}
                                                                </Label>
                                                                <Input
                                                                    type="radio"
                                                                    className={`custom-control-input`}
                                                                    name={(name !== undefined && name) ? name : dynamicKey + index}
                                                                    key={(id !== undefined && id) ? id : dynamicKey + index}
                                                                    id={(id !== undefined && id) ? id + '_' + index : dynamicKey + index}
                                                                    value={item.value !== undefined ? item.value : ''}
                                                                    disabled={((isDisabled !== undefined && isDisabled) || optionDisabled) ? isDisabled : false}
                                                                    required={(required !== undefined && required) ? required : false}
                                                                    checked={(defaultValue !== undefined && item.value !== undefined && defaultValue === item.value) ? 'checked' : ''}
                                                                    // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange('radio', e.target.name, e.target.value, e.target.checked)}
                                                                    onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                                    onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                                    onChange={((isDisabled !== undefined && isDisabled) || optionDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, isDirectSubmit))}
                                                                />
                                                            </div>
                                                            :
                                                            <div className="custom-control custom-radio custom-control-inline" key={`mlti_rdi_${index}`}>
                                                                <Input
                                                                    type="radio"
                                                                    className={`custom-control-input`}
                                                                    name={(name !== undefined && name) ? name : dynamicKey + index}
                                                                    key={(id !== undefined && id) ? id : dynamicKey + index}
                                                                    id={(id !== undefined && id) ? id + '_' + index : dynamicKey + index}
                                                                    value={item.value !== undefined ? item.value : ''}
                                                                    disabled={((isDisabled !== undefined && isDisabled) || optionDisabled) ? isDisabled : false}
                                                                    required={(required !== undefined && required) ? required : false}
                                                                    checked={(defaultValue !== undefined && item.value !== undefined && defaultValue === item.value) ? 'checked' : ''}
                                                                    // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange('radio', e.target.name, e.target.value, e.target.checked)}
                                                                    onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                                    onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                                    onChange={((isDisabled !== undefined && isDisabled) || optionDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, isDirectSubmit))}
                                                                />
                                                                {(item.label !== undefined && item.label.locale !== undefined && item.label.locale[defaultLng] !== undefined) &&
                                                                    <label className="custom-control-label" htmlFor={id + '_' + index}>{item.label.locale[defaultLng]}</label>}
                                                            </div>
                                                    }
                                                </Fragment>
                                            )
                                        })}
                                    </div>
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                            </Fragment>
                    }
                </FormGroup>
                {mdlOpen &&
                    <ModalMandatory
                        mdlOpen={mdlOpen}
                        anyClickClose={false}
                        customClasses={mdlCustomClasses}
                        topPart={true}
                        bottomPart={true}
                        icon={mdlIcon}
                        tp_text1={tp_text1 !== '' ? intl.formatMessage({ id: tp_text1 }) : ''}
                        bp_text1={bp_text1 !== '' ? intl.formatMessage({ id: bp_text1 }) : ''}
                        button1={button1 !== '' ? intl.formatMessage({ id: button1 }) : ''}
                        button2={button2 !== '' ? intl.formatMessage({ id: button2 }) : ''}
                        toggleMethod={() => this.onClickOpen()}
                        btnMethod1={() => this.onClickClose()}
                        btnMethod2={() => this.onClickClose()}
                        props={this.props}
                    />
                }
                {/* } */}
            </Fragment>
        )
    }
}

//Default Props for Radio
Radio.defaultProps = {
    optionsObj: {
        id: 'Demo',
        className: 'cstm_input_sel',
        label: 'Radio',
        name: 'Demo',
        status: false,
        required: true,
        validationMsg: '',
        regex: '',
        isDisabled: false,
        options: [
            {
                "value": "Male",
                "result": "1"
            },
            {
                "value": "Female",
                "result": "2"
            },
            {
                "value": "Other",
                "result": "3"
            }
        ],
        labelAlignment: 'left',
        icon: '',
        iconPosition: '',
        displayAsButton: false,
        isMargeKeyValue: false,
        onBlurURL: "",
        onFocusURL: "",
        onChangeURL: "",
    },
    defaultValue: '',
    defaultLng: 'en',
    onChange: '',
    errorMsg: ''
}

export default Radio;