/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control radio
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
 import React, { Component, Fragment } from 'react';
 import { Label, FormGroup, Input } from 'reactstrap';
//  import AppConfig from 'DefaultConstants/AppConfig';;
//  const {swaggerPostAPI, swaggerGetAPI, getValueUsingKey, getValueUsingMapping }= require('DefaultHelpers')
 
 
 
 /**
  * Start Radio class component
  * @state {*Object} reqData
  */
 class RadioWithImage extends Component {
 
     constructor(props) {
         super(props);
         this.state = {
             selectOptions: [],
             externalURL: '',
             loading: true,
             name: props.optionsObj.name
         }
         //this.callAPI = this.callAPI.bind(this)
     }
 
     shouldComponentUpdate = (nextProps, nextState) => {
         if (this.props === nextProps) {
             return false;
         }
         return true;
     };
 
     // componentDidMount() {
     //     this.callAPI();
     // }
 
     componentWillMount() {
         this.callAPI();
     }
 
     /* on blur event */
     handleOnBlurEvent = (e) => {
         this.onBlurCallAPI(e);
     }
     /* on focus event */
     handleOnFocusEvent = (e) => {
         this.onFocusCallAPI(e);
     }
     /* on change event */
     handleOnChangeEvent = (e) => {
         this.props.onChange(e.target.type, e.target.name, e.target.value, e.target.checked)
         this.onChangeCallAPI(e);
     }
 
     callAPI = async () => {
         const { optionsObj: { options: defaultOptions = [], externalURL: { URL: extUrl = '', label: extLabel = '', value: extValue = '' } = {}, externalURL: externalObj = {} } = {} } = this.props;
 
         if (defaultOptions.length) {
 
             this.setState({ ...this.state, selectOptions: defaultOptions, loading: false })
         } else if (externalObj) {
 
             let externalObj = this.props.optionsObj.externalURL;
             const { optionsObj: { externalURL: { URL = '', method = "", request = [], listKey = '' } = {} } = {}, assignOptions = '' } = this.props;
 
             if (URL === '') {
                 this.setState({ loading: false })
                 return false;
             }
 
             var response = {};
             if (method === "POST") {
 
                 let { reqData: formRequest = {} } = this.props;
                 let apiRequest = { data: {} };
                 if (formRequest['userIdentifier'] === undefined && localStorage.getItem('user') !== null && localStorage.getItem('user') !== undefined)
                     formRequest['userIdentifier'] = apiRequest.data['userIdentifier'] = localStorage.getItem('user');
                 else if (!request.length)
                     apiRequest.data['userIdentifier'] = localStorage.getItem('user');
 
                 Array.isArray(request) && request.map((item) => {
                     const { key = '', value = '' } = item;
                     if (key !== '' && value !== '' && formRequest[value] !== '') {
                         apiRequest.data[key] = key === 'userIdentifier' ? localStorage.getItem('user') : formRequest[value];
                     } else {
                         apiRequest.data[key] = key === 'userIdentifier' ? localStorage.getItem('user') : '';
                     }
                 });
                 if(typeof this.props.swaggerPostAPI === 'function'){
                 response = await this.props.swaggerPostAPI(URL, apiRequest, true);
                }
 
             } else if(typeof this.props.swaggerGetAPI === 'function'){
                 response = await this.props.swaggerGetAPI(URL, {}, true);
             }
             // response = { "responseCode": 0, "errCode": "1", "message": "Success", "data": [{ "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Tom Dick" }, "UserAccountIdentifier": "7500075771", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515929102835048678664" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Bhavesh" }, "UserAccountIdentifier": "7580907426", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936065125725154969" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Dhruvit" }, "UserAccountIdentifier": "7528173747", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515937626770913723529" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test Branch" }, "UserAccountIdentifier": "7500075025", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924786534912002765" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "yuvi" }, "UserAccountIdentifier": "7500075781", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935284845022592197" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Dipesh" }, "UserAccountIdentifier": "7504248870", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515937614012519889521" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test Branch" }, "UserAccountIdentifier": "7500075007", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "243.00", "AvailableBalanceMajor": "243.00", "UsedValueMajor": "68.00" }] }], "UserAccountUniqueId": "192.168.2.22515904163391506809584" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Branch Test" }, "UserAccountIdentifier": "7500075084", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924828010773185662" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Testing Branch" }, "UserAccountIdentifier": "7500075011", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935960960468106119" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "John Branch" }, "UserAccountIdentifier": "7500078651", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935034671775345748" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test branch new" }, "UserAccountIdentifier": "7511595175", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515912550639133064809" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075024", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924719069386924667" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "John Branch" }, "UserAccountIdentifier": "7500007861", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515930669998288863290" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Testing" }, "UserAccountIdentifier": "7500070011", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515940094683952757395" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test Branch" }, "UserAccountIdentifier": "7500075014", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "1.00", "AvailableBalanceMajor": "1.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515907748412975970446" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075081", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924088046235102768" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500078630", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515934190002438777101" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500071111", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936210714052852340" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075093", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924130547578686914" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500078652", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935039344598621956" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075091", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924094511957188727" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7511595563", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515912559655764781789" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075092", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924122738517108441" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500007860", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515931605789452776765" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7560040075", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936059785412936331" }] }
             if (response.responseCode === 0) {
                 if (typeof response.data === "object" && response.data["0"] !== undefined) {
                     let tempArray = [];
                     Object.keys(response.data).map((key) => {
                         tempArray.push(response.data[key])
                     });
                     response.data = tempArray;
                 }
                 let filteredOptions = [];
                 const { optionsObj: { filter = [] } } = this.props;
                 if (Array.isArray(filter) && filter.length > 0 && typeof this.props.getValueUsingKey === 'function') {
                     response.data.map((value) => {
                         // const filter = [{ key: "STATUS", value: "ACTIVE" }, { key: "STATUS", value: "INACTIVES" }]
                         filter.map(filterItem => {
                             const splitRegex = '|'
                             const nameList = filterItem.value.split(splitRegex)
                             nameList.map(valueItem => {
                                 let keyValue = this.props.getValueUsingKey(filterItem.key, value);
                                 if (keyValue !== '' && valueItem !== undefined)
                                     if (keyValue.toString().toLowerCase() === valueItem.toString().toLowerCase()) {
                                         filteredOptions.push(value);
                                     }
                             })
                         })
                     });
                 } else {
                     filteredOptions = response.data;
                 }
 
                 if (typeof assignOptions === 'function') {
                     this.setState({ loading: false })
                     if (listKey !== '' && typeof this.props.getValueUsingKey === 'function') {
                         let optionsList = this.props.getValueUsingKey(listKey, filteredOptions);
                         if (optionsList !== '')
                             assignOptions(this.props.optionsObj.name, optionsList)
                     } else {
                         assignOptions(this.props.optionsObj.name, filteredOptions)
                     }
                 } else {
                     let selectOptions = [];
                     filteredOptions.map((value) => {
                         let optionLabel = value[externalObj.label];
                         if (value[externalObj.label] !== undefined && value[externalObj.label].locale !== undefined && Object.keys(value[externalObj.label].locale).length > 0) {
                             optionLabel = value[externalObj.label]['locale'][this.props.defaultLng];
                         } else if (value[externalObj.label] !== undefined && typeof value[externalObj.label] === 'object' && Object.keys(value[externalObj.label]).length > 0) {
                             optionLabel = value[externalObj.label][this.props.defaultLng]
                         } else if( typeof this.props.getValueUsingKey === 'function' ) {
                             optionLabel = this.props.getValueUsingKey(externalObj.label, value)
                         }
                         let object = {
                             label: optionLabel,
                             value: typeof this.props.getValueUsingKey === 'function' ? this.props.getValueUsingKey(externalObj.value, value) : ''
                         };
                         if (value[externalObj.image] !== undefined && value[externalObj.image] !== '') {
                             object.image = value[externalObj.image];
                         }
                         selectOptions.push(object);
                     });
                     console.log(selectOptions, 'selectOptions')
                     this.setState({ selectOptions: selectOptions, externalURL: externalObj.URL, loading: false })
                 }
             } else {
                 this.setState({ selectOptions: [], externalURL: externalObj.URL, loading: false })
             }
         }
     }
 
     onBlurCallAPI = async (e) => {
         const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {}, assignResponseValue } = this.props;
         if (onBlurURL !== '') {
 
             let response = '';
             let inputName = e.target.name;
             let inputValue = e.target.value;
 
             if (blurMethod !== '' && blurMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                 let data = {
                     [inputName]: inputValue
                 }
                 response = await this.props.swaggerPostAPI(onBlurURL, data, true);
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(inputName, `error.message.${response.errCode}`)
                 }
                 // to do handle response of post method
             } else if(typeof this.props.swaggerGetAPI === 'function') {
                 response = await this.props.swaggerGetAPI(onBlurURL, {}, true);
                 // response = { responseCode: 0, data: { billAmount: 1000 } }
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                     }
                 }
             }
 
         }
     }
 
     onFocusCallAPI = async (e) => {
         const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue } = this.props;
         if (onFocusURL !== '') {
 
             let data = {
                 [e.target.name]: e.target.value
             }
             let response = '';
 
             if (focusMethod !== '' && focusMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                 response = await this.props.swaggerPostAPI(onFocusURL, data, true);
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(e.target.name, `error.message.${response.errCode}`)
                 }
                 // to do handle response of post method
             } else if(typeof this.props.swaggerGetAPI === 'function'){
                 response = await this.props.swaggerGetAPI(onFocusURL, data, true);
                 // response = { responseCode: 0, data: { billAmount: 1000 } }
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(e.target.name, `error.message.${response.errCode}`)
                 }
             }
 
         }
 
     }
 
     async onChangeCallAPI(e) {
         const { optionsObj: { onChangeURL = '', pageId = '', changeBindIn = '', changeResponseField = '', changeMethod = '' } = {}, assignResponseValue } = this.props;
         if (onChangeURL !== '') {
             const { location: { state: { page_id: OldPageID = '' } = {} } = {} } = this.props;
             if (OldPageID === pageId) {
                 return false; // do nothing when same page id are same
             } else if (pageId !== '') {
                 this.props.history.push({
                     pathname: onChangeURL,
                     state: { page_id: pageId }
                 })
             } else {
                 let data = {
                     [e.target.name]: e.target.value
                 }
                 let response = '';
 
                 if (changeMethod !== '' && changeMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                     response = await this.props.swaggerPostAPI(onChangeURL, data, true);
                     if (response.responseCode === 0) {
                         if (typeof assignResponseValue === 'function') {
                             assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                         }
                     } else if (response.responseCode === 1) {
                         this.props.onError(e.target.name, `error.message.${response.errCode}`)
                     }
                     // to do handle response of post method
                 } else if(typeof this.props.swaggerGetAPI === 'function'){
                     response = await this.props.swaggerGetAPI(onChangeURL, data, true);
                     // response = { responseCode: 0, data: { billAmount: 1000 } }
                     if (response.responseCode === 0) {
                         if (typeof assignResponseValue === 'function') {
                             assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                         }
                     } else if (response.responseCode === 1) {
                         this.props.onError(e.target.name, `error.message.${response.errCode}`)
                     }
                 }
             }
         }
 
     }
 
     componentWillReceiveProps(nextProps) {
         // this.callAPI()
         if (nextProps.optionsObj.name === this.state.name && nextProps.optionsObj.options !== undefined && nextProps.optionsObj.options.length && this.state.selectOptions !== nextProps.optionsObj.options) {
             // const selectedOptions = this._convertOptions(nextProps.optionsObj.options);
             this.setState({ selectOptions: nextProps.optionsObj.options })
         } else if (nextProps && nextProps.optionsObj && nextProps.optionsObj.options !== undefined && nextProps.optionsObj.options.length && nextProps.optionsObj.name === this.state.name) {
             // const selectedOptions = this._convertOptions(nextProps.optionsObj.options);
             this.setState({ selectOptions: nextProps.optionsObj.options, externalURL: '' })
         } else if (nextProps.optionsObj && nextProps.optionsObj.externalURL && nextProps.optionsObj.externalURL.URL && this.state.externalURL !== nextProps.optionsObj.externalURL.URL && nextProps.optionsObj.name === this.state.name) {
             this.setState({ selectOptions: [], externalURL: this.props.optionsObj.externalURL.URL }, () => {
                 this.callAPI()
             })
         } else if (nextProps && nextProps.optionsObj && nextProps.optionsObj.options && nextProps.optionsObj.options.length && nextProps.optionsObj.selectObjFromProfile) {
             this.setState({ selectOptions: nextProps.optionsObj.options, externalURL: '' })
         } else if (nextProps.optionsObj.options !== undefined && !nextProps.optionsObj.options.length && (nextProps.optionsObj && (!nextProps.optionsObj.externalURL || !nextProps.optionsObj.externalURL.URL)) && nextProps.optionsObj.name === this.state.name) {
             this.setState({ selectOptions: [], externalURL: '' });
         }
     }
 
     render() {
         const { errorMsg, defaultValue, defaultLng } = this.props;
         const { id, className, key, label, name, status, required, isDisabled, options, labelAlignment, displayAsButton, isMargeKeyValue, onBlurURL, onFocusURL, onChangeURL } = this.props.optionsObj;
         const { selectOptions = [] } = this.state
         let dynamicKey = 'frm_radio_' + (name !== undefined ? name : 'textRadioInput');
         let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
         let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
         let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
         let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
         // let showAsButton = displayAsButton !== undefined && displayAsButton ? displayAsButton : false;
         let showAsButton = false;
         let showMargeKeyValue = isMargeKeyValue !== undefined && isMargeKeyValue ? isMargeKeyValue : false;
         let lenghtClass = 'col-md-4';
         if (selectOptions.length === 1) {
             lenghtClass = 'col-md-12';
         } else if (selectOptions.length < 3) {
             lenghtClass = 'col-md-6';
         }
 
 
 
         return (
             <Fragment>
                 {/* {status && */}
                 {
                     labelString === 'right'
                         ?
                         <Fragment>
                             <div className={classInput + ' ' + className}>
                                 <div className={`cstm_icn_area ${showAsButton && 'show_btn row'}`}>
                                     {(selectOptions !== undefined && selectOptions.length > 0) && selectOptions.map((item, index) => {
 
                                         let displayLabel = '';
                                         if (typeof item.label === "object" && item.label.locale !== undefined && Object.keys(item.label.locale).length > 0) {
                                             displayLabel = item.label.locale[defaultLng];
                                         } else {
                                             displayLabel = item.label;
                                         }
                                         let isSingleRadioDisabled = item.isDisabled !== undefined && item.isDisabled === true ? 'disabled' : '';
                                         return (
                                             <Fragment key={index}>
                                                 <FormGroup className="row" key={dynamicKey} check isSingleRadioDisabled>
                                                     <Label check>
                                                         <Input
                                                             type="radio"
                                                             // className={`custom-control-input`}
                                                             name={(name !== undefined && name) ? name : dynamicKey + index}
                                                             key={(id !== undefined && id) ? id : dynamicKey + index}
                                                             id={(id !== undefined && id) ? id + '_' + index : dynamicKey + index}
                                                             value={item.value !== undefined ? item.value : ''}
                                                             disabled={isSingleRadioDisabled}
                                                             required={(required !== undefined && required) ? required : false}
                                                             checked={(defaultValue !== undefined && item.value !== undefined && defaultValue === item.value) ? 'checked' : ''}
                                                             // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange('radio', e.target.name, e.target.value, e.target.checked)}
                                                             onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                             onFocus={(onFocusURL !== undefined && onFocusURL) ? ((e) => this.handleOnFocusEvent(e)) : () => ({})}
                                                             onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                         /> {' '}
                                                         {
                                                             (item.label !== undefined && item.label.locale !== undefined && item.label.locale[defaultLng] !== undefined) &&
                                                             item.label.locale[defaultLng]
                                                         }
                                                     </Label>
                                                 </FormGroup>
                                             </Fragment>
                                         )
                                     })}
                                 </div>
                                 {errorMsg && <div className="validation_error">{errorMsg}</div>}
                             </div>
                             {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                 <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                         </Fragment>
                         :
                         <Fragment>
                             {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                 <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                             <div className={classInput + ' ' + className}>
                                 <div className={`cstm_icn_area ${showAsButton && 'show_btn row'}`}>
                                     {(selectOptions !== undefined && selectOptions.length > 0) && selectOptions.map((item, index) => {
                                         let displayLabel = '';
                                         if (typeof item.label === "object" && item.label.locale !== undefined && Object.keys(item.label.locale).length > 0) {
                                             displayLabel = item.label.locale[defaultLng];
                                         } else {
                                             displayLabel = item.label;
                                         }
 
                                         let isSingleRadioDisabled = item.isDisabled !== undefined && item.isDisabled === true ? 'disabled' : '';
                                         let image = item.image !== undefined ? item.image : ''
 
                                         return (
                                             <Fragment key={index}>
                                                 <FormGroup className="row custom-control-radio" key={dynamicKey} check isSingleRadioDisabled>
                                                     <Label check>
                                                         <Input
                                                             type="radio"
                                                             className={`option-input radio`}
                                                             name={(name !== undefined && name) ? name : dynamicKey + index}
                                                             key={(id !== undefined && id) ? id : dynamicKey + index}
                                                             id={(id !== undefined && id) ? id + '_' + index : dynamicKey + index}
                                                             value={item.value !== undefined ? item.value : ''}
                                                             disabled={isSingleRadioDisabled}
                                                             required={(required !== undefined && required) ? required : false}
                                                             checked={(defaultValue !== undefined && item.value !== undefined && defaultValue === item.value) ? 'checked' : ''}
                                                             // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange('radio', e.target.name, e.target.value, e.target.checked)}
                                                             onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                             onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                             onChange={(isDisabled !== undefined && !isDisabled) ? (e) => this.handleOnChangeEvent(e) :() => ({}) }
                                                         /> {' '}
                                                         {
                                                             (item.label !== undefined && item.label.locale !== undefined && item.label.locale[defaultLng] !== undefined) &&
                                                             <span>{item.label.locale[defaultLng]}</span>
                                                         }
                                                     </Label>
                                                     {
                                                         item.image != '' &&
                                                         <img src={require(`./image/api/${image}.png`)} className="float-right"/>
                                                     }
                                                 </FormGroup>
                                             </Fragment>
                                         )
                                     })}
                                 </div>
                                 {errorMsg && <div className="validation_error">{errorMsg}</div>}
                             </div>
                         </Fragment>
                 }
                 {/* } */}
             </Fragment>
         )
     }
 }
 
 //Default Props for Radio
 RadioWithImage.defaultProps = {
     optionsObj: {
         id: 'Demo',
         className: 'cstm_input_sel',
         label: 'Radio',
         name: 'Demo',
         status: false,
         required: true,
         validationMsg: '',
         regex: '',
         isDisabled: false,
         options: [
             {
                 "value": "Male",
                 "result": "1"
             },
             {
                 "value": "Female",
                 "result": "2"
             },
             {
                 "value": "Other",
                 "result": "3"
             }
         ],
         labelAlignment: 'left',
         icon: '',
         iconPosition: '',
         displayAsButton: false,
         isMargeKeyValue: false,
         onBlurURL: "",
         onFocusURL: "",
         onChangeURL: "",
     },
     defaultValue: '',
     defaultLng: '',
     onChange: '',
     errorMsg: ''
 }
 
 export default RadioWithImage;