/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control React Select
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input } from 'reactstrap';
import ReactHtmlParser from "react-html-parser";
//  import CircularProgress from '@material-ui/core/CircularProgress';
// import AppConfig from 'DefaultConstants/AppConfig';
// const { MUIDataTable, ModalMandatory } = require('DefaultComponents/Widgets')
import Select from "react-select";
// const { swaggerPostAPI, swaggerGetAPI, getValueUsingKey, getValueUsingMapping, encodeQueryData } = require('DefaultHelpers')
import dot from 'dot-object';
dot.override = true;

/**
 * Start ReactSelectWidget class component
 * @state {*Object} reqData
 */
class ReactSelectWidget extends Component {
    constructor(props) {
        super(props);
        this.state = {
            selectOptions: [],
            externalURL: '',
            loading: true,
            name: props.optionsObj.name,
            displayTable: false,
            tableResponse: {},
            mdlOpen: false,
            mdlConfig: {}
        }
        //this.callAPI = this.callAPI.bind(this)
        const { defaultValue = '', optionsObj: { onChangeURL = '', changeMethod = '', changeBindIn = '', changeResponseField = '', setOptionsIn = '', autoCompleteServerSide = {}, name = '' } = {} } = props;
        const { enabled = false, } = autoCompleteServerSide;
        if (defaultValue !== '' && onChangeURL !== '' && changeMethod !== '' && ((changeBindIn !== '' && changeResponseField !== '') || setOptionsIn !== '')) {

            let e = { target: { value: defaultValue } };
            this.onChangeCallAPI(e, false, false, e.target, true);
        }
        /* check if autcomplete with server side */
        if (defaultValue !== "" && enabled) {
            this.onSearchCallAPI(defaultValue)
        }

    }

    onClickOpen = () => {
        this.setState({ mdlOpen: !this.state.mdlOpen });
    };

    onClickClose = () => {
        this.setState({ mdlOpen: false });
    };

    /* Convert option to react select options*/
    _convertOptions(reactOptions) {
        let selectOptions = [];
        reactOptions.map((item) => {
            let optionLabel = item.label;
            if (item.label !== undefined && Object.keys(item.label).length > 0 && item.label.locale !== undefined && Object.keys(item.label.locale).length > 0) {
                optionLabel = item.label.locale[this.props.defaultLng];
            } else if (item.label !== undefined && Object.keys(item.label).length > 0) {
                optionLabel = item.label[this.props.defaultLng]
            }
            let object = {
                label: optionLabel,
                value: item.value
            };
            if (item.image !== undefined && item.image !== '') {
                object.image = item.image;
            }
            selectOptions.push(object);
        });
        return selectOptions;
    }

    componentDidMount() {
        this.callAPI();

    }

    componentWillReceiveProps(nextProps) {
        if (nextProps.optionsObj.name === this.state.name && this.state.selectOptions !== nextProps.optionsObj.options) {
            // const selectedOptions = this._convertOptions(nextProps.optionsObj.options);
            this.setState({ selectOptions: nextProps.optionsObj.options })
        } else if (nextProps && nextProps.optionsObj && nextProps.optionsObj.options && nextProps.optionsObj.options.length && nextProps.optionsObj.name === this.state.name) {
            // const selectedOptions = this._convertOptions(nextProps.optionsObj.options);
            this.setState({ selectOptions: nextProps.optionsObj.options, externalURL: '' })
        } else if (nextProps.optionsObj && nextProps.optionsObj.externalURL && nextProps.optionsObj.externalURL.URL && this.state.externalURL !== nextProps.optionsObj.externalURL.URL && nextProps.optionsObj.name === this.state.name) {
            this.setState({ selectOptions: [], externalURL: this.props.optionsObj.externalURL.URL }, () => {
                this.callAPI()
            })
        } else if (nextProps && nextProps.optionsObj && nextProps.optionsObj.options && nextProps.optionsObj.options.length && nextProps.optionsObj.selectObjFromProfile) {
            this.setState({ selectOptions: nextProps.optionsObj.options, externalURL: '' })
        } else if (!nextProps.optionsObj.options.length && (nextProps.optionsObj && (!nextProps.optionsObj.externalURL || !nextProps.optionsObj.externalURL.URL)) && nextProps.optionsObj.name === this.state.name) {
            this.setState({ selectOptions: [], externalURL: '' });
        }
    }

    async callAPI() {
        if (this.props.optionsObj && this.props.optionsObj.options && this.props.optionsObj.options.length) {
            this.setState({ selectOptions: this.props.optionsObj.options, loading: false })
        } else if (this.props.optionsObj && this.props.optionsObj.externalURL) {

            let externalObj = this.props.optionsObj.externalURL;
            const { optionsObj: { externalURL: { URL = '', method = "", request = [], listKey = '' } = {}, editProfile = false } = {}, assignOptions = '', reqData: formRequest = {}, savedObject, defaultValue, swaggerPostAPI, swaggerGetAPI, encodeQueryData, getValueUsingKey } = this.props;

            if (URL === '') {
                this.setState({ loading: false })
                return false;
            }

            // let { reqData: formRequest = {} } = this.props;
            let apiRequest = { data: {} };
            if (formRequest['userIdentifier'] === undefined && localStorage.getItem('user') !== null && localStorage.getItem('user') !== undefined)
                formRequest['userIdentifier'] = apiRequest.data['userIdentifier'] = localStorage.getItem('user');
            else if (!request.length)
                apiRequest.data['userIdentifier'] = localStorage.getItem('user');

            Array.isArray(request) && request.map((item) => {
                const { key = '', value = '' } = item;
                let resValue = getValueUsingKey(value, { ...formRequest, ...savedObject });
                if (key !== '' && value !== '') {
                    // let resValue = dot.pick(value, { ...formRequest, ...savedObject });
                    apiRequest.data[key] = (resValue !== undefined && resValue !== '') ? resValue : (value !== '' && value.toString().indexOf('.') === -1 ? value : '');
                }
                if (key !== '' && value !== '' && formRequest[value] !== '') {
                    apiRequest.data[key] = key === 'userIdentifier' ? localStorage.getItem('user') : resValue;
                } else {
                    apiRequest.data[key] = key === 'userIdentifier' ? localStorage.getItem('user') : '';
                }
            });

            var response = {};
            if (method === "POST" && typeof swaggerPostAPI === 'function' && typeof getValueUsingKey === "function") {


                response = await swaggerPostAPI(URL, apiRequest, true);

            } else if (typeof encodeQueryData === 'function' && typeof swaggerGetAPI === 'function') {
                let apiUrl = URL;
                if (apiUrl.toString().indexOf("?") > -1) {
                    apiUrl = apiUrl + '&' + encodeQueryData(apiRequest.data);
                } else {
                    apiUrl = apiUrl + '?' + encodeQueryData(apiRequest.data);
                }
                response = await swaggerGetAPI(apiUrl, {}, true);
            }
            // response = { "responseCode": 0, "errCode": "1", "message": "Success", "data": [{ "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Tom Dick" }, "UserAccountIdentifier": "7500075771", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515929102835048678664" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Bhavesh" }, "UserAccountIdentifier": "7580907426", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936065125725154969" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Dhruvit" }, "UserAccountIdentifier": "7528173747", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515937626770913723529" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test Branch" }, "UserAccountIdentifier": "7500075025", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924786534912002765" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "yuvi" }, "UserAccountIdentifier": "7500075781", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935284845022592197" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Dipesh" }, "UserAccountIdentifier": "7504248870", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515937614012519889521" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test Branch" }, "UserAccountIdentifier": "7500075007", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "243.00", "AvailableBalanceMajor": "243.00", "UsedValueMajor": "68.00" }] }], "UserAccountUniqueId": "192.168.2.22515904163391506809584" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Branch Test" }, "UserAccountIdentifier": "7500075084", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924828010773185662" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Testing Branch" }, "UserAccountIdentifier": "7500075011", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935960960468106119" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "John Branch" }, "UserAccountIdentifier": "7500078651", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935034671775345748" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test branch new" }, "UserAccountIdentifier": "7511595175", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515912550639133064809" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075024", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924719069386924667" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "John Branch" }, "UserAccountIdentifier": "7500007861", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515930669998288863290" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Testing" }, "UserAccountIdentifier": "7500070011", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515940094683952757395" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test Branch" }, "UserAccountIdentifier": "7500075014", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "1.00", "AvailableBalanceMajor": "1.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515907748412975970446" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075081", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924088046235102768" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500078630", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515934190002438777101" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500071111", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936210714052852340" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075093", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924130547578686914" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500078652", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935039344598621956" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075091", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924094511957188727" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7511595563", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515912559655764781789" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075092", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924122738517108441" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500007860", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515931605789452776765" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7560040075", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936059785412936331" }] }
            if (response.responseCode === 0) {

                if (typeof response.data === "object" && response.data["0"] !== undefined) {
                    let tempArray = [];
                    Object.keys(response.data).map((key) => {
                        tempArray.push(response.data[key])
                    });
                    response.data = tempArray;
                }
                let filteredOptions = [], optionsList = [];
                if (listKey !== '' && typeof getValueUsingKey === "function") {
                    optionsList = getValueUsingKey(listKey, listKey.indexOf('data.') > -1 ? response : filteredOptions);
                } else {
                    optionsList = response.data;
                }

                const { optionsObj: { filter = [] } } = this.props;
                if (Array.isArray(filter) && filter.length > 0) {
                    optionsList.map((value) => {
                        // const filter = [{ key: "STATUS", value: "ACTIVE" }, { key: "STATUS", value: "INACTIVES" }]
                        filter.map(filterItem => {
                            const splitRegex = '|'
                            const nameList = filterItem.value.split(splitRegex)
                            nameList.map(valueItem => {
                                if (typeof getValueUsingKey === "function") {
                                    let keyValue = getValueUsingKey(filterItem.key, value);
                                    if (keyValue !== '' && valueItem !== undefined)
                                        if (keyValue.toString().toLowerCase() === valueItem.toString().toLowerCase()) {
                                            filteredOptions.push(value);
                                        }
                                }
                            })
                        })
                    });
                } else {
                    filteredOptions = optionsList;
                }

                if (typeof assignOptions === 'function') {
                    this.setState({ loading: false })
                    assignOptions(this.props.optionsObj.name, filteredOptions, defaultValue !== '' || editProfile)
                } else {
                    let selectOptions = [];
                    filteredOptions.map((value) => {
                        let optionLabel = value[externalObj.label];
                        if (value[externalObj.label] !== undefined && value[externalObj.label].locale !== undefined && Object.keys(value[externalObj.label].locale).length > 0) {
                            optionLabel = value[externalObj.label]['locale'][this.props.defaultLng];
                        } else if (value[externalObj.label] !== undefined && Object.keys(value[externalObj.label]).length > 0) {
                            optionLabel = value[externalObj.label][this.props.defaultLng]
                        } else if (typeof getValueUsingKey === "function") {
                            optionLabel = getValueUsingKey(externalObj.label, value)
                        }
                        if (typeof getValueUsingKey === "function") {
                            let object = {
                                label: optionLabel,
                                value: getValueUsingKey(externalObj.value, value)
                            };
                            if (value[externalObj.image] !== undefined && value[externalObj.image] !== '') {
                                object.image = value[externalObj.image];
                            }
                            selectOptions.push(object);
                        }
                    });
                    this.setState({ selectOptions: selectOptions, externalURL: externalObj.URL, loading: false })
                }
            } else {
                this.setState({ selectOptions: [], externalURL: externalObj.URL, loading: false })
            }
        }
    }

    /* on blur event */
    handleOnBlurEvent = (e, reactSelect) => {
        this.onBlurCallAPI(e, reactSelect);
    }
    /* on focus event */
    handleOnFocusEvent = (e) => {
        this.onFocusCallAPI(e);
    }
    /* on change event */
    handleOnChangeEvent = (e, isMultiple, reactSelect) => {

        const {
            optionsObj: {
                name: inputName = '',
                displayObject: { enabled: displayEnabled = false } = {},
                externalURL: { value: extValue = '' } = {},
                allowClear: { enabled: allowEnabled = false } = {},
                mdlConfig: { enabled: mdlEnabled = false, valueMatch = '', isNonEmpty = false } = {},
                mdlConfig: _mdlConfig = {},
                allowClear = {}
            } = {}, defaultValue = '',
            allowClearAggregator,
            onChange,
            getValueUsingKey
        } = this.props;

        if (mdlEnabled && ((e.value === valueMatch) || (isNonEmpty && e.value !== ''))) {
            this.setState({ mdlOpen: true, mdlConfig: _mdlConfig });
        } else {
            if (allowEnabled && defaultValue !== '' && defaultValue !== e.value && typeof allowClearAggregator === "function") {
                allowClear['key'] = inputName;
                allowClear['value'] = e.value;
                allowClearAggregator(allowClear)
            }

            let selectedObject = {};
            if (isMultiple !== undefined && isMultiple && typeof onChange === "function") {
                onChange('multi_select', this.props.optionsObj.name, e);
            } else {
                let selectValue = e.value;
                if (displayEnabled && typeof getValueUsingKey === 'function') {
                    const { selectOptions = [] } = this.state;
                    selectOptions.map(sItem => {
                        if (typeof sItem.object === 'object' && getValueUsingKey(extValue, sItem.object) === selectValue) {
                            this.setState({ tableResponse: sItem.object, displayTable: true })
                        } else if (getValueUsingKey(extValue, sItem) === selectValue) {
                            this.setState({ tableResponse: sItem, displayTable: true })
                        }
                    })
                } else if (typeof getValueUsingKey === 'function') {
                    const { selectOptions = [] } = this.state;
                    selectOptions.map(sItem => {
                        if (typeof sItem.object === 'object' && getValueUsingKey(extValue, sItem.object) === selectValue) {
                            selectedObject = sItem.object;
                        } else if (getValueUsingKey(extValue, sItem) === selectValue) {
                            selectedObject = sItem;
                        }
                    })
                }
                if (typeof onChange === "function") {
                    onChange('select', this.props.optionsObj.name, selectValue, '', '', '', e.label)
                }
            }
            this.onChangeCallAPI(e, isMultiple, reactSelect, selectedObject);
        }
    }

    onBlurCallAPI = async (e) => {

        const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {}, assignResponseValue, onError, swaggerPostAPI, swaggerGetAPI } = this.props;
        if (onBlurURL !== '') {

            let response = '';
            let inputName = e.target.name;
            let inputValue = e.target.value;

            if (blurMethod !== '' && blurMethod === 'POST' && typeof swaggerPostAPI === "function") {
                let data = {
                    [inputName]: inputValue
                }
                response = await swaggerPostAPI(onBlurURL, data, true);
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1 && typeof onError === "function") {
                    onError(inputName, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof swaggerGetAPI === "function") {
                response = await swaggerGetAPI(onBlurURL, {}, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                }
            }

        }
    }

    onFocusCallAPI = async (e) => {

        const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue, swaggerPostAPI, swaggerGetAPI, onError } = this.props;
        if (onFocusURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (focusMethod !== '' && focusMethod === 'POST') {
                response = await swaggerPostAPI(onFocusURL, data, true);
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1 && typeof onError === "function") {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof swaggerGetAPI === "function") {
                response = await swaggerGetAPI(onFocusURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0 && typeof assignResponseValue === 'function') {
                    assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1 && typeof onError === "function") {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }

    onChangeCallAPI = async (e, isMultiple, reactSelect, selectedObject, ignoreAssignOptions = false) => {

        let { optionsObj: { onChange = [], onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '', setOptionsIn = '', changeRequest = [] } = {}, assignResponseValue, assignOptions, swaggerPostAPI, swaggerGetAPI, getValueUsingKey, onError } = this.props;

        if (onChange.length === 0) {
            onChange.push({ onChangeURL, changeBindIn, changeResponseField, changeMethod, setOptionsIn, changeRequest });
        }

        onChange.map(async (item) => {
            const { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '', setOptionsIn = '', changeRequest = [] } = item;

            if ((onChangeURL !== '' && changeMethod !== '' && setOptionsIn !== '') || (onChangeURL !== '' && changeMethod !== '')) {

                let response = {};
                if (setOptionsIn !== '' && typeof assignOptions === 'function' && !ignoreAssignOptions) {
                    setTimeout(function () {
                        assignOptions(setOptionsIn, [])
                    }, 500)
                }

                let { reqData: formRequest = {} } = this.props;
                if (formRequest['userIdentifier'] !== undefined && localStorage.getItem('user') !== null && localStorage.getItem('user') !== undefined)
                    formRequest['userIdentifier'] = localStorage.getItem('user');

                let apiRequest = { data: {} };
                Array.isArray(changeRequest) && changeRequest.map((item) => {
                    const { key = '', value = '', isFromSelected = false } = item;
                    if (key !== '' /* && value !== '' && formRequest[value] !== '' */) {
                        if (isFromSelected) {
                            apiRequest.data[key] = (reactSelect) ? e.value : e.target.value;
                        } else {
                            apiRequest.data[key] = formRequest[value];
                        }
                    } else {
                        apiRequest.data[key] = ''
                    }
                });
                this.setState({ loading: true })
                if (changeMethod !== '' && changeMethod === 'POST' && typeof swaggerPostAPI === "function") {
                    if (isMultiple !== undefined && isMultiple) {
                        response = await swaggerPostAPI(onChangeURL, e.target.selectedOptions, true);
                    } else {
                        response = await swaggerPostAPI(onChangeURL, apiRequest, true);
                    }
                    // response = { "responseCode": 0, "errCode": "1", "message": "Success", "data": [{ "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075771", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515929102835048678664" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7580907426", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936065125725154969" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7528173747", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515937626770913723529" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075025", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924786534912002765" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075781", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935284845022592197" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7504248870", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515937614012519889521" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075007", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "243.00", "AvailableBalanceMajor": "243.00", "UsedValueMajor": "68.00" }] }], "UserAccountUniqueId": "192.168.2.22515904163391506809584" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075084", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924828010773185662" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075011", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935960960468106119" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500078651", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935034671775345748" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7511595175", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515912550639133064809" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075024", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924719069386924667" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500007861", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515930669998288863290" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500070011", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515940094683952757395" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075014", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "1.00", "AvailableBalanceMajor": "1.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515907748412975970446" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075081", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924088046235102768" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "John Teller" }, "UserAccountIdentifier": "7500078630", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515934190002438777101" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test teller" }, "UserAccountIdentifier": "7500071111", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936210714052852340" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075093", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924130547578686914" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "John Teller" }, "UserAccountIdentifier": "7500078652", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935039344598621956" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075091", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924094511957188727" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test Teller new" }, "UserAccountIdentifier": "7511595563", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515912559655764781789" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075092", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924122738517108441" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "John Teller" }, "UserAccountIdentifier": "7500007860", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515931605789452776765" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Bhavesh" }, "UserAccountIdentifier": "7560040075", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936059785412936331" }] };
                    // response = await swaggerPostAPI(onChangeURL, data, true);
                    if (response.responseCode === 0) {
                        if (typeof assignResponseValue === 'function' && typeof getValueUsingKey === "function" && changeBindIn !== '') {
                            let onChangeResponseField = changeResponseField;
                            if (onChangeResponseField.toString().indexOf('|') > -1 && changeBindIn.toString().indexOf('|') > -1) {

                                setTimeout(() => {
                                    let onChangeBindIn = changeBindIn.split('|');
                                    onChangeResponseField.split('|').map((value, index) => {
                                        if (value !== '' && value.toString().indexOf('.') > -1) {
                                            setTimeout(function () {
                                                let resParamValue = getValueUsingKey(value, response); // first argument field and second response value
                                                if (resParamValue !== undefined) {
                                                    assignResponseValue(onChangeBindIn[index], resParamValue); // first argument field and second response value
                                                } else {
                                                    assignResponseValue(onChangeBindIn[index], '', '', true); // first argument field and second response value
                                                }
                                            }, 500);
                                        } else {
                                            let foundValue = false;
                                            Array.isArray(this.state.selectOptions) && this.state.selectOptions.length > 0 && this.state.selectOptions.map((item) => {
                                                if (item.value == ((reactSelect) ? e.value : e.target.value) && item.object !== undefined && item.object[value] !== undefined) {
                                                    foundValue = true;
                                                    setTimeout(function () {
                                                        if (item.object[value] !== undefined) {
                                                            assignResponseValue(onChangeBindIn[index], item.object[value]); // first argument field and second response value
                                                        } else {
                                                            assignResponseValue(onChangeBindIn[index], '', '', true); // first argument field and second response value
                                                        }
                                                    }, 500);
                                                }
                                            });
                                            if (!foundValue) {
                                                setTimeout(function () {
                                                    assignResponseValue(onChangeBindIn[index], '', '', true); // first argument field and second response value
                                                }, 500);
                                            }
                                        }
                                    });
                                }, ignoreAssignOptions ? 2000 : 0);

                            } else {
                                if (changeResponseField !== '' && changeResponseField.toString().indexOf('.') > -1) {
                                    let resParamValue = getValueUsingKey(changeResponseField, response); // first argument field and second response value
                                    assignResponseValue(changeBindIn, resParamValue !== undefined ? resParamValue : '', '', true); // first argument field and second response value
                                } else {
                                    assignResponseValue(changeBindIn, response.data[changeResponseField] !== undefined ? response.data[changeResponseField] : '', '', true); // first argument field and second response value
                                }
                            }
                        } else if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                            if (typeof response.data === "object" && response.data["0"] !== undefined) {
                                let tempArray = [];
                                Object.keys(response.data).map((key) => {
                                    tempArray.push(response.data[key])
                                });
                                response.data = tempArray;
                            }
                            let filteredOptions = [];
                            const { optionsObj: { filter = [] } } = this.props;
                            if (Array.isArray(filter) && filter.length > 0) {
                                response.data.map((value) => {
                                    // const filter = [{ key: "STATUS", value: "ACTIVE" }, { key: "STATUS", value: "INACTIVES" }]
                                    filter.map(filterItem => {
                                        const splitRegex = '|'
                                        const nameList = filterItem.value.split(splitRegex)
                                        nameList.map(valueItem => {
                                            if (typeof getValueUsingKey === "function") {
                                                let keyValue = getValueUsingKey(filterItem.key, value);
                                                if (keyValue !== '' && valueItem !== undefined)
                                                    if (keyValue.toString().toLowerCase() === valueItem.toString().toLowerCase()) {
                                                        filteredOptions.push(value);
                                                    }
                                            }
                                        })
                                    })
                                });
                            } else {
                                filteredOptions = response.data;
                            }
                            assignOptions(setOptionsIn, filteredOptions)
                        }
                    } else if (response.responseCode === 1) {
                        if (typeof assignResponseValue === 'function' && changeBindIn !== '') {
                            assignResponseValue(changeBindIn, ''); // first argument field and second response value
                        } else if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                            assignOptions(setOptionsIn, [])
                        }
                        if (typeof onError === "function") {
                            onError(e.target.name, `apiErrCode.${response.errCode}`)
                        }
                    }
                    // to do handle response of post method
                } else {
                    let apiUrl = onChangeURL;
                    if (typeof encodeQueryData === "function") {
                        if (apiUrl.toString().indexOf("?")) {
                            apiUrl = apiUrl + '&' + encodeQueryData(apiRequest.data);
                        } else {
                            apiUrl = apiUrl + '?' + encodeQueryData(apiRequest.data);
                        }
                    }
                    if (isMultiple !== undefined && isMultiple && typeof swaggerGetAPI === "function") {
                        response = await swaggerGetAPI(apiUrl, {}, true);
                    } else if (typeof swaggerGetAPI === "function") {
                        // let selectedID = (reactSelect) ? e.value : e.target.value;
                        // let url = apiUrl + '' + selectedID;
                        response = await swaggerGetAPI(apiUrl, {}, true);
                    }
                    // response = await swaggerGetAPI(onChangeURL, data, true);
                    // response = { responseCode: 0, data: { billAmount: 1000 } }
                    if (response.responseCode === 0) {
                        if (typeof assignResponseValue === 'function' && changeBindIn !== '') {
                            assignResponseValue(changeBindIn, response.data[changeResponseField], ignoreAssignOptions); // first argument field and second response value
                        } else if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                            if (typeof response.data === "object" && response.data["0"] !== undefined) {
                                let tempArray = [];
                                Object.keys(response.data).map((key) => {
                                    tempArray.push(response.data[key])
                                });
                                response.data = tempArray;
                            }
                            let filteredOptions = [];
                            const { optionsObj: { filter = [] } } = this.props;
                            if (Array.isArray(filter) && filter.length > 0) {
                                response.data.map((value) => {
                                    // const filter = [{ key: "STATUS", value: "ACTIVE" }, { key: "STATUS", value: "INACTIVES" }]
                                    filter.map(filterItem => {
                                        const splitRegex = '|'
                                        const nameList = filterItem.value.split(splitRegex)
                                        nameList.map(valueItem => {
                                            if (typeof getValueUsingKey === "function") {
                                                let keyValue = getValueUsingKey(filterItem.key, value);
                                                if (keyValue !== '' && valueItem !== undefined)
                                                    if (keyValue.toString().toLowerCase() === valueItem.toString().toLowerCase()) {
                                                        filteredOptions.push(value);
                                                    }
                                            }
                                        })
                                    })
                                });
                            } else {
                                filteredOptions = response.data;
                            }
                            setTimeout(function () {
                                if (typeof assignOptions === "function") {
                                    assignOptions(setOptionsIn, filteredOptions)
                                }
                            }, 500);
                        }
                    } else if (response.responseCode === 1) {
                        if (typeof onError === "function" && typeof assignResponseValue === 'function' && changeBindIn !== '') {
                            assignResponseValue(changeBindIn, ''); // first argument field and second response value
                            onError(changeBindIn, `apiErrCode.${response.errCode}`)
                        } else if (setOptionsIn !== '' && typeof assignOptions === 'function' && typeof onError === "function") {
                            assignOptions(setOptionsIn, [])
                            onError(setOptionsIn, `apiErrCode.${response.errCode}`)
                        }
                        // this.props.onError(e.target.name, `apiErrCode.${response.errCode}`)
                    }
                }
                this.setState({ loading: false })

            } else if (changeResponseField !== '' && changeBindIn !== '' && typeof assignResponseValue === 'function' && typeof getValueUsingKey === "function") {
                setTimeout(() => {
                    assignResponseValue(changeBindIn, getValueUsingKey(changeResponseField, selectedObject));
                }, 1000)
            }
        });

    }

    onLinkClick = () => {
        const { tableResponse: currentItem = {} } = this.state;
        const { getValueUsingKey } = this.props;
        const {
            displayObject: {
                action: {
                    enabled: actionEnabled = false,
                    route: linkUrl = '',
                    page_id = '',
                    transaction_page_id = '',
                    request: actionRequest = []
                } = {}
            } = {}
        } = this.props.optionsObj;

        if (actionEnabled) {
            let stateObj = {
                page_id: "",
                transaction_page_id: transaction_page_id
            }
            if (actionRequest.length > 0) {
                actionRequest.map(aItem => {
                    const { key: reqKey = '', value: reqValue = '' } = aItem;
                    // stateObj[reqKey] = reqValue.indexOf('.') !== -1 ? getValueUsingKey(reqValue, currentItem) : currentItem[reqValue];
                    if (reqKey !== '' && typeof getValueUsingKey === "function") {
                        stateObj[reqKey] = reqValue.indexOf('.') !== -1 ? getValueUsingKey(reqValue, currentItem) : currentItem[reqValue];
                    }
                })
            }
            this.props.history.push({ pathname: linkUrl, state: { stateReq: stateObj } })
        }
    }

    /* shouldComponentUpdate = (nextProps, nextState) => {
        if (this.props === nextProps || nextState === this.state) {
            return false;
        }
        return true;
    }; */

    handleInputChange = (inputValue) => {
        //get the character entered by user here in inputValue
        const { autoCompleteServerSide = {} } = this.props.optionsObj;
        const { enabled = false, URL = "", method = "", requestKey = "", minCharacter = "" } = autoCompleteServerSide;
        if (enabled) {
            if (URL !== "" && method !== "" && minCharacter !== "") {
                const minChar = parseInt(minCharacter)
                if (inputValue.length >= minChar) {
                    this.setState({ loading: true });
                    this.onSearchCallAPI(inputValue)
                }
            }
        }
    };

    onSearchCallAPI = async (inputValue) => {
        let { assignOptions = '', swaggerPostAPI, onError } = this.props;
        const { autoCompleteServerSide = {}, name = "" } = this.props.optionsObj;
        const { URL = "", method = "", requestKey = "", responseKey = "", additionalRequest = [], label = "", value = "" } = autoCompleteServerSide;
        if (URL !== '') {
            /* if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                setTimeout(function () {
                    assignOptions(setOptionsIn, [])
                }, 500)
            } */
            let { reqData: formRequest = {} } = this.props;
            if (formRequest['userIdentifier'] !== undefined && localStorage.getItem('user') !== null && localStorage.getItem('user') !== undefined)
                formRequest['userIdentifier'] = localStorage.getItem('user');
            let data = {
                [requestKey]: inputValue
            }
            let apiRequest = { data: data };
            Array.isArray(additionalRequest) && additionalRequest.map((item) => {
                const { key = '', value = '', isFromSelected = false } = item;
                if (key !== '' && value !== '' && formRequest[value] !== '') {
                    if (isFromSelected) {
                        apiRequest.data[key] = formRequest[value];
                    } else {
                        apiRequest.data[key] = value;
                    }
                } else {
                    apiRequest.data[key] = ''
                }
            });
            let response = '';
            if (method !== '' && method === 'POST' && typeof swaggerPostAPI === "function") {
                response = await swaggerPostAPI(URL, apiRequest, true);
                this.setState({ loading: false });
                if (response.responseCode === 0) {
                    if (typeof assignOptions === 'function') {
                        let filteredOptions = response.data;
                        let selectOptions = [];
                        filteredOptions.map((filterValue) => {
                            let optionLabel = filterValue[label];
                            if (filterValue[label] !== undefined && filterValue[label].locale !== undefined && Object.keys(filterValue[label].locale).length > 0) {
                                optionLabel = filterValue[label]['locale'][this.props.defaultLng];
                            } else if (filterValue[label] !== undefined && typeof filterValue[label] === "object" && Object.keys(filterValue[label]).length > 0) {
                                const filterlabel = filterValue[label];
                                optionLabel = filterValue[label][this.props.defaultLng]
                            } else if (typeof getValueUsingKey === "function") {
                                optionLabel = getValueUsingKey(label, filterValue)
                            }
                            if (typeof getValueUsingKey === "function") {
                                let object = {
                                    label: optionLabel,
                                    value: getValueUsingKey(value, filterValue)
                                };

                                selectOptions.push(object);
                            }
                        });
                        // this.setState({ selectOptions: selectOptions, loading: false })
                        // setTimeout(function () {
                        assignOptions(name, selectOptions)
                        // }, 500);
                    }
                } else if (response.responseCode === 1 && typeof assignOptions === "function" && typeof onError === "function") {
                    assignOptions(name, [])
                    onError(name, `error.message.${response.errCode}`)
                }
            } else if (typeof swaggerGetAPI === "function") {
                response = await swaggerGetAPI(URL, apiRequest, true);
                this.setState({ loading: false });
                if (response.responseCode === 0) {
                    if (typeof assignOptions === 'function') {
                        let filteredOptions = response.data;
                        let selectOptions = [];
                        filteredOptions.map((filterValue) => {
                            let optionLabel = filterValue[label];
                            if (filterValue[label] !== undefined && filterValue[label].locale !== undefined && Object.keys(filterValue[label].locale).length > 0) {
                                optionLabel = filterValue[label]['locale'][this.props.defaultLng];
                            } else if (filterValue[label] !== undefined && typeof filterValue[label] === "object" && Object.keys(filterValue[label]).length > 0) {
                                const filterlabel = filterValue[label];
                                optionLabel = filterValue[label][this.props.defaultLng]
                            } else if (typeof getValueUsingKey === "function") {
                                optionLabel = getValueUsingKey(label, filterValue)
                            }
                            if (typeof getValueUsingKey === "function") {
                                let object = {
                                    label: optionLabel,
                                    value: getValueUsingKey(value, filterValue)
                                };
                                /*  if (filterValue[image] !== undefined && filterValue[image] !== '') {
                                     object.image = filterValue[image];
                                 } */
                                selectOptions.push(object);
                            }
                        });
                        // this.setState({ selectOptions: selectOptions, loading: false })
                        //  setTimeout(function () {
                        assignOptions(name, selectOptions)
                        // }, 500);
                    }
                } else if (response.responseCode === 1 && typeof assignOptions === "function" && typeof onError === "function") {
                    assignOptions(name, [])
                    onError(name, `error.message.${response.errCode}`)
                }
            }

        }

    }

    render() {

        const { errorMsg, defaultLng, defaultValue, intl, MUIDataTable, ModalMandatory, AppConfig: { totalRecordDisplayInList = 0, rowsPerPageOptions = 0 } = {}, getValueUsingKey, getValueUsingMapping } = this.props;
        const { autoComplete, id, key, className = 'rect_select', label, name, status, required, isDisabled, options, isMultiple, displaysize, labelAlignment, icon, iconPosition, helpText, autoFocus, type, onBlurURL, onFocusURL, onChangeURL, displayObject = {}, externalURL, placeHolder = {} } = this.props.optionsObj;
        let { enabled: displayEnabled = false, showImage: { enabled: displayShowImage = false } = {}, fieldset: displayFieldSet = [] } = displayObject;
        const { selectOptions, displayTable, tableResponse, mdlOpen, mdlConfig = {} } = this.state;
        const { customClasses: mdlCustomClasses = '', icon: mdlIcon = '', tp_text1 = '', bp_text1 = '', button1 = '', button2 = "" } = mdlConfig;
        let dynamicKey = 'frm_select_' + (name !== undefined ? name : 'textSelectInput');
        let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
        let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
        let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
        let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
        let reactDefaultValue = [];
        if (Array.isArray(defaultValue) && defaultValue.length > 0) {
            selectOptions.map((item) => {
                if (defaultValue.indexOf(item.value) !== -1) {
                    let rObj = { label: item.label, value: item.value };
                     /* if(item.icon !== undefined && item.icon !== '') {
                         rObj.label = ReactHtmlParser('<i class="'+item.icon+'" /> '+item.label);
                     } else */ if (item.image !== undefined && item.image !== '') {
                        let imageUrl = item.image !== '' ? item.image : require('./image/default.png');
                        let onErrorMethod = (e) => { e.target.src = require('./image/default.png') };
                        rObj.label = ReactHtmlParser('<img src="' + imageUrl + '" alt="' + item.label + '" class="mr-10" height="25px" width="25px" onError="' + onErrorMethod + '" />' + item.label);
                    }
                    reactDefaultValue.push(rObj);
                }
            })
        } else if (defaultValue !== undefined && defaultValue !== '') {
            selectOptions.map((item) => {
                // if (item.value === defaultValue) {
                const { value = '' } = item;
                if (value.toString().toLowerCase() == defaultValue.toString().toLowerCase()) {
                    let displayLabel = '';
                    const { label: { locale: { [defaultLng]: optionLable = '' } = {} } = {}, label = '', value = '' } = item;
                    if (typeof label === "object" && Object.keys(label).length > 0) {
                        displayLabel = optionLable;
                    } else {
                        displayLabel = label;
                    }
                    let rObj = { label: displayLabel, value: item.value };
                     /* if(item.icon !== undefined && item.icon !== '') {
                         rObj.label = ReactHtmlParser('<i class="'+item.icon+'" /> '+item.label.locale[defaultLng]);
                     } else */ if (item.image !== undefined && item.image !== '') {
                        let imageUrl = item.image !== '' ? item.image : require('./image/default.png');
                        let onErrorMethod = (e) => { e.target.src = require('./image/default.png') };
                        rObj.label = ReactHtmlParser('<img src="' + imageUrl + '" alt="' + item.label + '" class="mr-10" height="25px" width="25px" onError="' + onErrorMethod + '" />' + item.label);
                    }
                    reactDefaultValue.push(rObj);
                }
            })
        }

        if (icon !== '') {
            classInput += (iconPosition !== undefined && iconPosition.toLowerCase() === 'right') ? ' icon_right' : ' icon_left';
        }

        let tblColumns = [];
        let tblData = [];
        let tblOptions = {};
        if (defaultValue === '') {
            displayEnabled = false
        } else if (displayEnabled && displayTable) {
            if (displayFieldSet.length > 0) {
                displayFieldSet.map((dfItem, dfIndex) => {
                    const { value: columnName = '', title: { locale: { [defaultLng]: columnLabel = '' } = {} } = {} } = dfItem;
                    if (dfIndex === 0) {
                        tblColumns.push({
                            name: 'sr_no',
                            label: intl !== undefined ? intl.formatMessage({ id: 'list.srNo' }) : ""
                        })
                    }
                    tblColumns.push({
                        name: columnName,
                        label: columnLabel
                    })
                })
            }

            let srNoIndex = 1;
            let tblObj = [srNoIndex++];
            displayFieldSet.map(dfItem => {
                const { value: columnName = '', isLink = false, isHighLight = false, mapping = [] } = dfItem;
                let tData = '';
                tData = tableResponse[columnName];
                if (columnName.indexOf('.') !== -1 && typeof getValueUsingKey === "function") {
                    tData = getValueUsingKey(columnName, tableResponse);
                }
                if (Array.isArray(mapping) && mapping.length > 0 && typeof getValueUsingMapping === "function") {
                    tData = getValueUsingMapping(tData, mapping, defaultLng)
                }
                //is link true..
                if (isLink) {
                    tData = <Fragment>{tData ? <a href="javascript:void(0)" onClick={() => this.onLinkClick()}>{tData}</a> : '-'}</Fragment>
                }
                //is highlighted true..
                if (isHighLight) {
                    tData = <Fragment>{tData ? <span className="badge badge-primary">{tData}</span> : '-'}</Fragment>
                }
                // tblObj[columnName] = tData ? tData : '-'
                tblObj.push(tData)
            });
            tblData.push(tblObj)

            tblOptions = {
                filter: false,
                viewColumns: false,
                print: false,
                selectableRows: false,
                rowsPerPage: totalRecordDisplayInList,
                pagination: false,
                rowsPerPageOptions: rowsPerPageOptions,
                sort: true,
                search: false,
                print: false,
                download: false,
                textLabels: {
                    body: {
                        noMatch: intl !== undefined ? intl.formatMessage({ id: "message.emptyTable" }) : ""
                    }
                }
            };
        }
        return (
            <Fragment>
                {/* {status && */}
                <FormGroup className={`row${displayEnabled ? ' w-50' : ''}`} key={dynamicKey}>
                    {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    {/* {(this.state.loading &&typeof CircularProgress ==='function')&& <CircularProgress className="cstm_progress" thickness={3} />} */}
                                    {(selectOptions.length > 0 || true) &&
                                        <Select
                                            type="select"
                                            /* new changed added */
                                            onInputChange={this.handleInputChange}
                                            placeholder={(placeHolder !== undefined && placeHolder.locale !== undefined && placeHolder.locale[defaultLng] !== undefined && placeHolder.locale[defaultLng] !== "") ? placeHolder.locale[defaultLng] : 'Select...'}
                                            isMulti={(isMultiple !== undefined && isMultiple) ? isMultiple : false}
                                            isSearchable
                                            closeMenuOnSelect={false}
                                            autoComplete={autoComplete}
                                            autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                            className={`${(className !== undefined && className) ? className : ''} ${(isMultiple !== undefined && isMultiple) ? ' is_multi_sel' : ''}`}
                                            key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                            id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                            name={(name !== undefined && name) ? name : 'textSelectInput'}
                                            disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                            required={(required !== undefined && required) ? required : false}
                                            size={(displaysize !== undefined && displaysize) ? displaysize : ''}
                                            onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e, true) : () => ({})}
                                            onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                            onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, isMultiple, true))}
                                            // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange((isMultiple !== undefined && isMultiple) ? 'multi_select' : 'select', (name !== undefined && name) ? name : 'textSelectInput', (isMultiple !== undefined && isMultiple) ? e.target.selectedOptions : e.value)}
                                            value={reactDefaultValue}
                                            defaultValue={reactDefaultValue}
                                            options={selectOptions.map((item, i) => {
                                                let displayLabel = '';
                                                const { label: { locale: { [defaultLng]: optionLable = '' } = {} } = {}, label = '', value = '' } = item;
                                                if (typeof label === "object" && Object.keys(label).length > 0) {
                                                    displayLabel = optionLable;
                                                } else {
                                                    displayLabel = label;
                                                }
                                                return {
                                                    label: (
                                                        (item.image !== undefined && item.image !== '')
                                                            ?
                                                            <span>
                                                                <img
                                                                    src={item.image}
                                                                    className="mr-10"
                                                                    height="25px"
                                                                    width="25px"
                                                                    alt={displayLabel}
                                                                    onError={(e) => {
                                                                        e.target.src = require('./image/default.png')
                                                                    }}
                                                                />
                                                                {displayLabel}
                                                            </span>
                                                            :
                                                            displayLabel
                                                    ),
                                                    value: value,
                                                    // name: (name !== undefined && name) ? name : 'textSelectInput',
                                                }
                                            })}
                                        />}
                                    {icon !== '' && <span className="is_icon"><i className={icon} /></span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    {/* {this.state.loading && <CircularProgress className="cstm_progress" thickness={3} />} */}
                                    {(selectOptions.length != 0 || true) && <Select
                                        /* new changed added */
                                        onInputChange={this.handleInputChange}
                                        placeholder={(placeHolder !== undefined && placeHolder.locale !== undefined && placeHolder.locale[defaultLng] !== undefined && placeHolder.locale[defaultLng] !== "") ? placeHolder.locale[defaultLng] : 'Select...'}
                                        isMulti={(isMultiple !== undefined && isMultiple) ? isMultiple : false}
                                        type="select"
                                        isSearchable={autoComplete}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        className={`${(className !== undefined && className) ? className : ''} ${(isMultiple !== undefined && isMultiple) ? ' is_multi_sel' : ''}`}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        name={(name !== undefined && name) ? name : 'textSelectInput'}
                                        isDisabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        size={(displaysize !== undefined && displaysize) ? displaysize : ''}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e, true) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, isMultiple, true))}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange((isMultiple !== undefined && isMultiple) ? 'multi_select' : 'select', (name !== undefined && name) ? name : 'textSelectInput', (isMultiple !== undefined && isMultiple) ? e.target.selectedOptions : e.value)}
                                        value={reactDefaultValue}
                                        defaultValue={reactDefaultValue}
                                        options={selectOptions.map((item, i) => {
                                            let displayLabel = '';
                                            const { label: { locale: { [defaultLng]: optionLable = '' } = {} } = {}, label = '', value = '' } = item;
                                            if (typeof label === "object" && Object.keys(label).length > 0) {
                                                displayLabel = optionLable;
                                            } else {
                                                displayLabel = label;
                                            }
                                            return {
                                                label: (
                                                    (item.image !== undefined && item.image !== '')
                                                        ?
                                                        <span>
                                                            <img
                                                                src={item.image}
                                                                className="mr-10"
                                                                height="25px"
                                                                width="25px"
                                                                alt={displayLabel}
                                                                onError={(e) => {
                                                                    e.target.src = require('./image/default.png')
                                                                }}
                                                            />
                                                            {displayLabel}
                                                        </span>
                                                        :
                                                        displayLabel
                                                ),
                                                value: value,
                                                // name: (name !== undefined && name) ? name : 'textSelectInput',
                                            }
                                        })}
                                    />}
                                    {icon !== '' && <span className="is_icon"><i className={icon} /></span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                            </Fragment>
                    }
                </FormGroup>
                {/* } */}
                {(displayTable && displayEnabled && typeof MUIDataTable === "function") &&
                    <div className="mb-20">
                        <MUIDataTable
                            title=""
                            data={tblData}
                            columns={tblColumns}
                            options={tblOptions}
                        />
                    </div>}
                {(mdlOpen && typeof ModalMandatory === "function") &&
                    <ModalMandatory
                        mdlOpen={mdlOpen}
                        anyClickClose={false}
                        customClasses={mdlCustomClasses}
                        topPart={true}
                        bottomPart={true}
                        icon={mdlIcon}
                        tp_text1={tp_text1 !== '' ? (intl !== undefined ? intl.formatMessage({ id: tp_text1 }) : "") : ''}
                        bp_text1={bp_text1 !== '' ? (intl !== undefined ? intl.formatMessage({ id: bp_text1 }) : "") : ''}
                        button1={button1 !== '' ? (intl !== undefined ? intl.formatMessage({ id: button1 }) : "") : ''}
                        button2={button2 !== '' ? (intl !== undefined ? intl.formatMessage({ id: button2 }) : "") : ''}
                        toggleMethod={() => this.onClickOpen()}
                        btnMethod1={() => this.onClickClose()}
                        btnMethod2={() => this.onClickClose()}
                    />
                }
            </Fragment>
        )
    }
}

//Default Props for Select
ReactSelectWidget.defaultProps = {
    optionsObj: {
        autoComplete: false,
        id: 'Demo',
        className: 'cstm_input_sel',
        label: 'Select',
        name: 'Demo',
        status: false,
        required: true,
        validationMsg: '',
        regex: '',
        isDisabled: false,
        options: [],
        isMultiple: false,
        displaysize: 1,
        labelAlignment: 'left',
        icon: '',
        iconPosition: '',
        helpText: {},
        autoFocus: false,
        type: 'default',
        onBlurURL: "",
        onFocusURL: "",
        onChangeURL: "",
    },
    defaultValue: '',
    defaultLng: 'en',
    onChange: '',
    errorMsg: ''
}

export default ReactSelectWidget;