/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control React Select
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input } from 'reactstrap';
import ReactHtmlParser from "react-html-parser";
// import CircularProgress from '@material-ui/core/CircularProgress';
// import AppConfig from 'DefaultConstants/AppConfig'
// import { injectIntl } from 'react-intl';
import Select from "react-select";
// const { swaggerPostAPI, swaggerGetAPI } = require('DefaultHelpers')

/**
 * Start ReactSelectForOnBoard class component
 * @state {*Object} reqData
 */
class ReactSelectForOnBoard extends Component {
    constructor(props) {
        super(props);
        const { optionsObj: { name = '' } = {} } = props;
        this.state = {
            selectOptions: [],
            externalURL: { URL: '' },
            loading: true,
            name: name
        }
        //this.callAPI = this.callAPI.bind(this)
    }

    componentDidMount() {
        // console.log('componentDidMount :', this.props.optionsObj.options)
        this.callAPI();
        /* console.log("this.props.optionsObj",this.props.optionsObj)
            if (this.props.optionsObj && this.props.optionsObj.options && this.props.optionsObj.options.length) {
                this.setState({ selectOptions: this.props.optionsObj.options })
            } else if (this.props.optionsObj && this.props.optionsObj.externalURL) {
                var response = await swaggerGetAPI(this.props.optionsObj.externalURL.URL, {}, true);
                if (response.responseCode === 0) {
                    let selectOptions = [];
                    response.data.map((value) => {
                        let object = { label: value[this.props.optionsObj.externalURL.label], value: value[this.props.optionsObj.externalURL.value] };
                        selectOptions.push(object);
                    });
                    this.setState({ selectOptions: selectOptions })
                } else {
                    this.setState({ selectOptions: [] })
                }
            } */
    }

    componentWillReceiveProps(nextProps) {
        // console.log("nextProps",nextProps)
        // console.log("nextProps",nextProps.optionsObj.name,nextProps.optionsObj)
        if (nextProps.optionsObj.name === this.state.name && nextProps.optionsObj.passValueExternalID !== undefined
            && nextProps.optionsObj.passValueExternalID !== '' && this.state.selectOptions !== nextProps.optionsObj.options) {
            this.setState({ selectOptions: nextProps.optionsObj.options, loading: false })
        } else if (nextProps && nextProps.optionsObj && nextProps.optionsObj.options && nextProps.optionsObj.options.length && nextProps.optionsObj.name === this.state.name) {
            this.setState({ selectOptions: nextProps.optionsObj.options, externalURL: '', loading: false })
        } else if (nextProps.optionsObj && nextProps.optionsObj.externalURL && nextProps.optionsObj.externalURL.URL && this.state.externalURL !== nextProps.optionsObj.externalURL.URL && nextProps.optionsObj.name === this.state.name) {
            this.setState({ selectOptions: [], externalURL: this.props.optionsObj.externalURL.URL, loading: false }, () => {
                this.callAPI()
            })
        } else if (!nextProps.optionsObj.options.length && (nextProps.optionsObj && (!nextProps.optionsObj.externalURL || !nextProps.optionsObj.externalURL.URL)) && nextProps.optionsObj.name === this.state.name) {
            this.setState({ selectOptions: [], externalURL: '', loading: false });
        }
    }

    async callAPI() {
        if (this.props.optionsObj && this.props.optionsObj.options && this.props.optionsObj.options.length) {
            this.setState({ selectOptions: this.props.optionsObj.options, loading: false })
        } else if (this.props.optionsObj && this.props.optionsObj.externalURL && typeof this.props.swaggerGetAPI === 'function') {
            let externalObj = this.props.optionsObj.externalURL;
            var response = await this.props.swaggerGetAPI(externalObj.URL, {}, true);
            if (response.responseCode === 0) {
                let selectOptions = [];
                const { optionsObj: { filter = [] } } = this.props;
                response.data.map((value) => {
                    if (filter !== undefined && filter.length > 0) {
                        filter.map(filterItem => {
                            const splitRegex = '|'
                            const nameList = filterItem.value.split(splitRegex)
                            nameList.map(valueItem => {
                                if (value[filterItem.key] !== undefined && valueItem !== undefined)
                                    if (value[filterItem.key].toLowerCase() === valueItem.toLowerCase()) {
                                        let label = (value[this.props.optionsObj.externalURL.label].hasOwnProperty('locale')) ? value[this.props.optionsObj.externalURL.label].locale[this.props.defaultLng] : value[this.props.optionsObj.externalURL.label];
                                        let object = { label: label, value: value[this.props.optionsObj.externalURL.value] };
                                        selectOptions.push(object);
                                    }
                            })
                        })
                    } else {
                        let label = (value[this.props.optionsObj.externalURL.label].hasOwnProperty('locale')) ? value[this.props.optionsObj.externalURL.label].locale[this.props.defaultLng] : value[this.props.optionsObj.externalURL.label];
                        let object = { label: label, value: value[this.props.optionsObj.externalURL.value] };
                        selectOptions.push(object);
                    }
                });
                this.setState({ selectOptions: selectOptions, externalURL: externalObj.URL, loading: false })
            } else {
                this.setState({ selectOptions: [], externalURL: externalObj.URL, loading: false })
            }
        }
    }

    /* on blur event */
    handleOnBlurEvent = (e, reactSelect) => {
        this.onBlurCallAPI(e, reactSelect);
    }
    /* on focus event */
    handleOnFocusEvent = (e) => {
        this.onFocusCallAPI(e);
    }
    /* on change event */
    handleOnChangeEvent = (e, isMultiple, reactSelect) => {
        if (isMultiple !== undefined && isMultiple) {
            this.props.onChange('multi_select', this.state.name, e);
        } else {
            this.props.onChange('select', this.state.name, e.value, '', '', '', e.label)
        }
        this.onChangeCallAPI(e, isMultiple, reactSelect);
    }

    onBlurCallAPI = async (e) => {

        const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {}, assignResponseValue } = this.props;
        if (onBlurURL !== '') {

            let response = '';
            let inputName = e.target.name;
            let inputValue = e.target.value;

            if (blurMethod !== '' && blurMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                let data = {
                    [inputName]: inputValue
                }
                response = await this.props.swaggerPostAPI(onBlurURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(inputName, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if(typeof this.props.swaggerGetAPI === 'function') {
                response = await this.props.swaggerGetAPI(onBlurURL, {}, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                    }
                }
            }

        }
    }

    onFocusCallAPI = async (e) => {

        const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue } = this.props;
        if (onFocusURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (focusMethod !== '' && focusMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                response = await this.props.swaggerPostAPI(onFocusURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if(typeof this.props.swaggerGetAPI === 'function') {
                response = await this.props.swaggerGetAPI(onFocusURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }

    async onChangeCallAPI(e, isMultiple, reactSelect) {

        const { optionsObj: { onChange = [], onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '', setOptionsIn = '', changeRequest = [] } = {}, assignResponseValue, assignOptions } = this.props;

        if (onChange.length === 0) {
            onChange.push({ onChangeURL, changeBindIn, changeResponseField, changeMethod, setOptionsIn, changeRequest });
        }

        onChange.map(async (item) => {

            const { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '', setOptionsIn = '', changeRequest = [] } = item;
            if (onChangeURL !== '' && changeMethod !== '' && setOptionsIn !== '') {

                let response = '';

                if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                    setTimeout(function () {
                        assignOptions(setOptionsIn, [])
                    }, 100)
                }

                if (changeMethod !== '' && changeMethod === 'POST') {
                    if (isMultiple !== undefined && isMultiple && typeof this.props.swaggerPostAPI === 'function') {
                        response = await this.props.swaggerPostAPI(onChangeURL, e.target.selectedOptions, true);
                    } else if (typeof this.props.swaggerPostAPI === 'function') {
                        response = await this.props.swaggerPostAPI(onChangeURL, (reactSelect) ? e.value : e.target.value, true);
                    }
                    // response = await swaggerPostAPI(onChangeURL, data, true);
                    if (response.responseCode === 0) {
                        if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                            assignOptions(setOptionsIn, response.data)
                        }
                    } else if (response.responseCode === 1) {
                        if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                            assignOptions(setOptionsIn, [])
                        }
                        this.props.onError(this.props.optionsObj.name, `error.message.${response.errCode}`)
                    }
                    // to do handle response of post method
                } else {
                    if (isMultiple !== undefined && isMultiple && typeof this.props.swaggerGetAPI === 'function') {
                        response = await this.props.swaggerGetAPI(onChangeURL, e.target.selectedOptions, true);
                    } else  if(typeof this.props.swaggerGetAPI === 'function'){
                        let selectedID = (reactSelect) ? e.value : e.target.value;
                        let url = onChangeURL + '' + selectedID;
                        response = await this.props.swaggerGetAPI(url, {}, true);
                    }
                    // response = await swaggerGetAPI(onChangeURL, data, true);
                    // response = { responseCode: 0, data: { billAmount: 1000 } }
                    if (response.responseCode === 0) {
                        if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                            assignOptions(setOptionsIn, response.data)
                        }
                    } else if (response.responseCode === 1) {
                        if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                            assignOptions(setOptionsIn, [])
                        }
                        this.props.onError(this.props.optionsObj.name, `error.message.${response.errCode}`)
                    }
                }

            }

        })

    }

    /* shouldComponentUpdate = (nextProps, nextState) => {
        if (this.props === nextProps || nextState === this.state) {
            return false;
        }
        return true;
    }; */

    render() {
        const { errorMsg, defaultLng, defaultValue, intl } = this.props;
        const { autoComplete, id, key, className = 'rect_select', label, name, status, required, isDisabled, options, isMultiple, displaysize, labelAlignment, icon, iconPosition, helpText, autoFocus, type, onBlurURL, onFocusURL, onChangeURL, externalURL } = this.props.optionsObj;
        let { selectOptions } = this.state;
        let dynamicKey = 'frm_select_' + (name !== undefined ? name : 'textSelectInput');
        let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
        let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
        let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
        let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
        let reactDefaultValue = [];

        if (Array.isArray(defaultValue) && defaultValue.length > 0) {
            selectOptions.map((item) => {
                if (defaultValue.indexOf(item.value) !== -1) {
                    const { label = '', label: { locale: { [defaultLng]: selectlabel = '' } = {} } = {} } = item;
                    let rObj = { label: selectlabel !== '' ? selectlabel : label, value: item.value };
                    /* if(item.icon !== undefined && item.icon !== '') {
                        rObj.label = ReactHtmlParser('<i class="'+item.icon+'" /> '+selectlabel !== '' ? selectlabel : label);
                    } else */ if (item.image !== undefined && item.image !== '') {
                        let imageUrl = item.image !== '' ? item.image : require('./image/default.png');
                        let onErrorMethod = (e) => { e.target.src = require('./image/default.png') };
                        rObj.label = ReactHtmlParser('<img src="' + imageUrl + '" alt="' + selectlabel !== '' ? selectlabel : label + '" class="mr-10" height="25px" width="25px" onError="' + onErrorMethod + '" />' + selectlabel !== '' ? selectlabel : label);
                    }
                    reactDefaultValue.push(rObj);
                }
            })
        } else if (defaultValue !== undefined && defaultValue !== '') {
            selectOptions.map((item) => {
                if (item.value === defaultValue) {
                    const { label = '', label: { locale: { [defaultLng]: selectlabel = '' } = {} } = {} } = item;
                    let rObj = { label: selectlabel !== '' ? selectlabel : label, value: item.value };
                    /* if(item.icon !== undefined && item.icon !== '') {
                        rObj.label = ReactHtmlParser('<i class="'+item.icon+'" /> '+selectlabel !== '' ? selectlabel : label.locale[defaultLng]);
                    } else */ if (item.image !== undefined && item.image !== '') {
                        let imageUrl = item.image !== '' ? item.image : require('./image/default.png');
                        let onErrorMethod = (e) => { e.target.src = require('./image/default.png') };
                        rObj.label = ReactHtmlParser('<img src="' + imageUrl + '" alt="' + selectlabel !== '' ? selectlabel : label + '" class="mr-10" height="25px" width="25px" onError="' + onErrorMethod + '" />' + selectlabel !== '' ? selectlabel : label);
                    }
                    reactDefaultValue.push(rObj);
                }
            })
        }

        if (icon !== '') {
            classInput += (iconPosition !== undefined && iconPosition.toLowerCase() === 'right') ? ' icon_right' : ' icon_left';
        }
        return (
            <Fragment>
                {/* {status && */}
                <FormGroup className="row" key={dynamicKey}>
                    {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={classInput + ' ' + ((className !== undefined && className) ? className : '')}>
                                    {/* {this.state.loading && <CircularProgress className="cstm_progress" thickness={3} />} */}
                                    <Select
                                        type="select"
                                        isMulti={(isMultiple !== undefined && isMultiple) ? isMultiple : false}
                                        isSearchable
                                        closeMenuOnSelect={false}
                                        autoComplete={autoComplete}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        className={`${(className !== undefined && className) ? className : ''} ${(isMultiple !== undefined && isMultiple) ? ' is_multi_sel' : ''}`}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        name={(name !== undefined && name) ? name : 'textSelectInput'}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        size={(displaysize !== undefined && displaysize) ? displaysize : ''}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e, true) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, isMultiple, true))}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange((isMultiple !== undefined && isMultiple) ? 'multi_select' : 'select', (name !== undefined && name) ? name : 'textSelectInput', (isMultiple !== undefined && isMultiple) ? e.target.selectedOptions : e.value)}
                                        value={reactDefaultValue}
                                        defaultValue={reactDefaultValue}
                                        options={selectOptions.map((item, i) => ({
                                            label: (
                                                (item.image !== undefined && item.image !== '')
                                                    ?
                                                    <span>
                                                        <img
                                                            src={item.image}
                                                            className="mr-10"
                                                            height="25px"
                                                            width="25px"
                                                            alt={item.label}
                                                            onError={(e) => {
                                                                e.target.src = require('./image/default.png')
                                                            }}
                                                        />
                                                        {/* item.label */}
                                                        {(item.label !== undefined && item.label.locale !== undefined && item.label.locale[defaultLng] !== undefined) ? item.label.locale[defaultLng] : item.label}
                                                    </span>
                                                    :
                                                    /* item.label */
                                                    (item.label !== undefined && item.label.locale !== undefined && item.label.locale[defaultLng] !== undefined) ? item.label.locale[defaultLng] : item.label
                                            ),
                                            value: item.value,
                                            // name: (name !== undefined && name) ? name : 'textSelectInput',
                                        }))}
                                    />
                                    {icon !== '' && <span className="is_icon"><i className={icon} /></span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                                <div className={classInput + ' ' + ((className !== undefined && className) ? className : '')}>
                                    {/* {this.state.loading && <CircularProgress className="cstm_progress" thickness={3} />} */}
                                    <Select
                                        isMulti={(isMultiple !== undefined && isMultiple) ? isMultiple : false}
                                        type="select"
                                        isSearchable={autoComplete}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        className={`${(className !== undefined && className) ? className : ''} ${(isMultiple !== undefined && isMultiple) ? ' is_multi_sel' : ''}`}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        name={(name !== undefined && name) ? name : 'textSelectInput'}
                                        isDisabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        size={(displaysize !== undefined && displaysize) ? displaysize : ''}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e, true) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, isMultiple, true))}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange((isMultiple !== undefined && isMultiple) ? 'multi_select' : 'select', (name !== undefined && name) ? name : 'textSelectInput', (isMultiple !== undefined && isMultiple) ? e.target.selectedOptions : e.value)}
                                        value={reactDefaultValue}
                                        defaultValue={reactDefaultValue}
                                        options={selectOptions.map((item, i) => ({
                                            label: (
                                                (item.image !== undefined && item.image !== '')
                                                    ?
                                                    <span>
                                                        <img
                                                            src={item.image}
                                                            className="mr-10"
                                                            height="25px"
                                                            width="25px"
                                                            alt={item.label}
                                                            onError={(e) => {
                                                                e.target.src = require('./image/default.png')
                                                            }}
                                                        />
                                                        {/* item.label */}
                                                        {(item.label !== undefined && item.label.locale !== undefined && item.label.locale[defaultLng] !== undefined) ? item.label.locale[defaultLng] : item.label}
                                                    </span>
                                                    :
                                                    /* item.label */
                                                    (item.label !== undefined && item.label.locale !== undefined && item.label.locale[defaultLng] !== undefined) ? item.label.locale[defaultLng] : item.label

                                            ),
                                            value: item.value,
                                            // name: (name !== undefined && name) ? name : 'textSelectInput',
                                        }))}
                                    />
                                    {icon !== '' && <span className="is_icon"><i className={icon} /></span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                            </Fragment>
                    }
                </FormGroup>
                {/* } */}
            </Fragment>
        )
    }
}

//Default Props for Select
ReactSelectForOnBoard.defaultProps = {
    optionsObj: {
        autoComplete: false,
        id: 'Demo',
        className: 'cstm_input_sel',
        label: 'Select',
        name: 'Demo',
        status: false,
        required: true,
        validationMsg: '',
        regex: '',
        isDisabled: false,
        options: [],
        isMultiple: false,
        displaysize: 1,
        labelAlignment: 'left',
        icon: '',
        iconPosition: '',
        helpText: {},
        autoFocus: false,
        type: 'default',
        onBlurURL: "",
        onFocusURL: "",
        onChangeURL: "",
    },
    defaultValue: '',
    defaultLng: '',
    onChange: '',
    errorMsg: ''
}

export default ReactSelectForOnBoard;