/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control select
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input } from 'reactstrap';
//  import CircularProgress from '@material-ui/core/CircularProgress';
//  const { MUIDataTable } = require('DefaultComponents/Widgets')
//  const { swaggerPostAPI, swaggerGetAPI, getValueUsingKey, getValueUsingMapping,isUserLogin } = require('DefaultHelpers')
//  import AppConfig from 'DefaultConstants/AppConfig';

/**
 * Start Select class component
 * @state {*Object} reqData
 */
class SelectWidget extends Component {
    constructor(props) {
        super(props);
        this.state = {
            selectOptions: [],
            externalURL: '',
            loading: true,
            displayTable: false,
            tableResponse: {},
            name: props.optionsObj.name,
            defaultValue: props.defaultValue
        }
        //this.callAPI = this.callAPI.bind(this)
    }

    componentDidMount() {
        // console.log('componentDidMount :', this.props.optionsObj.options)
        this.callAPI();
        /* console.log("this.props.optionsObj",this.props.optionsObj)
         if (this.props.optionsObj && this.props.optionsObj.options && this.props.optionsObj.options.length) {
             this.setState({ selectOptions: this.props.optionsObj.options })
         } else if (this.props.optionsObj && this.props.optionsObj.externalURL) {
             var response = await swaggerGetAPI(this.props.optionsObj.externalURL.URL, {}, true);
             if (response.responseCode === 0) {
                 let selectOptions = [];
                 response.data.map((value) => {
                     let object = { label: value[this.props.optionsObj.externalURL.label], value: value[this.props.optionsObj.externalURL.value] };
                     selectOptions.push(object);
                 });
                 this.setState({ selectOptions: selectOptions })
             } else {
                 this.setState({ selectOptions: [] })
             }
         } */
        setTimeout(() => {
            const { name = '', defaultValue = '' } = this.props.optionsObj;
            let dynamicKey = 'frm_select_' + (name !== undefined ? name : 'textSelectInput') + 'id';
            var input = document.getElementById(dynamicKey)
            this.props.onChange('select', name, input.value, '', '', '', input[input.selectedIndex].text)
        }, 500)
    }

    componentWillReceiveProps(nextProps) {
        // console.log("nextProps",nextProps)
        // console.log('componentWillReceiveProps :', nextProps.optionsObj.options);
        // this.callAPI()
        if (nextProps.optionsObj.name === this.state.name && this.state.selectOptions !== nextProps.optionsObj.options) {
            // const selectedOptions = this._convertOptions(nextProps.optionsObj.options);
            this.setState({ selectOptions: nextProps.optionsObj.options })
        } else if (nextProps && nextProps.optionsObj && nextProps.optionsObj.options && nextProps.optionsObj.options.length && nextProps.optionsObj.name === this.state.name) {
            // const selectedOptions = this._convertOptions(nextProps.optionsObj.options);
            this.setState({ selectOptions: nextProps.optionsObj.options, externalURL: '' })
        } else if (nextProps.optionsObj && nextProps.optionsObj.externalURL && nextProps.optionsObj.externalURL.URL && this.state.externalURL !== nextProps.optionsObj.externalURL.URL && nextProps.optionsObj.name === this.state.name) {
            this.setState({ selectOptions: [], externalURL: this.props.optionsObj.externalURL.URL }, () => {
                this.callAPI()
            })
        } else if (nextProps && nextProps.optionsObj && nextProps.optionsObj.options && nextProps.optionsObj.options.length && nextProps.optionsObj.selectObjFromProfile) {
            this.setState({ selectOptions: nextProps.optionsObj.options, externalURL: '' })
        } else if (!nextProps.optionsObj.options.length && (nextProps.optionsObj && (!nextProps.optionsObj.externalURL || !nextProps.optionsObj.externalURL.URL)) && nextProps.optionsObj.name === this.state.name) {
            this.setState({ selectOptions: [], externalURL: '' });
        }
    }

    async callAPI() {
        const { optionsObj: { options: defaultOptions = [], externalURL: { URL: extUrl = '', label: extLabel = '', value: extValue = '' } = {}, externalURL: externalObj = {} } = {}, swaggerPostAPI, swaggerGetAPI, isUserLogin } = this.props;
        if (defaultOptions.length) {
            this.setState({ selectOptions: defaultOptions, loading: false })
        } else if (externalObj) {

            let externalObj = this.props.optionsObj.externalURL;
            const { optionsObj: { externalURL: { URL = '', method = "", request = [], listKey = '' } = {} } = {}, assignOptions = '' } = this.props;

            if (URL === '') {
                this.setState({ loading: false })
                return false;
            }

            var response = {};
            if (method === "POST" && typeof swaggerPostAPI === 'function' && typeof isUserLogin === 'function') {
                let { reqData: formRequest = {} } = this.props;
                let apiRequest = { data: {} };
                if (formRequest['userIdentifier'] === undefined && localStorage.getItem('user') !== null && localStorage.getItem('user') !== undefined)
                    formRequest['userIdentifier'] = apiRequest.data['userIdentifier'] = localStorage.getItem('user');
                else if (!request.length)
                    apiRequest.data['userIdentifier'] = localStorage.getItem('user');

                Array.isArray(request) && request.map((item) => {
                    const { key = '', value = '' } = item;
                    let assignValue = formRequest[value] === undefined ? value : formRequest[value];
                    if (key !== '' && value !== '') {
                        apiRequest.data[key] = key === 'userIdentifier' ? localStorage.getItem('user') : assignValue;
                    } else {
                        apiRequest.data[key] = key === 'userIdentifier' ? localStorage.getItem('user') : '';
                    }
                });

                response = await swaggerPostAPI(URL, apiRequest, true, !isUserLogin());

            } else if (typeof swaggerGetAPI === 'function') {
                response = await swaggerGetAPI(URL, {}, true);
            }
            // response = { "responseCode": 0, "errCode": "1", "message": "Success", "data": [{ "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Tom Dick" }, "UserAccountIdentifier": "7500075771", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515929102835048678664" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Bhavesh" }, "UserAccountIdentifier": "7580907426", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936065125725154969" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Dhruvit" }, "UserAccountIdentifier": "7528173747", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515937626770913723529" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test Branch" }, "UserAccountIdentifier": "7500075025", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924786534912002765" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "yuvi" }, "UserAccountIdentifier": "7500075781", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935284845022592197" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Dipesh" }, "UserAccountIdentifier": "7504248870", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515937614012519889521" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test Branch" }, "UserAccountIdentifier": "7500075007", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "243.00", "AvailableBalanceMajor": "243.00", "UsedValueMajor": "68.00" }] }], "UserAccountUniqueId": "192.168.2.22515904163391506809584" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Branch Test" }, "UserAccountIdentifier": "7500075084", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924828010773185662" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Testing Branch" }, "UserAccountIdentifier": "7500075011", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935960960468106119" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "John Branch" }, "UserAccountIdentifier": "7500078651", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935034671775345748" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test branch new" }, "UserAccountIdentifier": "7511595175", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515912550639133064809" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075024", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924719069386924667" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "John Branch" }, "UserAccountIdentifier": "7500007861", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515930669998288863290" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Testing" }, "UserAccountIdentifier": "7500070011", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515940094683952757395" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": { "FULL_NAME_IN_ENGLISH": "Test Branch" }, "UserAccountIdentifier": "7500075014", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "1.00", "AvailableBalanceMajor": "1.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515907748412975970446" }, { "UserCategory": "BRANCH_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "BRANCH_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075081", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924088046235102768" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500078630", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515934190002438777101" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500071111", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936210714052852340" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075093", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924130547578686914" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500078652", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515935039344598621956" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075091", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924094511957188727" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7511595563", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515912559655764781789" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500075092", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515924122738517108441" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7500007860", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515931605789452776765" }, { "UserCategory": "TELLER_CATEGORY", "UserEntityType": "OPERATINGENTITY", "UserEntityId": "TELLER_OPERATING_ENTITY_TEMPLATE", "KycDetail": {}, "UserAccountIdentifier": "7560040075", "Wallet": [{ "Pouch": [{ "UnUsedValueMajor": "0.00", "AvailableBalanceMajor": "0.00", "UsedValueMajor": "0.00" }] }], "UserAccountUniqueId": "192.168.2.22515936059785412936331" }] }
            if (response.responseCode === 0) {
                if (typeof response.data === "object" && response.data["0"] !== undefined) {
                    let tempArray = [];
                    Object.keys(response.data).map((key) => {
                        tempArray.push(response.data[key])
                    });
                    response.data = tempArray;
                }
                let filteredOptions = [], optionsList = [];
                if (listKey !== '' && typeof this.props.getValueUsingKey === 'function') {
                    optionsList = this.props.getValueUsingKey(listKey, listKey.indexOf('data.') > -1 ? response : filteredOptions);
                } else {
                    optionsList = response.data;
                }

                const { optionsObj: { filter = [] } } = this.props;
                if (Array.isArray(filter) && filter.length > 0 && typeof this.props.getValueUsingKey === 'function') {
                    optionsList.map((value) => {
                        // const filter = [{ key: "STATUS", value: "ACTIVE" }, { key: "STATUS", value: "INACTIVES" }]
                        filter.map(filterItem => {
                            const splitRegex = '|'
                            const nameList = filterItem.value.split(splitRegex)
                            nameList.map(valueItem => {
                                let keyValue = this.props.getValueUsingKey(filterItem.key, value);
                                if (keyValue !== '' && valueItem !== undefined)
                                    if (keyValue.toString().toLowerCase() === valueItem.toString().toLowerCase()) {
                                        filteredOptions.push(value);
                                    }
                            })
                        })
                    });
                } else {
                    filteredOptions = optionsList;
                }

                if (typeof assignOptions === 'function') {
                    this.setState({ loading: false })
                    assignOptions(this.props.optionsObj.name, filteredOptions)
                } else if (typeof this.props.getValueUsingKey === 'function') {
                    let selectOptions = [];
                    filteredOptions.map((value) => {
                        let optionLabel = value[externalObj.label];
                        if (value[externalObj.label] !== undefined && value[externalObj.label].locale !== undefined && Object.keys(value[externalObj.label].locale).length > 0) {
                            optionLabel = value[externalObj.label]['locale'][this.props.defaultLng];
                        } else if (value[externalObj.label] !== undefined && Object.keys(value[externalObj.label]).length > 0) {
                            optionLabel = value[externalObj.label][this.props.defaultLng]
                        } else {
                            optionLabel = this.props.getValueUsingKey(externalObj.label, value)
                        }
                        let object = {
                            label: optionLabel,
                            value: this.props.getValueUsingKey(externalObj.value, value)
                        };
                        if (value[externalObj.image] !== undefined && value[externalObj.image] !== '') {
                            object.image = value[externalObj.image];
                        }
                        selectOptions.push(object);
                    });
                    this.setState({ selectOptions: selectOptions, externalURL: externalObj.URL, loading: false })
                }
            } else {
                this.setState({ selectOptions: [], externalURL: externalObj.URL, loading: false })
            }
        }
    }

    /* on blur event */
    handleOnBlurEvent = (e, reactSelect) => {
        this.onBlurCallAPI(e, reactSelect);
    }
    /* on focus event */
    handleOnFocusEvent = (e) => {
        this.onFocusCallAPI(e);
    }
    /* on change event */
    handleOnChangeEvent = (e, isMultiple, reactSelect) => {
        // console.log('handleOnChangeEvent :', JSON.parse(e.target.value))
        const {
            name = 'textSelectInput',
            defaultLng,
            optionsObj: {
                displayObject: { enabled: displayEnabled = false } = {},
                externalURL: { label: extLabel = '', value: extValue = '' } = {}
            } = {}
        } = this.props;

        let selectedObject = {};
        if (isMultiple !== undefined && isMultiple) {
            this.props.onChange('multi_select', name, e.target.selectedOptions)
        } else if (typeof this.props.getValueUsingKey === 'function') {
            let selectValue = reactSelect ? e.value : e.target.value;
            let selectName = reactSelect ? e.name : e.target.name;
            if (displayEnabled && typeof this.props.getValueUsingKey === 'function') {
                const { selectOptions = [] } = this.state;
                selectOptions.map(sItem => {
                    if (typeof sItem.object === 'object' && this.props.getValueUsingKey(extValue, sItem.object) === selectValue) {
                        this.setState({ tableResponse: sItem.object, displayTable: true })
                    } else if (this.props.getValueUsingKey(extValue, sItem) === selectValue) {
                        this.setState({ tableResponse: sItem, displayTable: true })
                    }
                })
            } else {
                const { selectOptions = [] } = this.state;
                selectOptions.map(sItem => {
                    if (extLabel !== "") {
                        let arrExtLabel = [];
                        arrExtLabel = extLabel.split("|")
                        let strLabel = "";
                        if (arrExtLabel.length > 0 && typeof this.props.getValueUsingKey === 'function') {
                            arrExtLabel.map((label) => {
                                strLabel += this.props.getValueUsingKey("object." + label, sItem) + " "
                            })
                        } else if (typeof this.props.getValueUsingKey === 'function') {
                            strLabel = this.props.getValueUsingKey("object." + extLabel, sItem);
                        }
                        if (typeof this.props.getValueUsingKey === 'function' && typeof sItem.object === 'object' && this.props.getValueUsingKey(extValue, sItem.object) === selectValue) {
                            selectedObject = { label: { locale: { [defaultLng]: strLabel } }, value: this.props.getValueUsingKey("object." + extValue, sItem), ...sItem.object }
                        }
                    } else if (typeof this.props.getValueUsingKey === 'function') {
                        if (typeof sItem.object === 'object' && this.props.getValueUsingKey(extValue, sItem.object) === selectValue) {
                            selectedObject = sItem.object;
                        } else if (this.props.getValueUsingKey(extValue, sItem) === selectValue) {
                            selectedObject = sItem;
                        }
                    }
                })
            }
            // this.props.onChange('select', selectName, selectValue, '', '', '', e.target[e.target.selectedIndex].text)
            // console.log("selectName", selectName, selectValue)
            this.props.onChange('select', selectName, selectValue, '', '', '', e.target[e.target.selectedIndex].text)
        }
        this.onChangeCallAPI(e, isMultiple, reactSelect, selectedObject);
    }

    onBlurCallAPI = async (e) => {

        const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {}, assignResponseValue, swaggerPostAPI, swaggerGetAPI } = this.props;
        if (onBlurURL !== '') {

            let response = '';
            let inputName = e.target.name;
            let inputValue = e.target.value;

            if (blurMethod !== '' && blurMethod === 'POST' && typeof swaggerPostAPI === 'function') {
                let data = {
                    [inputName]: inputValue
                }
                response = await swaggerPostAPI(onBlurURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(inputName, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof swaggerGetAPI === 'function') {
                response = await swaggerGetAPI(onBlurURL, {}, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                    }
                }
            }

        }
    }

    onFocusCallAPI = async (e) => {

        const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue, swaggerPostAPI, swaggerGetAPI } = this.props;
        if (onFocusURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (focusMethod !== '' && focusMethod === 'POST' && typeof swaggerPostAPI === 'function') {
                response = await swaggerPostAPI(onFocusURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof swaggerGetAPI === 'function') {
                response = await swaggerGetAPI(onFocusURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }

    async onChangeCallAPI(e, isMultiple, reactSelect, selectedObject) {
        const { optionsObj: { onChange = [], onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '', setOptionsIn = '', changeRequest = [], request = [] } = {}, assignResponseValue, assignOptions, reqData } = this.props;

        if (onChange.length === 0) {
            let requestObj = changeRequest.length > 0 ? changeRequest : request;
            onChange.push({ onChangeURL, changeBindIn, changeResponseField, changeMethod, setOptionsIn, request: requestObj });
        }

        onChange.map(async (item) => {
            const { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '', setOptionsIn = '', request = [] } = item;
            const { swaggerPostAPI, swaggerGetAPI } = this.props
            if (onChangeURL !== '' && changeMethod !== '' && setOptionsIn !== '') {

                let response = {};
                if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                    setTimeout(function () {
                        assignOptions(setOptionsIn, [])
                    }, 500)
                }

                let { reqData: formRequest = {} } = this.props;
                if (/* formRequest['userIdentifier'] !== undefined &&  */localStorage.getItem('user') !== null && localStorage.getItem('user') !== undefined)
                    formRequest['userIdentifier'] = localStorage.getItem('user');

                let apiRequest = { data: {} };
                Array.isArray(request) && request.map((item) => {
                    const { key = '', value = '', isFromSelected = false } = item;
                    if (key !== '' /* && value !== '' && formRequest[value] !== '' */) {
                        if (isFromSelected) {
                            apiRequest.data[key] = (reactSelect) ? e.value : e.target.value;
                        } else {
                            apiRequest.data[key] = formRequest[value];
                        }
                    } else {
                        apiRequest.data[key] = ''
                    }
                });
                this.setState({ loading: true })
                if (changeMethod !== '' && changeMethod === 'POST' && typeof swaggerPostAPI === 'function') {
                    if (isMultiple !== undefined && isMultiple) {
                        response = await swaggerPostAPI(onChangeURL, e.target.selectedOptions, true);
                    } else {
                        response = await swaggerPostAPI(onChangeURL, apiRequest, true);
                    }
                    // response = {"responseCode":0,"errCode":"1","message":"Success","data":[{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"Tom Dick"},"UserAccountIdentifier":"7500075771","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515929102835048678664"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"Bhavesh"},"UserAccountIdentifier":"7580907426","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515936065125725154969"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"Dhruvit"},"UserAccountIdentifier":"7528173747","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515937626770913723529"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"Test Branch"},"UserAccountIdentifier":"7500075025","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515924786534912002765"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"yuvi"},"UserAccountIdentifier":"7500075781","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515935284845022592197"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"Dipesh"},"UserAccountIdentifier":"7504248870","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515937614012519889521"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"Test Branch"},"UserAccountIdentifier":"7500075007","Wallet":[{"Pouch":[{"UnUsedValueMajor":"243.00","AvailableBalanceMajor":"243.00","UsedValueMajor":"68.00"}]}],"UserAccountUniqueId":"192.168.2.22515904163391506809584"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"Branch Test"},"UserAccountIdentifier":"7500075084","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515924828010773185662"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"Testing Branch"},"UserAccountIdentifier":"7500075011","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515935960960468106119"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"John Branch"},"UserAccountIdentifier":"7500078651","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515935034671775345748"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"Test branch new"},"UserAccountIdentifier":"7511595175","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515912550639133064809"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{},"UserAccountIdentifier":"7500075024","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515924719069386924667"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"John Branch"},"UserAccountIdentifier":"7500007861","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515930669998288863290"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"Testing"},"UserAccountIdentifier":"7500070011","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515940094683952757395"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{"NAME":"Test Branch"},"UserAccountIdentifier":"7500075014","Wallet":[{"Pouch":[{"UnUsedValueMajor":"1.00","AvailableBalanceMajor":"1.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515907748412975970446"},{"UserCategory":"BRANCH_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"BRANCH_OPERATING_ENTITY_TEMPLATE","KycDetail":{},"UserAccountIdentifier":"7500075081","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515924088046235102768"},{"UserCategory":"TELLER_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"TELLER_OPERATING_ENTITY_TEMPLATE","KycDetail":{"FULL_NAME_IN_ENGLISH":"John Teller"},"UserAccountIdentifier":"7500078630","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515934190002438777101"},{"UserCategory":"TELLER_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"TELLER_OPERATING_ENTITY_TEMPLATE","KycDetail":{"FULL_NAME_IN_ENGLISH":"Test teller"},"UserAccountIdentifier":"7500071111","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515936210714052852340"},{"UserCategory":"TELLER_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"TELLER_OPERATING_ENTITY_TEMPLATE","KycDetail":{},"UserAccountIdentifier":"7500075093","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515924130547578686914"},{"UserCategory":"TELLER_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"TELLER_OPERATING_ENTITY_TEMPLATE","KycDetail":{"FULL_NAME_IN_ENGLISH":"John Teller"},"UserAccountIdentifier":"7500078652","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515935039344598621956"},{"UserCategory":"TELLER_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"TELLER_OPERATING_ENTITY_TEMPLATE","KycDetail":{},"UserAccountIdentifier":"7500075091","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515924094511957188727"},{"UserCategory":"TELLER_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"TELLER_OPERATING_ENTITY_TEMPLATE","KycDetail":{"FULL_NAME_IN_ENGLISH":"Test Teller new"},"UserAccountIdentifier":"7511595563","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515912559655764781789"},{"UserCategory":"TELLER_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"TELLER_OPERATING_ENTITY_TEMPLATE","KycDetail":{},"UserAccountIdentifier":"7500075092","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515924122738517108441"},{"UserCategory":"TELLER_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"TELLER_OPERATING_ENTITY_TEMPLATE","KycDetail":{"FULL_NAME_IN_ENGLISH":"John Teller"},"UserAccountIdentifier":"7500007860","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515931605789452776765"},{"UserCategory":"TELLER_CATEGORY","UserEntityType":"OPERATINGENTITY","UserEntityId":"TELLER_OPERATING_ENTITY_TEMPLATE","KycDetail":{"FULL_NAME_IN_ENGLISH":"Bhavesh"},"UserAccountIdentifier":"7560040075","Wallet":[{"Pouch":[{"UnUsedValueMajor":"0.00","AvailableBalanceMajor":"0.00","UsedValueMajor":"0.00"}]}],"UserAccountUniqueId":"192.168.2.22515936059785412936331"}]}
                    // response = await swaggerPostAPI(onChangeURL, data, true);
                    if (response.responseCode === 0) {
                        setTimeout(() => {
                            if (typeof assignResponseValue === 'function' && changeBindIn !== '') {
                                assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                            } else if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                                assignOptions(setOptionsIn, response.data)
                            }
                        }, 500);
                    } else if (response.responseCode === 1) {
                        setTimeout(() => {
                            if (typeof assignResponseValue === 'function' && changeBindIn !== '') {
                                assignResponseValue(changeBindIn, ''); // first argument field and second response value
                            } else if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                                assignOptions(setOptionsIn, [])
                            }
                            this.props.onError(e.target.name, `apiErrCode.${response.errCode}`)
                        }, 500);
                    }
                    // to do handle response of post method
                } else {
                    if (isMultiple !== undefined && isMultiple && swaggerGetAPI === 'function') {
                        response = await swaggerGetAPI(onChangeURL, e.target.selectedOptions, true);
                    } else if (typeof swaggerGetAPI === 'function') {
                        let selectedID = (reactSelect) ? e.value : e.target.value;
                        let url = onChangeURL + '' + selectedID;
                        response = await swaggerGetAPI(url, {}, true);
                    }
                    // response = await swaggerGetAPI(onChangeURL, data, true);
                    // response = { responseCode: 0, data: { billAmount: 1000 } }
                    if (response.responseCode === 0) {
                        if (typeof assignResponseValue === 'function' && changeBindIn !== '') {
                            assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                        } else if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                            assignOptions(setOptionsIn, response.data)
                        }
                    } else if (response.responseCode === 1) {
                        if (typeof assignResponseValue === 'function' && changeBindIn !== '') {
                            assignResponseValue(changeBindIn, ''); // first argument field and second response value
                        } else if (setOptionsIn !== '' && typeof assignOptions === 'function') {
                            assignOptions(setOptionsIn, [])
                        }
                        this.props.onError(e.target.name, `apiErrCode.${response.errCode}`)
                    }
                }
                this.setState({ loading: false })

            } else if (changeResponseField !== '' && changeBindIn !== '' && typeof assignResponseValue === 'function' && Object.keys(selectedObject).length > 0 && typeof this.props.getValueUsingKey === 'function') {
                const splitRegex = '|';
                const changeBindArray = changeBindIn.split(splitRegex);
                const changeResponseFieldArray = changeResponseField.split(splitRegex);
                changeBindArray.map((multiBind, index) => {
                    setTimeout(() => {
                        assignResponseValue(multiBind, this.props.getValueUsingKey(changeResponseFieldArray[index], selectedObject));
                    }, 1000)
                })
            }

        })

    }

    shouldComponentUpdate = (nextProps, nextState) => {
        if ((this.props === nextProps) || (nextState === this.state)) {
            return false;
        }
        return true;
    };

    onLinkClick = () => {
        const { tableResponse: currentItem = {} } = this.state;
        const {
            displayObject: {
                action: {
                    enabled: actionEnabled = false,
                    route: linkUrl = '',
                    page_id = '',
                    transaction_page_id = '',
                    request: actionRequest = []
                } = {}
            } = {}
        } = this.props.optionsObj;

        if (actionEnabled) {
            let stateObj = {
                page_id: '',
                transaction_page_id: transaction_page_id
            }
            if (actionRequest.length > 0) {
                actionRequest.map(aItem => {
                    const { key: reqKey = '', value: reqValue = '' } = aItem;
                    // stateObj[reqKey] = reqValue.indexOf('.') !== -1 ? getValueUsingKey(reqValue, currentItem) : currentItem[reqValue];
                    if (reqKey !== '' && typeof this.props.getValueUsingKey === 'function') {
                        stateObj[reqKey] = reqValue.indexOf('.') !== -1 ? this.props.getValueUsingKey(reqValue, currentItem) : currentItem[reqValue];
                    }
                })
            }
            this.props.history.push({ pathname: linkUrl, state: { stateReq: stateObj } })
        }
    }

    render() {
        const { errorMsg, defaultLng, defaultValue = '', intl, AppConfig: { totalRecordDisplayInList = "", rowsPerPageOptions = '' } = {}, MUIDataTable } = this.props;
        const { autoComplete = '', id, key, className, label, name, status, required, isDisabled, options, isMultiple, displaysize, labelAlignment, icon = '', iconPosition = '', helpText, autoFocus, type, onBlurURL, onFocusURL, onChangeURL, displayObject = {}, externalURL: { label: extLabel = '', value: extValue = '' } = {} } = this.props.optionsObj;
        let { enabled: displayEnabled = false, showImage: { enabled: displayShowImage = false } = {}, fieldset: displayFieldSet = [] } = displayObject;
        let dynamicKey = 'frm_select_' + (name !== undefined ? name : 'textSelectInput');
        const { selectOptions, displayTable, tableResponse } = this.state;
        let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
        let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
        let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
        let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
        if (icon !== '') {
            classInput += (iconPosition !== '' && iconPosition.toLowerCase() === 'right') ? ' icon_right' : ' icon_left';
        }

        /* let displayOptions = [];
        if (Array.isArray(selectOptions) && selectOptions.length > 0) {
            selectOptions.map((item) => {
                if (typeof item[extLabel] === "object" && Object.keys(item[extLabel]).length > 0) {
                    displayOptions.push({ label: item[extLabel], value: item[extValue] });
                } else {
                    displayOptions.push({ label: { locale: { [defaultLng]: getValueUsingKey(extLabel, item) } }, value: getValueUsingKey(extValue, item) });
                }
            })
        } */

        let tblColumns = [];
        let tblData = [];
        let tblOptions = {};

        if (defaultValue === '') {
            displayEnabled = false
        } else if (displayEnabled && displayTable) {
            if (displayFieldSet.length > 0) {
                displayFieldSet.map((dfItem, dfIndex) => {
                    const { value: columnName = '', title: { locale: { [defaultLng]: columnLabel = '' } = {} } = {} } = dfItem;
                    if (dfIndex === 0) {
                        tblColumns.push({
                            name: 'sr_no',
                            label: intl.formatMessage({ id: 'list.srNo' })
                        })
                    }
                    tblColumns.push({
                        name: columnName,
                        label: columnLabel
                    })
                })
            }

            let srNoIndex = 1;
            let tblObj = [srNoIndex++];
            displayFieldSet.map(dfItem => {
                const { value: columnName = '', isLink = false, isHighLight = false, mapping = [] } = dfItem;
                let tData = '';
                tData = tableResponse[columnName] ? tableResponse[columnName] : '-';
                if (columnName.indexOf('.') !== -1 && typeof this.props.getValueUsingKey === 'function') {
                    tData = this.props.getValueUsingKey(columnName, tableResponse);
                }
                if (Array.isArray(mapping) && mapping.length > 0 && typeof this.props.getValueUsingMapping === 'function')
                    tData = this.props.getValueUsingMapping(tData, mapping, defaultLng)
                //is link true..
                if (isLink) {
                    tData = <a href="javascript:void(0)" onClick={() => this.onLinkClick()}>{tData}</a>
                }
                //is highlighted true..
                if (isHighLight) {
                    tData = <span className="badge badge-primary">{tData}</span>
                }
                // tblObj[columnName] = tData ? tData : '-'
                tblObj.push(tData)
            });
            tblData.push(tblObj)

            tblOptions = {
                filter: false,
                viewColumns: false,
                print: false,
                selectableRows: false,
                rowsPerPage: totalRecordDisplayInList,
                pagination: false,
                rowsPerPageOptions: rowsPerPageOptions,
                sort: true,
                search: false,
                print: false,
                download: false,
                textLabels: {
                    body: {
                        noMatch: intl.formatMessage({ id: "message.emptyTable" })
                    }
                }
            };
        }


        return (
            <Fragment>
                {/* {status && */}
                <FormGroup className={`row${displayEnabled ? ' w-50' : ''}`} key={dynamicKey}>
                    {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    {/* {this.state.loading && <CircularProgress className="cstm_progress" thickness={3} />} */}
                                    <Input
                                        type="select"
                                        autoComplete={autoComplete.toString()}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        className={`${(className !== undefined && className) ? className : ''} ${(isMultiple !== undefined && isMultiple) ? ' is_multi_sel' : ''}`}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        className={(className !== undefined && className) ? className : ''}
                                        name={(name !== undefined && name) ? name : 'textSelectInput'}
                                        // value={(defaultValue !== undefined && defaultValue) ? JSON.stringify(defaultValue) : ''}
                                        value={(defaultValue !== undefined && defaultValue) ? defaultValue : ''}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        multiple={(isMultiple !== undefined && isMultiple) ? isMultiple : ''}
                                        size={(displaysize !== undefined && displaysize) ? displaysize : ''}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange((isMultiple !== undefined && isMultiple) ? 'multi_select' : 'select', e.target.name, (isMultiple !== undefined && isMultiple) ? e.target.selectedOptions : e.target.value)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e, false) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, isMultiple, false))}
                                    >
                                        {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                            <option value="" disabled>{label.locale[defaultLng]} --</option>}
                                        {selectOptions.map((item, index) => {
                                            const { label: { locale: { [defaultLng]: optionLable = '' } = {} } = {}, label = '', value = '' } = item;
                                            let displayLabel = '';
                                            if (typeof label === "object" && Object.keys(label).length > 0) {
                                                displayLabel = optionLable;
                                            } else {
                                                displayLabel = label;
                                            }
                                            return (
                                                <option value={value} key={`sel_opt_${index}`}>{displayLabel}</option>
                                            )
                                        })}
                                    </Input>
                                    {icon !== '' && <span className="is_icon"><i className={icon} /></span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    {/* {this.state.loading && <CircularProgress className="cstm_progress" thickness={3} />} */}
                                    <Input
                                        type="select"
                                        autoComplete={autoComplete.toString()}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        className={`${(className !== undefined && className) ? className : ''} ${(isMultiple !== undefined && isMultiple) ? ' is_multi_sel' : ''}`}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        className={(className !== undefined && className) ? className : ''}
                                        name={(name !== undefined && name) ? name : 'textSelectInput'}
                                        // value={(defaultValue !== undefined && defaultValue) ? JSON.stringify(defaultValue) : ''}
                                        value={(defaultValue !== undefined && defaultValue) ? defaultValue : ''}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        multiple={(isMultiple !== undefined && isMultiple) ? isMultiple : ''}
                                        size={(displaysize !== undefined && displaysize) ? displaysize : ''}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange((isMultiple !== undefined && isMultiple) ? 'multi_select' : 'select', e.target.name, (isMultiple !== undefined && isMultiple) ? e.target.selectedOptions : e.target.value)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e, false) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, isMultiple, false))}
                                    >
                                        {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                            <option value="" disabled>{label.locale[defaultLng]} --</option>}
                                        {selectOptions.map((item, index) => {
                                            const { label: { locale: { [defaultLng]: optionLable = '' } = {} } = {}, label = '', value = '' } = item;
                                            let displayLabel = '';
                                            if (typeof label === "object" && Object.keys(label).length > 0) {
                                                displayLabel = optionLable;
                                            } else {
                                                displayLabel = label;
                                            }
                                            return (
                                                <option value={value} key={`sel_opt_${index}`}>{displayLabel}</option>
                                            )
                                        })}
                                    </Input>
                                    {icon !== '' && <span className="is_icon"><i className={icon} /></span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                            </Fragment>
                    }
                </FormGroup>
                {/* } */}
                {(displayTable && displayEnabled) &&
                    <div className="mb-20">
                        <MUIDataTable
                            title=""
                            data={tblData}
                            columns={tblColumns}
                            options={tblOptions}
                        />
                    </div>}
            </Fragment>
        )
    }
}

//Default Props for Select
SelectWidget.defaultProps = {
    optionsObj: {
        autoComplete: false,
        id: 'Demo',
        className: 'cstm_input_sel',
        label: 'Select',
        name: 'Demo',
        status: false,
        required: true,
        validationMsg: '',
        regex: '',
        isDisabled: false,
        options: [],
        isMultiple: false,
        displaysize: 1,
        labelAlignment: 'left',
        icon: '',
        iconPosition: '',
        helpText: {},
        autoFocus: false,
        type: 'default',
        onBlurURL: "",
        onFocusURL: "",
        onChangeURL: "",
    },
    defaultValue: '',
    defaultLng: '',
    onChange: '',
    errorMsg: ''
}

export default SelectWidget;