/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control otp
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
 import React, { Component, Fragment } from 'react';
 import { Label, FormGroup } from 'reactstrap';
 // import AppConfig from 'DefaultConstants/AppConfig';
 // const CouponCard =  require('DefaultComponents/Widgets/CouponCard').default
 // const { getValueUsingKey, getDefaultLogo } = require('DefaultHelpers');
 // import IntlMessages from "Util/IntlMessages";
 /**
  * Start Otp class component
  * @state {*Object} reqData
  */
 class ServiceCard extends Component {
     render() {
         const { defaultLng, optionsObj = {}, reqData = {},CouponCard ,IntlMessages, AppConfig: { mainCurrency = "" } = {}} = this.props;
         const { showLogo: { enabled: logoEnabled = false, responseBindFrom = '' } = {}, columns = 2, displayFields = [], } = optionsObj;
         let logoSrc = typeof this.props.getValueUsingKey === 'function' ?  this.props.getValueUsingKey(responseBindFrom, reqData) : '';
         logoSrc = logoSrc ? logoSrc : (typeof this.props.getDefaultLogo === 'function' ? this.props.getDefaultLogo() : '');
         let data = '';
         return (
             <Fragment>
                 <CouponCard isGradient={true} customClasses="mh_120">
                     <div className="left_part">
                         <div className="row">
                             {Array.isArray(displayFields) && displayFields.map((item, index) => {
                                 const { title = '', value = '', showCurrency = false } = item;
                                 let displayTitle = title !== '' ? <IntlMessages id={title} /> : '', displayValue = '';
                                 if (showCurrency) {
                                     displayValue = mainCurrency;
                                 } else if(typeof this.props.getValueUsingKey === 'function'){
                                     displayValue = this.props.getValueUsingKey(value, reqData);
                                     if (displayValue !== '' && displayValue.toString().indexOf('category.') > -1) {
                                         displayValue = <IntlMessages id={displayValue} />;
                                     }
                                 }
                                 let extraClass = (index + 1) % 2 === 0 ? ' mb-10 text-right' : '';
                                 data = <div className={`col-sm-${Math.ceil(12 / parseInt(columns))} col-xs-${Math.ceil(12 / parseInt(columns))} col-md-${Math.ceil(12 / parseInt(columns))} ${extraClass}`}>{displayTitle}  {displayValue}</div>
                                 return data;
                             })}
                             {/* <div className="col-sm-4 text-right">IQD</div>
                             <div className="col-sm-8 mb-10">Game Pass</div>
                             <div className="col-sm-4 text-right mb-10">35,000.00</div>
                             <div className="col-sm-8"></div>
                             <div className="col-sm-4 text-right">Valid for 6 months</div> */}
                         </div>
                     </div>
                     {logoEnabled && logoSrc !== '' && <div className="right_part">
                         <img src={logoSrc} className="rnd_image" />
                     </div>}
                 </CouponCard>
             </Fragment>
         );
     }
 }
 
 export default ServiceCard;