/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control checkbox
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
 import React, { Component, Fragment } from 'react';
 import { Label, FormGroup, Input } from 'reactstrap';
//  import AppConfig from 'DefaultConstants/AppConfig';
//  const { swaggerPostAPI, swaggerGetAPI, serviceRouteList }= require('DefaultHelpers')
 import ReactHtmlParser from "react-html-parser";
//  const { CopyClipBoard, PageNotFound, HeadingType1, ModelDialog } = require('DefaultComponents/Widgets')
//  import IntlMessages from "Util/IntlMessages";
 /**
  * 
  * Start Checkbox class component
  * @state {*Object} reqData
  */
 class TermsCondition extends Component {
     constructor(props) {
         super(props);
         this.state = {
             isShowNoPageContent: false,
             isModelOpen: false,
             pageDetails: {}
         }
 
     }
     shouldComponentUpdate = (nextProps, nextState) => {
         if (this.props === nextProps) {
             return false;
         }
         return true;
     };
 
     /* on blur event */
     handleOnBlurEvent = (e) => {
         this.onBlurCallAPI(e);
     }
     /* on focus event */
     handleOnFocusEvent = (e) => {
         this.onFocusCallAPI(e);
     }
     /* on change event */
     handleOnChangeEvent = (e) => {
         // this.props.onChange(e.target.type, e.target.name, e.target.value, e.target.checked)
         this.props.onChange('terms_condition', e.target.name, e.target.value, e.target.checked)
         this.onChangeCallAPI(e);
     }
 
     onBlurCallAPI = async (e) => {
 
         const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {}, assignResponseValue } = this.props;
         if (onBlurURL !== '') {
 
             let response = '';
             let inputName = e.target.name;
             let inputValue = e.target.value;
 
             if (blurMethod !== '' && blurMethod === 'POST') {
                 let data = {
                     [inputName]: inputValue
                 }
                 if(typeof this.props.swaggerPostAPI === 'function' ){
                    response = await this.props.swaggerPostAPI(onBlurURL, data, true);
                }
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(inputName, `error.message.${response.errCode}`)
                 }
                 // to do handle response of post method
             } else if(typeof this.props.swaggerGetAPI === 'function'){
                 response = await this.props.swaggerGetAPI(onBlurURL, {}, true);
                 // response = { responseCode: 0, data: { billAmount: 1000 } }
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                     }
                 }
             }
 
         }
     }
 
     onFocusCallAPI = async (e) => {
 
         const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue } = this.props;
         if (onFocusURL !== '') {
 
             let data = {
                 [e.target.name]: e.target.value
             }
             let response = '';
 
             if (focusMethod !== '' && focusMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                 response = await this.props.swaggerPostAPI(onFocusURL, data, true);
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(e.target.name, `error.message.${response.errCode}`)
                 }
                 // to do handle response of post method
             } else if(typeof this.props.swaggerGetAPI === 'function') {
                 response = await this.props.swaggerGetAPI(onFocusURL, data, true);
                 // response = { responseCode: 0, data: { billAmount: 1000 } }
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(e.target.name, `error.message.${response.errCode}`)
                 }
             }
 
         }
 
     }
 
     async onChangeCallAPI(e) {
 
         const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '' } = {}, assignResponseValue } = this.props;
         if (onChangeURL !== '') {
 
             let data = {
                 [e.target.name]: e.target.value
             }
             let response = '';
 
             if (changeMethod !== '' && changeMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                 response = await this.props.swaggerPostAPI(onChangeURL, data, true);
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(e.target.name, `error.message.${response.errCode}`)
                 }
                 // to do handle response of post method
             } else if(typeof this.props.swaggerGetAPI === 'function'){
                 response = await this.props.swaggerGetAPI(onChangeURL, data, true);
                 // response = { responseCode: 0, data: { billAmount: 1000 } }
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(e.target.name, `error.message.${response.errCode}`)
                 }
             }
 
         }
 
     }
 
     /* get CMS page content method.... */
     _getModelContent(currentPath = '') {
         if (currentPath !== '') {
             this._getCMSPageContent(currentPath); //Get page content..
         } else {
             this.setState({ isShowNoPageContent: false });
         }
     }
 
     async _getCMSPageContent(currentPath) {
        const { AppConfig: { locale: { locale = '' } = {} , staticAPIURLs = {} } = {}} = this.props;
         let defaultLng = localStorage.getItem('locale') !== undefined ? localStorage.getItem('locale') : AppConfig.locale.locale;
         if(typeof this.props.swaggerGetAPI === 'function'  ){
         let response = await this.props.swaggerGetAPI(AppConfig.staticAPIURLs['getCMSPageURL'] + ((typeof this.props.serviceRouteList === 'function') ? this.props.serviceRouteList[currentPath]: ''), {});
        }
         // console.log('_getCMSPageContent', response)
         if (response.responseCode > 0) {
             this.setState({ isShowNoPageContent: true, pageDetails: {}, isModelOpen: true });
         } else if (response.responseCode === 0) {
             this.setState({
                 isShowNoPageContent: false,
                 isModelOpen: true,
                 pageDetails: response.data.locale[defaultLng]
             });
             this.forceUpdate();
         }
     }
 
     onClickClose = () => {
         this.setState({ isModelOpen: false });
         this.forceUpdate();
     };
 
     render() {
         const { isModelOpen, pageDetails, isShowNoPageContent } = this.state;
         const { errorMsg, defaultValue, defaultLng ,PageNotFound,HeadingType1 ,ModelDialog ,IntlMessages} = this.props;
         const { id, className, label, name, status, required, isDisabled, options, labelAlignment, displayAsButton, onBlurURL, onFocusURL, onChangeURL, showInDialog = false, showAsLink = false, URL = '' } = this.props.optionsObj;
         let dynamicKey = 'frm_checkbox_' + (name !== undefined ? name : 'textCheckBoxInput');
         let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
         let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
         let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-12 col-sm-12';
         let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
         let showAsButton = displayAsButton !== undefined && displayAsButton ? displayAsButton : false;
 
         return (
             <Fragment>
                 {/* {status && */}
                 <FormGroup className="row" key={dynamicKey}>
                     <Fragment>
                     <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                             <div className={`cstm_icn_area`}>
                                 <div className="custom-control custom-checkbox custom-control-inline">
                                     <Input
                                         type="checkbox"
                                         className={`custom-control-input`}
                                         name={((name !== undefined && name) ? name : dynamicKey)}
                                         key={'agree_terms'}
                                         id={'agree_terms'}
                                         value={(defaultValue !== undefined && defaultValue) ? defaultValue : ''}
                                         disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                         required={(required !== undefined && required) ? required : false}
                                         checked={(defaultValue !== undefined && defaultValue) ? defaultValue : false}
                                         // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange(e.target.type, e.target.name, e.target.value, e.target.checked)}
                                         onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                         onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                         onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                     />
                                     {(label !== undefined
                                         && label.locale !== undefined
                                         && label.locale[defaultLng] !== undefined) &&
                                         <label className="custom-control-label" htmlFor={'agree_terms'}>
                                             {(showInDialog) ? <a sethref="javascript:void(0)" onClick={() => this._getModelContent(URL)}>{ReactHtmlParser(label.locale[defaultLng])}</a> : ReactHtmlParser(label.locale[defaultLng])}
                                         </label>}
                                 </div>
 
                             </div>
                             {errorMsg && <div className="validation_error">{errorMsg}</div>}
                         </div>
                     </Fragment>
 
                 </FormGroup>
                 {isModelOpen &&
                     <ModelDialog mdlOpen={isModelOpen} customClasses="" toggleMethod={() => this.onClickOpen()}>
                         {
                             isShowNoPageContent
                                 ? <PageNotFound {...this.props} />
                                 :
                                 <div className="mdl_cnt">
                                     <HeadingType1 title={pageDetails.title} {...this.props} />
                                     {/* <h2 className="ptitle">{pageDetails.title}</h2> */}
                                     <div className="bx_scroll">
                                         {ReactHtmlParser(pageDetails.content)}
                                     </div>
                                     {/* {(isShowGeneratePassword && AppConfig.generatePasswordEnabled) && <CopyClipBoard configuration={copyJsonObj} {...this.props} />} */}
                                     <div class="btn_area btn_center">
                                         <button class="btn_general" onClick={() => this.onClickClose()}><IntlMessages id="general.btnClose" /></button>
                                     </div>
                                 </div>
                         }
                     </ModelDialog>
                 }
             </Fragment>
         )
     }
 }
 
 //Default Props for Checkbox
 TermsCondition.defaultProps = {
     optionsObj: {
         id: 'Demo',
         className: 'cstm_input_sel',
         label: 'Checkbox',
         name: 'Demo',
         status: false,
         required: true,
         validationMsg: '',
         regex: '',
         isDisabled: false,
         options: [],
         labelAlignment: 'left',
         icon: '',
         iconPosition: '',
         displayAsButton: false,
         onBlurURL: "",
         onFocusURL: "",
         onChangeURL: "",
     },
     defaultValue: [],
     defaultLng: '',
     onChange: '',
     errorMsg: ''
 }
 
 export default TermsCondition;