/**
 * Auther : MobifinElite Developer
 * Created : 18-03-2020
 * Form control text
 *
 * Text box (input element text and handle all the things)
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input, NavbarText, Modal, ModalBody } from 'reactstrap';
import passwordPolicy from 'password-policy';
import ReactHtmlParser from "react-html-parser";
// import AppConfig from 'DefaultConstants/AppConfig';
import { NotificationManager } from 'react-notifications';
import Tooltip from '@material-ui/core/Tooltip';
// const { CopyClipBoard, PageNotFound, HeadingType1 } = require('DefaultComponents/Widgets');
// const { swaggerPostAPI, swaggerGetAPI, isUserLogin, serviceRouteList, getLinkObjBaseOnUrl, convertProperString, getValueUsingKey } = require('DefaultHelpers')

const isShowPageInModel = ['/app/transaction-pin-policy', '/app/password-policy', '/app/terms-of-services', '/app/privacy-policy', '/app/login-pin-policy'];

/**
 * Start Text class component
 * @state {*Object} reqData
 */
class Text extends Component {
    constructor(props) {
        super(props);
        this.state = {
            isShowNoPageContent: false,
            isShowPassword: false,
            isModelOpen: false,
            isShowGeneratePassword: false,
            copyJsonObj: {},
            pageDetails: {}
        }

    }
    // componentDidMount() {
    //     this.callAPI();
    // }

    onClickOpen = () => {
        this.setState({ isModelOpen: !this.state.isModelOpen });
    };

    onClickClose = () => {
        this.setState({ isModelOpen: false });
    };

    /* get CMS page content method.... */
    _getModelContent(currentPath = '') {
        if (currentPath !== '') {
            this._getCMSPageContent(currentPath); //Get page content..
        } else {
            this.setState({ isShowNoPageContent: false });
        }
    }

    async _getCMSPageContent(currentPath) {
        const { AppConfig: { locale: { locale = '' } = {}, staticAPIURLs = {} } = {} } = this.props;
        let defaultLng = localStorage.getItem('locale') !== undefined ? localStorage.getItem('locale') : locale;
        if (typeof this.props.swaggerGetAPI === 'function') {
            let response = await this.props.swaggerGetAPI(staticAPIURLs['getCMSPageURL'] + ((typeof this.props.serviceRouteList === 'function') ? this.props.serviceRouteList[currentPath] : ''), {});
            const { responseCode = 1, data: { locale: { [defaultLng]: pageCOntent = {} } = {} } = {} } = response;
            if (responseCode > 0) {
                this.setState({ isShowNoPageContent: true, pageDetails: {}, isModelOpen: true });
            } else if (responseCode === 0) {
                this.setState({
                    isShowGeneratePassword: (currentPath === "/app/transaction-pin-policy" || currentPath === "/app/password-policy" || currentPath === "/app/login-pin-policy") ? true : false,
                    copyJsonObj: {},
                    isShowNoPageContent: false,
                    isModelOpen: true,
                    pageDetails: pageCOntent
                });
            }
        }
    }

    showHidePassword = () => {
        this.setState({ isShowPassword: !this.state.isShowPassword ? true : false });
    }

    /* shouldComponentUpdate = (nextProps, nextState) => {
        if (this.props === nextProps) {
            return false;
        }
        return true;
    }; */
    /* on blur event */
    handleOnBlurEvent = (e) => {
        this.onBlurCallAPI(e);

    }
    /* on focus event */
    handleOnFocusEvent = (e) => {
        this.onFocusCallAPI(e);
    }
    /* on change event */
    handleOnChangeEvent = (e, inputType) => {
        if (typeof this.props.onChange === 'function')
            this.props.onChange(inputType, e.target.name, e.target.value)
        this.onChangeCallAPI(e);
    }

    onBlurCallAPI = async (e) => {
        const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '', setOptionsIn = '' } = {}, assignResponseValue, assignOptions, AppConfig = {} } = this.props;
        if (onBlurURL !== '') {

            let response = '';
            let inputName = e.target.name;
            let inputValue = e.target.value;
            if (onBlurURL.indexOf(staticAPIURLs['isUserExistsURL']) !== -1 && typeof this.props.swaggerPostAPI === 'function') {
                let validationType = onBlurURL.split('/');
                let data = {
                    validateType: validationType[2],
                    [inputName]: inputValue
                }
                response = await this.props.swaggerPostAPI(onBlurURL, { data }, true);
                if (response.responseCode === 1 && typeof this.props.onError === 'function') {
                    this.props.onError(inputName, `error.message.${response.errCode}`)
                }
            } else if (onBlurURL.indexOf('adapter/v1/billinquiry') !== -1 && typeof this.props.swaggerPostAPI === 'function') {
                let data = {
                    ...this.props.reqData,
                    [inputName]: inputValue
                }
                response = await this.props.swaggerPostAPI(onBlurURL, { data }, true);
                if (response.responseCode === 1 && typeof this.props.onError === 'function') {
                    this.props.onError(inputName, `error.message.${response.errCode}`)
                }
            } else {
                if (inputValue !== '') {

                    if (blurMethod !== '' && blurMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                        let data = {}
                        if (typeof assignOptions === 'function' && setOptionsIn !== '') {
                            data = {
                                'data': {
                                    [inputName]: inputValue
                                }
                            }
                        } else {
                            data = {
                                [inputName]: inputValue
                            }
                        }
                        response = await this.props.swaggerPostAPI(onBlurURL, data, true);
                        if (response.responseCode === 0) {
                            if (typeof assignOptions === 'function' && setOptionsIn !== '') {
                                let optionsList = []
                                if (blurResponseField !== '' && blurResponseField.indexOf('data.') > -1 && typeof this.props.getValueUsingKey === 'function') {
                                    optionsList = this.props.getValueUsingKey(blurResponseField, response);
                                } else {
                                    optionsList = response.data[blurResponseField];
                                }
                                if (typeof this.props.assignOptions === 'function')
                                    this.props.assignOptions(setOptionsIn, optionsList); // first argument field and second response value

                            } else if (typeof this.props.assignResponseValue === 'function') {
                                this.props.assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                            }
                        } else if (response.responseCode === 1 && typeof this.props.onError === 'function') {
                            this.props.onError(inputName, `error.message.${response.errCode}`)
                        }
                        // to do handle response of post method
                    } else if (typeof this.props.swaggerGetAPI === 'function') {
                        response = await this.props.swaggerGetAPI(onBlurURL, {}, true);
                        // response = { responseCode: 0, data: { billAmount: 1000 } }
                        if (response.responseCode === 0) {
                            if (typeof this.props.assignResponseValue === 'function') {
                                this.props.assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                            }
                        }
                    }

                }
            }
        }
    }

    onFocusCallAPI = async (e) => {

        const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue } = this.props;
        if (onFocusURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (focusMethod !== '' && focusMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                response = await this.props.swaggerPostAPI(onFocusURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1 && typeof this.props.onError === 'function') {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof this.props.swaggerGetAPI === 'function') {
                response = await this.props.swaggerGetAPI(onFocusURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1 && typeof this.props.onError === 'function') {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }

    async onChangeCallAPI(e) {

        const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '' } = {}, assignResponseValue, swaggerPostAPI, swaggerGetAPI } = this.props;
        if (onChangeURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (changeMethod !== '' && changeMethod === 'POST' && typeof swaggerPostAPI === 'function') {
                response = await swaggerPostAPI(onChangeURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof swaggerGetAPI === 'function') {
                response = await swaggerGetAPI(onChangeURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1 && typeof this.props.onError === 'function') {
                    this.props.onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        } else if (changeBindIn !== '' && e.target !== undefined) {
            var inputValue = e.target.value;
            setTimeout(() => {
                if (typeof assignResponseValue === 'function') {
                    assignResponseValue(changeBindIn, inputValue); // first argument field and second response value
                }
            }, 500)
        }

    }

    keyPress = (e) => {
        console.log("this.props", this.props)
        const { optionsObj: { type = '', keyboardType = "default" } = {} } = this.props;
        if (type === 'number' || (keyboardType !== undefined && keyboardType === 'numeric')) {
            e = e || window.event;
            var charCode = (typeof e.which == "undefined") ? e.keyCode : e.which;
            var charStr = String.fromCharCode(charCode);
            if ([8, 46, 13, 9, 16, 37, 39, 190, 110, 35, 40, 34, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105].indexOf(charCode) === -1 && !charStr.match(/^[0-9.]+$/)) {
                e.preventDefault();
            }
        }

        if (e.keyCode == 13 && typeof this.props.onSubmit === 'function') {
            this.props.onSubmit(e);
        }
    }

    numberValidate = (e) => {
        const { optionsObj: { type = '', maxLength = '' } = {}, defaultValue = '' } = this.props;
        if (type === 'number' && maxLength !== '') {
            if (defaultValue.length == maxLength)
                e.preventDefault();
        }
    }

    redirectToLink = (title, url) => {
        if (title === "Copy") {
            const el = document.createElement('textarea');
            el.value = this.props.defaultValue;
            document.body.appendChild(el);
            el.select();
            document.execCommand('copy');
            const { IntlMessages = ({}) } = this.props;
            NotificationManager.success(<IntlMessages id="general.codeCopy" />)
        } else {
            if (url.indexOf('?') !== -1) {
                let redirectObject = {};
                if (typeof this.props.getLinkObjBaseOnUrl === 'function') {
                    redirectObject = this.props.getLinkObjBaseOnUrl(url);
                }
                if (redirectObject.state === undefined) {
                    redirectObject.state = {};
                }
                redirectObject.state = { ...this.props.reqData, ...redirectObject.state }
                this.props.history.push(redirectObject)
            } else {
                this.props.history.push(url);
            }
        }
    }

    downloadFile = async (urlDetail, fileName, uploadedFileDownload, approvedStatus = '') => {
        // console.log("urlDetail, fileName, uploadedFileDownload", urlDetail, fileName, uploadedFileDownload)
        const { showLink, link: { url = '' } = {} } = this.props.optionsObj;
        const { AppConfig: { staticAPIURLs = {} } = {} } = this.props;
        // console.log("showLink && url", showLink, url)
        if (showLink && url !== '' && typeof this.props.swaggerGetAPI === 'function') {
            let originalFileName = fileName;
            fileName = fileName.split('.')[0]
            const response = await this.props.swaggerGetAPI(uploadedFileDownload ? approvedStatus !== "2" ? staticAPIURLs['downloadFileURL'] + '?file=process/' + fileName : staticAPIURLs['downloadFileURL'] + '?file=?path=/data/Orbit/TRNData/process/archive/' + originalFileName : url, {}, true);
            if (response.responseCode === 0 && response.data !== undefined && response.data.file !== undefined) {
                if (response.data.fileType !== undefined && response.data.fileType !== '') {
                    // window.open(`data:${response.data.fileType};base64,${response.data.file}`, 'target_blank');
                    var a = document.createElement("a"); //Create <a>
                    a.href = `data:${response.data.fileType};base64,${response.data.file}`; //Image Base64 Goes here
                    a.download = fileName + response.data.fileExtention;
                    a.click();
                } else {
                    var a = document.createElement("a"); //Create <a>
                    a.href = `data:image/png;base64,${response.data.file}`; //Image Base64 Goes here
                    a.download = fileName + response.data.fileExtention;
                    a.click();
                    // window.open(`data:image/png;base64,${response.data.file}`, 'target_blank');
                }
            }
        }
    }

    render() {
        const { isShowPassword, isModelOpen, pageDetails, isShowNoPageContent, copyJsonObj, isShowGeneratePassword } = this.state;
        let { errorMsg = '', defaultValue = '', defaultLng, savedObject = {}, optionsObj = {}, IntlMessages = ({}), CopyClipBoard, HeadingType1, PageNotFound, AppConfig: { generatePasswordEnabled = false } = {} } = this.props;
        let {
            autoComplete = false,
            autoFocus = false,
            key = '',
            id = '',
            className = '',
            label: { locale: { [defaultLng]: labelTitle = '' } = {} } = {},
            label,
            name = '',
            type: inputType = 'text',
            status,
            placeHolder,
            placeHolder: { locale: { [defaultLng]: placeholder = '' } = {} } = {},
            required = false,
            isDisabled = false,
            minLength = '',
            maxLength = '',
            labelAlignment = '',
            icon = '',
            iconPosition = 'right',
            showLink = false,
            link: NewLink = {},
            link: {
                url: linkUrl = '',
                position: linkPosition = 'right',
                label: { locale: { [defaultLng]: linkTitle = '' } = {} } = {}
            } = {},
            isShowHideMethod = false,
            selectText = false,
            helpText: { locale: { [defaultLng]: helpTitle = '' } = {} } = {},
            showClear = false,
            onBlurURL = '',
            onFocusURL = '',
            onChangeURL = '',
            isAccessPhoneBook: isPhoneBook = false,
            showPasswordStrength = {},
            responseBindFrom = '',
            disabledOnResponseBindFrom = false,
            prefixConfig: {
                enabled: prefixedEnabled = false,
                key: prefixKey = '',
                disabled: prefixDisabled = true,
                bindInRequest = false
            } = {},
            tooltip: {
                enabled: showTooltip = false,
                locale: { [defaultLng]: tooltipContent = '' } = {}
            } = {}
        } = optionsObj;

        let dynamicKey = 'frm_text_' + (name !== '' ? name : 'dynamicKeyTextInput');
        let labelString = labelAlignment !== '' ? labelAlignment.toString().toLowerCase() : '';
        // let classLabel = (labelString === 'top-left' || labelString === 'top-right') && showLink ? 'col-7 d-flex' : 'col-12 d-flex';
        let classLabel = (labelString === 'top-left' || labelString === 'top-right') && showLink ? 'col-7 d-flex' : 'col';
        let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
        let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
        // let inputType = type !== undefined ? type : 'text';
        let isShowHide = inputType === 'password' && isShowHideMethod !== undefined && isShowHideMethod ? isShowHideMethod : false;
        // let isPhoneBook = (isAccessPhoneBook !== undefined && isAccessPhoneBook) ? isAccessPhoneBook : false;
        inputType = isShowPassword && inputType === 'password' ? 'text' : inputType;
        let isLinkClick = false;
        let link = NewLink;
        if (showLink && linkUrl !== '') {
            const { pathname = '' } = this.props.location;
            // if (!isUserLogin() && isShowPageInModel.indexOf(link.url) !== -1) {
            if (((typeof this.props.isUserLogin === 'function' && !this.props.isUserLogin()) || pathname === '/activation') && isShowPageInModel.indexOf(linkUrl) !== -1) {
                isLinkClick = true;
            }
        }


        //if prefix enabled then add input-group class
        if (prefixedEnabled) {
            classInput += ' prefixed_area';
        }

        if (icon !== '') {
            classInput += (iconPosition !== undefined && iconPosition.toLowerCase() === 'right') ? ' icon_right' : ' icon_left';
        } else if (showClear) {
            classInput += ' icon_clear ';
        }

        let helpTextDetail = {};
        if (typeof this.props.convertProperString === 'function')
            this.props.convertProperString(helpTitle, '', savedObject)
        // var helpTextDetail = helpText !== undefined ? helpText : {};
        /* if (typeof helpTextDetail === "object" && helpTextDetail.locale !== undefined && savedObject !== undefined && Object.keys(savedObject).length > 0) {
            Object.keys(helpTextDetail.locale).map((key) => {
                Object.keys(savedObject).map((savedKey) => {
                    var regex = new RegExp("{" + savedKey + "}", 'g');
                    helpTextDetail.locale[key] = helpTextDetail.locale[key].replace(regex, savedObject[savedKey])
                });
            });
        } */
        let displayAsDownloadLink = false;
        if (defaultValue !== '' && typeof defaultValue !== 'number') { //FILE16004168590948117027.csv
            if (defaultValue.indexOf('FILE') > -1 && /^[FILE]+[0-9.csv]*$/.test(defaultValue)) {
                displayAsDownloadLink = true;
            }
        }
        if (enabled) {
            let displayValue = defaultValue;
            var lastString = displayValue.substring(displayValue.toString().length - parseInt(lastCharacters));
            let mask = displayValue.substring(displayValue.toString().length - parseInt(lastCharacters) - 1, displayValue.toString().length).replace(/\d/g, "*");
            defaultValue = mask + lastString;
        }
        const { enabled = false, showProgressBar = false, showTags = false, hasUpperCase = false, hasLowerCase = false, hasNumber = false, hasSpecialCharacter = false, hasLength = false } = showPasswordStrength;
        let hasLowerCaseBit = false, hasUpperCaseBit = false, hasNumberBit = false, hasSpecialCharacterBit = false, hasLengthBit = false, counter = 0, totalCount = 0;
        if (enabled && defaultValue !== '') {
            if (hasLowerCase) {
                totalCount++;
                hasLowerCaseBit = passwordPolicy.hasLowerCase(defaultValue);
                if (hasLowerCaseBit)
                    counter++;
            }
            if (hasUpperCase) {
                totalCount++;
                hasUpperCaseBit = passwordPolicy.hasUpperCase(defaultValue);
                if (hasUpperCaseBit)
                    counter++;
            }
            if (hasNumber) {
                totalCount++;
                hasNumberBit = passwordPolicy.hasNumber(defaultValue);
                if (hasNumberBit)
                    counter++;
            }
            if (hasSpecialCharacter) {
                totalCount++;
                hasSpecialCharacterBit = passwordPolicy.hasSpecialCharacter(defaultValue);
                if (hasSpecialCharacterBit)
                    counter++;
            }
            if (hasLength && minLength !== '' && maxLength !== '') {
                totalCount++;
                hasLengthBit = (defaultValue.toString().length >= parseInt(minLength) && defaultValue.toString().length <= parseInt(maxLength));
                if (hasLengthBit)
                    counter++;
            }
        }

        let progressBarStyle = { "width": `${defaultValue !== '' ? ((100 / totalCount) * counter) : 0}%` };
        // let progressBarStyle = { "width": `${(100 / totalCount) * counter}%`, "backgroundColor": "red !important" };

        let color = '';
        /* if (totalCount === counter) {
            color = 'green'
        } else  */if ((100 / totalCount) * counter <= 20) {
            color = 'red'
        } else if ((100 / totalCount) * counter <= 40) {
            color = 'yellow'
        } else if ((100 / totalCount) * counter <= 60) {
            color = 'pink'
        } else if ((100 / totalCount) * counter <= 80) {
            color = 'brown'
        } else if ((100 / totalCount) * counter <= 100) {
            color = 'green'
        }

        let redColor = defaultValue.toString().length > 0 ? ' red' : '';

        if (responseBindFrom !== '' && disabledOnResponseBindFrom && typeof this.props.getValueUsingKey === 'function') {
            let resData = this.props.getValueUsingKey(responseBindFrom, savedObject);
            isDisabled = (resData !== undefined && resData !== '');
        }
        return (
            <Fragment>
                {/* {status && */}
                <FormGroup className="row" key={dynamicKey}>
                    {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    {prefixedEnabled &&
                                        <Input
                                            type="text"
                                            key={`prefix_${name}`}
                                            id={`prefix_id_${name}`}
                                            className="prefix_ipt"
                                            name="prefixed_text"
                                            value={prefixKey}
                                            placeholder=""
                                            disabled={prefixDisabled}
                                            required={false}
                                            minLength="3"
                                            maxLength="3"
                                        />}
                                    <Input
                                        type={inputType}
                                        autoComplete={(autoComplete !== undefined && autoComplete === true) ? "on" : "off"}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        className={((className !== undefined && className) ? className : '') + (selectText === false ? " noselect " : "")}
                                        name={(name !== undefined && name) ? name : 'textInput'}
                                        value={(defaultValue !== undefined && defaultValue) ? defaultValue : ''}
                                        placeholder={(placeHolder !== undefined && placeHolder.locale !== undefined && placeHolder.locale[defaultLng] !== undefined) ? placeHolder.locale[defaultLng] : ''}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        minLength={(minLength !== undefined && minLength) ? minLength : ''}
                                        maxLength={(maxLength !== undefined && maxLength) ? maxLength : ''}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange(inputType, e.target.name, e.target.value)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, inputType))}
                                        onKeyDown={this.keyPress}
                                        onKeyPress={this.numberValidate}
                                    />
                                    <Fragment>
                                        {(icon !== undefined && icon !== '' && !isPhoneBook) &&
                                            <Fragment>
                                                {isShowHideMethod
                                                    ?
                                                    <span className="is_icon" onMouseDown={this.showHidePassword} onMouseLeave={this.showHidePassword}><i className={isShowPassword ? icon : 'zmdi zmdi-eye-off'} /></span>
                                                    :
                                                    <span className="is_icon" onClick={isPhoneBook ? () => this.openPhoneBook() : () => ({})}><i className={icon} /></span>
                                                }
                                            </Fragment>
                                        }
                                        {(showClear !== undefined && showClear === true && defaultValue.length > 0 && !isDisabled) &&
                                            <Fragment>
                                                <span className="is_icon_close" onClick={(e) => this.props.onChange(inputType, (name !== undefined && name) ? name : 'textInput', '')}><i className={'zmdi zmdi-close'} /></span>
                                            </Fragment>
                                        }
                                    </Fragment>
                                    {helpTextDetail !== undefined && Object.keys(helpTextDetail).length > 0 && <span className="text-muted font-xs">{helpTextDetail.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>
                                        {label.locale[defaultLng]}{required && <span className="text-danger">*</span>}{showTooltip && <Tooltip id="tooltip-icon" title={ReactHtmlParser(tooltipContent)} disableFocusListener={true}><i className="zmdi zmdi-info zmdi-hc-lg fs-lg float-right" /></Tooltip>}
                                    </Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>
                                        {label !== undefined && label.locale[defaultLng]}{required && <span className="text-danger">*</span>}{showTooltip && <Tooltip id="tooltip-icon" title={ReactHtmlParser(tooltipContent)} disableFocusListener={true}><i className="zmdi zmdi-info zmdi-hc-lg fs-lg float-right" /></Tooltip>}
                                    </Label>}
                                {(showLink !== undefined && showLink == true && Object.keys(link).length > 0) &&
                                    <Label className={`control-label col temp`} align={link.position}>
                                        {isLinkClick
                                            ? <a sethref="javascript:void(0)" onClick={() => this._getModelContent(link.url)}>{link.label.locale[defaultLng]}</a>
                                            // : <Link to={"#"} onClick={() => this.redirectToLink(link.label.locale[defaultLng], link.url)}>{link.label.locale[defaultLng]}</Link>
                                            : <a sethref="javascript:void(0)" onClick={
                                                !displayAsDownloadLink ?
                                                    () => this.redirectToLink(link.label.locale['en'], link.url)
                                                    :
                                                    () => this.downloadFile('', link.label.locale[defaultLng], false, savedObject.ActionStatus)
                                            }>{link.label.locale[defaultLng]
                                                }</a>
                                        }
                                        {/* <a href={link.url}>{link.label.locale[defaultLng]}</a> */}
                                    </Label>}
                                {!displayAsDownloadLink ? <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    {prefixedEnabled &&
                                        <Input
                                            type="text"
                                            key={`prefix_${name}`}
                                            id={`prefix_id_${name}`}
                                            className="prefix_ipt"
                                            name="prefixed_text"
                                            value={prefixKey}
                                            placeholder=""
                                            disabled={prefixDisabled}
                                            required={false}
                                            minLength="3"
                                            maxLength="3"
                                        />}
                                    <Input
                                        type={inputType}
                                        autoComplete={(autoComplete !== undefined && autoComplete === true) ? 'on' : 'off'}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        className={((className !== undefined && className) ? className : '') + (selectText === false ? " noselect " : "")}
                                        name={(name !== undefined && name) ? name : 'textInput'}
                                        value={(defaultValue !== undefined && defaultValue) ? defaultValue : ''}
                                        placeholder={(placeHolder !== undefined && placeHolder.locale !== undefined && placeHolder.locale[defaultLng] !== undefined) ? placeHolder.locale[defaultLng] : ''}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        minLength={(minLength !== undefined && minLength) ? minLength : ''}
                                        maxLength={(maxLength !== undefined && maxLength) ? maxLength : ''}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange(inputType, e.target.name, e.target.value)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, inputType))}
                                        onKeyDown={this.keyPress}
                                        onKeyPress={this.numberValidate}
                                    />
                                    <Fragment>
                                        {(icon !== undefined && icon !== '' && !isPhoneBook) &&
                                            <Fragment>
                                                {isShowHideMethod
                                                    ?
                                                    <span className="is_icon" onMouseDown={this.showHidePassword} onMouseUp={this.showHidePassword}><i className={isShowPassword ? icon : 'zmdi zmdi-eye-off'} /></span>
                                                    :
                                                    <span className="is_icon" onClick={isPhoneBook ? () => this.openPhoneBook() : () => ({})}><i className={icon} /></span>
                                                }
                                            </Fragment>
                                        }
                                        {(showClear !== undefined && showClear === true && defaultValue.length > 0 && !isDisabled) &&
                                            <Fragment>
                                                <span className="is_icon_close" onClick={(e) => this.props.onChange(inputType, (name !== undefined && name) ? name : 'textInput', '')}><i className={'fa fa-close'} /></span>
                                            </Fragment>
                                        }
                                    </Fragment>
                                    {helpTextDetail !== undefined && Object.keys(helpTextDetail).length > 0 && <span className="text-muted font-xs">{helpTextDetail.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div> :
                                    <div className={classInput + ' ' + className}>
                                        <div className="txtbox_w_lnk">
                                            <a sethref="#" onClick={() => this.downloadFile('', defaultValue, 1, savedObject.ActionStatus)}><span className="highlight">{<IntlMessages id='common.download' />}</span></a>
                                        </div>
                                    </div>
                                }
                            </Fragment>
                    }
                </FormGroup>
                {enabled && <ul className="list-inline strength-password" >
                    {hasLength && <li className={`list-inline-item strength-pass ${hasLengthBit ? 'green' : redColor}`}>8-14 ch.</li>} {/* hasLength */}
                    {hasUpperCase && <li className={`list-inline-item strength-pass ${hasUpperCaseBit ? 'green' : redColor}`}>A-Z</li>} {/* hasUpperCase */}
                    {hasLowerCase && <li className={`list-inline-item strength-pass ${hasLowerCaseBit ? 'green' : redColor}`}>a-z</li>} {/* hasLowerCase */}
                    {hasNumber && <li className={`list-inline-item strength-pass ${hasNumberBit ? 'green' : redColor}`}>0-9</li>} {/* hasNumber */}
                    {hasSpecialCharacter && <li className={`list-inline-item strength-pass ${hasSpecialCharacterBit ? 'green' : redColor}`}>sp.ch-@$#*&!^</li>} {/* hasSpecialCharacter */}
                </ul>}
                {enabled && showProgressBar && <div className="strength-password"><div className="progress" style={{ "height": "2px;" }}>
                    <div className={`progress-bar ${color}`} role="progressbar" style={progressBarStyle} aria-valuenow={(100 / totalCount) * counter} aria-valuemin="0" aria-valuemax="100"></div>
                </div></div>}
                {/* } */}
                {isModelOpen &&
                    <Modal isOpen={isModelOpen} toggle={() => this.onClickOpen()} className="sml-modal-dialog">
                        <ModalBody className="model_bo">
                            {
                                isShowNoPageContent
                                    ? typeof PageNotFound === 'function' ? <PageNotFound {...this.props} /> : ''
                                    :
                                    <div className="gnrt_newpass_area mdl_cnt">
                                        {typeof HeadingType1 === 'function' && <HeadingType1 title={pageDetails.title} {...this.props} />}
                                        {ReactHtmlParser(pageDetails.content)}
                                        {((isShowGeneratePassword) || (isShowGeneratePassword && generatePasswordEnabled)) && CopyClipBoard === 'function' && <CopyClipBoard configuration={copyJsonObj} {...this.props} />}
                                        <div class="btn_area btn_center">
                                            <button class="btn_general" onClick={() => this.onClickClose()}><IntlMessages id="general.btnClose" /></button>
                                        </div>
                                    </div>
                            }
                        </ModalBody>
                    </Modal>
                }
            </Fragment>
        )
    }
}

//Default Props for Text
Text.defaultProps = {
    optionsObj: {
        autoComplete: false,
        autoFocus: false,
        key: 'input_txt_',
        id: 'Demo_text',
        className: 'cstm_input_txt',
        label: 'Text',
        name: 'Demo',
        type: 'text',
        status: false,
        placeHolder: 'Demo input',
        required: true,
        validationMsg: '',
        regex: '',
        isDisabled: false,
        minLength: '',
        maxLength: '',
        labelAlignment: 'left',
        icon: '',
        iconPosition: '',
        showLink: false,
        link: {},
        isShowHideMethod: true,
        selectText: true,
        helpText: {},
        showClear: false,
        onBlurURL: "",
        onFocusURL: "",
        onChangeURL: "",
    },
    defaultValue: '',
    defaultLng: '',
    onChange: '',
    errorMsg: ''
}

// export default withRouter(Text);
export default Text;