/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control textarea
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input } from 'reactstrap';
// import AppConfig from 'DefaultConstants/AppConfig';
// const { swaggerPostAPI, swaggerGetAPI } = require('DefaultHelpers')
/**
 * Start Textarea class component
 * @state {*Object} reqData
 */
class TextWithConversion extends Component {
    constructor(props) {
        super(props);
        this.state = {
            converted: "",
            exchangeRate: 0
        }
        this.getExchangeRate();
    }
    /* on blur event */
    handleOnBlurEvent = (e) => {
        this.onBlurCallAPI(e);
    }
    /* on focus event */
    handleOnFocusEvent = (e) => {
        this.onFocusCallAPI(e);
    }
    /* on change event */
    handleOnChangeEvent = (e, inputType) => {
        this.props.onChange(inputType, e.target.name, e.target.value)
        this.onChangeCallAPI(e);
        // console.log('res', res);
    }

    onBlurCallAPI = async (e) => {

        const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {}, assignResponseValue } = this.props;
        if (onBlurURL !== '') {

            let response = '';
            let inputName = e.target.name;
            let inputValue = e.target.value;

            if (blurMethod !== '' && blurMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                let data = {
                    [inputName]: inputValue
                }
                response = await this.props.swaggerPostAPI(onBlurURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(inputName, `apiErrCode.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof this.props.swaggerGetAPI === 'function') {
                response = await this.props.swaggerGetAPI(onBlurURL, {}, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                    }
                }
            }

        }
    }

    onFocusCallAPI = async (e) => {

        const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue } = this.props;
        if (onFocusURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (focusMethod !== '' && focusMethod === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
                response = await this.props.swaggerPostAPI(onFocusURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `apiErrCode.${response.errCode}`)
                }
                // to do handle response of post method
            } else if (typeof this.props.swaggerGetAPI === 'function') {
                response = await this.props.swaggerGetAPI(onFocusURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `apiErrCode.${response.errCode}`)
                }
            }

        }

    }

    /* async onChangeCallAPI(e) {

        const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '' } = {}, assignResponseValue } = this.props;
        if (onChangeURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (changeMethod !== '' && changeMethod === 'POST') {
                response = await swaggerPostAPI(onChangeURL, data, true);
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `apiErrCode.${response.errCode}`)
                }
                // to do handle response of post method
            } else {
                response = await swaggerGetAPI(onChangeURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0) {
                    if (typeof assignResponseValue === 'function') {
                        assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                    }
                } else if (response.responseCode === 1) {
                    this.props.onError(e.target.name, `apiErrCode.${response.errCode}`)
                }
            }

        }

    } */

    getExchangeRate = async () => {

        if (this.props.optionsObj && this.props.optionsObj.conversionURL && typeof this.props.swaggerPostAPI === 'function') {
            var response = await this.props.swaggerPostAPI(this.props.optionsObj.conversionURL, {}, true);
            const { data: { [this.props.optionsObj.fieldMap !== undefined ? this.props.optionsObj.fieldMap : '']: ExchangeRate = 0 } = {} } = response;
            if (ExchangeRate !== 0) {
                this.setState({ exchangeRate: ExchangeRate })
            }
        }

    }

    async onChangeCallAPI(e) {
        const { AppConfig: { decimalPlaces = '' } = {} } = this.props;
        if (this.props.optionsObj && this.props.optionsObj.conversionURL) {

            let hiddenFieldName = (this.props.optionsObj.hiddenFieldName !== undefined) ? this.props.optionsObj.hiddenFieldName : "";
            const { exchangeRate } = this.state;
            let res = parseFloat(parseFloat(e.target.value) * (exchangeRate)).toFixed(decimalPlaces);
            var self = this;
            if (e.target.value !== '' && parseFloat(e.target.value) > 0) {
                self.setState({
                    converted: res
                }, () => {
                    let filedsList = hiddenFieldName.toString().split("|");
                    filedsList.map((value) => {
                        setTimeout(() => {
                            self.props.onChange('text', value, res)
                        }, 500);
                    })
                })
            } else {
                self.setState({
                    converted: 0.00
                }, () => {
                    let filedsList = hiddenFieldName.toString().split("|");
                    filedsList.map((value) => {
                        setTimeout(() => {
                            self.props.onChange('text', value, 0.00)
                        }, 500);
                    })
                })
            }

        }

        /* if (this.props.optionsObj && this.props.optionsObj.conversionURL) {
            let value = e.target.value;
            var response = await swaggerPostAPI(this.props.optionsObj.conversionURL, value, true);
            const { data: { [this.props.optionsObj.fieldMap !== undefined ? this.props.optionsObj.fieldMap : '']: ExchangeRate = 0 } = {} } = response;
            let hiddenFieldName = (this.props.optionsObj.hiddenFieldName !== undefined) ? this.props.optionsObj.hiddenFieldName : "";
            if (ExchangeRate !== 0) {
                let res = parseFloat(parseFloat(value) * (ExchangeRate)).toFixed(AppConfig.decimalPlaces);
                this.setState({
                    converted: res
                }, () => this.props.onChange('text', hiddenFieldName, res))

            } else {
                this.setState({
                    converted: 0.00
                }, () => this.props.onChange('text', hiddenFieldName, 0.00))
            }
        } */
    }

    keyPress = (e) => {
        const { optionsObj: { type = '', keyboardType = "default" } = {} } = this.props;
        if (type === 'number' || (keyboardType !== undefined && keyboardType === 'numeric')) {
            e = e || window.event;
            var charCode = (typeof e.which == "undefined") ? e.keyCode : e.which;
            var charStr = String.fromCharCode(charCode);
            if ([8, 46, 13, 9, 16, 37, 39, 190, 110, 35, 40, 34, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105].indexOf(charCode) === -1 && !charStr.match(/^[0-9.]+$/)) {
                e.preventDefault();
            }
        }

        if (e.keyCode == 13 && this.props.onSubmit !== undefined) {
            this.props.onSubmit(e);
        }
    }

    /* render component */
    render() {
        const { errorMsg, defaultValue, defaultLng, AppConfig: { mainCurrency = '' } = {} } = this.props;
        const { converted } = this.state;
        const {
            autoComplete = false,
            autoFocus = false,
            helpText = "",
            key = 'input_conversion_txt_',
            id = 'Demo_text_conversion',
            className = 'cstm_input_txt',
            label = '',
            name = 'demo',
            placeHolder = '',
            required = false,
            isDisabled = false,
            minLength = '',
            maxLength = '',
            labelAlignment = 'left',
            icon = '',
            iconPosition = '',
            selectText = true,
            separator = "",
            onBlurURL = "",
            onFocusURL = "",
        } = this.props.optionsObj;
        let dynamicKey = 'frm_text_' + (name !== undefined ? name : 'dynamicKeyTextInput');
        let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
        let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
        let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
        let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
        let inputType = 'text';

        if (icon !== '') {
            classInput += (iconPosition !== undefined && iconPosition.toLowerCase() === 'right') ? ' icon_right' : ' icon_left';
        }
        return (
            <Fragment>
                {/* {status && */}
                <FormGroup className="row" key={dynamicKey}>
                    {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    <Input
                                        type={inputType}
                                        autoComplete={(autoComplete !== undefined && autoComplete === true) ? "on" : "off"}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        className={((className !== undefined && className) ? className : '') + (selectText === false ? " noselect " : "")}
                                        name={(name !== undefined && name) ? name : 'textInput'}
                                        value={(defaultValue !== undefined && defaultValue) ? defaultValue : ''}
                                        placeholder={(placeHolder !== undefined && placeHolder.locale !== undefined && placeHolder.locale[defaultLng] !== undefined) ? placeHolder.locale[defaultLng] : ''}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        minLength={(minLength !== undefined && minLength) ? minLength : ''}
                                        maxLength={(maxLength !== undefined && maxLength) ? maxLength : ''}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange(inputType, e.target.name, e.target.value)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, inputType))}
                                        onKeyDown={this.keyPress}
                                    />
                                    {(icon !== undefined && icon !== '') && <span className="is_icon"><i className={icon} /></span>}
                                    {(icon !== undefined && icon !== '') && <span className="is_icon"><i className={icon} /></span>}
                                    {(icon !== undefined && icon !== '') && <span className="is_icon"><i className={icon} /></span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {(separator !== undefined && separator !== '') && <span className="is_separator">{separator}</span>}
                                    {(converted !== undefined && converted !== '') && <span className="is_converted">{mainCurrency} {converted}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    <Input
                                        type={inputType}
                                        autoComplete={(autoComplete !== undefined && autoComplete === true) ? 'on' : 'off'}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        className={((className !== undefined && className) ? className : '') + (selectText === false ? " noselect " : "")}
                                        name={(name !== undefined && name) ? name : 'textInput'}
                                        value={(defaultValue !== undefined && defaultValue) ? defaultValue : ''}
                                        placeholder={(placeHolder !== undefined && placeHolder.locale !== undefined && placeHolder.locale[defaultLng] !== undefined) ? placeHolder.locale[defaultLng] : ''}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        minLength={(minLength !== undefined && minLength) ? minLength : ''}
                                        maxLength={(maxLength !== undefined && maxLength) ? maxLength : ''}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange(inputType, e.target.name, e.target.value)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e, inputType))}
                                        onKeyDown={this.keyPress}
                                    />
                                    {(icon !== undefined && icon !== '') && <span className="is_icon"><i className={icon} /></span>}
                                    {(separator !== undefined && separator !== '') && <span className="is_separator">{separator}</span>}
                                    {(converted !== undefined && converted !== '') && <span className="is_converted">{mainCurrency} {converted}</span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                            </Fragment>
                    }
                </FormGroup>
                {/* } */}
            </Fragment >
        )
    }
}


//Default Props for Textarea
TextWithConversion.defaultProps = {
    optionsObj: {
        autoFocus: false,
        key: 'input_conversion_txt_',
        id: 'Demo_text_conversion',
        className: 'cstm_input_txt',
        label: '',
        name: 'demo',
        placeHolder: '',
        required: true,
        validationMsg: '',
        regex: '',
        isDisabled: false,
        minLength: '',
        maxLength: '',
        labelAlignment: 'left',
        icon: '',
        iconPosition: '',
        selectText: true,
        conversionURL: "--",
        separator: "=",
        fieldMap: "",
        hiddenFieldName: "",
        onBlurURL: "",
        onFocusURL: "",
    },
    defaultValue: '',
    defaultLng: '',
    onChange: '',
    errorMsg: ''
}

export default TextWithConversion;