/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control textarea
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component, Fragment } from 'react';
import { Label, FormGroup, Input } from 'reactstrap';
// import AppConfig from 'DefaultConstants/AppConfig';
// const {swaggerPostAPI, swaggerGetAPI }= require('DefaultHelpers')
/**
 * Start Textarea class component
 * @state {*Object} reqData
 */
class Textarea extends Component {
    shouldComponentUpdate = (nextProps, nextState) => {
        if (this.props === nextProps) {
            return false;
        }
        return true;
    };

    /* on blur event */
    handleOnBlurEvent = (e) => {
        this.onBlurCallAPI(e);
    }
    /* on focus event */
    handleOnFocusEvent = (e) => {
        this.onFocusCallAPI(e);
    }
    /* on change event */
    handleOnChangeEvent = (e) => {
        this.props.onChange(e.target.type, e.target.name, e.target.value)
        this.onChangeCallAPI(e);
    }

    onBlurCallAPI = async (e) => {

        const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {},onError, assignResponseValue,swaggerPostAPI,swaggerGetAPI } = this.props;
        if (onBlurURL !== '') {

            let response = '';
            let inputName = e.target.name;
            let inputValue = e.target.value;

            if (blurMethod !== '' && blurMethod === 'POST'&& typeof swaggerPostAPI === 'function') {
                let data = {
                    [inputName]: inputValue
                }
                response = await swaggerPostAPI(onBlurURL, data, true);
                if (response.responseCode === 0&&typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1&&typeof onError=== 'function') {
                    onError(inputName, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if(typeof swaggerGetAPI === 'function'){
                response = await swaggerGetAPI(onBlurURL, {}, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0&&typeof assignResponseValue === 'function') {
                        assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                }
            }

        }
    }

    onFocusCallAPI = async (e) => {

        const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue,swaggerPostAPI,swaggerGetAPI,onError } = this.props;
        if (onFocusURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (focusMethod !== '' && focusMethod === 'POST' && typeof swaggerPostAPI === 'function') {
                response = await swaggerPostAPI(onFocusURL, data, true);
                if (response.responseCode === 0&&typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1&&typeof onError === 'function') {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if(typeof swaggerGetAPI === 'function'){
                response = await swaggerGetAPI(onFocusURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0&&typeof assignResponseValue === 'function') {
                        assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1&&typeof onError=== 'function') {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }

    async onChangeCallAPI(e) {

        const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '' } = {}, assignResponseValue,swaggerPostAPI,swaggerGetAPI,onError } = this.props;
        if (onChangeURL !== '') {

            let data = {
                [e.target.name]: e.target.value
            }
            let response = '';

            if (changeMethod !== '' && changeMethod === 'POST' && typeof swaggerPostAPI === 'function') {
                response = await swaggerPostAPI(onChangeURL, data, true);
                if (response.responseCode === 0&&typeof assignResponseValue === 'function') {
                        assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1&&typeof onError === 'function') {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
                // to do handle response of post method
            } else if(typeof swaggerGetAPI === 'function'){
                response = await swaggerGetAPI(onChangeURL, data, true);
                // response = { responseCode: 0, data: { billAmount: 1000 } }
                if (response.responseCode === 0&&typeof assignResponseValue === 'function') {
                        assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                } else if (response.responseCode === 1&&typeof onError === 'function') {
                    onError(e.target.name, `error.message.${response.errCode}`)
                }
            }

        }

    }


    render() {
        const { errorMsg, defaultLng, defaultValue } = this.props;
        const { autoComplete, key, id, className, label, name, status, placeHolder, required, isDisabled, minLength, maxLength, rows, cols, labelAlignment, icon, iconPosition, helpText, autoFocus, selectText, onBlurURL, onFocusURL, onChangeURL } = this.props.optionsObj;
        let dynamicKey = 'frm_textarea_' + (name !== undefined ? name : 'textAreaInput');
        let labelString = labelAlignment !== undefined ? labelAlignment.toString().toLowerCase() : '';
        let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
        let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
        let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';

        if (icon !== '') {
            classInput += (iconPosition !== undefined && iconPosition.toLowerCase() === 'right') ? ' icon_right' : ' icon_left';
        }

        return (
            <Fragment>
                <FormGroup className="row" key={dynamicKey}>
                    {
                        labelString === 'right'
                            ?
                            <Fragment>
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    <Input
                                        type="textarea"
                                        autoComplete={(autoComplete !== undefined && autoComplete) ? autoComplete : ''}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        className={((className !== undefined && className) ? className : '') + (selectText === false ? " noselect " : "")}
                                        name={(name !== undefined && name) ? name : 'textAreaInput'}
                                        value={(defaultValue !== undefined && defaultValue) ? defaultValue : ''}
                                        placeholder={(placeHolder !== undefined && placeHolder.locale !== undefined && placeHolder.locale[defaultLng] !== undefined) ? placeHolder.locale[defaultLng] : ''}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        minLength={(minLength !== undefined && minLength) ? minLength : ''}
                                        maxLength={(maxLength !== undefined && maxLength) ? maxLength : ''}
                                        rows={(rows !== undefined && rows) ? rows : ''}
                                        cols={(cols !== undefined && cols) ? cols : ''}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange(e.target.type, e.target.name, e.target.value)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                    />
                                    {(icon !== undefined && icon !== '') && <span className="is_icon"><i className={icon} /></span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                            </Fragment>
                            :
                            <Fragment>
                                {(label !== undefined && label.locale !== undefined && label.locale[defaultLng] !== undefined) &&
                                    <Label className={`control-label ${classLabel}`} align={lableAlign}>{label.locale[defaultLng]}{required && <span className="text-danger">*</span>}</Label>}
                                <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                    <Input
                                        type="textarea"
                                        autoComplete={(autoComplete !== undefined && autoComplete) ? autoComplete : ''}
                                        autoFocus={(autoFocus !== undefined && autoFocus === true) ? true : false}
                                        key={(key !== undefined && key) ? key : dynamicKey + "key"}
                                        id={(id !== undefined && id) ? id : dynamicKey + "id"}
                                        className={((className !== undefined && className) ? className : '') + (selectText === false ? " noselect " : "")}
                                        name={(name !== undefined && name) ? name : 'textAreaInput'}
                                        value={(defaultValue !== undefined && defaultValue) ? defaultValue : ''}
                                        placeholder={(placeHolder !== undefined && placeHolder.locale !== undefined && placeHolder.locale[defaultLng] !== undefined) ? placeHolder.locale[defaultLng] : ''}
                                        disabled={(isDisabled !== undefined && isDisabled) ? isDisabled : false}
                                        required={(required !== undefined && required) ? required : false}
                                        minLength={(minLength !== undefined && minLength) ? minLength : ''}
                                        maxLength={(maxLength !== undefined && maxLength) ? maxLength : ''}
                                        rows={(rows !== undefined && rows) ? rows : ''}
                                        cols={(cols !== undefined && cols) ? cols : ''}
                                        // onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : (e) => this.props.onChange(e.target.type, e.target.name, e.target.value)}
                                        onBlur={(onBlurURL !== undefined && onBlurURL) ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                        onFocus={(onFocusURL !== undefined && onFocusURL) ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                        onChange={(isDisabled !== undefined && isDisabled) ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                    />
                                    {(icon !== undefined && icon !== '') && <span className="is_icon"><i className={icon} /></span>}
                                    {helpText !== undefined && Object.keys(helpText).length > 0 && <span className="text-muted font-xs">{helpText.locale[defaultLng]}</span>}
                                    {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                </div>
                            </Fragment>
                    }
                </FormGroup>
                {/* } */}
            </Fragment >
        )
    }
}

//Default Props for Textarea
Textarea.defaultProps = {
    optionsObj: {
        autoComplete: false,
        key: 'input_txtarea_',
        id: 'Demo_textarea',
        className: 'cstm_input_txtarea',
        label: 'Textarea',
        name: 'Demo',
        status: false,
        placeHolder: 'Demo input',
        required: true,
        validationMsg: '',
        regex: '',
        isDisabled: false,
        minLength: '',
        maxLength: '',
        labelAlignment: 'left',
        icon: '',
        iconPosition: '',
        rows: '1',
        cols: '',
        helpText: {},
        autoFocus: false,
        selectText: true,
        onBlurURL: "",
        onFocusURL: "",
        onChangeURL: "",
    },
    defaultValue: '',
    defaultLng: 'en',
    onChange: '',
    errorMsg: ''
}

export default Textarea;