/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control Video
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
 import React, { Component, Fragment } from 'react';
 import { post } from 'axios';
 import { Label, FormGroup, Input, Button } from 'reactstrap';
//  import IntlMessages from "Util/IntlMessages";
//  const { FileDetails, ModelDialog } = require('DefaultComponents/Widgets');
 import 'video.js/dist/video-js.css';
 import videojs from 'video.js';
 import 'webrtc-adapter';
 import RecordRTC from 'recordrtc';
 import 'videojs-record/dist/css/videojs.record.css';
 import Record from 'videojs-record/dist/videojs.record.js';
 // import TsEBMLEngine from 'videojs-record/dist/plugins/videojs.record.ts-ebml.js';
 // import '@mattiasbuelens/web-streams-polyfill/dist/polyfill.min.js';
 // import WebmWasmEngine from 'videojs-record/dist/plugins/videojs.record.webm-wasm.js';
//  const { swaggerPostAPI, swaggerGetAPI, redirectToLogin, getFileSizeToBase64String, checkReactNativeWebView, callNativeFunction, getValueUsingKey, getNotificationFunction } = require('DefaultHelpers');
 import dot from 'dot-object';
//  import AppConfig from 'DefaultConstants/AppConfig';
 import Tooltip from '@material-ui/core/Tooltip';
 import ReactHtmlParser from "react-html-parser";
 dot.override = true;
 
 /**
  * Start Video class component
  * @state {*Object} reqData
  */
 class Video extends Component {
     state = {
         fileData: {},
         loader: false,
         _openWebCamera: false,
         videoData: {}
     }
 
     componentWillReceiveProps(nextProps) {
         const { optionsObj: { name = '', responseBindFrom = '' } = {}, reqData = {} } = nextProps;
         // console.log('componentWillReceiveProps :', reqData, name, responseBindFrom)
         if (!this.state.isDelete && name !== '' && responseBindFrom !== '' && Object.keys(reqData).length > 0 && reqData.hasOwnProperty(name) /* && typeof reqData[name] === 'object' */) {
             const fileData = dot.pick(responseBindFrom, reqData) !== undefined ? dot.pick(responseBindFrom, reqData) : dot.pick(name, reqData)
             this.setState({ fileData: { [name]: fileData } })
         }
     }
 
     componentDidMount() {
         const { optionsObj: { name = '', responseBindFrom = '' } = {}, reqData = {} } = this.props;
         // console.log('componentDidMount :', reqData, name, responseBindFrom)
         if (name !== '' && responseBindFrom !== '' && Object.keys(reqData).length > 0 && reqData.hasOwnProperty(name) /* && typeof reqData[name] === 'object' */) {
             const fileData = dot.pick(responseBindFrom, reqData) !== undefined ? dot.pick(responseBindFrom, reqData) : dot.pick(name, reqData)
             this.setState({ fileData: { [name]: fileData } })
         }
     }
 
     shouldComponentUpdate = (nextProps, nextState) => {
         if (this.props === nextProps && this.state === nextState) {
             return false;
         }
         return true;
     };
 
     /* on blur event */
     handleOnBlurEvent = (e) => {
         this.onBlurCallAPI(e);
     }
 
     /* on focus event */
     handleOnFocusEvent = (e) => {
         this.onFocusCallAPI(e);
     }
 
     /* on change event */
     handleOnChangeEvent = (videoData = {}) => {
         const { optionsObj: { isShowFileDetails = false, name: inputName = '' } = {} } = this.props;
         let fileImage = '';
         const { name: fileName = '', size: fileSize = '', type: fileType = '' } = videoData;
         const fileExtension = '.' + fileName.toString().split('.').pop();
         const sizeIn = 'kb';
         let fileData = {
             [inputName]: {
                 imageUrl: '',
                 name: fileName,
                 size: fileSize,
                 sizeLabel: (typeof this.props.getFileSizeToBase64String === 'function' ? this.props.getFileSizeToBase64String(fileSize, sizeIn, true): '') + sizeIn,
                 type: fileType,
                 inputName: inputName,
                 fileExtension: fileExtension
             }
         };
         if (isShowFileDetails) {
             let reader = new FileReader();
             reader.onloadend = () => {
                 fileData[inputName].imageUrl = reader.result;
                 this.setState({ fileData: fileData });
             }
             reader.readAsDataURL(videoData);
         } else {
             this.setState({ fileData: {} });
         }
         let _fileData = [fileData[inputName]]
         // this.props.onChange('video', inputName, fileImage)
         // console.log('video file onchagne :', _fileData)
         let startProcess = this.checkFileValidation(fileData);
         if (startProcess) {
             setTimeout(() => {
                 // this.props.onChange('file', inputName, _fileData, '', _fileData, '', '', 1)
                 this.onChangeCallAPI(videoData, _fileData);
             }, 100);
         }
     }
 
     toggleWebCamera = () => {
         this.setState({ _openWebCamera: !this.state._openWebCamera });
     }
 
     openWebCamera = () => {
         this.setState({
             _openWebCamera: true
         }, () => this.videoPlayerReady());
     }
 
     videoPlayerReady() {
         this.player = videojs(this.videoNode, this.props, function onPlayerReady() {
         })
 
         // user completed recording and stream is available
         this.player.on('finishRecord', () => {
             // recordedData is a blob object containing the recorded data that
             // can be downloaded by the user, stored on server etc.
             var videoData = this.player.recordedData;
             // console.log('videoData :', videoData)
             this.setState({ videoData: videoData });
         });
 
         this.player.on('finishConvert', () => {
             // the convertedData object contains the recorded data that
             // can be downloaded by the user, stored on server etc.
             // console.log('finished converting: ', this.player.convertedData);
         });
 
         // error handling
         this.player.on('error', (element, error) => {
             if (typeof this.props.getNotificationFunction === 'function') {
                 this.props.getNotificationFunction('error', error);
             }
         });
 
         this.player.on('deviceError', () => {
            if (typeof this.props.getNotificationFunction === 'function') {
             this.props.getNotificationFunction('error', this.player.deviceErrorCode);
            }
         });
     }
 
     closeWebCamera = () => {
         // this.componentWillUnmount();
         if (this.player) {
             this.player.dispose();
         }
         this.setState({ _openWebCamera: false });
     }
 
     handleCameraError = (error) => {
        if (typeof this.props.getNotificationFunction === 'function') {
         this.props.getNotificationFunction('error', error);
        }
     }
 
     onBlurCallAPI = async (e) => {
 
         const { optionsObj: { onBlurURL = '', blurBindIn = '', blurResponseField = '', blurMethod = '' } = {}, assignResponseValue, name } = this.props;
         if (onBlurURL !== '') {
 
             let response = '';
             let inputName = e.target.name;
             let inputValue = e.target.value;
 
             if (blurMethod !== '' && blurMethod === 'POST'  && typeof this.props.swaggerPostAPI === 'function') {
                 let data = {
                     [inputName]: inputValue
                 }
                 response = await this.props.swaggerPostAPI(onBlurURL, data, true);
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(inputName, `error.message.${response.errCode}`)
                 }
                 // to do handle response of post method
             } else if(typeof this.props.swaggerGetAPI === 'function'){
                 response = await this.props.swaggerGetAPI(onBlurURL, {}, true);
                 // response = { responseCode: 0, data: { billAmount: 1000 } }
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(blurBindIn, response.data[blurResponseField]); // first argument field and second response value
                     }
                 }
             }
 
         }
     }
 
     onFocusCallAPI = async (e) => {
 
         const { optionsObj: { onFocusURL = '', focusBindIn = '', focusResponseField = '', focusMethod = '' } = {}, assignResponseValue } = this.props;
         if (onFocusURL !== '') {
 
             let data = {
                 [e.target.name]: e.target.value
             }
             let response = '';
 
             if (focusMethod !== '' && focusMethod === 'POST'  && typeof this.props.swaggerPostAPI === 'function') {
                 response = await this.props.swaggerPostAPI(onFocusURL, data, true);
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(e.target.name, `error.message.${response.errCode}`)
                 }
                 // to do handle response of post method
             } else if(typeof this.props.swaggerGetAPI === 'function'){
                 response = await this.props.swaggerGetAPI(onFocusURL, data, true);
                 // response = { responseCode: 0, data: { billAmount: 1000 } }
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(focusBindIn, response.data[focusResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.props.onError(e.target.name, `error.message.${response.errCode}`)
                 }
             }
 
         }
 
     }
 
     async onChangeCallAPI(webCameraObj = {}, fileData = {}) {
         const { videoData = {} } = this.state;
         const { optionsObj: { onChangeURL = '', name: inputName = '', kycPath = '', kycResponseBindFrom = '' } = {}, savedObject = {} } = this.props;
         if (onChangeURL !== '') {
             var formData = new FormData();
             /* let webName = webCameraObj.name.split('.');
             webCameraObj.name = webName[0] + '.mkv';
             webCameraObj.type = 'video/mkv;codecs=avc1';*/
             if (kycPath !== '') {
                 let kycPathNew = kycPath;
                 if (kycResponseBindFrom !== '') {
                     kycPathNew = kycPathNew + dot.pick(kycResponseBindFrom, savedObject);
                 }
                 formData.append('keyType', kycPathNew);
             } else {
                 formData.append('kycField', inputName);
             }
             formData.append('files', webCameraObj, webCameraObj.name);
             let targetFile = { files: fileData };
             this.uploadFile(formData, targetFile);
         }
     }
 
     checkFileValidation = (webCameraObj = {}) => {
         const { optionsObj: { name: inputName = '', type: validType = [], size: fileSize = '' } = {} } = this.props;
         const { [inputName]: { type: fileType = '', fileTypeExtension = '', size = '' } = {}, [inputName]: fileData = {} } = webCameraObj;
         let _fileData = [fileData]
 
         if (fileType !== '' && Array.isArray(validType) && validType.length > 0 && !validType.includes(fileType)) {
             this.props.onChange('file', inputName, _fileData, '', _fileData, '', '', 1)
             return false;
         } else if (fileType === '' && !validType.includes(fileTypeExtension)) {
             this.props.onChange('file', inputName, _fileData, '', _fileData, '', '', 1)
             return false;
         } else if (size !== undefined && size !== '' && parseFloat(fileSize) > parseFloat(size)) {
             this.props.onChange('file', inputName, _fileData, '', _fileData, '', '', 1)
             return false;
         } else {
             return true;
         }
 
 
         // const { size: webCamSize = '', name: webCamName = '', type: webCamType = '', inputName = '', filePath = '' } = webCameraObj;
         // let targetFile = Object.keys(webCameraObj).length > 0 ? {} : e.target;
         // let fileType = webCamType !== '' ? webCamType : targetFile.files[0].type;
         // // console.log("targetFile.files[0]", targetFile.files[0])
         // let fileSize = webCamSize !== '' ? webCamSize : targetFile.files[0].size;
         // let targetFiles = targetFile.files !== undefined ? targetFile.files : [];
         // let fileTypeExtension = '.' + (webCamName !== '' ? webCamName.toString().split('.').pop() : targetFile.files[0].name.toString().split('.').pop());// targetFiles[0].type;
         // let validType = type !== '' ? type : [];
         // let dynamicKeyValue = 'frm_file_' + (name !== '' ? name : 'textFileInput');
         // let fieldId = name !== '' ? name : dynamicKeyValue + "id";
         // // console.log("webCamSize", size, targetFile.files[0])
         // if (Object.keys(webCameraObj).length > 0) {
         //     return true;
         // } else {
         //     if (fileType !== '' && Array.isArray(validType) && validType.length > 0 && !validType.includes(fileType)) {
         //         $("#" + fieldId).val('');
         //         // this.props.onChange('file_type1', inputName, {})
         //         this.props.onChange(e.target.type, e.target.name, e.target.value, '', targetFiles)
         //         return false;
         //     } else if (fileType === '' && !validType.includes(fileTypeExtension)) {
         //         $("#" + fieldId).val('');
         //         // this.props.onChange('file_type1', inputName, {})
         //         this.props.onChange(e.target.type, e.target.name, e.target.value, '', targetFiles)
         //         return false;
         //     } else if (size !== undefined && size !== '' && parseFloat(fileSize) > parseFloat(size)) {
         //         $("#" + fieldId).val('');
         //         this.props.onChange(e.target.type, e.target.name, e.target.value, '', targetFiles)
         //         // this.props.onChange('file_type1', inputName, {})
         //         return false;
         //     } else {
         //         return true;
         //     }
         // }
     }
 
     deleteFile = () => {
         this.setState({ fileData: {}, videoData: {} });
     }
 
     downloadFile = () => {
         const { optionsObj: { name: inputName = '' } = {} } = this.props;
         const { fileData: { [inputName]: { imageUrl = '', name = '' } = {} } = {} } = this.state;
         // console.log('downloadFile :', this.state.fileData)
         if (imageUrl !== '') {
             if (typeof this.props.checkReactNativeWebView === 'function' && this.props.checkReactNativeWebView() && typeof this.props.callNativeFunction === 'function') {
                 // alert("name|" + name +"|"+inputName)
                 this.props.callNativeFunction("onDownloadFile", { based64String: imageUrl, name });
             } else {
                 const downloadLink = document.createElement("a");
                 downloadLink.href = imageUrl;
                 downloadLink.download = name;
                 downloadLink.click();
             }
         }
     }
 
     // function for file upload into server and get id from response and set into request Object
     uploadFile = async (formData, targetFile, inputFieldName = '') => {
         this.setState({ loader: true });
         const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '', name: inputName = '', validateImage = {} } = {}, assignResponseValue ,
         AppConfig: { nodeAPIUrl = {}, authorizationToken : AuthorizationToken = {} } = {} 
        } = this.props;
 
         let response = '';
         const loaderTime = 200;
         const url = nodeAPIUrl + onChangeURL;
         let authorizationToken = localStorage.getItem('front_authorize_token');
         const selfProcessStart = sessionStorage.getItem('selfProcessStart') !== undefined ? sessionStorage.getItem('selfProcessStart') : '';
         if (selfProcessStart !== '' && selfProcessStart == 1) {
             authorizationToken = sessionStorage.getItem('front_temp_authorize_token');
         }
         const config = {
             headers: {
                 'content-type': 'multipart/form-data', // 'application/x-www-form-urlencoded'
                 'authorization': AuthorizationToken + authorizationToken
                 // get token from local storage
             }
         }
 
         if (changeMethod !== '' && changeMethod === 'POST') {
             var self = this;
             // alert("call api")
             // response = await swaggerPostAPI(onChangeURL, formData, 99); // pass 99 for add content type extra for file
             try {
                 post(url, formData, config).then((apiResponse) => {
                     const { data: response = {} } = apiResponse;
                     // alert("call api||" + JSON.stringify(apiResponse))
 
                     // response = { responseCode: 0, data: { fileUniqueId: "abc" + (Math.random()) } }
                     if (apiResponse !== undefined && apiResponse.status === 401 && typeof this.props.redirectToLogin === 'function') {
                         this.props.redirectToLogin();
                     } else if (response.responseCode === 0) {
                         let bindData = '';
                         if (changeResponseField !== '') {
                             bindData = dot.pick(changeResponseField, response);
                         } else {
                             bindData = dot.pick('data.fileUniqueId', response);
                         }
 
                         const { files: { [0]: { name = '' } = {} } = {} } = targetFile;
                         if (name !== '') {
                             let extension = name.toString().split('.').pop();
                             bindData = bindData + '.' + extension;
                         }
 
                         self.checkImageValidation(validateImage, response, assignResponseValue, bindData, function (isSuccess) {
                             console.log('targetFile checkImageValidation:', validateImage, response, assignResponseValue, bindData, isSuccess)
                             if (typeof assignResponseValue === 'function' && isSuccess) {
                                 if (changeBindIn !== '')
                                     assignResponseValue(changeBindIn, bindData, 'fileUniqueId'); // first argument field and second response value
                                 else
                                     assignResponseValue(inputFieldName !== '' ? inputFieldName : inputName !== '' ? inputName : 'textDatePickerInput', bindData, 'fileUniqueId');
                                 // self.props.onChange(targetFile.type, name !== '' ? name : 'textDatePickerInput', targetFile.value, '', targetFile.files, '', '', response.data.fileUniqueId)
                             } else if (!isSuccess) {
                                 assignResponseValue(inputFieldName !== '' ? inputFieldName : inputName, '', '', true);
                                 self.setState({ fileData: {} });
                                 // self.props.onChange('file_type1', inputFieldName !== '' ? inputFieldName : inputName, {});
                             }
 
                             setTimeout(() => {
                                 self.setState({ loader: false });
                             }, loaderTime);
 
                         });
 
                     } else if (response.responseCode === 1) {
                         self.setState({ fileData: {} });
                         self.props.onChange('file_type1', inputFieldName !== '' ? inputFieldName : inputName, {})
                         if (changeBindIn === '')
                             self.props.onChange(targetFile.type, inputFieldName !== '' ? inputFieldName : inputName !== '' ? inputName : 'textDatePickerInput', targetFile.value, '', '')
                         self.props.onError(inputFieldName !== '' ? inputFieldName : inputName !== '' ? inputName : 'textDatePickerInput', `error.message.${response.errCode}`)
 
                         setTimeout(() => {
                             self.setState({ loader: false });
                         }, loaderTime);
 
                     }
 
                 });
 
             } catch (e) {
 
                 setTimeout(() => {
                     self.setState({ loader: false });
                 }, loaderTime);
 
                 self.setState({ fileData: {} });
                 alert("run onFileUpload Eupload " + e.message)
                 // getNotificationFunction('error', this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
             }
             // to do handle response of post method
         } else if(typeof this.props.swaggerGetAPI === 'function'){
             response = await this.props.swaggerGetAPI(onChangeURL, data, true);
             // response = { responseCode: 0, data: { billAmount: 1000 } }
             if (response.responseCode === 0) {
                 if (typeof assignResponseValue === 'function') {
                     assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                 }
             } else if (response.responseCode === 1) {
                 this.setState({ fileData: {} });
                 this.props.onError(e.target.name, `error.message.${response.errCode}`)
             }
             setTimeout(() => {
                 this.setState({ loader: false });
             }, loaderTime);
         }
     }
 
     onSaveVideo(e) {
         e.preventDefault();
         const { videoData = {} } = this.state;
         if (Object.keys(videoData).length > 0) {
             this.handleOnChangeEvent(videoData);
         }
         this.closeWebCamera();
     }
 
     checkImageValidation = async (validateImage, response, assignResponseValue, fileId, callback) => {
 
         let { enabled = false, request = [], apiMethod = '', apiUrl = '', changeBindIn = '', changeResponseField = '' } = validateImage;
         if (enabled && apiUrl !== '') {
 
             let { reqData = {}, savedObject = {} } = this.props;
             let apiRequest = { data: {} };
             Array.isArray(request) && request.map((item) => {
                 const { key = '', value = '', isFromResponse = false } = item;
                 if (key !== '' && key === 'fileUniqueId') {
                     apiRequest.data[key] = fileId;
                 } else if (key !== '' && key === 'userIdentifier') {
                     if (localStorage.getItem('user') !== null && localStorage.getItem('user') !== undefined)
                         apiRequest.data[key] = localStorage.getItem('user');
                     else if (sessionStorage.getItem('user') !== null && sessionStorage.getItem('user') !== undefined)
                         apiRequest.data[key] = sessionStorage.getItem('user');
                 } else if (key !== '' && typeof this.props.getValueUsingKey === 'function') {
                     if (isFromResponse) {
                         apiRequest.data[key] = this.props.getValueUsingKey(value, response);
                     } else {
                         apiRequest.data[key] = this.props.getValueUsingKey(value, { ...savedObject, ...reqData });
                     }
                 } else {
                     apiRequest.data[key] = '';
                 }
             });
 
             let resData = {};
             if (apiMethod !== '' && apiMethod.toString().toLowerCase() === 'post'  && typeof this.props.swaggerPostAPI === 'function') {
                 resData = await this.props.swaggerPostAPI(apiUrl, apiRequest, true);
             } else if(typeof this.props.swaggerGetAPI === 'function'){
                 if (apiUrl.toString().indexOf("?")) {
                     apiUrl = apiUrl + '&' + encodeQueryData(apiRequest.data);
                 } else {
                     apiUrl = apiUrl + '?' + encodeQueryData(apiRequest.data);
                 }
                 resData = await this.props.swaggerGetAPI(apiUrl, apiRequest, true);
             }
 
             const { responseCode = 1, errCode = '' } = resData;
             if (responseCode === 0) {
                 if (changeBindIn !== '' && changeResponseField !== '' && typeof this.props.getValueUsingKey === 'function') {
                     setTimeout(() => {
                         assignResponseValue(changeBindIn, this.props.getValueUsingKey(changeResponseField, resData));
                     }, 1000);
                 }
                 callback(true);
             } else if (typeof this.props.getNotificationFunction === 'function') {
                 this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: `error.message.${errCode}` }));
                 callback(false);
             }
 
         } else {
             callback(!enabled);
         }
     }
 
     render() {
         const { errorMsg, defaultLng, optionsObj = {}, reqData = {}, defaultValue , FileDetails , ModelDialog , IntlMessages} = this.props;
         let {
             id = 'vwc',
             key = '',
             className = '',
             label: { locale: { [defaultLng]: labelTitle = '' } = {} } = {},
             name = '',
             type = '',
             required = false,
             isDisabled = false,
             multiple = false,
             onBlurURL = '',
             onFocusURL = '',
             onChangeURL = '',
             showLink = false,
             labelAlignment = 'top-left',
             icon = '',
             iconPosition = 'right',
             link: {
                 url: lnkUrl = '',
                 position: lnkPosition = 'right',
                 label: { locale: { [defaultLng]: lnkLabel = '' } = {} } = {}
             } = {},
             helpText: { locale: { [defaultLng]: fNote = '' } = {} } = {},
             placeholder: { locale: { [defaultLng]: placeHolderLabel = '' } = {} } = {},
             isShowFileDetails = false,
             tooltip: {
                 enabled: showTooltip = false,
                 locale: { [defaultLng]: tooltipContent = '' } = {}
             } = {}
         } = optionsObj;
         let dynamicKey = 'frm_file_' + (name !== undefined ? name : 'textFileInput');
         let labelString = labelAlignment !== '' ? labelAlignment.toString().toLowerCase() : '';
         let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
         let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
         let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
         let utilityObj = {
             download: { enabled: true, icon: 'moon-Cloud-Download', downloadFile: () => this.downloadFile() },
             delete: { enabled: true, icon: 'moon-Delete', deleteFile: () => this.deleteFile() },
             // icon : 'moon-info'
         }
         const { fileData = {}, videoData = {}, _openWebCamera, loader } = this.state;
         const { [name]: { imageUrl: fileImage = '', name: fileName = '', sizeLabel: fileSize = '', type: fileType = '', fileExtension = '' } = {}, [name]: fileDataObj = {} } = fileData;
 
         return (
             <Fragment>
                 <FormGroup className="row" key={dynamicKey}>
                     {
                         labelString === 'right'
                             ?
                             <Fragment>
                                 <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                     {
                                         (!loader && isShowFileDetails && Object.keys(fileDataObj).length > 0 && !errorMsg)
                                             ?
                                             <FileDetails
                                                 // fileImage={fileImage}
                                                 fileImage=""
                                                 fileTitle={fileName}
                                                 fileSubTitle={fileSize}
                                                 isShowUtility={true}
                                                 utilityObj={utilityObj}
                                                 extraClass="type1"
                                                 displayImage={false}
                                                 {...this.props}
                                             />
                                             :
                                             <Fragment>
                                                 <div className="file_type1">
                                                     {loader && <div className="fl_loader"><i className="fa fa-spinner fa-spin" /> <IntlMessages id="constant.loading" /></div>}
                                                     <Label className="inner_area" key={`vwc_key_${name !== '' ? name : dynamicKey}`} htmlFor={`vwc_${name !== '' ? name : dynamicKey}`} onClick={() => this.openWebCamera()}>
                                                         {placeHolderLabel}
                                                         {icon !== '' && <span className="icon"><i className={icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                                     </Label>
                                                 </div>
                                                 {fNote && <div className="note_txt">{fNote}</div>}
                                                 {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                             </Fragment>
                                     }
                                 </div>
                                 {labelTitle !== '' && <Label className={`control-label ${classLabel}`} align={lableAlign}>{labelTitle}{required && <span className="text-danger">*</span>}{showTooltip && <Tooltip id="tooltip-icon" title={ReactHtmlParser(tooltipContent)} disableFocusListener={true}><i className="zmdi zmdi-info zmdi-hc-lg fs-lg float-right" /></Tooltip>}</Label>}
                             </Fragment>
                             :
                             <Fragment>
                                 {labelTitle !== '' && <Label className={`control-label ${classLabel}`} align={lableAlign}>{labelTitle}{required && <span className="text-danger">*</span>}{showTooltip && <Tooltip id="tooltip-icon" title={ReactHtmlParser(tooltipContent)} disableFocusListener={true}><i className="zmdi zmdi-info zmdi-hc-lg fs-lg float-right" /></Tooltip>}</Label>}
                                 {(showLink == true && lnkUrl !== '') &&
                                     <Label className={`control-label col temp`} align={lnkPosition}>
                                         <a sethref="javascript:void(0)" onClick={() => this.downloadFile(lnkUrl, lnkLabel)}>{lnkLabel}</a>
                                     </Label>
                                 }
                                 <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                     {
                                         (!loader && isShowFileDetails && Object.keys(fileDataObj).length > 0 && !errorMsg)
                                             ?
                                             <FileDetails
                                                 // fileImage={fileImage}
                                                 fileImage=""
                                                 fileTitle={fileName}
                                                 fileSubTitle={fileSize}
                                                 isShowUtility={true}
                                                 utilityObj={utilityObj}
                                                 {...this.props}
                                             />
                                             :
                                             <Fragment>
                                                 <div className="file_type1">
                                                     {loader && <div className="fl_loader"><i className="fa fa-spinner fa-spin" /> <IntlMessages id="constant.loading" /></div>}
                                                     <Label className="inner_area" key={`vwc_key_${name !== '' ? name : dynamicKey}`} htmlFor={`vwc_${name !== '' ? name : dynamicKey}`} onClick={() => this.openWebCamera()}>
                                                         {placeHolderLabel}
                                                         {icon !== '' && <span className="icon"><i className={icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                                     </Label>
                                                 </div>
                                                 {fNote && <div className="note_txt">{fNote}</div>}
                                                 {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                             </Fragment>
                                     }
                                 </div>
                             </Fragment>
                     }
                     <ModelDialog mdlOpen={_openWebCamera} anyClickClose={false} toggleMethod={() => this.toggleWebCamera()} customClasses="mdl_sml">
                         <div className="photo-capture">
                             <div data-vjs-player>
                                 <video id="myVideo" ref={node => this.videoNode = node} className="video-js vjs-default-skin" playsInline></video>
                             </div>
                             {/* <div className="ocrloader">
                                 <em></em>
                             </div> */}
                         </div>
                         <div className="btn_area">
                             <Button className="cstm_btn smpl_brd" onClick={() => this.closeWebCamera()}>Cancel</Button>
                             <Button className="cstm_btn btn_black" onClick={(e) => this.onSaveVideo(e)}>Ok</Button>
                         </div>
                     </ModelDialog>
                 </FormGroup>
             </Fragment >
         )
     }
 }
 
 export default Video;