/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control WalletWidget
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
import React, { Component } from 'react';
// import { injectIntl } from 'react-intl';
// import AppConfig from 'DefaultConstants/AppConfig';
// const { swaggerPostAPI, swaggerGetAPI, getValueUsingKey, formatNumber } = require('DefaultHelpers')

/**
 * Start WalletWidget class component
 * @state {*Object} reqData
 */
class WalletWidget extends Component {
    constructor(props) {
        super(props);
        this.state = {
            fromName: '',
            fromBalance: 0.00,
            toName: '',
            toBalance: 0.00,
            balanceData: []
        }
    }

    componentWillMount() {
        this.balanceAPICall();
    }

    balanceAPICall = async () => {
        const {
            optionsObj: {
                externalURL: { URL: apiUrl = '', listkey = '', method: methodName = 'POST', request: apiRequest = [] } = {}
            } = {}
        } = this.props;

        if (apiUrl === '') {
            // this.displayResponseValue();
            return false;
        }

        let data = {};
        if (apiRequest.length > 0) {
            apiRequest.map(aItem => {
                const { key = '', value = '', isFromSelected = false } = aItem;
                if (key !== '') {
                    if (isFromSelected) {
                        data[key] = key === 'userIdentifier' ? localStorage.getItem('user') : value;
                    } else {
                        data[key] = key === 'userIdentifier' ? localStorage.getItem('user') : value;
                    }
                }
            })
        }

        let response = {};
        if (methodName === 'POST' && typeof this.props.swaggerPostAPI === 'function') {
            response = await this.props.swaggerPostAPI(apiUrl, { data }, true);
        } else if (typeof this.props.swaggerGetAPI === 'function') {
            response = await this.props.swaggerGetAPI(apiUrl, { data }, true);
        }

        const { responseCode = '', errCode = '', data: { [listkey]: responseData = [] } = {} } = response;
        if (responseCode === 0) {
            this.displayResponseValue(responseData);
        } else if (response.responseCode === 1) {
            this.props.onError(inputName, `error.message.${errCode}`)
        }
    }

    displayResponseValue(balanceData) {
        let {
            intl,
            optionsObj: {
                from: { balanceValue: fromBalance = 0.00, name: fromName = '', value: fromWalletName = '', extrernalId: fromExtId = '' } = {},
                to: { balanceValue: toBalance = 0.00, name: toName = '', value: toWalletName = '', extrernalId: toExtId = '' } = {}
            } = {}
        } = this.props;

        /* //Send value to request..
        if(fromName !== '' && fromWalletName !== '') {
            this.props.assignResponseValue(fromName, intl.formatMessage({ id: fromWalletName }))
        }
        //Send value to request..
        if(toName !== '' && toWalletName !== '') {
            this.props.assignResponseValue(toName, intl.formatMessage({ id: toWalletName }))
        } */

        if (Array.isArray(balanceData) && balanceData.length > 0) {
            balanceData.map(bItem => {
                const { pouchExternalId = '' } = bItem;
                if (pouchExternalId !== '') {
                    if (pouchExternalId === fromExtId) {
                        fromBalance = bItem[fromBalance];
                    } else if (pouchExternalId === toExtId) {
                        toBalance = bItem[toBalance];
                    }
                }
            })
        }

        this.setState({ fromName, fromBalance, toName, toBalance, balanceData });
    }

    render() {
        const { fromBalance = 0.00, toBalance = 0.00, AppConfig: { mainCurrency = '', decimalPlaces = '' } = {} } = this.state;
        let {
            intl,
            optionsObj: {
                type = '1',
                from: { label: fromLabel = '', balanceLabel: fromBalanceLabel = '', value: fromWalletName = '', balanceValue: fromBalanceValue = '' } = {},
                to: { label: toLabel = '', balanceLabel: toBalanceLabel = '', value: toWalletName = '', balanceValue: toBalanceValue = '' } = {},
                responseBindFrom = ""
            } = {},
            reqData = {}
        } = this.props;

        return (
            <div className={`from_to_wallet type_${type}`}>
                {responseBindFrom !== '' ? <div className="from_wallet">
                    {fromLabel !== '' && <div className="w_title">{intl.formatMessage({ id: fromLabel })}</div>}
                    <div className="w_name">{typeof this.props.getValueUsingKey === 'function' ? this.props.getValueUsingKey(fromWalletName, reqData) : ''}</div>
                    <div className="w_title">{typeof this.props.getValueUsingKey === 'function' ? this.props.getValueUsingKey(fromBalanceLabel, reqData) : ''}</div>
                    <div className="w_balance">{typeof this.props.getValueUsingKey === 'function' ? this.props.getValueUsingKey(fromBalanceValue, reqData) : ''}</div>
                </div> : <div className="from_wallet">
                    {fromLabel !== '' && <div className="w_title">{intl.formatMessage({ id: fromLabel })}</div>}
                    {fromWalletName !== '' && <div className="w_name">{intl.formatMessage({ id: fromWalletName })}</div>}
                    {fromBalanceLabel !== '' && <div className="w_title">{intl.formatMessage({ id: fromBalanceLabel })}</div>}
                    <div className="w_balance"><span>{mainCurrency}</span> {parseFloat(fromBalance).toFixed(decimalPlaces)}</div>
                </div>}
                <div className="wallet_icon">
                    {type === '2' ? <i class="fa fa-long-arrow-right" /> : <i className="moon-arrow" />}
                </div>
                {responseBindFrom !== '' ?
                    <div className="to_wallet">
                        {toLabel !== '' && <div className="w_title">{intl.formatMessage({ id: toLabel })}</div>}
                        <div className="w_name">{typeof this.props.getValueUsingKey === 'function' ? this.props.getValueUsingKey(toWalletName, reqData) : ''}</div>
                        <div className="w_title">{typeof this.props.getValueUsingKey === 'function' ? this.props.getValueUsingKey(toBalanceLabel, reqData) : ''}</div>
                        <div className="w_balance">{typeof this.props.getValueUsingKey === 'function' ? this.props.getValueUsingKey(toBalanceValue, reqData) : ''}</div>
                    </div> : <div className="to_wallet">
                        {toLabel !== '' && <div className="w_title">{intl.formatMessage({ id: toLabel })}</div>}
                        {toWalletName !== '' && <div className="w_name">{intl.formatMessage({ id: toWalletName })}</div>}
                        {toBalanceLabel !== '' && <div className="w_title">{intl.formatMessage({ id: toBalanceLabel })}</div>}
                        <div className="w_balance"><span>{mainCurrency}</span> {parseFloat(toBalance).toFixed(decimalPlaces)}</div>
                    </div>}
            </div>
        )
    }
}

export default WalletWidget;